#include <stdio.h>
#include <stdlib.h>
#include "llist.h"

llist* list_remove(llist* list, int key) {
  llist* p = list;
  llist* last = NULL;

  while(p) {
    if(p->key == key) {
      if(last) {
	last->next = p->next;
	free(p);
	return list;
      } else {
	last = p->next;
	free(p);
	return last;
      }
    } else {
      last = p;
      p = p->next;
    }
  }

  return list;
}

int list_get_val(llist* list, int key) {
  llist* p = list;

  while(p) {
    if(p->key == key) {
      return p->val;
    }
    p = p->next;
  } 
  
  return -1;
}

int list_put_val(llist* list, int key, int val) {
  llist* p = list;
  llist* newnode;
  llist* last = NULL;
  
  while(p) {
    if(p->key == key) {
      p->val = val;
      return val;
    }
    last = p;
    p = p->next;
  }

  newnode = (llist*) malloc(sizeof(llist));
  if(newnode != NULL) {
    newnode->key = key;
    newnode->val = val;
    newnode->next = NULL;
    last->next = newnode;
    return val;
  }
}

llist* list_singleton(int key, int val) {
  llist* newnode = (llist*) malloc(sizeof(llist));
  newnode->key = key;
  newnode->val = val;
  newnode->next = NULL;
  return newnode;
}

void list_print(llist* list, FILE* fd) {
  llist* p = list;
  fprintf(fd, "(");
  while(p) {
    if(p->next)
      fprintf(fd, "[%d, %d] ", p->key, p->val);
    else 
      fprintf(fd, "[%d, %d]", p->key, p->val);
    p = p->next;
  }
  fprintf(fd, ")\n");
}

/* int main(int argc, char** argv) { */
/*   llist* list = list_singleton(1, 1); */
/*   fprintf(stderr, "Made list, list = %p\n", list); */
/*   list_print(list, stdout); */
/*   list_put_val(list, 2, 2); */
/*   fprintf(stderr, "Put 2\n"); */
/*   list_print(list, stdout); */
/*   list_put_val(list, 3, 3); */
/*   fprintf(stderr, "Put 3\n"); */
/*   list_print(list, stdout); */
/*   list_put_val(list, 5, 5); */
/*   fprintf(stderr, "Put 5\n"); */
/*   list_print(list, stdout); */
/*   list_put_val(list, 2, 5); */
/*   fprintf(stderr, "Put 2\n"); */
/*   list_print(list, stdout); */
/*   list = list_remove(list, 5); */
/*   fprintf(stderr, "Removed 5\n"); */
/*   list_print(list, stdout); */
/*   list = list_remove(list, 2); */
/*   list_print(list, stdout); */
/*   list = list_remove(list, 1); */
/*   list_print(list, stdout); */
/*   list = list_remove(list, 3); */
/*   list_print(list, stdout); */

  

/*   //  printf("get_val(1) = %d\n", list_get_val(list, 1)); */
/*   //  printf("get_val(2) = %d\n", list_get_val(list, 2)); */
/*   //  printf("get_val(3) = %d\n", list_get_val(list, 3)); */
/*   //  printf("get_val(5) = %d\n", list_get_val(list, 5)); */

/* } */


