#include <string.h>
#include "mystyx.h"

#define	PCHAR(x)	*p++ = f->x
#define	PSHORT(x)	p[0] = f->x;\
			p[1] = f->x>>8;\
			p += 2
#define	PLONG(x)	p[0] = f->x;\
			p[1] = f->x>>8;\
			p[2] = f->x>>16;\
			p[3] = f->x>>24;\
			p += 4
#define	PVLONG(x)	p[0] = f->x;\
			p[1] = f->x>>8;\
			p[2] = f->x>>16;\
			p[3] = f->x>>24;\
			p[4] = 0;\
			p[5] = 0;\
			p[6] = 0;\
			p[7] = 0;\
			p += 8
#define	PSTRING(x,n)	memmove(p, f->x, n); p += n

#define	GCHAR(x)	f->x =	*p++
#define	GSHORT(x)	f->x =	(p[0]|(p[1]<<8));\
			p += 2
#define	GLONG(x)	f->x =	(p[0]|\
			      	(p[1]<<8)|\
			      	(p[2]<<16)|\
			      	(p[3]<<24));\
			      	p += 4
#define	GVLONG(x)	f->x =	(p[0]|\
				(p[1]<<8)|\
				(p[2]<<16)|\
				(p[3]<<24));\
			p += 8
#define	GSTRING(x,n)	memmove(f->x, p, n); p += n

int
convD2M(Dir *f, char *ap, int useless)
{
	uchar *p;

	p = (uchar*)ap;
	PSTRING(name, sizeof(f->name));
	PSTRING(uid, sizeof(f->uid));
	PSTRING(gid, sizeof(f->gid));
	PLONG(qid.path);
	PLONG(qid.vers);
	PLONG(mode);
	PLONG(atime);
	PLONG(mtime);
	PVLONG(length);
	PSHORT(type);
	PSHORT(dev);
	return p - (uchar*)ap;
}

int
convM2D(char *ap, Dir *f)
{
	uchar *p;

	p = (uchar*)ap;
	GSTRING(name, sizeof(f->name));
	GSTRING(uid, sizeof(f->uid));
	GSTRING(gid, sizeof(f->gid));
	GLONG(qid.path);
	GLONG(qid.vers);
	GLONG(mode);
	GLONG(atime);
	GLONG(mtime);
	GVLONG(length);
	GSHORT(type);
	GSHORT(dev);
	return p - (uchar*)ap;
}

int
convM2S(uchar *ap, Fcall *f, int n)
{
	uchar *p;

	p = (uchar*)ap;
	if(n < 3)
		return 0;

	GCHAR(type);
	GSHORT(tag);
	
	if(f->type < 0 || f->type >= Tmax)
		return -1;
	if(n < msglen[f->type])
		return 0;

	switch(f->type) {
	default:
		return -1;

	case Tnop:
		break;
	case Tflush:
		GSHORT(oldtag);
		break;
	case Tattach:
		GSHORT(fid);
		GSTRING(uname, sizeof(f->uname));
		GSTRING(aname, sizeof(f->aname));
		break;
	case Tclone:
		GSHORT(fid);
		GSHORT(newfid);
		break;
	case Twalk:
		GSHORT(fid);
		GSTRING(name, sizeof(f->name));
		break;
	case Topen:
		GSHORT(fid);
		GCHAR(mode);
		break;
	case Tcreate:
		GSHORT(fid);
		GSTRING(name, sizeof(f->name));
		GLONG(perm);
		GCHAR(mode);
		break;
	case Tread:
		GSHORT(fid);
		GVLONG(offset);
		GSHORT(count);
		if(f->count > MAXREAD)
			return -1;
		break;
	case Twrite:
		GSHORT(fid);
		GVLONG(offset);
		GSHORT(count);
		if(f->count > MAXWRITE)
			return -1;
		if(n < msglen[f->type]+f->count)
			return 0;
		p++;	/* pad(1) */
		bcopy(p, &f->data, f->count);
		p += f->count;
		break;
	case Tclunk:
		GSHORT(fid);
		break;
	case Tremove:
		GSHORT(fid);
		break;
	case Tstat:
		GSHORT(fid);
		break;
	case Twstat:
		GSHORT(fid);
		GSTRING(stat, sizeof(f->stat));
		break;
	case Rnop:
		break;
	case Rerror:
		GSTRING(ename, sizeof(f->ename));
		break;
	case Rflush:
		break;
	case Rattach:
		GSHORT(fid);
		GLONG(qid.path);
		GLONG(qid.vers);
		break;
	case Rclone:
		GSHORT(fid);
		break;
	case Rwalk:
		GSHORT(fid);
		GLONG(qid.path);
		GLONG(qid.vers);
		break;
	case Ropen:
		GSHORT(fid);
		GLONG(qid.path);
		GLONG(qid.vers);
		break;
	case Rcreate:
		GSHORT(fid);
		GLONG(qid.path);
		GLONG(qid.vers);
		break;
	case Rread:
		GSHORT(fid);
		GSHORT(count);
		if(f->count > MAXREAD)
			return -1;
		if(n < msglen[f->type]+f->count)
			return 0;
		p++;			/* pad(1) */
		//bcopy(p, &f->data, f->count);
		p += f->count;
		break;
	case Rwrite:
		GSHORT(fid);
		GSHORT(count);
		if(f->count > MAXWRITE)
			return -1;
		break;
	case Rclunk:
		GSHORT(fid);
		break;
	case Rremove:
		GSHORT(fid);
		break;
	case Rstat:
		GSHORT(fid);
		GSTRING(stat, sizeof(f->stat));
		break;
	case Rwstat:
		GSHORT(fid);
		break;
	}
	return p - ap;
}

int
convS2M(Fcall *f, uchar *ap)
{
	uchar *p;

	p = (uchar*)ap;
	PCHAR(type);
	PSHORT(tag);
	switch(f->type) {
	default:
		return -1;

	case Tnop:
		break;
	case Tflush:
		PSHORT(oldtag);
		break;
	case Tattach:
		PSHORT(fid);
		PSTRING(uname, sizeof(f->uname));
		PSTRING(aname, sizeof(f->aname));
		break;
	case Tclone:
		PSHORT(fid);
		PSHORT(newfid);
		break;
	case Twalk:
		PSHORT(fid);
		PSTRING(name, sizeof(f->name));
		break;
	case Topen:
		PSHORT(fid);
		PCHAR(mode);
		break;
	case Tcreate:
		PSHORT(fid);
		PSTRING(name, sizeof(f->name));
		PLONG(perm);
		PCHAR(mode);
		break;
	case Tread:
		PSHORT(fid);
		PVLONG(offset);
		PSHORT(count);
		break;
	case Twrite:
		PSHORT(fid);
		PVLONG(offset);
		PSHORT(count);
		p++;	/* pad(1) */
		//		PSTRING(data, f->count);
		break;
	case Tclunk:
		PSHORT(fid);
		break;
	case Tremove:
		PSHORT(fid);
		break;
	case Tstat:
		PSHORT(fid);
		break;
	case Twstat:
		PSHORT(fid);
		PSTRING(stat, sizeof(f->stat));
		break;

	case Rnop:
		break;
	case Rerror:
		PSTRING(ename, sizeof(f->ename));
		break;
	case Rflush:
		break;
	case Rattach:
		PSHORT(fid);
		PLONG(qid.path);
		PLONG(qid.vers);
		break;
	case Rclone:
		PSHORT(fid);
		break;
	case Rwalk:
		PSHORT(fid);
		PLONG(qid.path);
		PLONG(qid.vers);
		break;
	case Ropen:
		PSHORT(fid);
		PLONG(qid.path);
		PLONG(qid.vers);
		break;
	case Rcreate:
		PSHORT(fid);
		PLONG(qid.path);
		PLONG(qid.vers);
		break;
	case Rread:
		PSHORT(fid);
		PSHORT(count);
		p++;	/* pad(1) */
		//PSTRING(data, f->count);
		break;
	case Rwrite:
		PSHORT(fid);
		PSHORT(count);
		break;
	case Rclunk:
		PSHORT(fid);
		break;
	case Rremove:
		PSHORT(fid);
		break;
	case Rstat:
		PSHORT(fid);
		PSTRING(stat, sizeof(f->stat));
		break;
	case Rwstat:
		PSHORT(fid);
		break;
	}
	return p - (uchar*)ap;
}
