#include <sys/types.h>
#include <sys/socket.h>   
#include <netinet/in.h>
#include <stdio.h>

//#define LISTEN_PORT 2000
#define LISTEN_PORT 2020
#define CONN_LIMIT 5

FILE *network_stream;
int new_socket;

int gdb_putc (int c) {
  int rv;

  if ((rv = write(new_socket, &c, 1)) != 1) {
    printf("putc failed, rv = %d.\n",rv);
    perror("putc");
    return -1;
  }
  printf("putc :: %c\n", c);
  return 1;
    
}

int gdb_getc (void) {
  char c;
  while (!(fread(&c, 1, 1, network_stream)));
  printf("getc :: %c, int = %x\n", c, (unsigned char)c);
  return c;
}

void gdb_monitor_onentry() {
  int my_socket;
  struct sockaddr_in my_addr;
  struct sockaddr_in incom_addr;

  int sin_size;
  int rv;


  printf("gdbstub:: waiting for connection.\n");
  my_socket=socket(AF_INET,SOCK_STREAM,0);
  if(my_socket<0)
    {
      printf("Unable to create socket. Exiting ...\n");
      exit(-1);
    }

  my_addr.sin_family= AF_INET;
  my_addr.sin_port=htons(LISTEN_PORT);
 
  my_addr.sin_addr.s_addr=inet_addr("129.79.246.182"); //myself

  printf("Binding to port...\n");
  if (bind(my_socket,(struct sockaddr *)&my_addr,sizeof(struct sockaddr))<0)
    {
      printf("Unable to bind to port. Exiting ...\n");
      exit(-1);
    }
  printf("Listening on port ...\n");
  if (listen(my_socket,CONN_LIMIT)<0)
    {
      printf("Unable to listen on port. Exiting ...\n");
      exit(-1);
    }
  sin_size = sizeof(struct sockaddr_in);
  new_socket = accept(my_socket,(struct sockaddr *)&incom_addr,&sin_size);
  if (new_socket<0)
    printf("Connection failed\n");   
  else
    printf("Connection came thru...\n");
  
   network_stream=fdopen(new_socket,"rw");

   if (network_stream==NULL)
    {
	printf("Unable to convert fd to stream. Exiting...\n");
	perror("fdopen");
	}
   else
    printf("fopened fine...\n");

  if ((rv = fprintf(network_stream, "g")) < 0) {
    if (ferror(network_stream))
      printf("error in network stream.\n");
    printf("putc failed, rv = %d.\n",rv);
    perror("putc");
    return -1;
  }
  else
    printf("output on stream during init\n");

}

void flush_comm() {
  //  fflush(network_stream);
}

void myputmsg() {
  fprintf(network_stream,"$OK#9a");
  fflush(network_stream);
}
