        .text 
        .code 32 
        .align 0

        .extern swi_handler
        .global software_interrupt_exception

/* Software exception wrapper utilized from p390-1 of "ARM System Developer's Guide */        
software_interrupt_exception:   
        stmfd sp!,{r0-r12,r14}   /* push off all of the regs */
        ldr r10,[r14,#-4]        /* dig back for the calling instruction (swi #num) */
        bic r10,r10,#0xff000000  /* mask off the op-code to get #num */
        mov r1,r13               /* save the supervisor sp in r1 - pass to swi_handler as param 2 */
        mrs r2,spsr              /* grab the current status reg */
        stmfd r13!,{r2}          /* push the sr onto the stack */
        bl swi_wrapper           /* call the swi handler */
        ldmfd r13!,{r2}          /* restore the sr from the stack to r2*/
        msr spsr_cxsf,r2         /* move r2 back to the sr */
        ldmfd r13!,{r0-r12,pc}^  /* restore the regs from earlier */
swi_wrapper:    
        mov r0,r10
        b swi_handler

