#include <errno.h>
#include <fcntl.h>
#include <stdio.h>

#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>

#include <sys/time.h>
#include <stdarg.h>
//#include <time.h>

#include <sys/types.h>

#include <setjmp.h>

#include "arch/thread.h"
#include "mount.h"
#include "error.h"
#include "dat.h"
#include "fns.h"
#include "arch/uart.h"

#define SERVER_PORT 6789

int kerndate;

extern Dev treedev;
extern Dev testdev;
extern Dev mspdev;
extern Dev armdev;

void serve();
void mainthrd (void);
void armtest();
void myprintf(char *str);

void armmain1();

Dev *devtab[] = {&treedev, &testdev, &mspdev, &armdev, 0};


/* channel for incoming packets  */
Channel inChan = CHANNELN(Fcall, 4);

/* channel for sending out packets */
Channel outChan = CHANNELN(Fcall *, 4);

/* channel to return fcall buffers   */
Channel rtnbufferChan = CHANNELN(Fcall *, 4);


int sa; // fd for network socket where this is being served


//char log; //to log or not to log

Thread srvT;
Thread gfcT;
Thread putfcT;
Thread rtnbuffT;
Thread mspdevT;
Thread armdevT;

jmp_buf jbuf;

extern void putfcall();
extern void getfcall();
extern void bufrtnthread();

void panic(char *fmt, ...)
{
  va_list arg;
  char buf[512];
  exit(0);
}

int seconds()
{
  return time(0);
}

void f1(int i) {
  printf("   f1 start, i = %d\n",i);
  if (i>0)
    longjmp(jbuf,1);
  printf("   f1 end, i = %d\n",i);
}


void f0() {
 int i;
 
 printf("inside f0\n");
 
   for(i=0;i<2;i++) {
   if (!(setjmp(jbuf))) {
     printf("f0 calling f1, i = %d\n",i);
     f1(i);
     printf("f0 after exiting f1, i = %d\n",i);
    }
   else
    printf("f0 after exception., i = %d\n",i);
  }
}

int main(int argc, char** argv)
{
  iFid *treefid0, *treefid1, *treefid2, *testfid, *mspfid, *armfid;
  int retval;
  int cpyone;

 
  inituart();
  handlerBegin();
  initFids();  /* initialize data structure for maintaining fids */

  
  // initialize each of the devices
  devtab[0]->init(devtab[0]);
  devtab[1]->init(devtab[1]);
  devtab[2]->init(devtab[2]);
  devtab[3]->init(devtab[3]);

  // mount testdev inside of treedev
  devtab[0]->attach(&treefid0, nil);
  devtab[0]->attach(&treefid1, nil);
  devtab[0]->attach(&treefid2, nil);
  devtab[1]->attach(&testfid, nil);
  devtab[2]->attach(&mspfid, nil);
  devtab[3]->attach(&armfid, nil);

  /* first mount the test device */
  devtab[0]->walk(treefid0, "testdevdir");
  mount(treefid0, testfid);

  /* then mount the msp device */
  devtab[0]->walk(treefid1, "mspdevdir");
  mount(treefid1, mspfid);

 /* then mount the arm device */
  devtab[0]->walk(treefid2, "armdevdir");
  mount(treefid2, armfid);

  handlerFinish();


  // create routines for processing incoming requests (serve), outputing packets, inputing packets
  //    recovering buffers

  // Inpktthrd --- callpipe --> Serve --- callpipe --> Device Mgr --- callpipe --> Outpktthrd

  // Outpktthrd --- callpipe --> Recoverbuf


   
  srvT.run = serve;
  setThrdName(srvT,'S');
  //  strcpy(srvT.name,"server");
  _threadready(&srvT);
  
  gfcT.run = getfcall;
  setThrdName(gfcT,'G');
  _threadready(&gfcT);

  putfcT.run = putfcall;
  setThrdName(putfcT,'P');
  _threadready(&putfcT);

  rtnbuffT.run = bufrtnthread;
  setThrdName(rtnbuffT,'B');
  _threadready(&rtnbuffT);

  printf("channels:\n");
  printf("  inChan:%p\n",&inChan);
  printf("  outchan:%p\n",&outChan);
  printf("  rtnbufChan:%p\n", &rtnbufferChan);
  _threadsched();
}

int main12(int argc, char** argv)
{
  struct timeval endtime;
  struct timeval starttime;
  ulong returntime;
  
 // mainthrd();
  armmain1();

 
}
