/*========================================================================*\
|                                                                          |
| Execution.h                                                              |
|                                                                          |
| This file contains the execution functions, and these functions contain  |
| most of the work-arounds to the device "features"                        |
| (a.k.a., device bugs)/exception conditions.                              |
|--------------------------------------------------------------------------|
| Project:              MSP430 JTAG interfcae                              |
| Developed using:      MS Visual C++ 5.0                                  |
|--------------------------------------------------------------------------|
| Author:               Dale Wellborn                                      |
| Version:              1.00                                               |
| Initial Version:      20 / 07 / 02                                       |
| Last Change:                                                             |
|--------------------------------------------------------------------------|
| Version history:                                                         |
| Version: 1.01                                                            |
|                                                                          |
|--------------------------------------------------------------------------|
| Designed 2002 by Texas Instruments                                       |
\*========================================================================*/

/*------------------------------------------------------------------------*\
| Remarks:                                                                 |
|                                                                          |
\*------------------------------------------------------------------------*/

#ifndef _EXECUTION_H_
#define _EXECUTION_H_

// Functions. -----------------------------------------------------------------

STATUS_T writeReg(int regNo);
STATUS_T readAllDeviceRegisters(LONG* registers, BOOL updateSavedReg);
STATUS_T writeAllDeviceRegisters(LONG* registers);
STATUS_T setBreakpointsActive(int nBreakpoints, WORD* bpState);
STATUS_T releaseCPU(void);
STATUS_T syncCPU(void);
STATUS_T syncCPUAfterDebug(WORD* procState, WORD* pc, BOOL* clearedCpuOff);

#endif // _EXECUTION_H_
