// Global variables.
//
// Version 1.0
//
// Texas Instruments, 2002

#ifndef _GLOBALS_H_
#define _GLOBALS_H_

// #includes. -----------------------------------------------------------------

#include "MSP/Devices.h"			// Device parameters.
#include "MSP/HIL.h"				// Hardware Interface Layer functions.

// #defines. ------------------------------------------------------------------

#define HIL_JTAG_IR_(INSTR) (eemOpen = FALSE, HIL_JTAG_IR(INSTR))
#define HIL_JTAG_DR16(DATA) HIL_JTAG_DR(DATA, 16)
#define HIL_JTAG_DR8(DATA) HIL_JTAG_DR(DATA, 8)

#define RET_ERR(ERROR_NUMBER) { errorNumber = ERROR_NUMBER; return (STATUS_ERROR); }
#define RET_OK { errorNumber = NO_ERR; return (STATUS_OK); }

// Global variables. ----------------------------------------------------------

extern int errorNumber;			// Error number.

extern int deviceId;	    	// Device identification.

extern BOOL hardwareBPsUsed;	// Hardware breakpoints are used.

extern LONG deviceRegs[16];		// Device registers.

extern WORD savedAdc10dtc0;		// ADC10 registers.
extern WORD savedAdc10ctl0;
extern WORD savedAdc10ctl1;

extern WORD emuMode;			// (F449) Emulation mode.
extern WORD genCntrl;			// General Control register.
extern WORD	clkCntrl;			// Clock Control register.
extern WORD	mclkCntrl0;			// Module Clock Control register.

extern WORD wWDTCTL;				// Watchdog Timer Control register.

extern BOOL executeVerify;		// Verify the stub code downloaded by executeCode().

extern BOOL eemOpen;			// Enhanced Emulation Module is open.

extern LONG	CPUCycles;			// CPU cycles executed during single step.

#endif // _GLOBALS_H_
