#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "treenode.h"


#define STREQ(a,b) !(strcmp(a,b))

int qid9p_eq(Qid9p a, Qid9p b) {
  if (a.path == b.path) return 1;
  else return 0;
}

TreeNode* tree_alloc(Dirtab* file, TreeNode* parent) {
  TreeNode* n = (TreeNode*) malloc(sizeof(TreeNode));

  bzero(n, sizeof(TreeNode));
  n->filenode = file;
  n->parent = parent;
  n->children = nil;

  return n;
}

TreeNode* tree_walk(TreeNode* node, char* name) {
  TreeNodeList* p = node->children;

  if (STREQ(name, "..")) {
    return node->parent;
  }

  while(p) {
    if (STREQ(p->data->filenode->name, name))
      return p->data;
    else
      p = p->next;
  }
  return nil;
}

void tree_addchild(TreeNode* node, Dirtab* child) {
  TreeNodeList* p = node->children;
  TreeNodeList* newlistnode = (TreeNodeList*) malloc(sizeof(TreeNodeList));
  TreeNode* newtreenode = tree_alloc(child, node);
  newlistnode->data = newtreenode;
  newlistnode->next = p;
  node->children = newlistnode;
}

TreeNode* tree_findfile(TreeNode* tree, unsigned int path) {
  TreeNodeList* p = tree->children;
 
  if(tree->filenode->qid == path) {
    return tree;
  } else {
    while(p) {
      TreeNode* r = tree_findfile(p->data, path);
      if (r) 
	return r;
      
      p = p->next;
    }
  }
  return nil;

}

void tree_print(TreeNode* tree, int level) {
  TreeNodeList* p = tree->children;
  int i = 0;
  for (i = 0; i < level; i++)
    printf("\t");
  printf("%s (%u)\n", tree->filenode->name, tree->filenode->qid);

  while(p) {
    tree_print(p->data, level + 1);
    p = p->next;

  }
  


}
