#ifndef TREENODE_H
#define TREENODE_H

#include "dat.h"

typedef struct TreeNode TreeNode;
typedef struct TreeNodeList TreeNodeList;

struct TreeNode {
  Dirtab* filenode;

  TreeNodeList* children;
  TreeNode* parent;
  //  Chan* to; // mounted channel
};

struct TreeNodeList {
  TreeNode* data;
  TreeNodeList* next;
};

TreeNode* tree_alloc(Dirtab* file, TreeNode* parent);
TreeNode* tree_walk(TreeNode* node, char* name);
void tree_addchild(TreeNode* node, Dirtab* child);
TreeNode* tree_findfile(TreeNode* tree, unsigned int path);
void tree_print(TreeNode* tree, int level);

#endif


