# on the server side:
#  listen -A (
#      'tcp!*!10101' {
#         echo connection >[1=2]
#         export /net $net/data
#      }
#   )

# on the client side:
#  mount -A tcp!129.79.246.76!10101 /net
# Note this program runs on the client side

implement Dialer;


include "sys.m";
include "draw.m";

Dialer : module
{
	init : fn(nil : ref Draw->Context,args : list of string);
};

sys	: Sys;

init(nil : ref Draw->Context,args : list of string)
{
	rdval :  int;
	counter : int;
	totalsecs : int;
	sensorreading : int;
	lasttime : int;
	temp     : int;

	ar:= array[4] of byte;
	databuf := array[5] of byte;

	sys = load Sys Sys->PATH;

	# connect to the 9P fileserver corresponding to cluster 1
	(i,c) := sys->dial("tcp!129.79.244.162!9876",nil);

	# mount the 9P filesystem 
	if (sys->mount(c.dfd,  "/tmp/sensornet/cluster1", sys->MREPL, nil) < 0)
	{
	  sys->print("mount failed\n");
	  exit;
	}
	sys->print("mount succeeded\n");

	# open the sensor reading file for sensor node 0
	snsrfd := sys->open("/tmp/sensornet/cluster1/sensor0/tempsensor0", sys->ORDWR);
	if (snsrfd == nil) {
	  sys->print("Unable to open tempsensor0\n");
	  exit;
	}

	# obtain the temperature reading
 	sys->seek(snsrfd, 0, sys->SEEKSTART);		
 	n = sys->read(snsrfd, databuf, 5);		

	# the sensor value is obtained as a series of ASCII numbers
        if (n < 0) {
	  	    sys->print("error during sensor read\n", n);
		    exit;
        }	    
        sensorreading = 0;
	temp = 0;
	for(; n > 0; n--) {
	   sensorreading = (sensorreading * 10 ) + int(databuf[temp])-48; 
	   temp++;
        }

        sys->print("reading obtained from sensor %d\n", sensorreading);
	
	sys->print("sensor value = %d\n", sensorreading);		
}

	         



