implement Dialer;
include "sys.m";
include "draw.m";

Dialer : module
{
	init : fn(nil : ref Draw->Context,args : list of string);
};

sys	: Sys;

init(nil : ref Draw->Context,args : list of string)
{
	rdval :  int;
	counter : int;
	totalsecs : int;
	sensorreading : int;
	lasttime : int;
	temp     : int;

	ar:= array[4] of byte;
	databuf := array[5] of byte;

	sys = load Sys Sys->PATH;

	(i,c) := sys->dial("tcp!129.79.244.162!9876",nil);

	sys->print("Path for dir = %s\n",c.dir);
	if (sys->mount(c.dfd,  "/tmp", sys->MREPL, nil) < 0)
	{
	  sys->print("mount failed\n");
	  exit;
	}
	sys->print("mount succeeded\n");

	# open the reading and event files
	eventfd := sys->open("/tmp/sensornet/cluter1/sensor0/tempevent0", sys->ORDWR);
	snsrfd := sys->open("/tmp/sensorne/cluster1/sensor0/tempsensor0", sys->ORDWR);
	if (eventfd == nil) {
	  sys->print("Unable to open tempevent0\n");
	  exit;
	}
	if (snsrfd == nil) {
	  sys->print("Unable to open tempsensor0\n");
	  exit;
	}

	# set threshold by writint to event file @ offset 1
	sys->print("setting threshold to be 50\n");
	databuf[0] = byte(50+48);
 	sys->seek(eventfd, 1, sys->SEEKSTART);		
  	n := sys->write(eventfd, databuf, 1);		

	# enable event notification by writing ASCII '1' to event file @ offset 0
	sys->print("requesting event notification\n");
	databuf[0] = byte(49);
 	sys->seek(eventfd, 0, sys->SEEKSTART);		
  	n = sys->write(eventfd, databuf, 1);		

	# wait for notification
	sys->print("waiting for event notification\n");
 	sys->seek(eventfd, 0, sys->SEEKSTART);		
  	n = sys->read(eventfd, databuf, 1);		
	sys->print("event recvd\n");

	# disable event notification by writing ASCII '0' to event file @ offset 0
 	sys->seek(eventfd, 0, sys->SEEKSTART);		
	databuf[0] = byte(48);
  	n = sys->write(eventfd, databuf, 1);		

	# now obtain reading
 	sys->seek(snsrfd, 0, sys->SEEKSTART);		
 	n = sys->read(snsrfd, databuf, 5);		
        if (n < 0) {
	  	    sys->print("error in sensor app read, n = %d\n", n);
	}	    
	
	# extract the reading from returned data
       sensorreading = 0;
       temp = 0;  
       for(; n > 0; n--) {
	    sensorreading = (sensorreading * 10 ) + int(databuf[temp])-48; 
	    temp++;
       }

       sys->print("sensor value = %d\n", sensorreading);		
}

	         



