--megafunction wizard: %Altera SOPC Builder%
--GENERATION: STANDARD
--VERSION: WM1.0


--Copyright (C) 1991-2004 Altera Corporation
--Any megafunction design, and related net list (encrypted or decrypted),
--support information, device programming or simulation file, and any other
--associated documentation or information provided by Altera or a partner
--under Altera's Megafunction Partnership Program may be used only to
--program PLD devices (but not masked PLD devices) from Altera.  Any other
--use of such megafunction design, net list, support information, device
--programming or simulation file, or any other related documentation or
--information is prohibited for any other purpose, including, but not
--limited to modification, reverse engineering, de-compiling, or use with
--any other silicon devices, unless such use is explicitly licensed under
--a separate agreement with Altera or a megafunction partner.  Title to
--the intellectual property, including patents, copyrights, trademarks,
--trade secrets, or maskworks, embodied in any such megafunction design,
--net list, support information, device programming or simulation file, or
--any other related documentation or information provided by Altera or a
--megafunction partner, remains with Altera, the megafunction partner, or
--their respective licensors.  No other licenses, including any licenses
--needed under any third party's intellectual property, are provided herein.
--Copying or modifying any file, or portion thereof, to which this notice
--is attached violates this copyright.

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity button_pio_s1_arbitrator is 
        port (
              -- inputs:
                 signal button_pio_s1_irq : IN STD_LOGIC;
                 signal button_pio_s1_readdata : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal button_pio_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal button_pio_s1_chipselect : OUT STD_LOGIC;
                 signal button_pio_s1_irq_from_sa : OUT STD_LOGIC;
                 signal button_pio_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal button_pio_s1_reset_n : OUT STD_LOGIC;
                 signal button_pio_s1_write_n : OUT STD_LOGIC;
                 signal button_pio_s1_writedata : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_granted_button_pio_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_button_pio_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_button_pio_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_button_pio_s1 : OUT STD_LOGIC;
                 signal d1_button_pio_s1_end_xfer : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of button_pio_s1_arbitrator : entity is FALSE;
end entity button_pio_s1_arbitrator;


architecture europa of button_pio_s1_arbitrator is
                signal button_pio_s1_allgrants :  STD_LOGIC;
                signal button_pio_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal button_pio_s1_any_continuerequest :  STD_LOGIC;
                signal button_pio_s1_arb_counter_enable :  STD_LOGIC;
                signal button_pio_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal button_pio_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal button_pio_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal button_pio_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal button_pio_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal button_pio_s1_begins_xfer :  STD_LOGIC;
                signal button_pio_s1_end_xfer :  STD_LOGIC;
                signal button_pio_s1_firsttransfer :  STD_LOGIC;
                signal button_pio_s1_grant_vector :  STD_LOGIC;
                signal button_pio_s1_in_a_read_cycle :  STD_LOGIC;
                signal button_pio_s1_in_a_write_cycle :  STD_LOGIC;
                signal button_pio_s1_master_qreq_vector :  STD_LOGIC;
                signal button_pio_s1_slavearbiterlockenable :  STD_LOGIC;
                signal button_pio_s1_waits_for_read :  STD_LOGIC;
                signal button_pio_s1_waits_for_write :  STD_LOGIC;
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_button_pio_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_button_pio_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_button_pio_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_button_pio_s1 :  STD_LOGIC;
                signal wait_for_button_pio_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT button_pio_s1_end_xfer;
      end if;
    end if;

  end process;

  button_pio_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_button_pio_s1);
  internal_cpu_data_master_requests_button_pio_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(25 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10000100100000100001100000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign button_pio_s1_readdata_from_sa = button_pio_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  button_pio_s1_readdata_from_sa <= button_pio_s1_readdata;
  --button_pio_s1_arb_share_counter set values, which is an e_mux
  button_pio_s1_arb_share_set_values <= std_logic_vector'("001");
  --button_pio_s1_arb_share_counter_next_value assignment, which is an e_assign
  button_pio_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(button_pio_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (button_pio_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(button_pio_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (button_pio_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --button_pio_s1_allgrants all slave grants, which is an e_mux
  button_pio_s1_allgrants <= button_pio_s1_grant_vector;
  --button_pio_s1_end_xfer assignment, which is an e_assign
  button_pio_s1_end_xfer <= NOT ((button_pio_s1_waits_for_read OR button_pio_s1_waits_for_write));
  --button_pio_s1_arb_share_counter arbitration counter enable, which is an e_assign
  button_pio_s1_arb_counter_enable <= button_pio_s1_end_xfer AND button_pio_s1_allgrants;
  --button_pio_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      button_pio_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(button_pio_s1_arb_counter_enable) = '1' then 
        button_pio_s1_arb_share_counter <= button_pio_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --button_pio_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      button_pio_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((button_pio_s1_master_qreq_vector AND button_pio_s1_end_xfer)) = '1' then 
        button_pio_s1_slavearbiterlockenable <= or_reduce(button_pio_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master button_pio/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= button_pio_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --button_pio_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  button_pio_s1_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_button_pio_s1 <= internal_cpu_data_master_requests_button_pio_s1 AND NOT (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write));
  --button_pio_s1_writedata mux, which is an e_mux
  button_pio_s1_writedata <= cpu_data_master_writedata (3 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_button_pio_s1 <= internal_cpu_data_master_qualified_request_button_pio_s1;
  --cpu/data_master saved-grant button_pio/s1, which is an e_assign
  cpu_data_master_saved_grant_button_pio_s1 <= internal_cpu_data_master_requests_button_pio_s1;
  --allow new arb cycle for button_pio/s1, which is an e_assign
  button_pio_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  button_pio_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  button_pio_s1_master_qreq_vector <= std_logic'('1');
  --button_pio_s1_reset_n assignment, which is an e_assign
  button_pio_s1_reset_n <= reset_n;
  button_pio_s1_chipselect <= internal_cpu_data_master_granted_button_pio_s1;
  --button_pio_s1_firsttransfer first transaction, which is an e_assign
  button_pio_s1_firsttransfer <= NOT ((button_pio_s1_slavearbiterlockenable AND button_pio_s1_any_continuerequest));
  --button_pio_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  button_pio_s1_beginbursttransfer_internal <= button_pio_s1_begins_xfer AND button_pio_s1_firsttransfer;
  --button_pio_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  button_pio_s1_arbitration_holdoff_internal <= button_pio_s1_begins_xfer AND button_pio_s1_firsttransfer;
  --~button_pio_s1_write_n assignment, which is an e_mux
  button_pio_s1_write_n <= NOT ((internal_cpu_data_master_granted_button_pio_s1 AND cpu_data_master_write));
  --button_pio_s1_address mux, which is an e_mux
  button_pio_s1_address <= A_EXT (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_button_pio_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_button_pio_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_button_pio_s1_end_xfer <= button_pio_s1_end_xfer;
      end if;
    end if;

  end process;

  --button_pio_s1_waits_for_read in a cycle, which is an e_mux
  button_pio_s1_waits_for_read <= button_pio_s1_in_a_read_cycle AND button_pio_s1_begins_xfer;
  --button_pio_s1_in_a_read_cycle assignment, which is an e_assign
  button_pio_s1_in_a_read_cycle <= internal_cpu_data_master_granted_button_pio_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= button_pio_s1_in_a_read_cycle;
  --button_pio_s1_waits_for_write in a cycle, which is an e_mux
  button_pio_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(button_pio_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --button_pio_s1_in_a_write_cycle assignment, which is an e_assign
  button_pio_s1_in_a_write_cycle <= internal_cpu_data_master_granted_button_pio_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= button_pio_s1_in_a_write_cycle;
  wait_for_button_pio_s1_counter <= std_logic'('0');
  --assign button_pio_s1_irq_from_sa = button_pio_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  button_pio_s1_irq_from_sa <= button_pio_s1_irq;
  --vhdl renameroo for output signals
  cpu_data_master_granted_button_pio_s1 <= internal_cpu_data_master_granted_button_pio_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_button_pio_s1 <= internal_cpu_data_master_qualified_request_button_pio_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_button_pio_s1 <= internal_cpu_data_master_requests_button_pio_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity cpu_jtag_debug_module_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_debugaccess : IN STD_LOGIC;
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal cpu_jtag_debug_module_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_jtag_debug_module_resetrequest : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_data_master_requests_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_instruction_master_requests_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_address : OUT STD_LOGIC_VECTOR (8 DOWNTO 0);
                 signal cpu_jtag_debug_module_begintransfer : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_jtag_debug_module_chipselect : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_debugaccess : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_jtag_debug_module_reset : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_reset_n : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_resetrequest_from_sa : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_write : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal d1_cpu_jtag_debug_module_end_xfer : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of cpu_jtag_debug_module_arbitrator : entity is FALSE;
end entity cpu_jtag_debug_module_arbitrator;


architecture europa of cpu_jtag_debug_module_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_arbiterlock :  STD_LOGIC;
                signal cpu_instruction_master_continuerequest :  STD_LOGIC;
                signal cpu_instruction_master_saved_grant_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_jtag_debug_module_allgrants :  STD_LOGIC;
                signal cpu_jtag_debug_module_allow_new_arb_cycle :  STD_LOGIC;
                signal cpu_jtag_debug_module_any_continuerequest :  STD_LOGIC;
                signal cpu_jtag_debug_module_arb_addend :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_arb_counter_enable :  STD_LOGIC;
                signal cpu_jtag_debug_module_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal cpu_jtag_debug_module_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal cpu_jtag_debug_module_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal cpu_jtag_debug_module_arb_winner :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_arbitration_holdoff_internal :  STD_LOGIC;
                signal cpu_jtag_debug_module_beginbursttransfer_internal :  STD_LOGIC;
                signal cpu_jtag_debug_module_begins_xfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_chosen_master_double_vector :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal cpu_jtag_debug_module_chosen_master_rot_left :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_end_xfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_firsttransfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_grant_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_in_a_read_cycle :  STD_LOGIC;
                signal cpu_jtag_debug_module_in_a_write_cycle :  STD_LOGIC;
                signal cpu_jtag_debug_module_master_qreq_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_saved_chosen_master_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_slavearbiterlockenable :  STD_LOGIC;
                signal cpu_jtag_debug_module_waits_for_read :  STD_LOGIC;
                signal cpu_jtag_debug_module_waits_for_write :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_data_master_requests_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_instruction_master_granted_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_instruction_master_requests_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_jtag_debug_module_reset_n :  STD_LOGIC;
                signal last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module :  STD_LOGIC;
                signal last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module :  STD_LOGIC;
                signal wait_for_cpu_jtag_debug_module_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT cpu_jtag_debug_module_end_xfer;
      end if;
    end if;

  end process;

  cpu_jtag_debug_module_begins_xfer <= NOT d1_reasons_to_wait AND ((internal_cpu_data_master_qualified_request_cpu_jtag_debug_module OR internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module));
  internal_cpu_data_master_requests_cpu_jtag_debug_module <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(25 DOWNTO 11) & std_logic_vector'("00000000000")) = std_logic_vector'("10000100100000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign cpu_jtag_debug_module_readdata_from_sa = cpu_jtag_debug_module_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  cpu_jtag_debug_module_readdata_from_sa <= cpu_jtag_debug_module_readdata;
  --cpu_jtag_debug_module_arb_share_counter set values, which is an e_mux
  cpu_jtag_debug_module_arb_share_set_values <= std_logic_vector'("001");
  --cpu_jtag_debug_module_arb_share_counter_next_value assignment, which is an e_assign
  cpu_jtag_debug_module_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(cpu_jtag_debug_module_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (cpu_jtag_debug_module_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(cpu_jtag_debug_module_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (cpu_jtag_debug_module_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --cpu_jtag_debug_module_allgrants all slave grants, which is an e_mux
  cpu_jtag_debug_module_allgrants <= ((or_reduce(cpu_jtag_debug_module_grant_vector) OR or_reduce(cpu_jtag_debug_module_grant_vector)) OR or_reduce(cpu_jtag_debug_module_grant_vector)) OR or_reduce(cpu_jtag_debug_module_grant_vector);
  --cpu_jtag_debug_module_end_xfer assignment, which is an e_assign
  cpu_jtag_debug_module_end_xfer <= NOT ((cpu_jtag_debug_module_waits_for_read OR cpu_jtag_debug_module_waits_for_write));
  --cpu_jtag_debug_module_arb_share_counter arbitration counter enable, which is an e_assign
  cpu_jtag_debug_module_arb_counter_enable <= cpu_jtag_debug_module_end_xfer AND cpu_jtag_debug_module_allgrants;
  --cpu_jtag_debug_module_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_jtag_debug_module_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(cpu_jtag_debug_module_arb_counter_enable) = '1' then 
        cpu_jtag_debug_module_arb_share_counter <= cpu_jtag_debug_module_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_jtag_debug_module_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_jtag_debug_module_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((or_reduce(cpu_jtag_debug_module_master_qreq_vector) AND cpu_jtag_debug_module_end_xfer)) = '1' then 
        cpu_jtag_debug_module_slavearbiterlockenable <= or_reduce(cpu_jtag_debug_module_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master cpu/jtag_debug_module arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= cpu_jtag_debug_module_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --cpu/instruction_master cpu/jtag_debug_module arbiterlock, which is an e_assign
  cpu_instruction_master_arbiterlock <= cpu_jtag_debug_module_slavearbiterlockenable AND cpu_instruction_master_continuerequest;
  --cpu/instruction_master granted cpu/jtag_debug_module last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_instruction_master_saved_grant_cpu_jtag_debug_module) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((cpu_jtag_debug_module_arbitration_holdoff_internal OR NOT internal_cpu_instruction_master_requests_cpu_jtag_debug_module))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module))))));
      end if;
    end if;

  end process;

  --cpu_instruction_master_continuerequest continued request, which is an e_mux
  cpu_instruction_master_continuerequest <= last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module AND internal_cpu_instruction_master_requests_cpu_jtag_debug_module;
  --cpu_jtag_debug_module_any_continuerequest at least one master continues requesting, which is an e_mux
  cpu_jtag_debug_module_any_continuerequest <= cpu_instruction_master_continuerequest OR cpu_data_master_continuerequest;
  internal_cpu_data_master_qualified_request_cpu_jtag_debug_module <= internal_cpu_data_master_requests_cpu_jtag_debug_module AND NOT (cpu_instruction_master_arbiterlock);
  --cpu_jtag_debug_module_writedata mux, which is an e_mux
  cpu_jtag_debug_module_writedata <= cpu_data_master_writedata;
  --mux cpu_jtag_debug_module_debugaccess, which is an e_mux
  cpu_jtag_debug_module_debugaccess <= cpu_data_master_debugaccess;
  internal_cpu_instruction_master_requests_cpu_jtag_debug_module <= to_std_logic(((Std_Logic_Vector'(cpu_instruction_master_address_to_slave(25 DOWNTO 11) & std_logic_vector'("00000000000")) = std_logic_vector'("10000100100000000000000000")))) AND (cpu_instruction_master_read);
  --cpu/data_master granted cpu/jtag_debug_module last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_data_master_saved_grant_cpu_jtag_debug_module) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((cpu_jtag_debug_module_arbitration_holdoff_internal OR NOT internal_cpu_data_master_requests_cpu_jtag_debug_module))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module))))));
      end if;
    end if;

  end process;

  --cpu_data_master_continuerequest continued request, which is an e_mux
  cpu_data_master_continuerequest <= last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module AND internal_cpu_data_master_requests_cpu_jtag_debug_module;
  internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module <= internal_cpu_instruction_master_requests_cpu_jtag_debug_module AND NOT (cpu_data_master_arbiterlock);
  --allow new arb cycle for cpu/jtag_debug_module, which is an e_assign
  cpu_jtag_debug_module_allow_new_arb_cycle <= NOT cpu_data_master_arbiterlock AND NOT cpu_instruction_master_arbiterlock;
  --cpu/instruction_master assignment into master qualified-requests vector for cpu/jtag_debug_module, which is an e_assign
  cpu_jtag_debug_module_master_qreq_vector(0) <= internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module;
  --cpu/instruction_master grant cpu/jtag_debug_module, which is an e_assign
  internal_cpu_instruction_master_granted_cpu_jtag_debug_module <= cpu_jtag_debug_module_grant_vector(0);
  --cpu/instruction_master saved-grant cpu/jtag_debug_module, which is an e_assign
  cpu_instruction_master_saved_grant_cpu_jtag_debug_module <= cpu_jtag_debug_module_arb_winner(0) AND internal_cpu_instruction_master_requests_cpu_jtag_debug_module;
  --cpu/data_master assignment into master qualified-requests vector for cpu/jtag_debug_module, which is an e_assign
  cpu_jtag_debug_module_master_qreq_vector(1) <= internal_cpu_data_master_qualified_request_cpu_jtag_debug_module;
  --cpu/data_master grant cpu/jtag_debug_module, which is an e_assign
  internal_cpu_data_master_granted_cpu_jtag_debug_module <= cpu_jtag_debug_module_grant_vector(1);
  --cpu/data_master saved-grant cpu/jtag_debug_module, which is an e_assign
  cpu_data_master_saved_grant_cpu_jtag_debug_module <= cpu_jtag_debug_module_arb_winner(1) AND internal_cpu_data_master_requests_cpu_jtag_debug_module;
  --cpu/jtag_debug_module chosen-master double-vector, which is an e_assign
  cpu_jtag_debug_module_chosen_master_double_vector <= A_EXT (((std_logic_vector'("0") & ((cpu_jtag_debug_module_master_qreq_vector & cpu_jtag_debug_module_master_qreq_vector))) AND (((std_logic_vector'("0") & (Std_Logic_Vector'(NOT cpu_jtag_debug_module_master_qreq_vector & NOT cpu_jtag_debug_module_master_qreq_vector))) + (std_logic_vector'("000") & (cpu_jtag_debug_module_arb_addend))))), 4);
  --stable onehot encoding of arb winner
  cpu_jtag_debug_module_arb_winner <= A_WE_StdLogicVector((std_logic'(((cpu_jtag_debug_module_allow_new_arb_cycle AND or_reduce(cpu_jtag_debug_module_grant_vector)))) = '1'), cpu_jtag_debug_module_grant_vector, cpu_jtag_debug_module_saved_chosen_master_vector);
  --saved cpu_jtag_debug_module_grant_vector, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_jtag_debug_module_saved_chosen_master_vector <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(cpu_jtag_debug_module_allow_new_arb_cycle) = '1' then 
        cpu_jtag_debug_module_saved_chosen_master_vector <= A_WE_StdLogicVector((std_logic'(or_reduce(cpu_jtag_debug_module_grant_vector)) = '1'), cpu_jtag_debug_module_grant_vector, cpu_jtag_debug_module_saved_chosen_master_vector);
      end if;
    end if;

  end process;

  --onehot encoding of chosen master
  cpu_jtag_debug_module_grant_vector <= Std_Logic_Vector'(A_ToStdLogicVector(((cpu_jtag_debug_module_chosen_master_double_vector(1) OR cpu_jtag_debug_module_chosen_master_double_vector(3)))) & A_ToStdLogicVector(((cpu_jtag_debug_module_chosen_master_double_vector(0) OR cpu_jtag_debug_module_chosen_master_double_vector(2)))));
  --cpu/jtag_debug_module chosen master rotated left, which is an e_assign
  cpu_jtag_debug_module_chosen_master_rot_left <= A_EXT (A_WE_StdLogicVector((((A_SLL(cpu_jtag_debug_module_arb_winner,std_logic_vector'("00000000000000000000000000000001")))) /= std_logic_vector'("00")), (std_logic_vector'("000000000000000000000000000000") & ((A_SLL(cpu_jtag_debug_module_arb_winner,std_logic_vector'("00000000000000000000000000000001"))))), std_logic_vector'("00000000000000000000000000000001")), 2);
  --cpu/jtag_debug_module's addend for next-master-grant
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_jtag_debug_module_arb_addend <= std_logic_vector'("01");
    elsif clk'event and clk = '1' then
      if std_logic'(or_reduce(cpu_jtag_debug_module_grant_vector)) = '1' then 
        cpu_jtag_debug_module_arb_addend <= A_WE_StdLogicVector((std_logic'(cpu_jtag_debug_module_end_xfer) = '1'), cpu_jtag_debug_module_chosen_master_rot_left, cpu_jtag_debug_module_grant_vector);
      end if;
    end if;

  end process;

  cpu_jtag_debug_module_begintransfer <= cpu_jtag_debug_module_begins_xfer;
  --assign lhs ~cpu_jtag_debug_module_reset of type reset_n to cpu_jtag_debug_module_reset_n, which is an e_assign
  cpu_jtag_debug_module_reset <= NOT internal_cpu_jtag_debug_module_reset_n;
  --cpu_jtag_debug_module_reset_n assignment, which is an e_assign
  internal_cpu_jtag_debug_module_reset_n <= reset_n;
  --assign cpu_jtag_debug_module_resetrequest_from_sa = cpu_jtag_debug_module_resetrequest so that symbol knows where to group signals which may go to master only, which is an e_assign
  cpu_jtag_debug_module_resetrequest_from_sa <= cpu_jtag_debug_module_resetrequest;
  cpu_jtag_debug_module_chipselect <= internal_cpu_data_master_granted_cpu_jtag_debug_module OR internal_cpu_instruction_master_granted_cpu_jtag_debug_module;
  --cpu_jtag_debug_module_firsttransfer first transaction, which is an e_assign
  cpu_jtag_debug_module_firsttransfer <= NOT ((cpu_jtag_debug_module_slavearbiterlockenable AND cpu_jtag_debug_module_any_continuerequest));
  --cpu_jtag_debug_module_beginbursttransfer_internal begin burst transfer, which is an e_assign
  cpu_jtag_debug_module_beginbursttransfer_internal <= cpu_jtag_debug_module_begins_xfer AND cpu_jtag_debug_module_firsttransfer;
  --cpu_jtag_debug_module_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  cpu_jtag_debug_module_arbitration_holdoff_internal <= cpu_jtag_debug_module_begins_xfer AND cpu_jtag_debug_module_firsttransfer;
  --cpu_jtag_debug_module_write assignment, which is an e_mux
  cpu_jtag_debug_module_write <= internal_cpu_data_master_granted_cpu_jtag_debug_module AND cpu_data_master_write;
  --cpu_jtag_debug_module_address mux, which is an e_mux
  cpu_jtag_debug_module_address <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_cpu_jtag_debug_module)) = '1'), (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010"))), (A_SRL(cpu_instruction_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")))), 9);
  --d1_cpu_jtag_debug_module_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_cpu_jtag_debug_module_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_cpu_jtag_debug_module_end_xfer <= cpu_jtag_debug_module_end_xfer;
      end if;
    end if;

  end process;

  --cpu_jtag_debug_module_waits_for_read in a cycle, which is an e_mux
  cpu_jtag_debug_module_waits_for_read <= cpu_jtag_debug_module_in_a_read_cycle AND cpu_jtag_debug_module_begins_xfer;
  --cpu_jtag_debug_module_in_a_read_cycle assignment, which is an e_assign
  cpu_jtag_debug_module_in_a_read_cycle <= ((internal_cpu_data_master_granted_cpu_jtag_debug_module AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_cpu_jtag_debug_module AND cpu_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= cpu_jtag_debug_module_in_a_read_cycle;
  --cpu_jtag_debug_module_waits_for_write in a cycle, which is an e_mux
  cpu_jtag_debug_module_waits_for_write <= cpu_jtag_debug_module_in_a_write_cycle AND cpu_jtag_debug_module_begins_xfer;
  --cpu_jtag_debug_module_in_a_write_cycle assignment, which is an e_assign
  cpu_jtag_debug_module_in_a_write_cycle <= internal_cpu_data_master_granted_cpu_jtag_debug_module AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= cpu_jtag_debug_module_in_a_write_cycle;
  wait_for_cpu_jtag_debug_module_counter <= std_logic'('0');
  --cpu_jtag_debug_module_byteenable byte enable port mux, which is an e_mux
  cpu_jtag_debug_module_byteenable <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_cpu_jtag_debug_module)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))), 4);
  --vhdl renameroo for output signals
  cpu_data_master_granted_cpu_jtag_debug_module <= internal_cpu_data_master_granted_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_cpu_jtag_debug_module <= internal_cpu_data_master_qualified_request_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_data_master_requests_cpu_jtag_debug_module <= internal_cpu_data_master_requests_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_cpu_jtag_debug_module <= internal_cpu_instruction_master_granted_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_cpu_jtag_debug_module <= internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_cpu_jtag_debug_module <= internal_cpu_instruction_master_requests_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_jtag_debug_module_reset_n <= internal_cpu_jtag_debug_module_reset_n;
--synthesis translate_off
    --grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_granted_cpu_jtag_debug_module))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_instruction_master_granted_cpu_jtag_debug_module))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line, now);
          write(write_line, string'(": "));
          write(write_line, string'("> 1 of grant signals are active simultaneously"));
          write(output, write_line.all);
          deallocate (write_line);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --saved_grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line1 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_data_master_saved_grant_cpu_jtag_debug_module))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_saved_grant_cpu_jtag_debug_module))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line1, now);
          write(write_line1, string'(": "));
          write(write_line1, string'("> 1 of saved_grant signals are active simultaneously"));
          write(output, write_line1.all);
          deallocate (write_line1);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity cpu_data_master_arbitrator is 
        port (
              -- inputs:
                 signal button_pio_s1_irq_from_sa : IN STD_LOGIC;
                 signal button_pio_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                 signal cpu_data_master_byteenable_ext_flash_s1 : IN STD_LOGIC;
                 signal cpu_data_master_debugaccess : IN STD_LOGIC;
                 signal cpu_data_master_granted_button_pio_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_data_master_granted_ext_flash_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_ext_ram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_high_res_timer_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_jtag_uart_avalon_jtag_slave : IN STD_LOGIC;
                 signal cpu_data_master_granted_jtagpio_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_lan91c111_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_led_pio_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_onchip_ram_64_kbytes_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_reconfig_request_pio_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_sdram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_seven_seg_pio_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_sys_clk_timer_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_sysid_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_granted_uart1_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_button_pio_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_ext_flash_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_ext_ram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_high_res_timer_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_jtagpio_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_lan91c111_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_led_pio_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_onchip_ram_64_kbytes_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_reconfig_request_pio_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_sdram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_seven_seg_pio_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_sys_clk_timer_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_sysid_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_uart1_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_button_pio_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_ext_flash_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_ext_ram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_high_res_timer_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_jtagpio_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_lan91c111_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_led_pio_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_reconfig_request_pio_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sdram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sdram_s1_shift_register : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal cpu_data_master_read_data_valid_seven_seg_pio_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sys_clk_timer_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sysid_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_uart1_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_button_pio_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_data_master_requests_ext_flash_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_ext_ram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_high_res_timer_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_jtag_uart_avalon_jtag_slave : IN STD_LOGIC;
                 signal cpu_data_master_requests_jtagpio_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_lan91c111_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_led_pio_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_onchip_ram_64_kbytes_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_reconfig_request_pio_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_sdram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_seven_seg_pio_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_sys_clk_timer_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_sysid_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_requests_uart1_s1 : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal d1_button_pio_s1_end_xfer : IN STD_LOGIC;
                 signal d1_cpu_jtag_debug_module_end_xfer : IN STD_LOGIC;
                 signal d1_ext_ram_bus_avalon_slave_end_xfer : IN STD_LOGIC;
                 signal d1_high_res_timer_s1_end_xfer : IN STD_LOGIC;
                 signal d1_irq_from_the_lan91c111 : IN STD_LOGIC;
                 signal d1_jtag_uart_avalon_jtag_slave_end_xfer : IN STD_LOGIC;
                 signal d1_jtagpio_s1_end_xfer : IN STD_LOGIC;
                 signal d1_led_pio_s1_end_xfer : IN STD_LOGIC;
                 signal d1_onchip_ram_64_kbytes_s1_end_xfer : IN STD_LOGIC;
                 signal d1_reconfig_request_pio_s1_end_xfer : IN STD_LOGIC;
                 signal d1_sdram_s1_end_xfer : IN STD_LOGIC;
                 signal d1_seven_seg_pio_s1_end_xfer : IN STD_LOGIC;
                 signal d1_sys_clk_timer_s1_end_xfer : IN STD_LOGIC;
                 signal d1_sysid_control_slave_end_xfer : IN STD_LOGIC;
                 signal d1_uart1_s1_end_xfer : IN STD_LOGIC;
                 signal ext_flash_s1_wait_counter_eq_0 : IN STD_LOGIC;
                 signal ext_flash_s1_wait_counter_eq_1 : IN STD_LOGIC;
                 signal high_res_timer_s1_irq_from_sa : IN STD_LOGIC;
                 signal high_res_timer_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal incoming_ext_ram_bus_data : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal incoming_ext_ram_bus_data_with_Xs_converted_to_0 : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal jtag_uart_avalon_jtag_slave_irq_from_sa : IN STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal jtag_uart_avalon_jtag_slave_waitrequest_from_sa : IN STD_LOGIC;
                 signal jtagpio_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                 signal lan91c111_s1_wait_counter_eq_0 : IN STD_LOGIC;
                 signal led_pio_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal onchip_ram_64_kbytes_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reconfig_request_pio_s1_readdata_from_sa : IN STD_LOGIC;
                 signal registered_cpu_data_master_read_data_valid_ext_flash_s1 : IN STD_LOGIC;
                 signal registered_cpu_data_master_read_data_valid_ext_ram_s1 : IN STD_LOGIC;
                 signal registered_cpu_data_master_read_data_valid_lan91c111_s1 : IN STD_LOGIC;
                 signal registered_cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1 : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;
                 signal sdram_s1_posted_fifo_readenable : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal sdram_s1_posted_fifo_writenable : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal sdram_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal sdram_s1_waitrequest_from_sa : IN STD_LOGIC;
                 signal sys_clk_timer_s1_irq_from_sa : IN STD_LOGIC;
                 signal sys_clk_timer_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal sysid_control_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal uart1_s1_irq_from_sa : IN STD_LOGIC;
                 signal uart1_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

              -- outputs:
                 signal cpu_data_master_address_to_slave : OUT STD_LOGIC_VECTOR (25 DOWNTO 0);
                 signal cpu_data_master_dbs_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_dbs_write_8 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal cpu_data_master_irq : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_data_master_no_byte_enables_and_last_term : OUT STD_LOGIC;
                 signal cpu_data_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_data_master_waitrequest : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of cpu_data_master_arbitrator : entity is FALSE;
end entity cpu_data_master_arbitrator;


architecture europa of cpu_data_master_arbitrator is
                signal cpu_data_master_dbs_increment :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal dbs_8_reg_segment_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal dbs_8_reg_segment_1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal dbs_8_reg_segment_2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal dbs_count_enable :  STD_LOGIC;
                signal dbs_counter_overflow :  STD_LOGIC;
                signal dummy_sink :  STD_LOGIC;
                signal internal_cpu_data_master_address_to_slave :  STD_LOGIC_VECTOR (25 DOWNTO 0);
                signal internal_cpu_data_master_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal internal_cpu_data_master_no_byte_enables_and_last_term :  STD_LOGIC;
                signal internal_cpu_data_master_waitrequest :  STD_LOGIC;
                signal last_dbs_term_and_run :  STD_LOGIC;
                signal next_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_cpu_data_master_waitrequest :  STD_LOGIC;
                signal p1_dbs_8_reg_segment_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal p1_dbs_8_reg_segment_1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal p1_dbs_8_reg_segment_2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal p1_registered_cpu_data_master_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal pre_dbs_count_enable :  STD_LOGIC;
                signal r_0 :  STD_LOGIC;
                signal r_1 :  STD_LOGIC;
                signal r_2 :  STD_LOGIC;
                signal registered_cpu_data_master_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);

begin

  --r_0 cascaded wait assignment, which is an e_assign
  r_0 <= Vector_To_Std_Logic(((((((((((((((((((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_button_pio_s1 OR NOT cpu_data_master_requests_button_pio_s1))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_button_pio_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_button_pio_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_data_master_requests_cpu_jtag_debug_module)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_granted_cpu_jtag_debug_module OR NOT cpu_data_master_qualified_request_cpu_jtag_debug_module)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_data_master_write)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((cpu_data_master_qualified_request_lan91c111_s1 OR registered_cpu_data_master_read_data_valid_lan91c111_s1) OR NOT cpu_data_master_requests_lan91c111_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((((cpu_data_master_qualified_request_ext_flash_s1 OR (((registered_cpu_data_master_read_data_valid_ext_flash_s1 AND internal_cpu_data_master_dbs_address(1)) AND internal_cpu_data_master_dbs_address(0)))) OR ((((cpu_data_master_write AND NOT(cpu_data_master_byteenable_ext_flash_s1)) AND internal_cpu_data_master_dbs_address(1)) AND internal_cpu_data_master_dbs_address(0)))) OR NOT cpu_data_master_requests_ext_flash_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((cpu_data_master_qualified_request_ext_ram_s1 OR registered_cpu_data_master_read_data_valid_ext_ram_s1) OR NOT cpu_data_master_requests_ext_ram_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_granted_lan91c111_s1 OR NOT cpu_data_master_qualified_request_lan91c111_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_granted_ext_flash_s1 OR NOT cpu_data_master_qualified_request_ext_flash_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_granted_ext_ram_s1 OR NOT cpu_data_master_qualified_request_ext_ram_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((NOT cpu_data_master_qualified_request_lan91c111_s1 OR NOT cpu_data_master_read) OR ((registered_cpu_data_master_read_data_valid_lan91c111_s1 AND cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_lan91c111_s1 OR NOT cpu_data_master_write)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_ext_ram_bus_avalon_slave_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((NOT cpu_data_master_qualified_request_ext_flash_s1 OR NOT cpu_data_master_read) OR (((registered_cpu_data_master_read_data_valid_ext_flash_s1 AND ((internal_cpu_data_master_dbs_address(1) AND internal_cpu_data_master_dbs_address(0)))) AND cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_ext_flash_s1 OR NOT cpu_data_master_write)))) OR ((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(ext_flash_s1_wait_counter_eq_1)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((internal_cpu_data_master_dbs_address(1) AND internal_cpu_data_master_dbs_address(0))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((NOT cpu_data_master_qualified_request_ext_ram_s1 OR NOT cpu_data_master_read) OR ((registered_cpu_data_master_read_data_valid_ext_ram_s1 AND cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_ext_ram_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_high_res_timer_s1 OR NOT cpu_data_master_requests_high_res_timer_s1)))))));
  --cascaded wait assignment, which is an e_assign
  p1_cpu_data_master_waitrequest <= NOT (((r_0 AND r_1) AND r_2));
  --r_1 cascaded wait assignment, which is an e_assign
  r_1 <= Vector_To_Std_Logic(((((((((((((((((((((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_high_res_timer_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_high_res_timer_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave OR NOT cpu_data_master_requests_jtag_uart_avalon_jtag_slave)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT jtag_uart_avalon_jtag_slave_waitrequest_from_sa)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave OR NOT cpu_data_master_write)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT jtag_uart_avalon_jtag_slave_waitrequest_from_sa)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_jtagpio_s1 OR NOT cpu_data_master_requests_jtagpio_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_jtagpio_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_jtagpio_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_led_pio_s1 OR NOT cpu_data_master_requests_led_pio_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_led_pio_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_led_pio_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((cpu_data_master_qualified_request_onchip_ram_64_kbytes_s1 OR registered_cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1) OR NOT cpu_data_master_requests_onchip_ram_64_kbytes_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_granted_onchip_ram_64_kbytes_s1 OR NOT cpu_data_master_qualified_request_onchip_ram_64_kbytes_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((NOT cpu_data_master_qualified_request_onchip_ram_64_kbytes_s1 OR NOT cpu_data_master_read) OR ((registered_cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1 AND cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_onchip_ram_64_kbytes_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_reconfig_request_pio_s1 OR NOT cpu_data_master_requests_reconfig_request_pio_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_reconfig_request_pio_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_reconfig_request_pio_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((cpu_data_master_qualified_request_sdram_s1 OR cpu_data_master_read_data_valid_sdram_s1) OR NOT cpu_data_master_requests_sdram_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_granted_sdram_s1 OR NOT cpu_data_master_qualified_request_sdram_s1)))))));
  --r_2 cascaded wait assignment, which is an e_assign
  r_2 <= Vector_To_Std_Logic(((((((((((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((NOT cpu_data_master_qualified_request_sdram_s1 OR NOT cpu_data_master_read) OR ((cpu_data_master_read_data_valid_sdram_s1 AND cpu_data_master_read))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_sdram_s1 OR NOT cpu_data_master_write)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT sdram_s1_waitrequest_from_sa)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_seven_seg_pio_s1 OR NOT cpu_data_master_requests_seven_seg_pio_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_seven_seg_pio_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_seven_seg_pio_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_sys_clk_timer_s1 OR NOT cpu_data_master_requests_sys_clk_timer_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_sys_clk_timer_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_sys_clk_timer_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_sysid_control_slave OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_sysid_control_slave OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_uart1_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_uart1_s1 OR NOT cpu_data_master_write)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))));
  --optimize select-logic by passing only those address bits which matter.
  internal_cpu_data_master_address_to_slave <= cpu_data_master_address(25 DOWNTO 0);
  --run register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_waitrequest <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        internal_cpu_data_master_waitrequest <= Vector_To_Std_Logic(NOT (A_WE_StdLogicVector((std_logic'((NOT ((cpu_data_master_read OR cpu_data_master_write)))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((NOT p1_cpu_data_master_waitrequest AND internal_cpu_data_master_waitrequest))))))));
      end if;
    end if;

  end process;

  --cpu/data_master readdata mux, which is an e_mux
  cpu_data_master_readdata <= (((((((((((((((A_REP(NOT cpu_data_master_requests_button_pio_s1, 32) OR (std_logic_vector'("0000000000000000000000000000") & (button_pio_s1_readdata_from_sa)))) AND ((A_REP(NOT cpu_data_master_requests_cpu_jtag_debug_module, 32) OR cpu_jtag_debug_module_readdata_from_sa))) AND ((A_REP(NOT cpu_data_master_requests_lan91c111_s1, 32) OR incoming_ext_ram_bus_data))) AND ((A_REP(NOT cpu_data_master_requests_ext_flash_s1, 32) OR (incoming_ext_ram_bus_data_with_Xs_converted_to_0 & dbs_8_reg_segment_2 & dbs_8_reg_segment_1 & dbs_8_reg_segment_0)))) AND ((A_REP(NOT cpu_data_master_requests_ext_ram_s1, 32) OR incoming_ext_ram_bus_data))) AND ((A_REP(NOT cpu_data_master_requests_high_res_timer_s1, 32) OR (std_logic_vector'("0000000000000000") & (high_res_timer_s1_readdata_from_sa))))) AND ((A_REP(NOT cpu_data_master_requests_jtag_uart_avalon_jtag_slave, 32) OR registered_cpu_data_master_readdata))) AND ((A_REP(NOT cpu_data_master_requests_jtagpio_s1, 32) OR (std_logic_vector'("00000000000") & (jtagpio_s1_readdata_from_sa))))) AND ((A_REP(NOT cpu_data_master_requests_led_pio_s1, 32) OR (std_logic_vector'("000000000000000000000000") & (led_pio_s1_readdata_from_sa))))) AND ((A_REP(NOT cpu_data_master_requests_onchip_ram_64_kbytes_s1, 32) OR onchip_ram_64_kbytes_s1_readdata_from_sa))) AND ((A_REP(NOT cpu_data_master_requests_reconfig_request_pio_s1, 32) OR (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(reconfig_request_pio_s1_readdata_from_sa)))))) AND ((A_REP(NOT cpu_data_master_requests_sdram_s1, 32) OR registered_cpu_data_master_readdata))) AND ((A_REP(NOT cpu_data_master_requests_sys_clk_timer_s1, 32) OR (std_logic_vector'("0000000000000000") & (sys_clk_timer_s1_readdata_from_sa))))) AND ((A_REP(NOT cpu_data_master_requests_sysid_control_slave, 32) OR sysid_control_slave_readdata_from_sa))) AND ((A_REP(NOT cpu_data_master_requests_uart1_s1, 32) OR (std_logic_vector'("0000000000000000") & (uart1_s1_readdata_from_sa))));
  --irq assign, which is an e_assign
  cpu_data_master_irq <= Std_Logic_Vector'(A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(d1_irq_from_the_lan91c111) & A_ToStdLogicVector(high_res_timer_s1_irq_from_sa) & A_ToStdLogicVector(jtag_uart_avalon_jtag_slave_irq_from_sa) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(button_pio_s1_irq_from_sa) & A_ToStdLogicVector(uart1_s1_irq_from_sa) & A_ToStdLogicVector(sys_clk_timer_s1_irq_from_sa));
  --no_byte_enables_and_last_term, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_no_byte_enables_and_last_term <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        internal_cpu_data_master_no_byte_enables_and_last_term <= last_dbs_term_and_run;
      end if;
    end if;

  end process;

  --compute the last dbs term, which is an e_mux
  last_dbs_term_and_run <= (to_std_logic(((internal_cpu_data_master_dbs_address = std_logic_vector'("11")))) AND cpu_data_master_write) AND NOT(cpu_data_master_byteenable_ext_flash_s1);
  --pre dbs count enable, which is an e_mux
  pre_dbs_count_enable <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((((((NOT internal_cpu_data_master_no_byte_enables_and_last_term) AND cpu_data_master_requests_ext_flash_s1) AND cpu_data_master_write) AND NOT(cpu_data_master_byteenable_ext_flash_s1))) OR cpu_data_master_read_data_valid_ext_flash_s1)))) OR ((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((cpu_data_master_granted_ext_flash_s1 AND cpu_data_master_write)))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((ext_flash_s1_wait_counter_eq_0 AND NOT d1_ext_ram_bus_avalon_slave_end_xfer)))))))));
  --input to dbs-8 stored 0, which is an e_mux
  p1_dbs_8_reg_segment_0 <= incoming_ext_ram_bus_data_with_Xs_converted_to_0;
  --dbs register for dbs-8 segment 0, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_8_reg_segment_0 <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_count_enable AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & ((internal_cpu_data_master_dbs_address(1 DOWNTO 0)))) = std_logic_vector'("00000000000000000000000000000000")))))) = '1' then 
        dbs_8_reg_segment_0 <= p1_dbs_8_reg_segment_0;
      end if;
    end if;

  end process;

  --input to dbs-8 stored 1, which is an e_mux
  p1_dbs_8_reg_segment_1 <= incoming_ext_ram_bus_data_with_Xs_converted_to_0;
  --dbs register for dbs-8 segment 1, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_8_reg_segment_1 <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_count_enable AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & ((internal_cpu_data_master_dbs_address(1 DOWNTO 0)))) = std_logic_vector'("00000000000000000000000000000001")))))) = '1' then 
        dbs_8_reg_segment_1 <= p1_dbs_8_reg_segment_1;
      end if;
    end if;

  end process;

  --input to dbs-8 stored 2, which is an e_mux
  p1_dbs_8_reg_segment_2 <= incoming_ext_ram_bus_data_with_Xs_converted_to_0;
  --dbs register for dbs-8 segment 2, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_8_reg_segment_2 <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_count_enable AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & ((internal_cpu_data_master_dbs_address(1 DOWNTO 0)))) = std_logic_vector'("00000000000000000000000000000010")))))) = '1' then 
        dbs_8_reg_segment_2 <= p1_dbs_8_reg_segment_2;
      end if;
    end if;

  end process;

  --mux write dbs 2, which is an e_mux
  cpu_data_master_dbs_write_8 <= A_WE_StdLogicVector((((std_logic_vector'("000000000000000000000000000000") & (internal_cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000000"))), cpu_data_master_writedata(7 DOWNTO 0), A_WE_StdLogicVector((((std_logic_vector'("000000000000000000000000000000") & (internal_cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000001"))), cpu_data_master_writedata(15 DOWNTO 8), A_WE_StdLogicVector((((std_logic_vector'("000000000000000000000000000000") & (internal_cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000010"))), cpu_data_master_writedata(23 DOWNTO 16), cpu_data_master_writedata(31 DOWNTO 24))));
  --dbs count increment, which is an e_mux
  cpu_data_master_dbs_increment <= A_EXT (A_WE_StdLogicVector((std_logic'((cpu_data_master_requests_ext_flash_s1)) = '1'), std_logic_vector'("00000000000000000000000000000001"), std_logic_vector'("00000000000000000000000000000000")), 2);
  --dbs counter overflow, which is an e_assign
  dbs_counter_overflow <= internal_cpu_data_master_dbs_address(1) AND NOT((next_dbs_address(1)));
  --next master address, which is an e_assign
  next_dbs_address <= A_EXT (((std_logic_vector'("0") & (internal_cpu_data_master_dbs_address)) + (std_logic_vector'("0") & (cpu_data_master_dbs_increment))), 2);
  --dbs count enable, which is an e_mux
  dbs_count_enable <= pre_dbs_count_enable;
  --dbs counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_dbs_address <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(dbs_count_enable) = '1' then 
        internal_cpu_data_master_dbs_address <= next_dbs_address;
      end if;
    end if;

  end process;

  --unpredictable registered wait state incoming data, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      registered_cpu_data_master_readdata <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        registered_cpu_data_master_readdata <= p1_registered_cpu_data_master_readdata;
      end if;
    end if;

  end process;

  --registered readdata mux, which is an e_mux
  p1_registered_cpu_data_master_readdata <= ((A_REP(NOT cpu_data_master_requests_jtag_uart_avalon_jtag_slave, 32) OR jtag_uart_avalon_jtag_slave_readdata_from_sa)) AND ((A_REP(NOT cpu_data_master_requests_sdram_s1, 32) OR sdram_s1_readdata_from_sa));
  --vhdl renameroo for output signals
  cpu_data_master_address_to_slave <= internal_cpu_data_master_address_to_slave;
  --vhdl renameroo for output signals
  cpu_data_master_dbs_address <= internal_cpu_data_master_dbs_address;
  --vhdl renameroo for output signals
  cpu_data_master_no_byte_enables_and_last_term <= internal_cpu_data_master_no_byte_enables_and_last_term;
  --vhdl renameroo for output signals
  cpu_data_master_waitrequest <= internal_cpu_data_master_waitrequest;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity cpu_instruction_master_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_instruction_master_address : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                 signal cpu_instruction_master_granted_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_instruction_master_granted_ext_flash_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_granted_ext_ram_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_granted_lan91c111_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_granted_onchip_ram_64_kbytes_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_granted_sdram_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_ext_flash_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_ext_ram_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_lan91c111_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_onchip_ram_64_kbytes_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_sdram_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_ext_flash_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_ext_ram_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_lan91c111_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_sdram_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_sdram_s1_shift_register : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal cpu_instruction_master_requests_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_ext_flash_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_ext_ram_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_lan91c111_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_onchip_ram_64_kbytes_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_sdram_s1 : IN STD_LOGIC;
                 signal cpu_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal d1_cpu_jtag_debug_module_end_xfer : IN STD_LOGIC;
                 signal d1_ext_ram_bus_avalon_slave_end_xfer : IN STD_LOGIC;
                 signal d1_onchip_ram_64_kbytes_s1_end_xfer : IN STD_LOGIC;
                 signal d1_sdram_s1_end_xfer : IN STD_LOGIC;
                 signal ext_flash_s1_wait_counter_eq_0 : IN STD_LOGIC;
                 signal incoming_ext_ram_bus_data : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal lan91c111_s1_wait_counter_eq_0 : IN STD_LOGIC;
                 signal onchip_ram_64_kbytes_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;
                 signal sdram_s1_posted_fifo_readenable : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal sdram_s1_posted_fifo_writenable : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal sdram_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- outputs:
                 signal cpu_instruction_master_address_to_slave : OUT STD_LOGIC_VECTOR (25 DOWNTO 0);
                 signal cpu_instruction_master_dbs_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_instruction_master_waitrequest : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of cpu_instruction_master_arbitrator : entity is FALSE;
end entity cpu_instruction_master_arbitrator;


architecture europa of cpu_instruction_master_arbitrator is
                signal active_and_waiting_last_time :  STD_LOGIC;
                signal cpu_instruction_master_address_last_time :  STD_LOGIC_VECTOR (25 DOWNTO 0);
                signal cpu_instruction_master_dbs_increment :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_instruction_master_read_last_time :  STD_LOGIC;
                signal dbs_8_reg_segment_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal dbs_8_reg_segment_1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal dbs_8_reg_segment_2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal dbs_count_enable :  STD_LOGIC;
                signal dbs_counter_overflow :  STD_LOGIC;
                signal dummy_sink :  STD_LOGIC;
                signal internal_cpu_instruction_master_address_to_slave :  STD_LOGIC_VECTOR (25 DOWNTO 0);
                signal internal_cpu_instruction_master_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal internal_cpu_instruction_master_waitrequest :  STD_LOGIC;
                signal next_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_dbs_8_reg_segment_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal p1_dbs_8_reg_segment_1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal p1_dbs_8_reg_segment_2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal pre_dbs_count_enable :  STD_LOGIC;
                signal r_0 :  STD_LOGIC;
                signal r_1 :  STD_LOGIC;
                signal r_2 :  STD_LOGIC;

begin

  --r_0 cascaded wait assignment, which is an e_assign
  r_0 <= Vector_To_Std_Logic((((((((((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((cpu_instruction_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_instruction_master_requests_cpu_jtag_debug_module)) AND ((cpu_instruction_master_granted_cpu_jtag_debug_module OR NOT cpu_instruction_master_qualified_request_cpu_jtag_debug_module)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_instruction_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_instruction_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_cpu_jtag_debug_module_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_read)))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((cpu_instruction_master_qualified_request_lan91c111_s1 OR cpu_instruction_master_read_data_valid_lan91c111_s1) OR NOT cpu_instruction_master_requests_lan91c111_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((cpu_instruction_master_qualified_request_ext_flash_s1 OR (((cpu_instruction_master_read_data_valid_ext_flash_s1 AND internal_cpu_instruction_master_dbs_address(1)) AND internal_cpu_instruction_master_dbs_address(0)))) OR NOT cpu_instruction_master_requests_ext_flash_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((cpu_instruction_master_qualified_request_ext_ram_s1 OR cpu_instruction_master_read_data_valid_ext_ram_s1) OR NOT cpu_instruction_master_requests_ext_ram_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_granted_lan91c111_s1 OR NOT cpu_instruction_master_qualified_request_lan91c111_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_granted_ext_flash_s1 OR NOT cpu_instruction_master_qualified_request_ext_flash_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_granted_ext_ram_s1 OR NOT cpu_instruction_master_qualified_request_ext_ram_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((NOT cpu_instruction_master_qualified_request_lan91c111_s1 OR NOT cpu_instruction_master_read) OR ((cpu_instruction_master_read_data_valid_lan91c111_s1 AND cpu_instruction_master_read)))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((NOT cpu_instruction_master_qualified_request_ext_flash_s1 OR NOT cpu_instruction_master_read) OR (((cpu_instruction_master_read_data_valid_ext_flash_s1 AND ((internal_cpu_instruction_master_dbs_address(1) AND internal_cpu_instruction_master_dbs_address(0)))) AND cpu_instruction_master_read)))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((NOT cpu_instruction_master_qualified_request_ext_ram_s1 OR NOT cpu_instruction_master_read) OR ((cpu_instruction_master_read_data_valid_ext_ram_s1 AND cpu_instruction_master_read)))))))));
  --cascaded wait assignment, which is an e_assign
  internal_cpu_instruction_master_waitrequest <= NOT (((r_0 AND r_1) AND r_2));
  --r_1 cascaded wait assignment, which is an e_assign
  r_1 <= (((((cpu_instruction_master_qualified_request_onchip_ram_64_kbytes_s1 OR cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1) OR NOT cpu_instruction_master_requests_onchip_ram_64_kbytes_s1)) AND ((cpu_instruction_master_granted_onchip_ram_64_kbytes_s1 OR NOT cpu_instruction_master_qualified_request_onchip_ram_64_kbytes_s1))) AND (((NOT cpu_instruction_master_qualified_request_onchip_ram_64_kbytes_s1 OR NOT cpu_instruction_master_read) OR ((cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1 AND cpu_instruction_master_read))))) AND (((cpu_instruction_master_qualified_request_sdram_s1 OR cpu_instruction_master_read_data_valid_sdram_s1) OR NOT cpu_instruction_master_requests_sdram_s1));
  --r_2 cascaded wait assignment, which is an e_assign
  r_2 <= ((cpu_instruction_master_granted_sdram_s1 OR NOT cpu_instruction_master_qualified_request_sdram_s1)) AND (((NOT cpu_instruction_master_qualified_request_sdram_s1 OR NOT cpu_instruction_master_read) OR ((cpu_instruction_master_read_data_valid_sdram_s1 AND cpu_instruction_master_read))));
  --optimize select-logic by passing only those address bits which matter.
  internal_cpu_instruction_master_address_to_slave <= cpu_instruction_master_address(25 DOWNTO 0);
  --cpu/instruction_master readdata mux, which is an e_mux
  cpu_instruction_master_readdata <= A_EXT ((((((std_logic_vector'("000000000000000000000000") & ((((A_REP(NOT cpu_instruction_master_requests_cpu_jtag_debug_module, 32) OR cpu_jtag_debug_module_readdata_from_sa)) AND ((A_REP(NOT cpu_instruction_master_requests_lan91c111_s1, 32) OR incoming_ext_ram_bus_data))))) AND (((std_logic_vector'("000000000000000000000000") & (A_REP(NOT cpu_instruction_master_requests_ext_flash_s1, 32))) OR (incoming_ext_ram_bus_data & dbs_8_reg_segment_2 & dbs_8_reg_segment_1 & dbs_8_reg_segment_0)))) AND (std_logic_vector'("000000000000000000000000") & (((A_REP(NOT cpu_instruction_master_requests_ext_ram_s1, 32) OR incoming_ext_ram_bus_data))))) AND (std_logic_vector'("000000000000000000000000") & (((A_REP(NOT cpu_instruction_master_requests_onchip_ram_64_kbytes_s1, 32) OR onchip_ram_64_kbytes_s1_readdata_from_sa))))) AND (std_logic_vector'("000000000000000000000000") & (((A_REP(NOT cpu_instruction_master_requests_sdram_s1, 32) OR sdram_s1_readdata_from_sa))))), 32);
  --input to dbs-8 stored 0, which is an e_mux
  p1_dbs_8_reg_segment_0 <= incoming_ext_ram_bus_data (7 DOWNTO 0);
  --dbs register for dbs-8 segment 0, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_8_reg_segment_0 <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_count_enable AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & ((internal_cpu_instruction_master_dbs_address(1 DOWNTO 0)))) = std_logic_vector'("00000000000000000000000000000000")))))) = '1' then 
        dbs_8_reg_segment_0 <= p1_dbs_8_reg_segment_0;
      end if;
    end if;

  end process;

  --input to dbs-8 stored 1, which is an e_mux
  p1_dbs_8_reg_segment_1 <= incoming_ext_ram_bus_data (7 DOWNTO 0);
  --dbs register for dbs-8 segment 1, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_8_reg_segment_1 <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_count_enable AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & ((internal_cpu_instruction_master_dbs_address(1 DOWNTO 0)))) = std_logic_vector'("00000000000000000000000000000001")))))) = '1' then 
        dbs_8_reg_segment_1 <= p1_dbs_8_reg_segment_1;
      end if;
    end if;

  end process;

  --input to dbs-8 stored 2, which is an e_mux
  p1_dbs_8_reg_segment_2 <= incoming_ext_ram_bus_data (7 DOWNTO 0);
  --dbs register for dbs-8 segment 2, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_8_reg_segment_2 <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_count_enable AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & ((internal_cpu_instruction_master_dbs_address(1 DOWNTO 0)))) = std_logic_vector'("00000000000000000000000000000010")))))) = '1' then 
        dbs_8_reg_segment_2 <= p1_dbs_8_reg_segment_2;
      end if;
    end if;

  end process;

  --dbs count increment, which is an e_mux
  cpu_instruction_master_dbs_increment <= A_EXT (A_WE_StdLogicVector((std_logic'((cpu_instruction_master_requests_ext_flash_s1)) = '1'), std_logic_vector'("00000000000000000000000000000001"), std_logic_vector'("00000000000000000000000000000000")), 2);
  --dbs counter overflow, which is an e_assign
  dbs_counter_overflow <= internal_cpu_instruction_master_dbs_address(1) AND NOT((next_dbs_address(1)));
  --next master address, which is an e_assign
  next_dbs_address <= A_EXT (((std_logic_vector'("0") & (internal_cpu_instruction_master_dbs_address)) + (std_logic_vector'("0") & (cpu_instruction_master_dbs_increment))), 2);
  --dbs count enable, which is an e_mux
  dbs_count_enable <= pre_dbs_count_enable;
  --dbs counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_instruction_master_dbs_address <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(dbs_count_enable) = '1' then 
        internal_cpu_instruction_master_dbs_address <= next_dbs_address;
      end if;
    end if;

  end process;

  --pre dbs count enable, which is an e_mux
  pre_dbs_count_enable <= cpu_instruction_master_read_data_valid_ext_flash_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_address_to_slave <= internal_cpu_instruction_master_address_to_slave;
  --vhdl renameroo for output signals
  cpu_instruction_master_dbs_address <= internal_cpu_instruction_master_dbs_address;
  --vhdl renameroo for output signals
  cpu_instruction_master_waitrequest <= internal_cpu_instruction_master_waitrequest;
--synthesis translate_off
    --cpu_instruction_master_address check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_instruction_master_address_last_time <= std_logic_vector'("00000000000000000000000000");
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          cpu_instruction_master_address_last_time <= cpu_instruction_master_address;
        end if;
      end if;

    end process;

    --cpu/instruction_master waited last time, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        active_and_waiting_last_time <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          active_and_waiting_last_time <= internal_cpu_instruction_master_waitrequest AND (cpu_instruction_master_read);
        end if;
      end if;

    end process;

    --cpu_instruction_master_address matches last port_name, which is an e_process
    process (active_and_waiting_last_time, cpu_instruction_master_address, cpu_instruction_master_address_last_time)
    VARIABLE write_line2 : line;
    begin
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((cpu_instruction_master_address /= cpu_instruction_master_address_last_time))))) = '1' then 
          write(write_line2, now);
          write(write_line2, string'(": "));
          write(write_line2, string'("cpu_instruction_master_address did not heed wait!!!"));
          write(output, write_line2.all);
          deallocate (write_line2);
          assert false report "VHDL STOP" severity failure;
        end if;

    end process;

    --cpu_instruction_master_read check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_instruction_master_read_last_time <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          cpu_instruction_master_read_last_time <= cpu_instruction_master_read;
        end if;
      end if;

    end process;

    --cpu_instruction_master_read matches last port_name, which is an e_process
    process (active_and_waiting_last_time, cpu_instruction_master_read, cpu_instruction_master_read_last_time)
    VARIABLE write_line3 : line;
    begin
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((std_logic'(cpu_instruction_master_read) /= std_logic'(cpu_instruction_master_read_last_time)))))) = '1' then 
          write(write_line3, now);
          write(write_line3, string'(": "));
          write(write_line3, string'("cpu_instruction_master_read did not heed wait!!!"));
          write(output, write_line3.all);
          deallocate (write_line3);
          assert false report "VHDL STOP" severity failure;
        end if;

    end process;

--synthesis translate_on

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity ext_ram_bus_avalon_slave_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_dbs_write_8 : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal cpu_data_master_no_byte_enables_and_last_term : IN STD_LOGIC;
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                 signal cpu_instruction_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal irq_from_the_lan91c111 : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal be_n_to_the_ext_ram : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_byteenable_ext_flash_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_granted_ext_flash_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_granted_ext_ram_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_granted_lan91c111_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_ext_flash_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_ext_ram_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_lan91c111_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_ext_flash_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_ext_ram_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_lan91c111_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_ext_flash_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_ext_ram_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_lan91c111_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_ext_flash_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_ext_ram_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_lan91c111_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_ext_flash_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_ext_ram_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_lan91c111_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_ext_flash_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_ext_ram_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_lan91c111_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_requests_ext_flash_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_requests_ext_ram_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_requests_lan91c111_s1 : OUT STD_LOGIC;
                 signal d1_ext_ram_bus_avalon_slave_end_xfer : OUT STD_LOGIC;
                 signal d1_irq_from_the_lan91c111 : OUT STD_LOGIC;
                 signal ext_flash_s1_wait_counter_eq_0 : OUT STD_LOGIC;
                 signal ext_flash_s1_wait_counter_eq_1 : OUT STD_LOGIC;
                 signal ext_ram_bus_address : OUT STD_LOGIC_VECTOR (22 DOWNTO 0);
                 signal ext_ram_bus_byteenablen : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal ext_ram_bus_data : INOUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal ext_ram_bus_readn : OUT STD_LOGIC;
                 signal incoming_ext_ram_bus_data : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal incoming_ext_ram_bus_data_with_Xs_converted_to_0 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal ior_n_to_the_lan91c111 : OUT STD_LOGIC;
                 signal iow_n_to_the_lan91c111 : OUT STD_LOGIC;
                 signal lan91c111_s1_wait_counter_eq_0 : OUT STD_LOGIC;
                 signal read_n_to_the_ext_ram : OUT STD_LOGIC;
                 signal registered_cpu_data_master_read_data_valid_ext_flash_s1 : OUT STD_LOGIC;
                 signal registered_cpu_data_master_read_data_valid_ext_ram_s1 : OUT STD_LOGIC;
                 signal registered_cpu_data_master_read_data_valid_lan91c111_s1 : OUT STD_LOGIC;
                 signal reset_n_to_the_lan91c111 : OUT STD_LOGIC;
                 signal select_n_to_the_ext_flash : OUT STD_LOGIC;
                 signal select_n_to_the_ext_ram : OUT STD_LOGIC;
                 signal write_n_to_the_ext_flash : OUT STD_LOGIC;
                 signal write_n_to_the_ext_ram : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of ext_ram_bus_avalon_slave_arbitrator : entity is FALSE;
end entity ext_ram_bus_avalon_slave_arbitrator;


architecture europa of ext_ram_bus_avalon_slave_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_byteenable_ext_flash_s1_segment_0 :  STD_LOGIC;
                signal cpu_data_master_byteenable_ext_flash_s1_segment_1 :  STD_LOGIC;
                signal cpu_data_master_byteenable_ext_flash_s1_segment_2 :  STD_LOGIC;
                signal cpu_data_master_byteenable_ext_flash_s1_segment_3 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_ext_flash_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_read_data_valid_ext_flash_s1_shift_register_in :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_ext_ram_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_read_data_valid_ext_ram_s1_shift_register_in :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_lan91c111_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_read_data_valid_lan91c111_s1_shift_register_in :  STD_LOGIC;
                signal cpu_data_master_saved_grant_ext_flash_s1 :  STD_LOGIC;
                signal cpu_data_master_saved_grant_ext_ram_s1 :  STD_LOGIC;
                signal cpu_data_master_saved_grant_lan91c111_s1 :  STD_LOGIC;
                signal cpu_instruction_master_arbiterlock :  STD_LOGIC;
                signal cpu_instruction_master_continuerequest :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_ext_flash_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_instruction_master_read_data_valid_ext_flash_s1_shift_register_in :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register_in :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_lan91c111_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_instruction_master_read_data_valid_lan91c111_s1_shift_register_in :  STD_LOGIC;
                signal cpu_instruction_master_saved_grant_ext_flash_s1 :  STD_LOGIC;
                signal cpu_instruction_master_saved_grant_ext_ram_s1 :  STD_LOGIC;
                signal cpu_instruction_master_saved_grant_lan91c111_s1 :  STD_LOGIC;
                signal d1_in_a_write_cycle :  STD_LOGIC;
                signal d1_outgoing_ext_ram_bus_data :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal ext_flash_s1_counter_load_value :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal ext_flash_s1_in_a_read_cycle :  STD_LOGIC;
                signal ext_flash_s1_in_a_write_cycle :  STD_LOGIC;
                signal ext_flash_s1_pretend_byte_enable :  STD_LOGIC;
                signal ext_flash_s1_wait_counter :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal ext_flash_s1_waits_for_read :  STD_LOGIC;
                signal ext_flash_s1_waits_for_write :  STD_LOGIC;
                signal ext_flash_s1_with_write_latency :  STD_LOGIC;
                signal ext_ram_bus_avalon_slave_allgrants :  STD_LOGIC;
                signal ext_ram_bus_avalon_slave_allow_new_arb_cycle :  STD_LOGIC;
                signal ext_ram_bus_avalon_slave_any_continuerequest :  STD_LOGIC;
                signal ext_ram_bus_avalon_slave_arb_addend :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal ext_ram_bus_avalon_slave_arb_counter_enable :  STD_LOGIC;
                signal ext_ram_bus_avalon_slave_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal ext_ram_bus_avalon_slave_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal ext_ram_bus_avalon_slave_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal ext_ram_bus_avalon_slave_arb_winner :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal ext_ram_bus_avalon_slave_arbitration_holdoff_internal :  STD_LOGIC;
                signal ext_ram_bus_avalon_slave_beginbursttransfer_internal :  STD_LOGIC;
                signal ext_ram_bus_avalon_slave_begins_xfer :  STD_LOGIC;
                signal ext_ram_bus_avalon_slave_chosen_master_double_vector :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal ext_ram_bus_avalon_slave_chosen_master_rot_left :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal ext_ram_bus_avalon_slave_end_xfer :  STD_LOGIC;
                signal ext_ram_bus_avalon_slave_firsttransfer :  STD_LOGIC;
                signal ext_ram_bus_avalon_slave_grant_vector :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal ext_ram_bus_avalon_slave_master_qreq_vector :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal ext_ram_bus_avalon_slave_read_pending :  STD_LOGIC;
                signal ext_ram_bus_avalon_slave_saved_chosen_master_vector :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal ext_ram_bus_avalon_slave_slavearbiterlockenable :  STD_LOGIC;
                signal ext_ram_bus_avalon_slave_write_pending :  STD_LOGIC;
                signal ext_ram_s1_in_a_read_cycle :  STD_LOGIC;
                signal ext_ram_s1_in_a_write_cycle :  STD_LOGIC;
                signal ext_ram_s1_waits_for_read :  STD_LOGIC;
                signal ext_ram_s1_waits_for_write :  STD_LOGIC;
                signal ext_ram_s1_with_write_latency :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal incoming_ext_ram_bus_data_bit_0_is_x :  STD_LOGIC;
                signal incoming_ext_ram_bus_data_bit_1_is_x :  STD_LOGIC;
                signal incoming_ext_ram_bus_data_bit_2_is_x :  STD_LOGIC;
                signal incoming_ext_ram_bus_data_bit_3_is_x :  STD_LOGIC;
                signal incoming_ext_ram_bus_data_bit_4_is_x :  STD_LOGIC;
                signal incoming_ext_ram_bus_data_bit_5_is_x :  STD_LOGIC;
                signal incoming_ext_ram_bus_data_bit_6_is_x :  STD_LOGIC;
                signal incoming_ext_ram_bus_data_bit_7_is_x :  STD_LOGIC;
                signal internal_cpu_data_master_byteenable_ext_flash_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_granted_ext_flash_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_granted_ext_ram_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_granted_lan91c111_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_ext_flash_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_ext_ram_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_lan91c111_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_ext_flash_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_ext_ram_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_lan91c111_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_granted_ext_flash_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_granted_ext_ram_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_granted_lan91c111_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_qualified_request_ext_flash_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_qualified_request_ext_ram_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_qualified_request_lan91c111_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_requests_ext_flash_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_requests_ext_ram_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_requests_lan91c111_s1 :  STD_LOGIC;
                signal internal_ext_flash_s1_wait_counter_eq_0 :  STD_LOGIC;
                signal internal_incoming_ext_ram_bus_data :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_lan91c111_s1_wait_counter_eq_0 :  STD_LOGIC;
                signal lan91c111_s1_counter_load_value :  STD_LOGIC;
                signal lan91c111_s1_in_a_read_cycle :  STD_LOGIC;
                signal lan91c111_s1_in_a_write_cycle :  STD_LOGIC;
                signal lan91c111_s1_wait_counter :  STD_LOGIC;
                signal lan91c111_s1_waits_for_read :  STD_LOGIC;
                signal lan91c111_s1_waits_for_write :  STD_LOGIC;
                signal lan91c111_s1_with_write_latency :  STD_LOGIC;
                signal last_cycle_cpu_data_master_granted_slave_ext_flash_s1 :  STD_LOGIC;
                signal last_cycle_cpu_data_master_granted_slave_ext_ram_s1 :  STD_LOGIC;
                signal last_cycle_cpu_data_master_granted_slave_lan91c111_s1 :  STD_LOGIC;
                signal last_cycle_cpu_instruction_master_granted_slave_ext_flash_s1 :  STD_LOGIC;
                signal last_cycle_cpu_instruction_master_granted_slave_ext_ram_s1 :  STD_LOGIC;
                signal last_cycle_cpu_instruction_master_granted_slave_lan91c111_s1 :  STD_LOGIC;
                signal outgoing_ext_ram_bus_data :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal p1_be_n_to_the_ext_ram :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal p1_cpu_data_master_read_data_valid_ext_flash_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_cpu_data_master_read_data_valid_ext_ram_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_cpu_data_master_read_data_valid_lan91c111_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_cpu_instruction_master_read_data_valid_ext_flash_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_cpu_instruction_master_read_data_valid_lan91c111_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_ext_ram_bus_address :  STD_LOGIC_VECTOR (22 DOWNTO 0);
                signal p1_ext_ram_bus_byteenablen :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal p1_ext_ram_bus_readn :  STD_LOGIC;
                signal p1_ior_n_to_the_lan91c111 :  STD_LOGIC;
                signal p1_iow_n_to_the_lan91c111 :  STD_LOGIC;
                signal p1_read_n_to_the_ext_ram :  STD_LOGIC;
                signal p1_reset_n_to_the_lan91c111 :  STD_LOGIC;
                signal p1_select_n_to_the_ext_flash :  STD_LOGIC;
                signal p1_select_n_to_the_ext_ram :  STD_LOGIC;
                signal p1_write_n_to_the_ext_flash :  STD_LOGIC;
                signal p1_write_n_to_the_ext_ram :  STD_LOGIC;
                signal time_to_write :  STD_LOGIC;
                signal wait_for_ext_flash_s1_counter :  STD_LOGIC;
                signal wait_for_ext_ram_s1_counter :  STD_LOGIC;
                signal wait_for_lan91c111_s1_counter :  STD_LOGIC;
                signal write_n_to_the_ext_ram_local :  STD_LOGIC;
                signal write_n_to_the_ext_ram_mask :  STD_LOGIC;
                signal wrote_half_cycle_ext_ram_s1_last_time :  STD_LOGIC;
attribute ALTERA_ATTRIBUTE : string;
attribute ALTERA_ATTRIBUTE of be_n_to_the_ext_ram : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of d1_in_a_write_cycle : signal is "FAST_OUTPUT_ENABLE_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of d1_outgoing_ext_ram_bus_data : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of ext_ram_bus_address : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of ext_ram_bus_byteenablen : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of ext_ram_bus_readn : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of internal_incoming_ext_ram_bus_data : signal is "FAST_INPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of ior_n_to_the_lan91c111 : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of iow_n_to_the_lan91c111 : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of read_n_to_the_ext_ram : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of reset_n_to_the_lan91c111 : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of select_n_to_the_ext_flash : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of select_n_to_the_ext_ram : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of write_n_to_the_ext_flash : signal is "FAST_OUTPUT_REGISTER=ON";

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT ext_ram_bus_avalon_slave_end_xfer;
      end if;
    end if;

  end process;

  ext_ram_bus_avalon_slave_begins_xfer <= NOT d1_reasons_to_wait AND ((((((internal_cpu_data_master_qualified_request_lan91c111_s1 OR internal_cpu_instruction_master_qualified_request_lan91c111_s1) OR internal_cpu_data_master_qualified_request_ext_flash_s1) OR internal_cpu_instruction_master_qualified_request_ext_flash_s1) OR internal_cpu_data_master_qualified_request_ext_ram_s1) OR internal_cpu_instruction_master_qualified_request_ext_ram_s1));
  internal_cpu_data_master_requests_lan91c111_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(25 DOWNTO 16) & std_logic_vector'("0000000000000000")) = std_logic_vector'("10000100010000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --~select_n_to_the_ext_flash of type chipselect to ~p1_select_n_to_the_ext_flash, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      select_n_to_the_ext_flash <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        select_n_to_the_ext_flash <= p1_select_n_to_the_ext_flash;
      end if;
    end if;

  end process;

  --~select_n_to_the_ext_ram of type chipselect to ~p1_select_n_to_the_ext_ram, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      select_n_to_the_ext_ram <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        select_n_to_the_ext_ram <= p1_select_n_to_the_ext_ram;
      end if;
    end if;

  end process;

  ext_ram_bus_avalon_slave_write_pending <= std_logic'('0');
  --registered rdv signal_name registered_cpu_data_master_read_data_valid_lan91c111_s1 assignment, which is an e_assign
  registered_cpu_data_master_read_data_valid_lan91c111_s1 <= cpu_data_master_read_data_valid_lan91c111_s1_shift_register(0);
  ext_ram_bus_avalon_slave_read_pending <= std_logic'('0');
  --ext_ram_bus_avalon_slave_arb_share_counter set values, which is an e_mux
  ext_ram_bus_avalon_slave_arb_share_set_values <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_ext_flash_s1)) = '1'), std_logic_vector'("00000000000000000000000000000100"), A_WE_StdLogicVector((std_logic'((internal_cpu_instruction_master_granted_ext_flash_s1)) = '1'), std_logic_vector'("00000000000000000000000000000100"), A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_ext_flash_s1)) = '1'), std_logic_vector'("00000000000000000000000000000100"), A_WE_StdLogicVector((std_logic'((internal_cpu_instruction_master_granted_ext_flash_s1)) = '1'), std_logic_vector'("00000000000000000000000000000100"), std_logic_vector'("00000000000000000000000000000001"))))), 3);
  --ext_ram_bus_avalon_slave_arb_share_counter_next_value assignment, which is an e_assign
  ext_ram_bus_avalon_slave_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(ext_ram_bus_avalon_slave_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (ext_ram_bus_avalon_slave_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(ext_ram_bus_avalon_slave_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (ext_ram_bus_avalon_slave_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --ext_ram_bus_avalon_slave_allgrants all slave grants, which is an e_mux
  ext_ram_bus_avalon_slave_allgrants <= ((((((((((or_reduce(ext_ram_bus_avalon_slave_grant_vector) OR or_reduce(ext_ram_bus_avalon_slave_grant_vector)) OR or_reduce(ext_ram_bus_avalon_slave_grant_vector)) OR or_reduce(ext_ram_bus_avalon_slave_grant_vector)) OR or_reduce(ext_ram_bus_avalon_slave_grant_vector)) OR or_reduce(ext_ram_bus_avalon_slave_grant_vector)) OR or_reduce(ext_ram_bus_avalon_slave_grant_vector)) OR or_reduce(ext_ram_bus_avalon_slave_grant_vector)) OR or_reduce(ext_ram_bus_avalon_slave_grant_vector)) OR or_reduce(ext_ram_bus_avalon_slave_grant_vector)) OR or_reduce(ext_ram_bus_avalon_slave_grant_vector)) OR or_reduce(ext_ram_bus_avalon_slave_grant_vector);
  --ext_ram_bus_avalon_slave_end_xfer assignment, which is an e_assign
  ext_ram_bus_avalon_slave_end_xfer <= NOT ((((((lan91c111_s1_waits_for_read OR lan91c111_s1_waits_for_write) OR ext_flash_s1_waits_for_read) OR ext_flash_s1_waits_for_write) OR ext_ram_s1_waits_for_read) OR ext_ram_s1_waits_for_write));
  --ext_ram_bus_avalon_slave_arb_share_counter arbitration counter enable, which is an e_assign
  ext_ram_bus_avalon_slave_arb_counter_enable <= ext_ram_bus_avalon_slave_end_xfer AND ext_ram_bus_avalon_slave_allgrants;
  --ext_ram_bus_avalon_slave_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      ext_ram_bus_avalon_slave_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(ext_ram_bus_avalon_slave_arb_counter_enable) = '1' then 
        ext_ram_bus_avalon_slave_arb_share_counter <= ext_ram_bus_avalon_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --ext_ram_bus_avalon_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      ext_ram_bus_avalon_slave_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((or_reduce(ext_ram_bus_avalon_slave_master_qreq_vector) AND ext_ram_bus_avalon_slave_end_xfer)) = '1' then 
        ext_ram_bus_avalon_slave_slavearbiterlockenable <= or_reduce(ext_ram_bus_avalon_slave_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master ext_ram_bus/avalon_slave arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= ext_ram_bus_avalon_slave_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --cpu/instruction_master ext_ram_bus/avalon_slave arbiterlock, which is an e_assign
  cpu_instruction_master_arbiterlock <= ext_ram_bus_avalon_slave_slavearbiterlockenable AND cpu_instruction_master_continuerequest;
  --cpu/instruction_master granted lan91c111/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_instruction_master_granted_slave_lan91c111_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_instruction_master_granted_slave_lan91c111_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_instruction_master_saved_grant_lan91c111_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((ext_ram_bus_avalon_slave_arbitration_holdoff_internal OR NOT internal_cpu_instruction_master_requests_lan91c111_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_instruction_master_granted_slave_lan91c111_s1))))));
      end if;
    end if;

  end process;

  --cpu_instruction_master_continuerequest continued request, which is an e_mux
  cpu_instruction_master_continuerequest <= (((last_cycle_cpu_instruction_master_granted_slave_lan91c111_s1 AND internal_cpu_instruction_master_requests_lan91c111_s1)) OR ((last_cycle_cpu_instruction_master_granted_slave_ext_flash_s1 AND internal_cpu_instruction_master_requests_ext_flash_s1))) OR ((last_cycle_cpu_instruction_master_granted_slave_ext_ram_s1 AND internal_cpu_instruction_master_requests_ext_ram_s1));
  --ext_ram_bus_avalon_slave_any_continuerequest at least one master continues requesting, which is an e_mux
  ext_ram_bus_avalon_slave_any_continuerequest <= ((((cpu_instruction_master_continuerequest OR cpu_instruction_master_continuerequest) OR cpu_instruction_master_continuerequest) OR cpu_data_master_continuerequest) OR cpu_data_master_continuerequest) OR cpu_data_master_continuerequest;
  internal_cpu_data_master_qualified_request_lan91c111_s1 <= internal_cpu_data_master_requests_lan91c111_s1 AND NOT (((((cpu_data_master_read AND ((ext_ram_bus_avalon_slave_write_pending OR (or_reduce(cpu_data_master_read_data_valid_lan91c111_s1_shift_register)))))) OR (((ext_ram_bus_avalon_slave_read_pending) AND cpu_data_master_write))) OR cpu_instruction_master_arbiterlock));
  --cpu_data_master_read_data_valid_lan91c111_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_data_master_read_data_valid_lan91c111_s1_shift_register_in <= ((internal_cpu_data_master_granted_lan91c111_s1 AND cpu_data_master_read) AND NOT lan91c111_s1_waits_for_read) AND NOT (or_reduce(cpu_data_master_read_data_valid_lan91c111_s1_shift_register));
  --shift register p1 cpu_data_master_read_data_valid_lan91c111_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_data_master_read_data_valid_lan91c111_s1_shift_register <= A_EXT ((cpu_data_master_read_data_valid_lan91c111_s1_shift_register & A_ToStdLogicVector(cpu_data_master_read_data_valid_lan91c111_s1_shift_register_in)), 2);
  --cpu_data_master_read_data_valid_lan91c111_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_data_master_read_data_valid_lan91c111_s1_shift_register <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_data_master_read_data_valid_lan91c111_s1_shift_register <= p1_cpu_data_master_read_data_valid_lan91c111_s1_shift_register;
      end if;
    end if;

  end process;

  --local readdatavalid cpu_data_master_read_data_valid_lan91c111_s1, which is an e_mux
  cpu_data_master_read_data_valid_lan91c111_s1 <= cpu_data_master_read_data_valid_lan91c111_s1_shift_register(1);
  --ext_ram_bus_data register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_incoming_ext_ram_bus_data <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        internal_incoming_ext_ram_bus_data <= ext_ram_bus_data;
      end if;
    end if;

  end process;

  --lan91c111_s1_with_write_latency assignment, which is an e_assign
  lan91c111_s1_with_write_latency <= in_a_write_cycle AND ((internal_cpu_data_master_qualified_request_lan91c111_s1 OR internal_cpu_instruction_master_qualified_request_lan91c111_s1));
  --time to write the data, which is an e_mux
  time_to_write <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((lan91c111_s1_with_write_latency)) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'((ext_flash_s1_with_write_latency)) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'((ext_ram_s1_with_write_latency)) = '1'), std_logic_vector'("00000000000000000000000000000001"), std_logic_vector'("00000000000000000000000000000000")))));
  --d1_outgoing_ext_ram_bus_data register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_outgoing_ext_ram_bus_data <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_outgoing_ext_ram_bus_data <= outgoing_ext_ram_bus_data;
      end if;
    end if;

  end process;

  --write cycle delayed by 1, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_in_a_write_cycle <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_in_a_write_cycle <= time_to_write;
      end if;
    end if;

  end process;

  --d1_outgoing_ext_ram_bus_data tristate driver, which is an e_assign
  ext_ram_bus_data <= A_WE_StdLogicVector((std_logic'((d1_in_a_write_cycle)) = '1'), d1_outgoing_ext_ram_bus_data, A_REP(std_logic'('Z'), 32));
  --outgoing_ext_ram_bus_data mux, which is an e_mux
  outgoing_ext_ram_bus_data <= A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_lan91c111_s1)) = '1'), cpu_data_master_writedata, A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_ext_flash_s1)) = '1'), (std_logic_vector'("000000000000000000000000") & (cpu_data_master_dbs_write_8)), cpu_data_master_writedata));
  internal_cpu_data_master_requests_ext_flash_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(25 DOWNTO 23) & std_logic_vector'("00000000000000000000000")) = std_logic_vector'("00000000000000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --registered rdv signal_name registered_cpu_data_master_read_data_valid_ext_flash_s1 assignment, which is an e_assign
  registered_cpu_data_master_read_data_valid_ext_flash_s1 <= cpu_data_master_read_data_valid_ext_flash_s1_shift_register(0);
  --cpu/instruction_master granted ext_flash/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_instruction_master_granted_slave_ext_flash_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_instruction_master_granted_slave_ext_flash_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_instruction_master_saved_grant_ext_flash_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((ext_ram_bus_avalon_slave_arbitration_holdoff_internal OR NOT internal_cpu_instruction_master_requests_ext_flash_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_instruction_master_granted_slave_ext_flash_s1))))));
      end if;
    end if;

  end process;

  internal_cpu_data_master_qualified_request_ext_flash_s1 <= internal_cpu_data_master_requests_ext_flash_s1 AND NOT (((((cpu_data_master_read AND ((ext_ram_bus_avalon_slave_write_pending OR (or_reduce(cpu_data_master_read_data_valid_ext_flash_s1_shift_register)))))) OR (((((ext_ram_bus_avalon_slave_read_pending OR cpu_data_master_no_byte_enables_and_last_term) OR NOT(internal_cpu_data_master_byteenable_ext_flash_s1))) AND cpu_data_master_write))) OR cpu_instruction_master_arbiterlock));
  --cpu_data_master_read_data_valid_ext_flash_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_data_master_read_data_valid_ext_flash_s1_shift_register_in <= ((internal_cpu_data_master_granted_ext_flash_s1 AND cpu_data_master_read) AND NOT ext_flash_s1_waits_for_read) AND NOT (or_reduce(cpu_data_master_read_data_valid_ext_flash_s1_shift_register));
  --shift register p1 cpu_data_master_read_data_valid_ext_flash_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_data_master_read_data_valid_ext_flash_s1_shift_register <= A_EXT ((cpu_data_master_read_data_valid_ext_flash_s1_shift_register & A_ToStdLogicVector(cpu_data_master_read_data_valid_ext_flash_s1_shift_register_in)), 2);
  --cpu_data_master_read_data_valid_ext_flash_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_data_master_read_data_valid_ext_flash_s1_shift_register <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_data_master_read_data_valid_ext_flash_s1_shift_register <= p1_cpu_data_master_read_data_valid_ext_flash_s1_shift_register;
      end if;
    end if;

  end process;

  --local readdatavalid cpu_data_master_read_data_valid_ext_flash_s1, which is an e_mux
  cpu_data_master_read_data_valid_ext_flash_s1 <= cpu_data_master_read_data_valid_ext_flash_s1_shift_register(1);
  --ext_flash_s1_with_write_latency assignment, which is an e_assign
  ext_flash_s1_with_write_latency <= in_a_write_cycle AND ((internal_cpu_data_master_qualified_request_ext_flash_s1 OR internal_cpu_instruction_master_qualified_request_ext_flash_s1));
  internal_cpu_data_master_requests_ext_ram_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(25 DOWNTO 20) & std_logic_vector'("00000000000000000000")) = std_logic_vector'("10000000000000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --registered rdv signal_name registered_cpu_data_master_read_data_valid_ext_ram_s1 assignment, which is an e_assign
  registered_cpu_data_master_read_data_valid_ext_ram_s1 <= cpu_data_master_read_data_valid_ext_ram_s1_shift_register(0);
  --shortening pos_edge ~write_n_to_the_ext_ram of type write to ~p1_write_n_to_the_ext_ram, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      write_n_to_the_ext_ram_local <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        write_n_to_the_ext_ram_local <= p1_write_n_to_the_ext_ram;
      end if;
    end if;

  end process;

  --shortening neg_edge ~write_n_to_the_ext_ram of type write to ~p1_write_n_to_the_ext_ram, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      write_n_to_the_ext_ram_mask <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '0' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        write_n_to_the_ext_ram_mask <= write_n_to_the_ext_ram_local;
      end if;
    end if;

  end process;

  --shortening assignment ~write_n_to_the_ext_ram of type write to ~p1_write_n_to_the_ext_ram, which is an e_assign
  write_n_to_the_ext_ram <= NOT ((NOT write_n_to_the_ext_ram_local AND write_n_to_the_ext_ram_mask));
  --wrote_half_cycle_ext_ram_s1_last_time register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      wrote_half_cycle_ext_ram_s1_last_time <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        wrote_half_cycle_ext_ram_s1_last_time <= NOT p1_write_n_to_the_ext_ram;
      end if;
    end if;

  end process;

  --cpu/instruction_master granted ext_ram/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_instruction_master_granted_slave_ext_ram_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_instruction_master_granted_slave_ext_ram_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_instruction_master_saved_grant_ext_ram_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((ext_ram_bus_avalon_slave_arbitration_holdoff_internal OR NOT internal_cpu_instruction_master_requests_ext_ram_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_instruction_master_granted_slave_ext_ram_s1))))));
      end if;
    end if;

  end process;

  internal_cpu_data_master_qualified_request_ext_ram_s1 <= internal_cpu_data_master_requests_ext_ram_s1 AND NOT (((((cpu_data_master_read AND ((ext_ram_bus_avalon_slave_write_pending OR (or_reduce(cpu_data_master_read_data_valid_ext_ram_s1_shift_register)))))) OR (((((wrote_half_cycle_ext_ram_s1_last_time OR NOT cpu_data_master_waitrequest) OR ext_ram_bus_avalon_slave_read_pending)) AND cpu_data_master_write))) OR cpu_instruction_master_arbiterlock));
  --cpu_data_master_read_data_valid_ext_ram_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_data_master_read_data_valid_ext_ram_s1_shift_register_in <= ((internal_cpu_data_master_granted_ext_ram_s1 AND cpu_data_master_read) AND NOT ext_ram_s1_waits_for_read) AND NOT (or_reduce(cpu_data_master_read_data_valid_ext_ram_s1_shift_register));
  --shift register p1 cpu_data_master_read_data_valid_ext_ram_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_data_master_read_data_valid_ext_ram_s1_shift_register <= A_EXT ((cpu_data_master_read_data_valid_ext_ram_s1_shift_register & A_ToStdLogicVector(cpu_data_master_read_data_valid_ext_ram_s1_shift_register_in)), 2);
  --cpu_data_master_read_data_valid_ext_ram_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_data_master_read_data_valid_ext_ram_s1_shift_register <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_data_master_read_data_valid_ext_ram_s1_shift_register <= p1_cpu_data_master_read_data_valid_ext_ram_s1_shift_register;
      end if;
    end if;

  end process;

  --local readdatavalid cpu_data_master_read_data_valid_ext_ram_s1, which is an e_mux
  cpu_data_master_read_data_valid_ext_ram_s1 <= cpu_data_master_read_data_valid_ext_ram_s1_shift_register(1);
  --ext_ram_s1_with_write_latency assignment, which is an e_assign
  ext_ram_s1_with_write_latency <= in_a_write_cycle AND ((internal_cpu_data_master_qualified_request_ext_ram_s1 OR internal_cpu_instruction_master_qualified_request_ext_ram_s1));
  internal_cpu_instruction_master_requests_lan91c111_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_instruction_master_address_to_slave(25 DOWNTO 16) & std_logic_vector'("0000000000000000")) = std_logic_vector'("10000100010000000000000000")))) AND (cpu_instruction_master_read);
  --cpu/data_master granted lan91c111/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_data_master_granted_slave_lan91c111_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_data_master_granted_slave_lan91c111_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_data_master_saved_grant_lan91c111_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((ext_ram_bus_avalon_slave_arbitration_holdoff_internal OR NOT internal_cpu_data_master_requests_lan91c111_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_data_master_granted_slave_lan91c111_s1))))));
      end if;
    end if;

  end process;

  --cpu_data_master_continuerequest continued request, which is an e_mux
  cpu_data_master_continuerequest <= (((last_cycle_cpu_data_master_granted_slave_lan91c111_s1 AND internal_cpu_data_master_requests_lan91c111_s1)) OR ((last_cycle_cpu_data_master_granted_slave_ext_flash_s1 AND internal_cpu_data_master_requests_ext_flash_s1))) OR ((last_cycle_cpu_data_master_granted_slave_ext_ram_s1 AND internal_cpu_data_master_requests_ext_ram_s1));
  internal_cpu_instruction_master_qualified_request_lan91c111_s1 <= internal_cpu_instruction_master_requests_lan91c111_s1 AND NOT ((((cpu_instruction_master_read AND ((ext_ram_bus_avalon_slave_write_pending OR (or_reduce(cpu_instruction_master_read_data_valid_lan91c111_s1_shift_register)))))) OR cpu_data_master_arbiterlock));
  --cpu_instruction_master_read_data_valid_lan91c111_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_instruction_master_read_data_valid_lan91c111_s1_shift_register_in <= ((internal_cpu_instruction_master_granted_lan91c111_s1 AND cpu_instruction_master_read) AND NOT lan91c111_s1_waits_for_read) AND NOT (or_reduce(cpu_instruction_master_read_data_valid_lan91c111_s1_shift_register));
  --shift register p1 cpu_instruction_master_read_data_valid_lan91c111_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_instruction_master_read_data_valid_lan91c111_s1_shift_register <= A_EXT ((cpu_instruction_master_read_data_valid_lan91c111_s1_shift_register & A_ToStdLogicVector(cpu_instruction_master_read_data_valid_lan91c111_s1_shift_register_in)), 2);
  --cpu_instruction_master_read_data_valid_lan91c111_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_instruction_master_read_data_valid_lan91c111_s1_shift_register <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_instruction_master_read_data_valid_lan91c111_s1_shift_register <= p1_cpu_instruction_master_read_data_valid_lan91c111_s1_shift_register;
      end if;
    end if;

  end process;

  --local readdatavalid cpu_instruction_master_read_data_valid_lan91c111_s1, which is an e_mux
  cpu_instruction_master_read_data_valid_lan91c111_s1 <= cpu_instruction_master_read_data_valid_lan91c111_s1_shift_register(1);
  internal_cpu_instruction_master_requests_ext_flash_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_instruction_master_address_to_slave(25 DOWNTO 23) & std_logic_vector'("00000000000000000000000")) = std_logic_vector'("00000000000000000000000000")))) AND (cpu_instruction_master_read);
  --cpu/data_master granted ext_flash/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_data_master_granted_slave_ext_flash_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_data_master_granted_slave_ext_flash_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_data_master_saved_grant_ext_flash_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((ext_ram_bus_avalon_slave_arbitration_holdoff_internal OR NOT internal_cpu_data_master_requests_ext_flash_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_data_master_granted_slave_ext_flash_s1))))));
      end if;
    end if;

  end process;

  internal_cpu_instruction_master_qualified_request_ext_flash_s1 <= internal_cpu_instruction_master_requests_ext_flash_s1 AND NOT ((((cpu_instruction_master_read AND ((ext_ram_bus_avalon_slave_write_pending OR (or_reduce(cpu_instruction_master_read_data_valid_ext_flash_s1_shift_register)))))) OR cpu_data_master_arbiterlock));
  --cpu_instruction_master_read_data_valid_ext_flash_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_instruction_master_read_data_valid_ext_flash_s1_shift_register_in <= ((internal_cpu_instruction_master_granted_ext_flash_s1 AND cpu_instruction_master_read) AND NOT ext_flash_s1_waits_for_read) AND NOT (or_reduce(cpu_instruction_master_read_data_valid_ext_flash_s1_shift_register));
  --shift register p1 cpu_instruction_master_read_data_valid_ext_flash_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_instruction_master_read_data_valid_ext_flash_s1_shift_register <= A_EXT ((cpu_instruction_master_read_data_valid_ext_flash_s1_shift_register & A_ToStdLogicVector(cpu_instruction_master_read_data_valid_ext_flash_s1_shift_register_in)), 2);
  --cpu_instruction_master_read_data_valid_ext_flash_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_instruction_master_read_data_valid_ext_flash_s1_shift_register <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_instruction_master_read_data_valid_ext_flash_s1_shift_register <= p1_cpu_instruction_master_read_data_valid_ext_flash_s1_shift_register;
      end if;
    end if;

  end process;

  --local readdatavalid cpu_instruction_master_read_data_valid_ext_flash_s1, which is an e_mux
  cpu_instruction_master_read_data_valid_ext_flash_s1 <= cpu_instruction_master_read_data_valid_ext_flash_s1_shift_register(1);
  internal_cpu_instruction_master_requests_ext_ram_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_instruction_master_address_to_slave(25 DOWNTO 20) & std_logic_vector'("00000000000000000000")) = std_logic_vector'("10000000000000000000000000")))) AND (cpu_instruction_master_read);
  --cpu/data_master granted ext_ram/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_data_master_granted_slave_ext_ram_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_data_master_granted_slave_ext_ram_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_data_master_saved_grant_ext_ram_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((ext_ram_bus_avalon_slave_arbitration_holdoff_internal OR NOT internal_cpu_data_master_requests_ext_ram_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_data_master_granted_slave_ext_ram_s1))))));
      end if;
    end if;

  end process;

  internal_cpu_instruction_master_qualified_request_ext_ram_s1 <= internal_cpu_instruction_master_requests_ext_ram_s1 AND NOT ((((cpu_instruction_master_read AND ((ext_ram_bus_avalon_slave_write_pending OR (or_reduce(cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register)))))) OR cpu_data_master_arbiterlock));
  --cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register_in <= ((internal_cpu_instruction_master_granted_ext_ram_s1 AND cpu_instruction_master_read) AND NOT ext_ram_s1_waits_for_read) AND NOT (or_reduce(cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register));
  --shift register p1 cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register <= A_EXT ((cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register & A_ToStdLogicVector(cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register_in)), 2);
  --cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register <= p1_cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register;
      end if;
    end if;

  end process;

  --local readdatavalid cpu_instruction_master_read_data_valid_ext_ram_s1, which is an e_mux
  cpu_instruction_master_read_data_valid_ext_ram_s1 <= cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register(1);
  --allow new arb cycle for ext_ram_bus/avalon_slave, which is an e_assign
  ext_ram_bus_avalon_slave_allow_new_arb_cycle <= NOT cpu_data_master_arbiterlock AND NOT cpu_instruction_master_arbiterlock;
  --cpu/instruction_master assignment into master qualified-requests vector for lan91c111/s1, which is an e_assign
  ext_ram_bus_avalon_slave_master_qreq_vector(0) <= internal_cpu_instruction_master_qualified_request_lan91c111_s1;
  --cpu/instruction_master grant lan91c111/s1, which is an e_assign
  internal_cpu_instruction_master_granted_lan91c111_s1 <= ext_ram_bus_avalon_slave_grant_vector(0);
  --cpu/instruction_master saved-grant lan91c111/s1, which is an e_assign
  cpu_instruction_master_saved_grant_lan91c111_s1 <= ext_ram_bus_avalon_slave_arb_winner(0) AND internal_cpu_instruction_master_requests_lan91c111_s1;
  --cpu/data_master assignment into master qualified-requests vector for lan91c111/s1, which is an e_assign
  ext_ram_bus_avalon_slave_master_qreq_vector(1) <= internal_cpu_data_master_qualified_request_lan91c111_s1;
  --cpu/data_master grant lan91c111/s1, which is an e_assign
  internal_cpu_data_master_granted_lan91c111_s1 <= ext_ram_bus_avalon_slave_grant_vector(1);
  --cpu/data_master saved-grant lan91c111/s1, which is an e_assign
  cpu_data_master_saved_grant_lan91c111_s1 <= ext_ram_bus_avalon_slave_arb_winner(1) AND internal_cpu_data_master_requests_lan91c111_s1;
  --cpu/instruction_master assignment into master qualified-requests vector for ext_flash/s1, which is an e_assign
  ext_ram_bus_avalon_slave_master_qreq_vector(2) <= internal_cpu_instruction_master_qualified_request_ext_flash_s1;
  --cpu/instruction_master grant ext_flash/s1, which is an e_assign
  internal_cpu_instruction_master_granted_ext_flash_s1 <= ext_ram_bus_avalon_slave_grant_vector(2);
  --cpu/instruction_master saved-grant ext_flash/s1, which is an e_assign
  cpu_instruction_master_saved_grant_ext_flash_s1 <= ext_ram_bus_avalon_slave_arb_winner(2) AND internal_cpu_instruction_master_requests_ext_flash_s1;
  --cpu/data_master assignment into master qualified-requests vector for ext_flash/s1, which is an e_assign
  ext_ram_bus_avalon_slave_master_qreq_vector(3) <= internal_cpu_data_master_qualified_request_ext_flash_s1;
  --cpu/data_master grant ext_flash/s1, which is an e_assign
  internal_cpu_data_master_granted_ext_flash_s1 <= ext_ram_bus_avalon_slave_grant_vector(3);
  --cpu/data_master saved-grant ext_flash/s1, which is an e_assign
  cpu_data_master_saved_grant_ext_flash_s1 <= ext_ram_bus_avalon_slave_arb_winner(3) AND internal_cpu_data_master_requests_ext_flash_s1;
  --cpu/instruction_master assignment into master qualified-requests vector for ext_ram/s1, which is an e_assign
  ext_ram_bus_avalon_slave_master_qreq_vector(4) <= internal_cpu_instruction_master_qualified_request_ext_ram_s1;
  --cpu/instruction_master grant ext_ram/s1, which is an e_assign
  internal_cpu_instruction_master_granted_ext_ram_s1 <= ext_ram_bus_avalon_slave_grant_vector(4);
  --cpu/instruction_master saved-grant ext_ram/s1, which is an e_assign
  cpu_instruction_master_saved_grant_ext_ram_s1 <= ext_ram_bus_avalon_slave_arb_winner(4) AND internal_cpu_instruction_master_requests_ext_ram_s1;
  --cpu/data_master assignment into master qualified-requests vector for ext_ram/s1, which is an e_assign
  ext_ram_bus_avalon_slave_master_qreq_vector(5) <= internal_cpu_data_master_qualified_request_ext_ram_s1;
  --cpu/data_master grant ext_ram/s1, which is an e_assign
  internal_cpu_data_master_granted_ext_ram_s1 <= ext_ram_bus_avalon_slave_grant_vector(5);
  --cpu/data_master saved-grant ext_ram/s1, which is an e_assign
  cpu_data_master_saved_grant_ext_ram_s1 <= ext_ram_bus_avalon_slave_arb_winner(5) AND internal_cpu_data_master_requests_ext_ram_s1;
  --ext_ram_bus/avalon_slave chosen-master double-vector, which is an e_assign
  ext_ram_bus_avalon_slave_chosen_master_double_vector <= A_EXT (((std_logic_vector'("0") & ((ext_ram_bus_avalon_slave_master_qreq_vector & ext_ram_bus_avalon_slave_master_qreq_vector))) AND (((std_logic_vector'("0") & (Std_Logic_Vector'(NOT ext_ram_bus_avalon_slave_master_qreq_vector & NOT ext_ram_bus_avalon_slave_master_qreq_vector))) + (std_logic_vector'("0000000") & (ext_ram_bus_avalon_slave_arb_addend))))), 12);
  --stable onehot encoding of arb winner
  ext_ram_bus_avalon_slave_arb_winner <= A_WE_StdLogicVector((std_logic'(((ext_ram_bus_avalon_slave_allow_new_arb_cycle AND or_reduce(ext_ram_bus_avalon_slave_grant_vector)))) = '1'), ext_ram_bus_avalon_slave_grant_vector, ext_ram_bus_avalon_slave_saved_chosen_master_vector);
  --saved ext_ram_bus_avalon_slave_grant_vector, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      ext_ram_bus_avalon_slave_saved_chosen_master_vector <= std_logic_vector'("000000");
    elsif clk'event and clk = '1' then
      if std_logic'(ext_ram_bus_avalon_slave_allow_new_arb_cycle) = '1' then 
        ext_ram_bus_avalon_slave_saved_chosen_master_vector <= A_WE_StdLogicVector((std_logic'(or_reduce(ext_ram_bus_avalon_slave_grant_vector)) = '1'), ext_ram_bus_avalon_slave_grant_vector, ext_ram_bus_avalon_slave_saved_chosen_master_vector);
      end if;
    end if;

  end process;

  --onehot encoding of chosen master
  ext_ram_bus_avalon_slave_grant_vector <= Std_Logic_Vector'(A_ToStdLogicVector(((ext_ram_bus_avalon_slave_chosen_master_double_vector(5) OR ext_ram_bus_avalon_slave_chosen_master_double_vector(11)))) & A_ToStdLogicVector(((ext_ram_bus_avalon_slave_chosen_master_double_vector(4) OR ext_ram_bus_avalon_slave_chosen_master_double_vector(10)))) & A_ToStdLogicVector(((ext_ram_bus_avalon_slave_chosen_master_double_vector(3) OR ext_ram_bus_avalon_slave_chosen_master_double_vector(9)))) & A_ToStdLogicVector(((ext_ram_bus_avalon_slave_chosen_master_double_vector(2) OR ext_ram_bus_avalon_slave_chosen_master_double_vector(8)))) & A_ToStdLogicVector(((ext_ram_bus_avalon_slave_chosen_master_double_vector(1) OR ext_ram_bus_avalon_slave_chosen_master_double_vector(7)))) & A_ToStdLogicVector(((ext_ram_bus_avalon_slave_chosen_master_double_vector(0) OR ext_ram_bus_avalon_slave_chosen_master_double_vector(6)))));
  --ext_ram_bus/avalon_slave chosen master rotated left, which is an e_assign
  ext_ram_bus_avalon_slave_chosen_master_rot_left <= A_EXT (A_WE_StdLogicVector((((A_SLL(ext_ram_bus_avalon_slave_arb_winner,std_logic_vector'("00000000000000000000000000000001")))) /= std_logic_vector'("000000")), (std_logic_vector'("00000000000000000000000000") & ((A_SLL(ext_ram_bus_avalon_slave_arb_winner,std_logic_vector'("00000000000000000000000000000001"))))), std_logic_vector'("00000000000000000000000000000001")), 6);
  --ext_ram_bus/avalon_slave's addend for next-master-grant
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      ext_ram_bus_avalon_slave_arb_addend <= std_logic_vector'("000001");
    elsif clk'event and clk = '1' then
      if std_logic'(or_reduce(ext_ram_bus_avalon_slave_grant_vector)) = '1' then 
        ext_ram_bus_avalon_slave_arb_addend <= A_WE_StdLogicVector((std_logic'(ext_ram_bus_avalon_slave_end_xfer) = '1'), ext_ram_bus_avalon_slave_chosen_master_rot_left, ext_ram_bus_avalon_slave_grant_vector);
      end if;
    end if;

  end process;

  --ext_ram_bus_avalon_slave_firsttransfer first transaction, which is an e_assign
  ext_ram_bus_avalon_slave_firsttransfer <= NOT ((ext_ram_bus_avalon_slave_slavearbiterlockenable AND ext_ram_bus_avalon_slave_any_continuerequest));
  --ext_ram_bus_avalon_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  ext_ram_bus_avalon_slave_beginbursttransfer_internal <= ext_ram_bus_avalon_slave_begins_xfer AND ext_ram_bus_avalon_slave_firsttransfer;
  --ext_ram_bus_avalon_slave_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  ext_ram_bus_avalon_slave_arbitration_holdoff_internal <= ext_ram_bus_avalon_slave_begins_xfer AND ext_ram_bus_avalon_slave_firsttransfer;
  --reset_n_to_the_lan91c111 of type reset_n to p1_reset_n_to_the_lan91c111, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      reset_n_to_the_lan91c111 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        reset_n_to_the_lan91c111 <= p1_reset_n_to_the_lan91c111;
      end if;
    end if;

  end process;

  --p1_reset_n_to_the_lan91c111 assignment, which is an e_assign
  p1_reset_n_to_the_lan91c111 <= reset_n;
  --~ior_n_to_the_lan91c111 of type read to ~p1_ior_n_to_the_lan91c111, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      ior_n_to_the_lan91c111 <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        ior_n_to_the_lan91c111 <= p1_ior_n_to_the_lan91c111;
      end if;
    end if;

  end process;

  --~iow_n_to_the_lan91c111 of type write to ~p1_iow_n_to_the_lan91c111, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      iow_n_to_the_lan91c111 <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        iow_n_to_the_lan91c111 <= p1_iow_n_to_the_lan91c111;
      end if;
    end if;

  end process;

  --~p1_ior_n_to_the_lan91c111 assignment, which is an e_mux
  p1_ior_n_to_the_lan91c111 <= NOT ((((((internal_cpu_data_master_granted_lan91c111_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_lan91c111_s1 AND cpu_instruction_master_read)))) AND NOT ext_ram_bus_avalon_slave_begins_xfer));
  --~ext_ram_bus_byteenablen of type byteenable to ~p1_ext_ram_bus_byteenablen, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      ext_ram_bus_byteenablen <= A_EXT (NOT std_logic_vector'("00000000000000000000000000000000"), 4);
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        ext_ram_bus_byteenablen <= p1_ext_ram_bus_byteenablen;
      end if;
    end if;

  end process;

  --~p1_iow_n_to_the_lan91c111 assignment, which is an e_mux
  p1_iow_n_to_the_lan91c111 <= NOT (((((internal_cpu_data_master_granted_lan91c111_s1 AND cpu_data_master_write)) AND NOT ext_ram_bus_avalon_slave_begins_xfer) AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(lan91c111_s1_wait_counter)))>=std_logic_vector'("00000000000000000000000000000001"))))));
  --ext_ram_bus_address of type address to p1_ext_ram_bus_address, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      ext_ram_bus_address <= std_logic_vector'("00000000000000000000000");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        ext_ram_bus_address <= p1_ext_ram_bus_address;
      end if;
    end if;

  end process;

  --p1_ext_ram_bus_address mux, which is an e_mux
  p1_ext_ram_bus_address <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_lan91c111_s1)) = '1'), (std_logic_vector'("00") & (cpu_data_master_address_to_slave)), A_WE_StdLogicVector((std_logic'((internal_cpu_instruction_master_granted_lan91c111_s1)) = '1'), (std_logic_vector'("00") & (cpu_instruction_master_address_to_slave)), A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_ext_flash_s1)) = '1'), (Std_Logic_Vector'(A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")) & cpu_data_master_dbs_address(1 DOWNTO 0))), A_WE_StdLogicVector((std_logic'((internal_cpu_instruction_master_granted_ext_flash_s1)) = '1'), (Std_Logic_Vector'(A_SRL(cpu_instruction_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")) & cpu_instruction_master_dbs_address(1 DOWNTO 0))), (std_logic_vector'("00") & (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_ext_ram_s1)) = '1'), cpu_data_master_address_to_slave, cpu_instruction_master_address_to_slave))))))), 23);
  --d1_ext_ram_bus_avalon_slave_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_ext_ram_bus_avalon_slave_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_ext_ram_bus_avalon_slave_end_xfer <= ext_ram_bus_avalon_slave_end_xfer;
      end if;
    end if;

  end process;

  --lan91c111_s1_waits_for_read in a cycle, which is an e_mux
  lan91c111_s1_waits_for_read <= lan91c111_s1_in_a_read_cycle AND ext_ram_bus_avalon_slave_begins_xfer;
  --lan91c111_s1_in_a_read_cycle assignment, which is an e_assign
  lan91c111_s1_in_a_read_cycle <= ((internal_cpu_data_master_granted_lan91c111_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_lan91c111_s1 AND cpu_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= (lan91c111_s1_in_a_read_cycle OR ext_flash_s1_in_a_read_cycle) OR ext_ram_s1_in_a_read_cycle;
  --lan91c111_s1_waits_for_write in a cycle, which is an e_mux
  lan91c111_s1_waits_for_write <= lan91c111_s1_in_a_write_cycle AND wait_for_lan91c111_s1_counter;
  --lan91c111_s1_in_a_write_cycle assignment, which is an e_assign
  lan91c111_s1_in_a_write_cycle <= internal_cpu_data_master_granted_lan91c111_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= (lan91c111_s1_in_a_write_cycle OR ext_flash_s1_in_a_write_cycle) OR ext_ram_s1_in_a_write_cycle;
  internal_lan91c111_s1_wait_counter_eq_0 <= to_std_logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(lan91c111_s1_wait_counter))) = std_logic_vector'("00000000000000000000000000000000")));
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      lan91c111_s1_wait_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        lan91c111_s1_wait_counter <= lan91c111_s1_counter_load_value;
      end if;
    end if;

  end process;

  lan91c111_s1_counter_load_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(((lan91c111_s1_in_a_write_cycle AND ext_ram_bus_avalon_slave_begins_xfer))) = '1'), std_logic_vector'("000000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'((NOT internal_lan91c111_s1_wait_counter_eq_0)) = '1'), ((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(lan91c111_s1_wait_counter))) - std_logic_vector'("000000000000000000000000000000001")), std_logic_vector'("000000000000000000000000000000000"))));
  wait_for_lan91c111_s1_counter <= ext_ram_bus_avalon_slave_begins_xfer OR NOT internal_lan91c111_s1_wait_counter_eq_0;
  --~p1_ext_ram_bus_byteenablen byte enable port mux, which is an e_mux
  p1_ext_ram_bus_byteenablen <= A_EXT (NOT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_lan91c111_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001")))), 4);
  p1_select_n_to_the_ext_flash <= NOT ((internal_cpu_data_master_granted_ext_flash_s1 OR internal_cpu_instruction_master_granted_ext_flash_s1));
  --~ext_ram_bus_readn of type read to ~p1_ext_ram_bus_readn, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      ext_ram_bus_readn <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        ext_ram_bus_readn <= p1_ext_ram_bus_readn;
      end if;
    end if;

  end process;

  --~write_n_to_the_ext_flash of type write to ~p1_write_n_to_the_ext_flash, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      write_n_to_the_ext_flash <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        write_n_to_the_ext_flash <= p1_write_n_to_the_ext_flash;
      end if;
    end if;

  end process;

  --~p1_ext_ram_bus_readn assignment, which is an e_mux
  p1_ext_ram_bus_readn <= NOT (((((((internal_cpu_data_master_granted_ext_flash_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_ext_flash_s1 AND cpu_instruction_master_read)))) AND NOT ext_ram_bus_avalon_slave_begins_xfer) AND to_std_logic((((std_logic_vector'("0000000000000000000000000000") & (ext_flash_s1_wait_counter))<std_logic_vector'("00000000000000000000000000001000"))))));
  --~p1_write_n_to_the_ext_flash assignment, which is an e_mux
  p1_write_n_to_the_ext_flash <= NOT (((((((internal_cpu_data_master_granted_ext_flash_s1 AND cpu_data_master_write)) AND NOT ext_ram_bus_avalon_slave_begins_xfer) AND to_std_logic((((std_logic_vector'("0000000000000000000000000000") & (ext_flash_s1_wait_counter))>=std_logic_vector'("00000000000000000000000000000010"))))) AND to_std_logic((((std_logic_vector'("0000000000000000000000000000") & (ext_flash_s1_wait_counter))<std_logic_vector'("00000000000000000000000000001010"))))) AND ext_flash_s1_pretend_byte_enable));
  --ext_flash_s1_wait_counter_eq_1 assignment, which is an e_assign
  ext_flash_s1_wait_counter_eq_1 <= to_std_logic(((std_logic_vector'("0000000000000000000000000000") & (ext_flash_s1_wait_counter)) = std_logic_vector'("00000000000000000000000000000001")));
  --ext_flash_s1_waits_for_read in a cycle, which is an e_mux
  ext_flash_s1_waits_for_read <= ext_flash_s1_in_a_read_cycle AND wait_for_ext_flash_s1_counter;
  --ext_flash_s1_in_a_read_cycle assignment, which is an e_assign
  ext_flash_s1_in_a_read_cycle <= ((internal_cpu_data_master_granted_ext_flash_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_ext_flash_s1 AND cpu_instruction_master_read));
  --ext_flash_s1_waits_for_write in a cycle, which is an e_mux
  ext_flash_s1_waits_for_write <= ext_flash_s1_in_a_write_cycle AND wait_for_ext_flash_s1_counter;
  --ext_flash_s1_in_a_write_cycle assignment, which is an e_assign
  ext_flash_s1_in_a_write_cycle <= internal_cpu_data_master_granted_ext_flash_s1 AND cpu_data_master_write;
  internal_ext_flash_s1_wait_counter_eq_0 <= to_std_logic(((std_logic_vector'("0000000000000000000000000000") & (ext_flash_s1_wait_counter)) = std_logic_vector'("00000000000000000000000000000000")));
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      ext_flash_s1_wait_counter <= std_logic_vector'("0000");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        ext_flash_s1_wait_counter <= ext_flash_s1_counter_load_value;
      end if;
    end if;

  end process;

  ext_flash_s1_counter_load_value <= A_EXT (A_WE_StdLogicVector((std_logic'(((ext_flash_s1_in_a_read_cycle AND ext_ram_bus_avalon_slave_begins_xfer))) = '1'), std_logic_vector'("000000000000000000000000000001000"), A_WE_StdLogicVector((std_logic'(((ext_flash_s1_in_a_write_cycle AND ext_ram_bus_avalon_slave_begins_xfer))) = '1'), std_logic_vector'("000000000000000000000000000001010"), A_WE_StdLogicVector((std_logic'((NOT internal_ext_flash_s1_wait_counter_eq_0)) = '1'), ((std_logic_vector'("00000000000000000000000000000") & (ext_flash_s1_wait_counter)) - std_logic_vector'("000000000000000000000000000000001")), std_logic_vector'("000000000000000000000000000000000")))), 4);
  wait_for_ext_flash_s1_counter <= ext_ram_bus_avalon_slave_begins_xfer OR NOT internal_ext_flash_s1_wait_counter_eq_0;
  --ext_flash_s1_pretend_byte_enable byte enable port mux, which is an e_mux
  ext_flash_s1_pretend_byte_enable <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_ext_flash_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_byteenable_ext_flash_s1))), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))));
  (cpu_data_master_byteenable_ext_flash_s1_segment_3, cpu_data_master_byteenable_ext_flash_s1_segment_2, cpu_data_master_byteenable_ext_flash_s1_segment_1, cpu_data_master_byteenable_ext_flash_s1_segment_0) <= cpu_data_master_byteenable;
  internal_cpu_data_master_byteenable_ext_flash_s1 <= A_WE_StdLogic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000000"))), cpu_data_master_byteenable_ext_flash_s1_segment_0, A_WE_StdLogic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000001"))), cpu_data_master_byteenable_ext_flash_s1_segment_1, A_WE_StdLogic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000010"))), cpu_data_master_byteenable_ext_flash_s1_segment_2, cpu_data_master_byteenable_ext_flash_s1_segment_3)));
  p1_select_n_to_the_ext_ram <= NOT ((internal_cpu_data_master_granted_ext_ram_s1 OR internal_cpu_instruction_master_granted_ext_ram_s1));
  --~read_n_to_the_ext_ram of type read to ~p1_read_n_to_the_ext_ram, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      read_n_to_the_ext_ram <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        read_n_to_the_ext_ram <= p1_read_n_to_the_ext_ram;
      end if;
    end if;

  end process;

  --~p1_read_n_to_the_ext_ram assignment, which is an e_mux
  p1_read_n_to_the_ext_ram <= NOT ((((internal_cpu_data_master_granted_ext_ram_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_ext_ram_s1 AND cpu_instruction_master_read))));
  --~be_n_to_the_ext_ram of type byteenable to ~p1_be_n_to_the_ext_ram, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      be_n_to_the_ext_ram <= A_EXT (NOT std_logic_vector'("00000000000000000000000000000000"), 4);
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        be_n_to_the_ext_ram <= p1_be_n_to_the_ext_ram;
      end if;
    end if;

  end process;

  --~p1_write_n_to_the_ext_ram assignment, which is an e_mux
  p1_write_n_to_the_ext_ram <= NOT ((internal_cpu_data_master_granted_ext_ram_s1 AND cpu_data_master_write));
  --ext_ram_s1_waits_for_read in a cycle, which is an e_mux
  ext_ram_s1_waits_for_read <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(ext_ram_s1_in_a_read_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --ext_ram_s1_in_a_read_cycle assignment, which is an e_assign
  ext_ram_s1_in_a_read_cycle <= ((internal_cpu_data_master_granted_ext_ram_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_ext_ram_s1 AND cpu_instruction_master_read));
  --ext_ram_s1_waits_for_write in a cycle, which is an e_mux
  ext_ram_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(ext_ram_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --ext_ram_s1_in_a_write_cycle assignment, which is an e_assign
  ext_ram_s1_in_a_write_cycle <= internal_cpu_data_master_granted_ext_ram_s1 AND cpu_data_master_write;
  wait_for_ext_ram_s1_counter <= std_logic'('0');
  --~p1_be_n_to_the_ext_ram byte enable port mux, which is an e_mux
  p1_be_n_to_the_ext_ram <= A_EXT (NOT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_ext_ram_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001")))), 4);
  --first irq irq_from_the_lan91c111 register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_irq_from_the_lan91c111 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_irq_from_the_lan91c111 <= irq_from_the_lan91c111;
      end if;
    end if;

  end process;

  --vhdl renameroo for output signals
  cpu_data_master_byteenable_ext_flash_s1 <= internal_cpu_data_master_byteenable_ext_flash_s1;
  --vhdl renameroo for output signals
  cpu_data_master_granted_ext_flash_s1 <= internal_cpu_data_master_granted_ext_flash_s1;
  --vhdl renameroo for output signals
  cpu_data_master_granted_ext_ram_s1 <= internal_cpu_data_master_granted_ext_ram_s1;
  --vhdl renameroo for output signals
  cpu_data_master_granted_lan91c111_s1 <= internal_cpu_data_master_granted_lan91c111_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_ext_flash_s1 <= internal_cpu_data_master_qualified_request_ext_flash_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_ext_ram_s1 <= internal_cpu_data_master_qualified_request_ext_ram_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_lan91c111_s1 <= internal_cpu_data_master_qualified_request_lan91c111_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_ext_flash_s1 <= internal_cpu_data_master_requests_ext_flash_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_ext_ram_s1 <= internal_cpu_data_master_requests_ext_ram_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_lan91c111_s1 <= internal_cpu_data_master_requests_lan91c111_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_ext_flash_s1 <= internal_cpu_instruction_master_granted_ext_flash_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_ext_ram_s1 <= internal_cpu_instruction_master_granted_ext_ram_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_lan91c111_s1 <= internal_cpu_instruction_master_granted_lan91c111_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_ext_flash_s1 <= internal_cpu_instruction_master_qualified_request_ext_flash_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_ext_ram_s1 <= internal_cpu_instruction_master_qualified_request_ext_ram_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_lan91c111_s1 <= internal_cpu_instruction_master_qualified_request_lan91c111_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_ext_flash_s1 <= internal_cpu_instruction_master_requests_ext_flash_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_ext_ram_s1 <= internal_cpu_instruction_master_requests_ext_ram_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_lan91c111_s1 <= internal_cpu_instruction_master_requests_lan91c111_s1;
  --vhdl renameroo for output signals
  ext_flash_s1_wait_counter_eq_0 <= internal_ext_flash_s1_wait_counter_eq_0;
  --vhdl renameroo for output signals
  incoming_ext_ram_bus_data <= internal_incoming_ext_ram_bus_data;
  --vhdl renameroo for output signals
  lan91c111_s1_wait_counter_eq_0 <= internal_lan91c111_s1_wait_counter_eq_0;
--synthesis translate_off
    --incoming_ext_ram_bus_data_bit_0_is_x x check, which is an e_assign_is_x
    incoming_ext_ram_bus_data_bit_0_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_ext_ram_bus_data(0))), '1','0');
    --Crush incoming_ext_ram_bus_data_with_Xs_converted_to_0[0] Xs to 0, which is an e_assign
    incoming_ext_ram_bus_data_with_Xs_converted_to_0(0) <= A_WE_StdLogic((std_logic'(incoming_ext_ram_bus_data_bit_0_is_x) = '1'), std_logic'('0'), internal_incoming_ext_ram_bus_data(0));
    --incoming_ext_ram_bus_data_bit_1_is_x x check, which is an e_assign_is_x
    incoming_ext_ram_bus_data_bit_1_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_ext_ram_bus_data(1))), '1','0');
    --Crush incoming_ext_ram_bus_data_with_Xs_converted_to_0[1] Xs to 0, which is an e_assign
    incoming_ext_ram_bus_data_with_Xs_converted_to_0(1) <= A_WE_StdLogic((std_logic'(incoming_ext_ram_bus_data_bit_1_is_x) = '1'), std_logic'('0'), internal_incoming_ext_ram_bus_data(1));
    --incoming_ext_ram_bus_data_bit_2_is_x x check, which is an e_assign_is_x
    incoming_ext_ram_bus_data_bit_2_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_ext_ram_bus_data(2))), '1','0');
    --Crush incoming_ext_ram_bus_data_with_Xs_converted_to_0[2] Xs to 0, which is an e_assign
    incoming_ext_ram_bus_data_with_Xs_converted_to_0(2) <= A_WE_StdLogic((std_logic'(incoming_ext_ram_bus_data_bit_2_is_x) = '1'), std_logic'('0'), internal_incoming_ext_ram_bus_data(2));
    --incoming_ext_ram_bus_data_bit_3_is_x x check, which is an e_assign_is_x
    incoming_ext_ram_bus_data_bit_3_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_ext_ram_bus_data(3))), '1','0');
    --Crush incoming_ext_ram_bus_data_with_Xs_converted_to_0[3] Xs to 0, which is an e_assign
    incoming_ext_ram_bus_data_with_Xs_converted_to_0(3) <= A_WE_StdLogic((std_logic'(incoming_ext_ram_bus_data_bit_3_is_x) = '1'), std_logic'('0'), internal_incoming_ext_ram_bus_data(3));
    --incoming_ext_ram_bus_data_bit_4_is_x x check, which is an e_assign_is_x
    incoming_ext_ram_bus_data_bit_4_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_ext_ram_bus_data(4))), '1','0');
    --Crush incoming_ext_ram_bus_data_with_Xs_converted_to_0[4] Xs to 0, which is an e_assign
    incoming_ext_ram_bus_data_with_Xs_converted_to_0(4) <= A_WE_StdLogic((std_logic'(incoming_ext_ram_bus_data_bit_4_is_x) = '1'), std_logic'('0'), internal_incoming_ext_ram_bus_data(4));
    --incoming_ext_ram_bus_data_bit_5_is_x x check, which is an e_assign_is_x
    incoming_ext_ram_bus_data_bit_5_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_ext_ram_bus_data(5))), '1','0');
    --Crush incoming_ext_ram_bus_data_with_Xs_converted_to_0[5] Xs to 0, which is an e_assign
    incoming_ext_ram_bus_data_with_Xs_converted_to_0(5) <= A_WE_StdLogic((std_logic'(incoming_ext_ram_bus_data_bit_5_is_x) = '1'), std_logic'('0'), internal_incoming_ext_ram_bus_data(5));
    --incoming_ext_ram_bus_data_bit_6_is_x x check, which is an e_assign_is_x
    incoming_ext_ram_bus_data_bit_6_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_ext_ram_bus_data(6))), '1','0');
    --Crush incoming_ext_ram_bus_data_with_Xs_converted_to_0[6] Xs to 0, which is an e_assign
    incoming_ext_ram_bus_data_with_Xs_converted_to_0(6) <= A_WE_StdLogic((std_logic'(incoming_ext_ram_bus_data_bit_6_is_x) = '1'), std_logic'('0'), internal_incoming_ext_ram_bus_data(6));
    --incoming_ext_ram_bus_data_bit_7_is_x x check, which is an e_assign_is_x
    incoming_ext_ram_bus_data_bit_7_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_ext_ram_bus_data(7))), '1','0');
    --Crush incoming_ext_ram_bus_data_with_Xs_converted_to_0[7] Xs to 0, which is an e_assign
    incoming_ext_ram_bus_data_with_Xs_converted_to_0(7) <= A_WE_StdLogic((std_logic'(incoming_ext_ram_bus_data_bit_7_is_x) = '1'), std_logic'('0'), internal_incoming_ext_ram_bus_data(7));
    --grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line4 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000") & (((std_logic_vector'("0") & (((std_logic_vector'("0") & (((std_logic_vector'("0") & (((std_logic_vector'("0") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_granted_ext_flash_s1))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_granted_ext_ram_s1)))))) + (std_logic_vector'("00") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_granted_lan91c111_s1)))))) + (std_logic_vector'("000") & (A_TOSTDLOGICVECTOR(internal_cpu_instruction_master_granted_ext_flash_s1)))))) + (std_logic_vector'("0000") & (A_TOSTDLOGICVECTOR(internal_cpu_instruction_master_granted_ext_ram_s1)))))) + (std_logic_vector'("00000") & (A_TOSTDLOGICVECTOR(internal_cpu_instruction_master_granted_lan91c111_s1))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line4, now);
          write(write_line4, string'(": "));
          write(write_line4, string'("> 1 of grant signals are active simultaneously"));
          write(output, write_line4.all);
          deallocate (write_line4);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --saved_grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line5 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000") & (((std_logic_vector'("0") & (((std_logic_vector'("0") & (((std_logic_vector'("0") & (((std_logic_vector'("0") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_data_master_saved_grant_ext_flash_s1))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_data_master_saved_grant_ext_ram_s1)))))) + (std_logic_vector'("00") & (A_TOSTDLOGICVECTOR(cpu_data_master_saved_grant_lan91c111_s1)))))) + (std_logic_vector'("000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_saved_grant_ext_flash_s1)))))) + (std_logic_vector'("0000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_saved_grant_ext_ram_s1)))))) + (std_logic_vector'("00000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_saved_grant_lan91c111_s1))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line5, now);
          write(write_line5, string'(": "));
          write(write_line5, string'("> 1 of saved_grant signals are active simultaneously"));
          write(output, write_line5.all);
          deallocate (write_line5);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on
--synthesis read_comments_as_HDL on
--    
--    incoming_ext_ram_bus_data_with_Xs_converted_to_0 <= internal_incoming_ext_ram_bus_data (7 DOWNTO 0);
--synthesis read_comments_as_HDL off

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity ext_ram_bus_bridge_arbitrator is 
end entity ext_ram_bus_bridge_arbitrator;


architecture europa of ext_ram_bus_bridge_arbitrator is

begin


end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity high_res_timer_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal high_res_timer_s1_irq : IN STD_LOGIC;
                 signal high_res_timer_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_high_res_timer_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_high_res_timer_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_high_res_timer_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_high_res_timer_s1 : OUT STD_LOGIC;
                 signal d1_high_res_timer_s1_end_xfer : OUT STD_LOGIC;
                 signal high_res_timer_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                 signal high_res_timer_s1_chipselect : OUT STD_LOGIC;
                 signal high_res_timer_s1_irq_from_sa : OUT STD_LOGIC;
                 signal high_res_timer_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal high_res_timer_s1_reset_n : OUT STD_LOGIC;
                 signal high_res_timer_s1_write_n : OUT STD_LOGIC;
                 signal high_res_timer_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of high_res_timer_s1_arbitrator : entity is FALSE;
end entity high_res_timer_s1_arbitrator;


architecture europa of high_res_timer_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_high_res_timer_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal high_res_timer_s1_allgrants :  STD_LOGIC;
                signal high_res_timer_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal high_res_timer_s1_any_continuerequest :  STD_LOGIC;
                signal high_res_timer_s1_arb_counter_enable :  STD_LOGIC;
                signal high_res_timer_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal high_res_timer_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal high_res_timer_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal high_res_timer_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal high_res_timer_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal high_res_timer_s1_begins_xfer :  STD_LOGIC;
                signal high_res_timer_s1_end_xfer :  STD_LOGIC;
                signal high_res_timer_s1_firsttransfer :  STD_LOGIC;
                signal high_res_timer_s1_grant_vector :  STD_LOGIC;
                signal high_res_timer_s1_in_a_read_cycle :  STD_LOGIC;
                signal high_res_timer_s1_in_a_write_cycle :  STD_LOGIC;
                signal high_res_timer_s1_master_qreq_vector :  STD_LOGIC;
                signal high_res_timer_s1_slavearbiterlockenable :  STD_LOGIC;
                signal high_res_timer_s1_waits_for_read :  STD_LOGIC;
                signal high_res_timer_s1_waits_for_write :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_high_res_timer_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_high_res_timer_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_high_res_timer_s1 :  STD_LOGIC;
                signal wait_for_high_res_timer_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT high_res_timer_s1_end_xfer;
      end if;
    end if;

  end process;

  high_res_timer_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_high_res_timer_s1);
  internal_cpu_data_master_requests_high_res_timer_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(25 DOWNTO 5) & std_logic_vector'("00000")) = std_logic_vector'("10000100100000100000100000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign high_res_timer_s1_readdata_from_sa = high_res_timer_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  high_res_timer_s1_readdata_from_sa <= high_res_timer_s1_readdata;
  --high_res_timer_s1_arb_share_counter set values, which is an e_mux
  high_res_timer_s1_arb_share_set_values <= std_logic_vector'("001");
  --high_res_timer_s1_arb_share_counter_next_value assignment, which is an e_assign
  high_res_timer_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(high_res_timer_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (high_res_timer_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(high_res_timer_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (high_res_timer_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --high_res_timer_s1_allgrants all slave grants, which is an e_mux
  high_res_timer_s1_allgrants <= high_res_timer_s1_grant_vector;
  --high_res_timer_s1_end_xfer assignment, which is an e_assign
  high_res_timer_s1_end_xfer <= NOT ((high_res_timer_s1_waits_for_read OR high_res_timer_s1_waits_for_write));
  --high_res_timer_s1_arb_share_counter arbitration counter enable, which is an e_assign
  high_res_timer_s1_arb_counter_enable <= high_res_timer_s1_end_xfer AND high_res_timer_s1_allgrants;
  --high_res_timer_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      high_res_timer_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(high_res_timer_s1_arb_counter_enable) = '1' then 
        high_res_timer_s1_arb_share_counter <= high_res_timer_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --high_res_timer_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      high_res_timer_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((high_res_timer_s1_master_qreq_vector AND high_res_timer_s1_end_xfer)) = '1' then 
        high_res_timer_s1_slavearbiterlockenable <= or_reduce(high_res_timer_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master high_res_timer/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= high_res_timer_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --high_res_timer_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  high_res_timer_s1_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_high_res_timer_s1 <= internal_cpu_data_master_requests_high_res_timer_s1 AND NOT (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write));
  --high_res_timer_s1_writedata mux, which is an e_mux
  high_res_timer_s1_writedata <= cpu_data_master_writedata (15 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_high_res_timer_s1 <= internal_cpu_data_master_qualified_request_high_res_timer_s1;
  --cpu/data_master saved-grant high_res_timer/s1, which is an e_assign
  cpu_data_master_saved_grant_high_res_timer_s1 <= internal_cpu_data_master_requests_high_res_timer_s1;
  --allow new arb cycle for high_res_timer/s1, which is an e_assign
  high_res_timer_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  high_res_timer_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  high_res_timer_s1_master_qreq_vector <= std_logic'('1');
  --high_res_timer_s1_reset_n assignment, which is an e_assign
  high_res_timer_s1_reset_n <= reset_n;
  high_res_timer_s1_chipselect <= internal_cpu_data_master_granted_high_res_timer_s1;
  --high_res_timer_s1_firsttransfer first transaction, which is an e_assign
  high_res_timer_s1_firsttransfer <= NOT ((high_res_timer_s1_slavearbiterlockenable AND high_res_timer_s1_any_continuerequest));
  --high_res_timer_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  high_res_timer_s1_beginbursttransfer_internal <= high_res_timer_s1_begins_xfer AND high_res_timer_s1_firsttransfer;
  --high_res_timer_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  high_res_timer_s1_arbitration_holdoff_internal <= high_res_timer_s1_begins_xfer AND high_res_timer_s1_firsttransfer;
  --~high_res_timer_s1_write_n assignment, which is an e_mux
  high_res_timer_s1_write_n <= NOT ((internal_cpu_data_master_granted_high_res_timer_s1 AND cpu_data_master_write));
  --high_res_timer_s1_address mux, which is an e_mux
  high_res_timer_s1_address <= A_EXT (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")), 3);
  --d1_high_res_timer_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_high_res_timer_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_high_res_timer_s1_end_xfer <= high_res_timer_s1_end_xfer;
      end if;
    end if;

  end process;

  --high_res_timer_s1_waits_for_read in a cycle, which is an e_mux
  high_res_timer_s1_waits_for_read <= high_res_timer_s1_in_a_read_cycle AND high_res_timer_s1_begins_xfer;
  --high_res_timer_s1_in_a_read_cycle assignment, which is an e_assign
  high_res_timer_s1_in_a_read_cycle <= internal_cpu_data_master_granted_high_res_timer_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= high_res_timer_s1_in_a_read_cycle;
  --high_res_timer_s1_waits_for_write in a cycle, which is an e_mux
  high_res_timer_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(high_res_timer_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --high_res_timer_s1_in_a_write_cycle assignment, which is an e_assign
  high_res_timer_s1_in_a_write_cycle <= internal_cpu_data_master_granted_high_res_timer_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= high_res_timer_s1_in_a_write_cycle;
  wait_for_high_res_timer_s1_counter <= std_logic'('0');
  --assign high_res_timer_s1_irq_from_sa = high_res_timer_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  high_res_timer_s1_irq_from_sa <= high_res_timer_s1_irq;
  --vhdl renameroo for output signals
  cpu_data_master_granted_high_res_timer_s1 <= internal_cpu_data_master_granted_high_res_timer_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_high_res_timer_s1 <= internal_cpu_data_master_qualified_request_high_res_timer_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_high_res_timer_s1 <= internal_cpu_data_master_requests_high_res_timer_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity jtag_uart_avalon_jtag_slave_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal jtag_uart_avalon_jtag_slave_dataavailable : IN STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_irq : IN STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal jtag_uart_avalon_jtag_slave_readyfordata : IN STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_waitrequest : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_jtag_uart_avalon_jtag_slave : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave : OUT STD_LOGIC;
                 signal cpu_data_master_requests_jtag_uart_avalon_jtag_slave : OUT STD_LOGIC;
                 signal d1_jtag_uart_avalon_jtag_slave_end_xfer : OUT STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_address : OUT STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_chipselect : OUT STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_dataavailable_from_sa : OUT STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_irq_from_sa : OUT STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_read_n : OUT STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal jtag_uart_avalon_jtag_slave_readyfordata_from_sa : OUT STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_reset_n : OUT STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_waitrequest_from_sa : OUT STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_write_n : OUT STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of jtag_uart_avalon_jtag_slave_arbitrator : entity is FALSE;
end entity jtag_uart_avalon_jtag_slave_arbitrator;


architecture europa of jtag_uart_avalon_jtag_slave_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_jtag_uart_avalon_jtag_slave :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_jtag_uart_avalon_jtag_slave :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave :  STD_LOGIC;
                signal internal_cpu_data_master_requests_jtag_uart_avalon_jtag_slave :  STD_LOGIC;
                signal internal_jtag_uart_avalon_jtag_slave_waitrequest_from_sa :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_allgrants :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_allow_new_arb_cycle :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_any_continuerequest :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_arb_counter_enable :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal jtag_uart_avalon_jtag_slave_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal jtag_uart_avalon_jtag_slave_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal jtag_uart_avalon_jtag_slave_arbitration_holdoff_internal :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_beginbursttransfer_internal :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_begins_xfer :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_end_xfer :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_firsttransfer :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_grant_vector :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_in_a_read_cycle :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_in_a_write_cycle :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_master_qreq_vector :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_slavearbiterlockenable :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_waits_for_read :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_waits_for_write :  STD_LOGIC;
                signal wait_for_jtag_uart_avalon_jtag_slave_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT jtag_uart_avalon_jtag_slave_end_xfer;
      end if;
    end if;

  end process;

  jtag_uart_avalon_jtag_slave_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave);
  internal_cpu_data_master_requests_jtag_uart_avalon_jtag_slave <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(25 DOWNTO 3) & std_logic_vector'("000")) = std_logic_vector'("10000100100000100010110000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign jtag_uart_avalon_jtag_slave_dataavailable_from_sa = jtag_uart_avalon_jtag_slave_dataavailable so that symbol knows where to group signals which may go to master only, which is an e_assign
  jtag_uart_avalon_jtag_slave_dataavailable_from_sa <= jtag_uart_avalon_jtag_slave_dataavailable;
  --assign jtag_uart_avalon_jtag_slave_readyfordata_from_sa = jtag_uart_avalon_jtag_slave_readyfordata so that symbol knows where to group signals which may go to master only, which is an e_assign
  jtag_uart_avalon_jtag_slave_readyfordata_from_sa <= jtag_uart_avalon_jtag_slave_readyfordata;
  --assign jtag_uart_avalon_jtag_slave_readdata_from_sa = jtag_uart_avalon_jtag_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  jtag_uart_avalon_jtag_slave_readdata_from_sa <= jtag_uart_avalon_jtag_slave_readdata;
  --assign jtag_uart_avalon_jtag_slave_waitrequest_from_sa = jtag_uart_avalon_jtag_slave_waitrequest so that symbol knows where to group signals which may go to master only, which is an e_assign
  internal_jtag_uart_avalon_jtag_slave_waitrequest_from_sa <= jtag_uart_avalon_jtag_slave_waitrequest;
  --jtag_uart_avalon_jtag_slave_arb_share_counter set values, which is an e_mux
  jtag_uart_avalon_jtag_slave_arb_share_set_values <= std_logic_vector'("001");
  --jtag_uart_avalon_jtag_slave_arb_share_counter_next_value assignment, which is an e_assign
  jtag_uart_avalon_jtag_slave_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(jtag_uart_avalon_jtag_slave_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (jtag_uart_avalon_jtag_slave_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(jtag_uart_avalon_jtag_slave_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (jtag_uart_avalon_jtag_slave_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --jtag_uart_avalon_jtag_slave_allgrants all slave grants, which is an e_mux
  jtag_uart_avalon_jtag_slave_allgrants <= jtag_uart_avalon_jtag_slave_grant_vector;
  --jtag_uart_avalon_jtag_slave_end_xfer assignment, which is an e_assign
  jtag_uart_avalon_jtag_slave_end_xfer <= NOT ((jtag_uart_avalon_jtag_slave_waits_for_read OR jtag_uart_avalon_jtag_slave_waits_for_write));
  --jtag_uart_avalon_jtag_slave_arb_share_counter arbitration counter enable, which is an e_assign
  jtag_uart_avalon_jtag_slave_arb_counter_enable <= jtag_uart_avalon_jtag_slave_end_xfer AND jtag_uart_avalon_jtag_slave_allgrants;
  --jtag_uart_avalon_jtag_slave_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      jtag_uart_avalon_jtag_slave_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(jtag_uart_avalon_jtag_slave_arb_counter_enable) = '1' then 
        jtag_uart_avalon_jtag_slave_arb_share_counter <= jtag_uart_avalon_jtag_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --jtag_uart_avalon_jtag_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      jtag_uart_avalon_jtag_slave_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((jtag_uart_avalon_jtag_slave_master_qreq_vector AND jtag_uart_avalon_jtag_slave_end_xfer)) = '1' then 
        jtag_uart_avalon_jtag_slave_slavearbiterlockenable <= or_reduce(jtag_uart_avalon_jtag_slave_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master jtag_uart/avalon_jtag_slave arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= jtag_uart_avalon_jtag_slave_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --jtag_uart_avalon_jtag_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  jtag_uart_avalon_jtag_slave_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave <= internal_cpu_data_master_requests_jtag_uart_avalon_jtag_slave AND NOT ((((cpu_data_master_read AND (NOT cpu_data_master_waitrequest))) OR (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write))));
  --jtag_uart_avalon_jtag_slave_writedata mux, which is an e_mux
  jtag_uart_avalon_jtag_slave_writedata <= cpu_data_master_writedata;
  --master is always granted when requested
  internal_cpu_data_master_granted_jtag_uart_avalon_jtag_slave <= internal_cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave;
  --cpu/data_master saved-grant jtag_uart/avalon_jtag_slave, which is an e_assign
  cpu_data_master_saved_grant_jtag_uart_avalon_jtag_slave <= internal_cpu_data_master_requests_jtag_uart_avalon_jtag_slave;
  --allow new arb cycle for jtag_uart/avalon_jtag_slave, which is an e_assign
  jtag_uart_avalon_jtag_slave_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  jtag_uart_avalon_jtag_slave_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  jtag_uart_avalon_jtag_slave_master_qreq_vector <= std_logic'('1');
  --jtag_uart_avalon_jtag_slave_reset_n assignment, which is an e_assign
  jtag_uart_avalon_jtag_slave_reset_n <= reset_n;
  jtag_uart_avalon_jtag_slave_chipselect <= internal_cpu_data_master_granted_jtag_uart_avalon_jtag_slave;
  --jtag_uart_avalon_jtag_slave_firsttransfer first transaction, which is an e_assign
  jtag_uart_avalon_jtag_slave_firsttransfer <= NOT ((jtag_uart_avalon_jtag_slave_slavearbiterlockenable AND jtag_uart_avalon_jtag_slave_any_continuerequest));
  --jtag_uart_avalon_jtag_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  jtag_uart_avalon_jtag_slave_beginbursttransfer_internal <= jtag_uart_avalon_jtag_slave_begins_xfer AND jtag_uart_avalon_jtag_slave_firsttransfer;
  --jtag_uart_avalon_jtag_slave_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  jtag_uart_avalon_jtag_slave_arbitration_holdoff_internal <= jtag_uart_avalon_jtag_slave_begins_xfer AND jtag_uart_avalon_jtag_slave_firsttransfer;
  --~jtag_uart_avalon_jtag_slave_read_n assignment, which is an e_mux
  jtag_uart_avalon_jtag_slave_read_n <= NOT ((internal_cpu_data_master_granted_jtag_uart_avalon_jtag_slave AND cpu_data_master_read));
  --~jtag_uart_avalon_jtag_slave_write_n assignment, which is an e_mux
  jtag_uart_avalon_jtag_slave_write_n <= NOT ((internal_cpu_data_master_granted_jtag_uart_avalon_jtag_slave AND cpu_data_master_write));
  --jtag_uart_avalon_jtag_slave_address mux, which is an e_mux
  jtag_uart_avalon_jtag_slave_address <= Vector_To_Std_Logic(A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")));
  --d1_jtag_uart_avalon_jtag_slave_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_jtag_uart_avalon_jtag_slave_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_jtag_uart_avalon_jtag_slave_end_xfer <= jtag_uart_avalon_jtag_slave_end_xfer;
      end if;
    end if;

  end process;

  --jtag_uart_avalon_jtag_slave_waits_for_read in a cycle, which is an e_mux
  jtag_uart_avalon_jtag_slave_waits_for_read <= jtag_uart_avalon_jtag_slave_in_a_read_cycle AND internal_jtag_uart_avalon_jtag_slave_waitrequest_from_sa;
  --jtag_uart_avalon_jtag_slave_in_a_read_cycle assignment, which is an e_assign
  jtag_uart_avalon_jtag_slave_in_a_read_cycle <= internal_cpu_data_master_granted_jtag_uart_avalon_jtag_slave AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= jtag_uart_avalon_jtag_slave_in_a_read_cycle;
  --jtag_uart_avalon_jtag_slave_waits_for_write in a cycle, which is an e_mux
  jtag_uart_avalon_jtag_slave_waits_for_write <= jtag_uart_avalon_jtag_slave_in_a_write_cycle AND internal_jtag_uart_avalon_jtag_slave_waitrequest_from_sa;
  --jtag_uart_avalon_jtag_slave_in_a_write_cycle assignment, which is an e_assign
  jtag_uart_avalon_jtag_slave_in_a_write_cycle <= internal_cpu_data_master_granted_jtag_uart_avalon_jtag_slave AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= jtag_uart_avalon_jtag_slave_in_a_write_cycle;
  wait_for_jtag_uart_avalon_jtag_slave_counter <= std_logic'('0');
  --assign jtag_uart_avalon_jtag_slave_irq_from_sa = jtag_uart_avalon_jtag_slave_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  jtag_uart_avalon_jtag_slave_irq_from_sa <= jtag_uart_avalon_jtag_slave_irq;
  --vhdl renameroo for output signals
  cpu_data_master_granted_jtag_uart_avalon_jtag_slave <= internal_cpu_data_master_granted_jtag_uart_avalon_jtag_slave;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave <= internal_cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave;
  --vhdl renameroo for output signals
  cpu_data_master_requests_jtag_uart_avalon_jtag_slave <= internal_cpu_data_master_requests_jtag_uart_avalon_jtag_slave;
  --vhdl renameroo for output signals
  jtag_uart_avalon_jtag_slave_waitrequest_from_sa <= internal_jtag_uart_avalon_jtag_slave_waitrequest_from_sa;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity jtagpio_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal jtagpio_s1_readdata : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_jtagpio_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_jtagpio_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_jtagpio_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_jtagpio_s1 : OUT STD_LOGIC;
                 signal d1_jtagpio_s1_end_xfer : OUT STD_LOGIC;
                 signal jtagpio_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal jtagpio_s1_chipselect : OUT STD_LOGIC;
                 signal jtagpio_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (20 DOWNTO 0);
                 signal jtagpio_s1_reset_n : OUT STD_LOGIC;
                 signal jtagpio_s1_write_n : OUT STD_LOGIC;
                 signal jtagpio_s1_writedata : OUT STD_LOGIC_VECTOR (20 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of jtagpio_s1_arbitrator : entity is FALSE;
end entity jtagpio_s1_arbitrator;


architecture europa of jtagpio_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_jtagpio_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_jtagpio_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_jtagpio_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_jtagpio_s1 :  STD_LOGIC;
                signal jtagpio_s1_allgrants :  STD_LOGIC;
                signal jtagpio_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal jtagpio_s1_any_continuerequest :  STD_LOGIC;
                signal jtagpio_s1_arb_counter_enable :  STD_LOGIC;
                signal jtagpio_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal jtagpio_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal jtagpio_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal jtagpio_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal jtagpio_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal jtagpio_s1_begins_xfer :  STD_LOGIC;
                signal jtagpio_s1_end_xfer :  STD_LOGIC;
                signal jtagpio_s1_firsttransfer :  STD_LOGIC;
                signal jtagpio_s1_grant_vector :  STD_LOGIC;
                signal jtagpio_s1_in_a_read_cycle :  STD_LOGIC;
                signal jtagpio_s1_in_a_write_cycle :  STD_LOGIC;
                signal jtagpio_s1_master_qreq_vector :  STD_LOGIC;
                signal jtagpio_s1_slavearbiterlockenable :  STD_LOGIC;
                signal jtagpio_s1_waits_for_read :  STD_LOGIC;
                signal jtagpio_s1_waits_for_write :  STD_LOGIC;
                signal wait_for_jtagpio_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT jtagpio_s1_end_xfer;
      end if;
    end if;

  end process;

  jtagpio_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_jtagpio_s1);
  internal_cpu_data_master_requests_jtagpio_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(25 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("00100000000000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign jtagpio_s1_readdata_from_sa = jtagpio_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  jtagpio_s1_readdata_from_sa <= jtagpio_s1_readdata;
  --jtagpio_s1_arb_share_counter set values, which is an e_mux
  jtagpio_s1_arb_share_set_values <= std_logic_vector'("001");
  --jtagpio_s1_arb_share_counter_next_value assignment, which is an e_assign
  jtagpio_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(jtagpio_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (jtagpio_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(jtagpio_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (jtagpio_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --jtagpio_s1_allgrants all slave grants, which is an e_mux
  jtagpio_s1_allgrants <= jtagpio_s1_grant_vector;
  --jtagpio_s1_end_xfer assignment, which is an e_assign
  jtagpio_s1_end_xfer <= NOT ((jtagpio_s1_waits_for_read OR jtagpio_s1_waits_for_write));
  --jtagpio_s1_arb_share_counter arbitration counter enable, which is an e_assign
  jtagpio_s1_arb_counter_enable <= jtagpio_s1_end_xfer AND jtagpio_s1_allgrants;
  --jtagpio_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      jtagpio_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(jtagpio_s1_arb_counter_enable) = '1' then 
        jtagpio_s1_arb_share_counter <= jtagpio_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --jtagpio_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      jtagpio_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((jtagpio_s1_master_qreq_vector AND jtagpio_s1_end_xfer)) = '1' then 
        jtagpio_s1_slavearbiterlockenable <= or_reduce(jtagpio_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master jtagpio/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= jtagpio_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --jtagpio_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  jtagpio_s1_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_jtagpio_s1 <= internal_cpu_data_master_requests_jtagpio_s1 AND NOT (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write));
  --jtagpio_s1_writedata mux, which is an e_mux
  jtagpio_s1_writedata <= cpu_data_master_writedata (20 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_jtagpio_s1 <= internal_cpu_data_master_qualified_request_jtagpio_s1;
  --cpu/data_master saved-grant jtagpio/s1, which is an e_assign
  cpu_data_master_saved_grant_jtagpio_s1 <= internal_cpu_data_master_requests_jtagpio_s1;
  --allow new arb cycle for jtagpio/s1, which is an e_assign
  jtagpio_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  jtagpio_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  jtagpio_s1_master_qreq_vector <= std_logic'('1');
  --jtagpio_s1_reset_n assignment, which is an e_assign
  jtagpio_s1_reset_n <= reset_n;
  jtagpio_s1_chipselect <= internal_cpu_data_master_granted_jtagpio_s1;
  --jtagpio_s1_firsttransfer first transaction, which is an e_assign
  jtagpio_s1_firsttransfer <= NOT ((jtagpio_s1_slavearbiterlockenable AND jtagpio_s1_any_continuerequest));
  --jtagpio_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  jtagpio_s1_beginbursttransfer_internal <= jtagpio_s1_begins_xfer AND jtagpio_s1_firsttransfer;
  --jtagpio_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  jtagpio_s1_arbitration_holdoff_internal <= jtagpio_s1_begins_xfer AND jtagpio_s1_firsttransfer;
  --~jtagpio_s1_write_n assignment, which is an e_mux
  jtagpio_s1_write_n <= NOT ((internal_cpu_data_master_granted_jtagpio_s1 AND cpu_data_master_write));
  --jtagpio_s1_address mux, which is an e_mux
  jtagpio_s1_address <= A_EXT (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_jtagpio_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_jtagpio_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_jtagpio_s1_end_xfer <= jtagpio_s1_end_xfer;
      end if;
    end if;

  end process;

  --jtagpio_s1_waits_for_read in a cycle, which is an e_mux
  jtagpio_s1_waits_for_read <= jtagpio_s1_in_a_read_cycle AND jtagpio_s1_begins_xfer;
  --jtagpio_s1_in_a_read_cycle assignment, which is an e_assign
  jtagpio_s1_in_a_read_cycle <= internal_cpu_data_master_granted_jtagpio_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= jtagpio_s1_in_a_read_cycle;
  --jtagpio_s1_waits_for_write in a cycle, which is an e_mux
  jtagpio_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(jtagpio_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --jtagpio_s1_in_a_write_cycle assignment, which is an e_assign
  jtagpio_s1_in_a_write_cycle <= internal_cpu_data_master_granted_jtagpio_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= jtagpio_s1_in_a_write_cycle;
  wait_for_jtagpio_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_data_master_granted_jtagpio_s1 <= internal_cpu_data_master_granted_jtagpio_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_jtagpio_s1 <= internal_cpu_data_master_qualified_request_jtagpio_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_jtagpio_s1 <= internal_cpu_data_master_requests_jtagpio_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity led_pio_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal led_pio_s1_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_led_pio_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_led_pio_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_led_pio_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_led_pio_s1 : OUT STD_LOGIC;
                 signal d1_led_pio_s1_end_xfer : OUT STD_LOGIC;
                 signal led_pio_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal led_pio_s1_chipselect : OUT STD_LOGIC;
                 signal led_pio_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal led_pio_s1_reset_n : OUT STD_LOGIC;
                 signal led_pio_s1_write_n : OUT STD_LOGIC;
                 signal led_pio_s1_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of led_pio_s1_arbitrator : entity is FALSE;
end entity led_pio_s1_arbitrator;


architecture europa of led_pio_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_led_pio_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_led_pio_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_led_pio_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_led_pio_s1 :  STD_LOGIC;
                signal led_pio_s1_allgrants :  STD_LOGIC;
                signal led_pio_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal led_pio_s1_any_continuerequest :  STD_LOGIC;
                signal led_pio_s1_arb_counter_enable :  STD_LOGIC;
                signal led_pio_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal led_pio_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal led_pio_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal led_pio_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal led_pio_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal led_pio_s1_begins_xfer :  STD_LOGIC;
                signal led_pio_s1_end_xfer :  STD_LOGIC;
                signal led_pio_s1_firsttransfer :  STD_LOGIC;
                signal led_pio_s1_grant_vector :  STD_LOGIC;
                signal led_pio_s1_in_a_read_cycle :  STD_LOGIC;
                signal led_pio_s1_in_a_write_cycle :  STD_LOGIC;
                signal led_pio_s1_master_qreq_vector :  STD_LOGIC;
                signal led_pio_s1_pretend_byte_enable :  STD_LOGIC;
                signal led_pio_s1_slavearbiterlockenable :  STD_LOGIC;
                signal led_pio_s1_waits_for_read :  STD_LOGIC;
                signal led_pio_s1_waits_for_write :  STD_LOGIC;
                signal wait_for_led_pio_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT led_pio_s1_end_xfer;
      end if;
    end if;

  end process;

  led_pio_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_led_pio_s1);
  internal_cpu_data_master_requests_led_pio_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(25 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10000100100000100001110000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign led_pio_s1_readdata_from_sa = led_pio_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  led_pio_s1_readdata_from_sa <= led_pio_s1_readdata;
  --led_pio_s1_arb_share_counter set values, which is an e_mux
  led_pio_s1_arb_share_set_values <= std_logic_vector'("001");
  --led_pio_s1_arb_share_counter_next_value assignment, which is an e_assign
  led_pio_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(led_pio_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (led_pio_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(led_pio_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (led_pio_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --led_pio_s1_allgrants all slave grants, which is an e_mux
  led_pio_s1_allgrants <= led_pio_s1_grant_vector;
  --led_pio_s1_end_xfer assignment, which is an e_assign
  led_pio_s1_end_xfer <= NOT ((led_pio_s1_waits_for_read OR led_pio_s1_waits_for_write));
  --led_pio_s1_arb_share_counter arbitration counter enable, which is an e_assign
  led_pio_s1_arb_counter_enable <= led_pio_s1_end_xfer AND led_pio_s1_allgrants;
  --led_pio_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      led_pio_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(led_pio_s1_arb_counter_enable) = '1' then 
        led_pio_s1_arb_share_counter <= led_pio_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --led_pio_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      led_pio_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((led_pio_s1_master_qreq_vector AND led_pio_s1_end_xfer)) = '1' then 
        led_pio_s1_slavearbiterlockenable <= or_reduce(led_pio_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master led_pio/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= led_pio_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --led_pio_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  led_pio_s1_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_led_pio_s1 <= internal_cpu_data_master_requests_led_pio_s1 AND NOT (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write));
  --led_pio_s1_writedata mux, which is an e_mux
  led_pio_s1_writedata <= cpu_data_master_writedata (7 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_led_pio_s1 <= internal_cpu_data_master_qualified_request_led_pio_s1;
  --cpu/data_master saved-grant led_pio/s1, which is an e_assign
  cpu_data_master_saved_grant_led_pio_s1 <= internal_cpu_data_master_requests_led_pio_s1;
  --allow new arb cycle for led_pio/s1, which is an e_assign
  led_pio_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  led_pio_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  led_pio_s1_master_qreq_vector <= std_logic'('1');
  --led_pio_s1_reset_n assignment, which is an e_assign
  led_pio_s1_reset_n <= reset_n;
  led_pio_s1_chipselect <= internal_cpu_data_master_granted_led_pio_s1;
  --led_pio_s1_firsttransfer first transaction, which is an e_assign
  led_pio_s1_firsttransfer <= NOT ((led_pio_s1_slavearbiterlockenable AND led_pio_s1_any_continuerequest));
  --led_pio_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  led_pio_s1_beginbursttransfer_internal <= led_pio_s1_begins_xfer AND led_pio_s1_firsttransfer;
  --led_pio_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  led_pio_s1_arbitration_holdoff_internal <= led_pio_s1_begins_xfer AND led_pio_s1_firsttransfer;
  --~led_pio_s1_write_n assignment, which is an e_mux
  led_pio_s1_write_n <= NOT ((((internal_cpu_data_master_granted_led_pio_s1 AND cpu_data_master_write)) AND led_pio_s1_pretend_byte_enable));
  --led_pio_s1_address mux, which is an e_mux
  led_pio_s1_address <= A_EXT (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_led_pio_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_led_pio_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_led_pio_s1_end_xfer <= led_pio_s1_end_xfer;
      end if;
    end if;

  end process;

  --led_pio_s1_waits_for_read in a cycle, which is an e_mux
  led_pio_s1_waits_for_read <= led_pio_s1_in_a_read_cycle AND led_pio_s1_begins_xfer;
  --led_pio_s1_in_a_read_cycle assignment, which is an e_assign
  led_pio_s1_in_a_read_cycle <= internal_cpu_data_master_granted_led_pio_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= led_pio_s1_in_a_read_cycle;
  --led_pio_s1_waits_for_write in a cycle, which is an e_mux
  led_pio_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(led_pio_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --led_pio_s1_in_a_write_cycle assignment, which is an e_assign
  led_pio_s1_in_a_write_cycle <= internal_cpu_data_master_granted_led_pio_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= led_pio_s1_in_a_write_cycle;
  wait_for_led_pio_s1_counter <= std_logic'('0');
  --led_pio_s1_pretend_byte_enable byte enable port mux, which is an e_mux
  led_pio_s1_pretend_byte_enable <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_led_pio_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))));
  --vhdl renameroo for output signals
  cpu_data_master_granted_led_pio_s1 <= internal_cpu_data_master_granted_led_pio_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_led_pio_s1 <= internal_cpu_data_master_qualified_request_led_pio_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_led_pio_s1 <= internal_cpu_data_master_requests_led_pio_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity onchip_ram_64_kbytes_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal onchip_ram_64_kbytes_s1_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_onchip_ram_64_kbytes_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_onchip_ram_64_kbytes_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_onchip_ram_64_kbytes_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_onchip_ram_64_kbytes_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_onchip_ram_64_kbytes_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_requests_onchip_ram_64_kbytes_s1 : OUT STD_LOGIC;
                 signal d1_onchip_ram_64_kbytes_s1_end_xfer : OUT STD_LOGIC;
                 signal onchip_ram_64_kbytes_s1_address : OUT STD_LOGIC_VECTOR (13 DOWNTO 0);
                 signal onchip_ram_64_kbytes_s1_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal onchip_ram_64_kbytes_s1_chipselect : OUT STD_LOGIC;
                 signal onchip_ram_64_kbytes_s1_clken : OUT STD_LOGIC;
                 signal onchip_ram_64_kbytes_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal onchip_ram_64_kbytes_s1_write : OUT STD_LOGIC;
                 signal onchip_ram_64_kbytes_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal registered_cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1 : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of onchip_ram_64_kbytes_s1_arbitrator : entity is FALSE;
end entity onchip_ram_64_kbytes_s1_arbitrator;


architecture europa of onchip_ram_64_kbytes_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register_in :  STD_LOGIC;
                signal cpu_data_master_saved_grant_onchip_ram_64_kbytes_s1 :  STD_LOGIC;
                signal cpu_instruction_master_arbiterlock :  STD_LOGIC;
                signal cpu_instruction_master_continuerequest :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register_in :  STD_LOGIC;
                signal cpu_instruction_master_saved_grant_onchip_ram_64_kbytes_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_onchip_ram_64_kbytes_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_onchip_ram_64_kbytes_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_onchip_ram_64_kbytes_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_granted_onchip_ram_64_kbytes_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_qualified_request_onchip_ram_64_kbytes_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_requests_onchip_ram_64_kbytes_s1 :  STD_LOGIC;
                signal last_cycle_cpu_data_master_granted_slave_onchip_ram_64_kbytes_s1 :  STD_LOGIC;
                signal last_cycle_cpu_instruction_master_granted_slave_onchip_ram_64_kbytes_s1 :  STD_LOGIC;
                signal onchip_ram_64_kbytes_s1_allgrants :  STD_LOGIC;
                signal onchip_ram_64_kbytes_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal onchip_ram_64_kbytes_s1_any_continuerequest :  STD_LOGIC;
                signal onchip_ram_64_kbytes_s1_arb_addend :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_ram_64_kbytes_s1_arb_counter_enable :  STD_LOGIC;
                signal onchip_ram_64_kbytes_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal onchip_ram_64_kbytes_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal onchip_ram_64_kbytes_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal onchip_ram_64_kbytes_s1_arb_winner :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_ram_64_kbytes_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal onchip_ram_64_kbytes_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal onchip_ram_64_kbytes_s1_begins_xfer :  STD_LOGIC;
                signal onchip_ram_64_kbytes_s1_chosen_master_double_vector :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal onchip_ram_64_kbytes_s1_chosen_master_rot_left :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_ram_64_kbytes_s1_end_xfer :  STD_LOGIC;
                signal onchip_ram_64_kbytes_s1_firsttransfer :  STD_LOGIC;
                signal onchip_ram_64_kbytes_s1_grant_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_ram_64_kbytes_s1_in_a_read_cycle :  STD_LOGIC;
                signal onchip_ram_64_kbytes_s1_in_a_write_cycle :  STD_LOGIC;
                signal onchip_ram_64_kbytes_s1_master_qreq_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_ram_64_kbytes_s1_saved_chosen_master_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_ram_64_kbytes_s1_slavearbiterlockenable :  STD_LOGIC;
                signal onchip_ram_64_kbytes_s1_waits_for_read :  STD_LOGIC;
                signal onchip_ram_64_kbytes_s1_waits_for_write :  STD_LOGIC;
                signal p1_cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register :  STD_LOGIC;
                signal p1_cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register :  STD_LOGIC;
                signal wait_for_onchip_ram_64_kbytes_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT onchip_ram_64_kbytes_s1_end_xfer;
      end if;
    end if;

  end process;

  onchip_ram_64_kbytes_s1_begins_xfer <= NOT d1_reasons_to_wait AND ((internal_cpu_data_master_qualified_request_onchip_ram_64_kbytes_s1 OR internal_cpu_instruction_master_qualified_request_onchip_ram_64_kbytes_s1));
  internal_cpu_data_master_requests_onchip_ram_64_kbytes_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(25 DOWNTO 16) & std_logic_vector'("0000000000000000")) = std_logic_vector'("10000100000000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign onchip_ram_64_kbytes_s1_readdata_from_sa = onchip_ram_64_kbytes_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  onchip_ram_64_kbytes_s1_readdata_from_sa <= onchip_ram_64_kbytes_s1_readdata;
  --registered rdv signal_name registered_cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1 assignment, which is an e_assign
  registered_cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1 <= cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register_in;
  --onchip_ram_64_kbytes_s1_arb_share_counter set values, which is an e_mux
  onchip_ram_64_kbytes_s1_arb_share_set_values <= std_logic_vector'("001");
  --onchip_ram_64_kbytes_s1_arb_share_counter_next_value assignment, which is an e_assign
  onchip_ram_64_kbytes_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(onchip_ram_64_kbytes_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (onchip_ram_64_kbytes_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(onchip_ram_64_kbytes_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (onchip_ram_64_kbytes_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --onchip_ram_64_kbytes_s1_allgrants all slave grants, which is an e_mux
  onchip_ram_64_kbytes_s1_allgrants <= ((or_reduce(onchip_ram_64_kbytes_s1_grant_vector) OR or_reduce(onchip_ram_64_kbytes_s1_grant_vector)) OR or_reduce(onchip_ram_64_kbytes_s1_grant_vector)) OR or_reduce(onchip_ram_64_kbytes_s1_grant_vector);
  --onchip_ram_64_kbytes_s1_end_xfer assignment, which is an e_assign
  onchip_ram_64_kbytes_s1_end_xfer <= NOT ((onchip_ram_64_kbytes_s1_waits_for_read OR onchip_ram_64_kbytes_s1_waits_for_write));
  --onchip_ram_64_kbytes_s1_arb_share_counter arbitration counter enable, which is an e_assign
  onchip_ram_64_kbytes_s1_arb_counter_enable <= onchip_ram_64_kbytes_s1_end_xfer AND onchip_ram_64_kbytes_s1_allgrants;
  --onchip_ram_64_kbytes_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      onchip_ram_64_kbytes_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(onchip_ram_64_kbytes_s1_arb_counter_enable) = '1' then 
        onchip_ram_64_kbytes_s1_arb_share_counter <= onchip_ram_64_kbytes_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --onchip_ram_64_kbytes_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      onchip_ram_64_kbytes_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((or_reduce(onchip_ram_64_kbytes_s1_master_qreq_vector) AND onchip_ram_64_kbytes_s1_end_xfer)) = '1' then 
        onchip_ram_64_kbytes_s1_slavearbiterlockenable <= or_reduce(onchip_ram_64_kbytes_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master onchip_ram_64_kbytes/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= onchip_ram_64_kbytes_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --cpu/instruction_master onchip_ram_64_kbytes/s1 arbiterlock, which is an e_assign
  cpu_instruction_master_arbiterlock <= onchip_ram_64_kbytes_s1_slavearbiterlockenable AND cpu_instruction_master_continuerequest;
  --cpu/instruction_master granted onchip_ram_64_kbytes/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_instruction_master_granted_slave_onchip_ram_64_kbytes_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_instruction_master_granted_slave_onchip_ram_64_kbytes_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_instruction_master_saved_grant_onchip_ram_64_kbytes_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((onchip_ram_64_kbytes_s1_arbitration_holdoff_internal OR NOT internal_cpu_instruction_master_requests_onchip_ram_64_kbytes_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_instruction_master_granted_slave_onchip_ram_64_kbytes_s1))))));
      end if;
    end if;

  end process;

  --cpu_instruction_master_continuerequest continued request, which is an e_mux
  cpu_instruction_master_continuerequest <= last_cycle_cpu_instruction_master_granted_slave_onchip_ram_64_kbytes_s1 AND internal_cpu_instruction_master_requests_onchip_ram_64_kbytes_s1;
  --onchip_ram_64_kbytes_s1_any_continuerequest at least one master continues requesting, which is an e_mux
  onchip_ram_64_kbytes_s1_any_continuerequest <= cpu_instruction_master_continuerequest OR cpu_data_master_continuerequest;
  internal_cpu_data_master_qualified_request_onchip_ram_64_kbytes_s1 <= internal_cpu_data_master_requests_onchip_ram_64_kbytes_s1 AND NOT (((((cpu_data_master_read AND (cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register))) OR (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write))) OR cpu_instruction_master_arbiterlock));
  --cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register_in <= ((internal_cpu_data_master_granted_onchip_ram_64_kbytes_s1 AND cpu_data_master_read) AND NOT onchip_ram_64_kbytes_s1_waits_for_read) AND NOT (cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register);
  --shift register p1 cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register <= Vector_To_Std_Logic(Std_Logic_Vector'(A_ToStdLogicVector(cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register) & A_ToStdLogicVector(cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register_in)));
  --cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register <= p1_cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register;
      end if;
    end if;

  end process;

  --local readdatavalid cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1, which is an e_mux
  cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1 <= cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register;
  --onchip_ram_64_kbytes_s1_writedata mux, which is an e_mux
  onchip_ram_64_kbytes_s1_writedata <= cpu_data_master_writedata;
  --mux onchip_ram_64_kbytes_s1_clken, which is an e_mux
  onchip_ram_64_kbytes_s1_clken <= std_logic'('1');
  internal_cpu_instruction_master_requests_onchip_ram_64_kbytes_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_instruction_master_address_to_slave(25 DOWNTO 16) & std_logic_vector'("0000000000000000")) = std_logic_vector'("10000100000000000000000000")))) AND (cpu_instruction_master_read);
  --cpu/data_master granted onchip_ram_64_kbytes/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_data_master_granted_slave_onchip_ram_64_kbytes_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_data_master_granted_slave_onchip_ram_64_kbytes_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_data_master_saved_grant_onchip_ram_64_kbytes_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((onchip_ram_64_kbytes_s1_arbitration_holdoff_internal OR NOT internal_cpu_data_master_requests_onchip_ram_64_kbytes_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_data_master_granted_slave_onchip_ram_64_kbytes_s1))))));
      end if;
    end if;

  end process;

  --cpu_data_master_continuerequest continued request, which is an e_mux
  cpu_data_master_continuerequest <= last_cycle_cpu_data_master_granted_slave_onchip_ram_64_kbytes_s1 AND internal_cpu_data_master_requests_onchip_ram_64_kbytes_s1;
  internal_cpu_instruction_master_qualified_request_onchip_ram_64_kbytes_s1 <= internal_cpu_instruction_master_requests_onchip_ram_64_kbytes_s1 AND NOT ((((cpu_instruction_master_read AND (cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register))) OR cpu_data_master_arbiterlock));
  --cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register_in <= ((internal_cpu_instruction_master_granted_onchip_ram_64_kbytes_s1 AND cpu_instruction_master_read) AND NOT onchip_ram_64_kbytes_s1_waits_for_read) AND NOT (cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register);
  --shift register p1 cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register <= Vector_To_Std_Logic(Std_Logic_Vector'(A_ToStdLogicVector(cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register) & A_ToStdLogicVector(cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register_in)));
  --cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register <= p1_cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register;
      end if;
    end if;

  end process;

  --local readdatavalid cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1, which is an e_mux
  cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1 <= cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1_shift_register;
  --allow new arb cycle for onchip_ram_64_kbytes/s1, which is an e_assign
  onchip_ram_64_kbytes_s1_allow_new_arb_cycle <= NOT cpu_data_master_arbiterlock AND NOT cpu_instruction_master_arbiterlock;
  --cpu/instruction_master assignment into master qualified-requests vector for onchip_ram_64_kbytes/s1, which is an e_assign
  onchip_ram_64_kbytes_s1_master_qreq_vector(0) <= internal_cpu_instruction_master_qualified_request_onchip_ram_64_kbytes_s1;
  --cpu/instruction_master grant onchip_ram_64_kbytes/s1, which is an e_assign
  internal_cpu_instruction_master_granted_onchip_ram_64_kbytes_s1 <= onchip_ram_64_kbytes_s1_grant_vector(0);
  --cpu/instruction_master saved-grant onchip_ram_64_kbytes/s1, which is an e_assign
  cpu_instruction_master_saved_grant_onchip_ram_64_kbytes_s1 <= onchip_ram_64_kbytes_s1_arb_winner(0) AND internal_cpu_instruction_master_requests_onchip_ram_64_kbytes_s1;
  --cpu/data_master assignment into master qualified-requests vector for onchip_ram_64_kbytes/s1, which is an e_assign
  onchip_ram_64_kbytes_s1_master_qreq_vector(1) <= internal_cpu_data_master_qualified_request_onchip_ram_64_kbytes_s1;
  --cpu/data_master grant onchip_ram_64_kbytes/s1, which is an e_assign
  internal_cpu_data_master_granted_onchip_ram_64_kbytes_s1 <= onchip_ram_64_kbytes_s1_grant_vector(1);
  --cpu/data_master saved-grant onchip_ram_64_kbytes/s1, which is an e_assign
  cpu_data_master_saved_grant_onchip_ram_64_kbytes_s1 <= onchip_ram_64_kbytes_s1_arb_winner(1) AND internal_cpu_data_master_requests_onchip_ram_64_kbytes_s1;
  --onchip_ram_64_kbytes/s1 chosen-master double-vector, which is an e_assign
  onchip_ram_64_kbytes_s1_chosen_master_double_vector <= A_EXT (((std_logic_vector'("0") & ((onchip_ram_64_kbytes_s1_master_qreq_vector & onchip_ram_64_kbytes_s1_master_qreq_vector))) AND (((std_logic_vector'("0") & (Std_Logic_Vector'(NOT onchip_ram_64_kbytes_s1_master_qreq_vector & NOT onchip_ram_64_kbytes_s1_master_qreq_vector))) + (std_logic_vector'("000") & (onchip_ram_64_kbytes_s1_arb_addend))))), 4);
  --stable onehot encoding of arb winner
  onchip_ram_64_kbytes_s1_arb_winner <= A_WE_StdLogicVector((std_logic'(((onchip_ram_64_kbytes_s1_allow_new_arb_cycle AND or_reduce(onchip_ram_64_kbytes_s1_grant_vector)))) = '1'), onchip_ram_64_kbytes_s1_grant_vector, onchip_ram_64_kbytes_s1_saved_chosen_master_vector);
  --saved onchip_ram_64_kbytes_s1_grant_vector, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      onchip_ram_64_kbytes_s1_saved_chosen_master_vector <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(onchip_ram_64_kbytes_s1_allow_new_arb_cycle) = '1' then 
        onchip_ram_64_kbytes_s1_saved_chosen_master_vector <= A_WE_StdLogicVector((std_logic'(or_reduce(onchip_ram_64_kbytes_s1_grant_vector)) = '1'), onchip_ram_64_kbytes_s1_grant_vector, onchip_ram_64_kbytes_s1_saved_chosen_master_vector);
      end if;
    end if;

  end process;

  --onehot encoding of chosen master
  onchip_ram_64_kbytes_s1_grant_vector <= Std_Logic_Vector'(A_ToStdLogicVector(((onchip_ram_64_kbytes_s1_chosen_master_double_vector(1) OR onchip_ram_64_kbytes_s1_chosen_master_double_vector(3)))) & A_ToStdLogicVector(((onchip_ram_64_kbytes_s1_chosen_master_double_vector(0) OR onchip_ram_64_kbytes_s1_chosen_master_double_vector(2)))));
  --onchip_ram_64_kbytes/s1 chosen master rotated left, which is an e_assign
  onchip_ram_64_kbytes_s1_chosen_master_rot_left <= A_EXT (A_WE_StdLogicVector((((A_SLL(onchip_ram_64_kbytes_s1_arb_winner,std_logic_vector'("00000000000000000000000000000001")))) /= std_logic_vector'("00")), (std_logic_vector'("000000000000000000000000000000") & ((A_SLL(onchip_ram_64_kbytes_s1_arb_winner,std_logic_vector'("00000000000000000000000000000001"))))), std_logic_vector'("00000000000000000000000000000001")), 2);
  --onchip_ram_64_kbytes/s1's addend for next-master-grant
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      onchip_ram_64_kbytes_s1_arb_addend <= std_logic_vector'("01");
    elsif clk'event and clk = '1' then
      if std_logic'(or_reduce(onchip_ram_64_kbytes_s1_grant_vector)) = '1' then 
        onchip_ram_64_kbytes_s1_arb_addend <= A_WE_StdLogicVector((std_logic'(onchip_ram_64_kbytes_s1_end_xfer) = '1'), onchip_ram_64_kbytes_s1_chosen_master_rot_left, onchip_ram_64_kbytes_s1_grant_vector);
      end if;
    end if;

  end process;

  onchip_ram_64_kbytes_s1_chipselect <= internal_cpu_data_master_granted_onchip_ram_64_kbytes_s1 OR internal_cpu_instruction_master_granted_onchip_ram_64_kbytes_s1;
  --onchip_ram_64_kbytes_s1_firsttransfer first transaction, which is an e_assign
  onchip_ram_64_kbytes_s1_firsttransfer <= NOT ((onchip_ram_64_kbytes_s1_slavearbiterlockenable AND onchip_ram_64_kbytes_s1_any_continuerequest));
  --onchip_ram_64_kbytes_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  onchip_ram_64_kbytes_s1_beginbursttransfer_internal <= onchip_ram_64_kbytes_s1_begins_xfer AND onchip_ram_64_kbytes_s1_firsttransfer;
  --onchip_ram_64_kbytes_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  onchip_ram_64_kbytes_s1_arbitration_holdoff_internal <= onchip_ram_64_kbytes_s1_begins_xfer AND onchip_ram_64_kbytes_s1_firsttransfer;
  --onchip_ram_64_kbytes_s1_write assignment, which is an e_mux
  onchip_ram_64_kbytes_s1_write <= internal_cpu_data_master_granted_onchip_ram_64_kbytes_s1 AND cpu_data_master_write;
  --onchip_ram_64_kbytes_s1_address mux, which is an e_mux
  onchip_ram_64_kbytes_s1_address <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_onchip_ram_64_kbytes_s1)) = '1'), (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010"))), (A_SRL(cpu_instruction_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")))), 14);
  --d1_onchip_ram_64_kbytes_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_onchip_ram_64_kbytes_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_onchip_ram_64_kbytes_s1_end_xfer <= onchip_ram_64_kbytes_s1_end_xfer;
      end if;
    end if;

  end process;

  --onchip_ram_64_kbytes_s1_waits_for_read in a cycle, which is an e_mux
  onchip_ram_64_kbytes_s1_waits_for_read <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(onchip_ram_64_kbytes_s1_in_a_read_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --onchip_ram_64_kbytes_s1_in_a_read_cycle assignment, which is an e_assign
  onchip_ram_64_kbytes_s1_in_a_read_cycle <= ((internal_cpu_data_master_granted_onchip_ram_64_kbytes_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_onchip_ram_64_kbytes_s1 AND cpu_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= onchip_ram_64_kbytes_s1_in_a_read_cycle;
  --onchip_ram_64_kbytes_s1_waits_for_write in a cycle, which is an e_mux
  onchip_ram_64_kbytes_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(onchip_ram_64_kbytes_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --onchip_ram_64_kbytes_s1_in_a_write_cycle assignment, which is an e_assign
  onchip_ram_64_kbytes_s1_in_a_write_cycle <= internal_cpu_data_master_granted_onchip_ram_64_kbytes_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= onchip_ram_64_kbytes_s1_in_a_write_cycle;
  wait_for_onchip_ram_64_kbytes_s1_counter <= std_logic'('0');
  --onchip_ram_64_kbytes_s1_byteenable byte enable port mux, which is an e_mux
  onchip_ram_64_kbytes_s1_byteenable <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_onchip_ram_64_kbytes_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))), 4);
  --vhdl renameroo for output signals
  cpu_data_master_granted_onchip_ram_64_kbytes_s1 <= internal_cpu_data_master_granted_onchip_ram_64_kbytes_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_onchip_ram_64_kbytes_s1 <= internal_cpu_data_master_qualified_request_onchip_ram_64_kbytes_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_onchip_ram_64_kbytes_s1 <= internal_cpu_data_master_requests_onchip_ram_64_kbytes_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_onchip_ram_64_kbytes_s1 <= internal_cpu_instruction_master_granted_onchip_ram_64_kbytes_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_onchip_ram_64_kbytes_s1 <= internal_cpu_instruction_master_qualified_request_onchip_ram_64_kbytes_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_onchip_ram_64_kbytes_s1 <= internal_cpu_instruction_master_requests_onchip_ram_64_kbytes_s1;
--synthesis translate_off
    --grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line6 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_granted_onchip_ram_64_kbytes_s1))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_instruction_master_granted_onchip_ram_64_kbytes_s1))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line6, now);
          write(write_line6, string'(": "));
          write(write_line6, string'("> 1 of grant signals are active simultaneously"));
          write(output, write_line6.all);
          deallocate (write_line6);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --saved_grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line7 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_data_master_saved_grant_onchip_ram_64_kbytes_s1))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_saved_grant_onchip_ram_64_kbytes_s1))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line7, now);
          write(write_line7, string'(": "));
          write(write_line7, string'("> 1 of saved_grant signals are active simultaneously"));
          write(output, write_line7.all);
          deallocate (write_line7);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity reconfig_request_pio_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reconfig_request_pio_s1_readdata : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_reconfig_request_pio_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_reconfig_request_pio_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_reconfig_request_pio_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_reconfig_request_pio_s1 : OUT STD_LOGIC;
                 signal d1_reconfig_request_pio_s1_end_xfer : OUT STD_LOGIC;
                 signal reconfig_request_pio_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal reconfig_request_pio_s1_chipselect : OUT STD_LOGIC;
                 signal reconfig_request_pio_s1_readdata_from_sa : OUT STD_LOGIC;
                 signal reconfig_request_pio_s1_reset_n : OUT STD_LOGIC;
                 signal reconfig_request_pio_s1_write_n : OUT STD_LOGIC;
                 signal reconfig_request_pio_s1_writedata : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of reconfig_request_pio_s1_arbitrator : entity is FALSE;
end entity reconfig_request_pio_s1_arbitrator;


architecture europa of reconfig_request_pio_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_reconfig_request_pio_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_reconfig_request_pio_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_reconfig_request_pio_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_reconfig_request_pio_s1 :  STD_LOGIC;
                signal reconfig_request_pio_s1_allgrants :  STD_LOGIC;
                signal reconfig_request_pio_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal reconfig_request_pio_s1_any_continuerequest :  STD_LOGIC;
                signal reconfig_request_pio_s1_arb_counter_enable :  STD_LOGIC;
                signal reconfig_request_pio_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal reconfig_request_pio_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal reconfig_request_pio_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal reconfig_request_pio_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal reconfig_request_pio_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal reconfig_request_pio_s1_begins_xfer :  STD_LOGIC;
                signal reconfig_request_pio_s1_end_xfer :  STD_LOGIC;
                signal reconfig_request_pio_s1_firsttransfer :  STD_LOGIC;
                signal reconfig_request_pio_s1_grant_vector :  STD_LOGIC;
                signal reconfig_request_pio_s1_in_a_read_cycle :  STD_LOGIC;
                signal reconfig_request_pio_s1_in_a_write_cycle :  STD_LOGIC;
                signal reconfig_request_pio_s1_master_qreq_vector :  STD_LOGIC;
                signal reconfig_request_pio_s1_slavearbiterlockenable :  STD_LOGIC;
                signal reconfig_request_pio_s1_waits_for_read :  STD_LOGIC;
                signal reconfig_request_pio_s1_waits_for_write :  STD_LOGIC;
                signal wait_for_reconfig_request_pio_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT reconfig_request_pio_s1_end_xfer;
      end if;
    end if;

  end process;

  reconfig_request_pio_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_reconfig_request_pio_s1);
  internal_cpu_data_master_requests_reconfig_request_pio_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(25 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10000100100000100010100000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign reconfig_request_pio_s1_readdata_from_sa = reconfig_request_pio_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  reconfig_request_pio_s1_readdata_from_sa <= reconfig_request_pio_s1_readdata;
  --reconfig_request_pio_s1_arb_share_counter set values, which is an e_mux
  reconfig_request_pio_s1_arb_share_set_values <= std_logic_vector'("001");
  --reconfig_request_pio_s1_arb_share_counter_next_value assignment, which is an e_assign
  reconfig_request_pio_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(reconfig_request_pio_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (reconfig_request_pio_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(reconfig_request_pio_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (reconfig_request_pio_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --reconfig_request_pio_s1_allgrants all slave grants, which is an e_mux
  reconfig_request_pio_s1_allgrants <= reconfig_request_pio_s1_grant_vector;
  --reconfig_request_pio_s1_end_xfer assignment, which is an e_assign
  reconfig_request_pio_s1_end_xfer <= NOT ((reconfig_request_pio_s1_waits_for_read OR reconfig_request_pio_s1_waits_for_write));
  --reconfig_request_pio_s1_arb_share_counter arbitration counter enable, which is an e_assign
  reconfig_request_pio_s1_arb_counter_enable <= reconfig_request_pio_s1_end_xfer AND reconfig_request_pio_s1_allgrants;
  --reconfig_request_pio_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      reconfig_request_pio_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(reconfig_request_pio_s1_arb_counter_enable) = '1' then 
        reconfig_request_pio_s1_arb_share_counter <= reconfig_request_pio_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --reconfig_request_pio_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      reconfig_request_pio_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((reconfig_request_pio_s1_master_qreq_vector AND reconfig_request_pio_s1_end_xfer)) = '1' then 
        reconfig_request_pio_s1_slavearbiterlockenable <= or_reduce(reconfig_request_pio_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master reconfig_request_pio/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= reconfig_request_pio_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --reconfig_request_pio_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  reconfig_request_pio_s1_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_reconfig_request_pio_s1 <= internal_cpu_data_master_requests_reconfig_request_pio_s1 AND NOT (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write));
  --reconfig_request_pio_s1_writedata mux, which is an e_mux
  reconfig_request_pio_s1_writedata <= cpu_data_master_writedata(0);
  --master is always granted when requested
  internal_cpu_data_master_granted_reconfig_request_pio_s1 <= internal_cpu_data_master_qualified_request_reconfig_request_pio_s1;
  --cpu/data_master saved-grant reconfig_request_pio/s1, which is an e_assign
  cpu_data_master_saved_grant_reconfig_request_pio_s1 <= internal_cpu_data_master_requests_reconfig_request_pio_s1;
  --allow new arb cycle for reconfig_request_pio/s1, which is an e_assign
  reconfig_request_pio_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  reconfig_request_pio_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  reconfig_request_pio_s1_master_qreq_vector <= std_logic'('1');
  --reconfig_request_pio_s1_reset_n assignment, which is an e_assign
  reconfig_request_pio_s1_reset_n <= reset_n;
  reconfig_request_pio_s1_chipselect <= internal_cpu_data_master_granted_reconfig_request_pio_s1;
  --reconfig_request_pio_s1_firsttransfer first transaction, which is an e_assign
  reconfig_request_pio_s1_firsttransfer <= NOT ((reconfig_request_pio_s1_slavearbiterlockenable AND reconfig_request_pio_s1_any_continuerequest));
  --reconfig_request_pio_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  reconfig_request_pio_s1_beginbursttransfer_internal <= reconfig_request_pio_s1_begins_xfer AND reconfig_request_pio_s1_firsttransfer;
  --reconfig_request_pio_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  reconfig_request_pio_s1_arbitration_holdoff_internal <= reconfig_request_pio_s1_begins_xfer AND reconfig_request_pio_s1_firsttransfer;
  --~reconfig_request_pio_s1_write_n assignment, which is an e_mux
  reconfig_request_pio_s1_write_n <= NOT ((internal_cpu_data_master_granted_reconfig_request_pio_s1 AND cpu_data_master_write));
  --reconfig_request_pio_s1_address mux, which is an e_mux
  reconfig_request_pio_s1_address <= A_EXT (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_reconfig_request_pio_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reconfig_request_pio_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reconfig_request_pio_s1_end_xfer <= reconfig_request_pio_s1_end_xfer;
      end if;
    end if;

  end process;

  --reconfig_request_pio_s1_waits_for_read in a cycle, which is an e_mux
  reconfig_request_pio_s1_waits_for_read <= reconfig_request_pio_s1_in_a_read_cycle AND reconfig_request_pio_s1_begins_xfer;
  --reconfig_request_pio_s1_in_a_read_cycle assignment, which is an e_assign
  reconfig_request_pio_s1_in_a_read_cycle <= internal_cpu_data_master_granted_reconfig_request_pio_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= reconfig_request_pio_s1_in_a_read_cycle;
  --reconfig_request_pio_s1_waits_for_write in a cycle, which is an e_mux
  reconfig_request_pio_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(reconfig_request_pio_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --reconfig_request_pio_s1_in_a_write_cycle assignment, which is an e_assign
  reconfig_request_pio_s1_in_a_write_cycle <= internal_cpu_data_master_granted_reconfig_request_pio_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= reconfig_request_pio_s1_in_a_write_cycle;
  wait_for_reconfig_request_pio_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_data_master_granted_reconfig_request_pio_s1 <= internal_cpu_data_master_granted_reconfig_request_pio_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_reconfig_request_pio_s1 <= internal_cpu_data_master_qualified_request_reconfig_request_pio_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_reconfig_request_pio_s1 <= internal_cpu_data_master_requests_reconfig_request_pio_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity sdram_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;
                 signal sdram_s1_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal sdram_s1_readdatavalid : IN STD_LOGIC;
                 signal sdram_s1_waitrequest : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_sdram_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_sdram_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sdram_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sdram_s1_shift_register : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal cpu_data_master_requests_sdram_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_sdram_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_sdram_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_sdram_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_sdram_s1_shift_register : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal cpu_instruction_master_requests_sdram_s1 : OUT STD_LOGIC;
                 signal d1_sdram_s1_end_xfer : OUT STD_LOGIC;
                 signal sdram_s1_address : OUT STD_LOGIC_VECTOR (21 DOWNTO 0);
                 signal sdram_s1_byteenable_n : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal sdram_s1_chipselect : OUT STD_LOGIC;
                 signal sdram_s1_posted_fifo_readenable : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal sdram_s1_posted_fifo_writenable : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal sdram_s1_read_n : OUT STD_LOGIC;
                 signal sdram_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal sdram_s1_reset_n : OUT STD_LOGIC;
                 signal sdram_s1_waitrequest_from_sa : OUT STD_LOGIC;
                 signal sdram_s1_write_n : OUT STD_LOGIC;
                 signal sdram_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of sdram_s1_arbitrator : entity is FALSE;
end entity sdram_s1_arbitrator;


architecture europa of sdram_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_sdram_s1_fifo_output :  STD_LOGIC;
                signal cpu_data_master_saved_grant_sdram_s1 :  STD_LOGIC;
                signal cpu_instruction_master_arbiterlock :  STD_LOGIC;
                signal cpu_instruction_master_continuerequest :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_sdram_s1_fifo_output :  STD_LOGIC;
                signal cpu_instruction_master_saved_grant_sdram_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_sdram_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_sdram_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_read_data_valid_sdram_s1_shift_register :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_cpu_data_master_requests_sdram_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_granted_sdram_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_qualified_request_sdram_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_cpu_instruction_master_requests_sdram_s1 :  STD_LOGIC;
                signal internal_sdram_s1_posted_fifo_readenable :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_sdram_s1_posted_fifo_writenable :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_sdram_s1_waitrequest_from_sa :  STD_LOGIC;
                signal last_cycle_cpu_data_master_granted_slave_sdram_s1 :  STD_LOGIC;
                signal last_cycle_cpu_instruction_master_granted_slave_sdram_s1 :  STD_LOGIC;
                signal sdram_s1_allgrants :  STD_LOGIC;
                signal sdram_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal sdram_s1_any_continuerequest :  STD_LOGIC;
                signal sdram_s1_arb_addend :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal sdram_s1_arb_counter_enable :  STD_LOGIC;
                signal sdram_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sdram_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sdram_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sdram_s1_arb_winner :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal sdram_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal sdram_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal sdram_s1_begins_xfer :  STD_LOGIC;
                signal sdram_s1_chosen_master_double_vector :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal sdram_s1_chosen_master_rot_left :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal sdram_s1_end_xfer :  STD_LOGIC;
                signal sdram_s1_firsttransfer :  STD_LOGIC;
                signal sdram_s1_grant_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal sdram_s1_in_a_read_cycle :  STD_LOGIC;
                signal sdram_s1_in_a_write_cycle :  STD_LOGIC;
                signal sdram_s1_master_qreq_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal sdram_s1_readdatavalid_from_sa :  STD_LOGIC;
                signal sdram_s1_saved_chosen_master_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal sdram_s1_slavearbiterlockenable :  STD_LOGIC;
                signal sdram_s1_waits_for_read :  STD_LOGIC;
                signal sdram_s1_waits_for_write :  STD_LOGIC;
                signal wait_for_sdram_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT sdram_s1_end_xfer;
      end if;
    end if;

  end process;

  sdram_s1_begins_xfer <= NOT d1_reasons_to_wait AND ((internal_cpu_data_master_qualified_request_sdram_s1 OR internal_cpu_instruction_master_qualified_request_sdram_s1));
  internal_cpu_data_master_requests_sdram_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(25 DOWNTO 24) & std_logic_vector'("000000000000000000000000")) = std_logic_vector'("01000000000000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign sdram_s1_readdata_from_sa = sdram_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  sdram_s1_readdata_from_sa <= sdram_s1_readdata;
  --assign sdram_s1_waitrequest_from_sa = sdram_s1_waitrequest so that symbol knows where to group signals which may go to master only, which is an e_assign
  internal_sdram_s1_waitrequest_from_sa <= sdram_s1_waitrequest;
  --assign sdram_s1_readdatavalid_from_sa = sdram_s1_readdatavalid so that symbol knows where to group signals which may go to master only, which is an e_assign
  sdram_s1_readdatavalid_from_sa <= sdram_s1_readdatavalid;
  --sdram_s1_arb_share_counter set values, which is an e_mux
  sdram_s1_arb_share_set_values <= std_logic_vector'("001");
  --sdram_s1_arb_share_counter_next_value assignment, which is an e_assign
  sdram_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(sdram_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (sdram_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(sdram_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (sdram_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --sdram_s1_allgrants all slave grants, which is an e_mux
  sdram_s1_allgrants <= ((or_reduce(sdram_s1_grant_vector) OR or_reduce(sdram_s1_grant_vector)) OR or_reduce(sdram_s1_grant_vector)) OR or_reduce(sdram_s1_grant_vector);
  --sdram_s1_end_xfer assignment, which is an e_assign
  sdram_s1_end_xfer <= NOT ((sdram_s1_waits_for_read OR sdram_s1_waits_for_write));
  --sdram_s1_arb_share_counter arbitration counter enable, which is an e_assign
  sdram_s1_arb_counter_enable <= sdram_s1_end_xfer AND sdram_s1_allgrants;
  --sdram_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sdram_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(sdram_s1_arb_counter_enable) = '1' then 
        sdram_s1_arb_share_counter <= sdram_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --sdram_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sdram_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((or_reduce(sdram_s1_master_qreq_vector) AND sdram_s1_end_xfer)) = '1' then 
        sdram_s1_slavearbiterlockenable <= or_reduce(sdram_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master sdram/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= sdram_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --cpu/instruction_master sdram/s1 arbiterlock, which is an e_assign
  cpu_instruction_master_arbiterlock <= sdram_s1_slavearbiterlockenable AND cpu_instruction_master_continuerequest;
  --cpu/instruction_master granted sdram/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_instruction_master_granted_slave_sdram_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_instruction_master_granted_slave_sdram_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_instruction_master_saved_grant_sdram_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((sdram_s1_arbitration_holdoff_internal OR NOT internal_cpu_instruction_master_requests_sdram_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_instruction_master_granted_slave_sdram_s1))))));
      end if;
    end if;

  end process;

  --cpu_instruction_master_continuerequest continued request, which is an e_mux
  cpu_instruction_master_continuerequest <= last_cycle_cpu_instruction_master_granted_slave_sdram_s1 AND internal_cpu_instruction_master_requests_sdram_s1;
  --sdram_s1_any_continuerequest at least one master continues requesting, which is an e_mux
  sdram_s1_any_continuerequest <= cpu_instruction_master_continuerequest OR cpu_data_master_continuerequest;
  internal_cpu_data_master_qualified_request_sdram_s1 <= internal_cpu_data_master_requests_sdram_s1 AND NOT (((((cpu_data_master_read AND ((NOT cpu_data_master_waitrequest OR (or_reduce(internal_cpu_data_master_read_data_valid_sdram_s1_shift_register)))))) OR (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write))) OR cpu_instruction_master_arbiterlock));
  --sdram_s1_posted_fifo_writenable register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_sdram_s1_posted_fifo_writenable <= std_logic_vector'("0000001");
    elsif clk'event and clk = '1' then
      if std_logic'((in_a_read_cycle AND NOT sdram_s1_waits_for_read)) = '1' then 
        internal_sdram_s1_posted_fifo_writenable <= Std_Logic_Vector'(A_ToStdLogicVector(internal_sdram_s1_posted_fifo_writenable(5)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_writenable(4)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_writenable(3)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_writenable(2)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_writenable(1)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_writenable(0)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_writenable(6)));
      end if;
    end if;

  end process;

  --sdram_s1_posted_fifo_readenable register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_sdram_s1_posted_fifo_readenable <= std_logic_vector'("0000001");
    elsif clk'event and clk = '1' then
      if std_logic'(sdram_s1_readdatavalid_from_sa) = '1' then 
        internal_sdram_s1_posted_fifo_readenable <= Std_Logic_Vector'(A_ToStdLogicVector(internal_sdram_s1_posted_fifo_readenable(5)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_readenable(4)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_readenable(3)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_readenable(2)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_readenable(1)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_readenable(0)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_readenable(6)));
      end if;
    end if;

  end process;

  --cpu_data_master_read_data_valid_sdram_s1_shift_register[0] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(0) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_read) AND internal_sdram_s1_posted_fifo_writenable(0)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(0) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(0))) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(0) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_data_master_read_data_valid_sdram_s1_shift_register[1] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(1) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_read) AND internal_sdram_s1_posted_fifo_writenable(1)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(1) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(1))) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(1) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_data_master_read_data_valid_sdram_s1_shift_register[2] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(2) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_read) AND internal_sdram_s1_posted_fifo_writenable(2)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(2) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(2))) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(2) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_data_master_read_data_valid_sdram_s1_shift_register[3] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(3) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_read) AND internal_sdram_s1_posted_fifo_writenable(3)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(3) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(3))) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(3) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_data_master_read_data_valid_sdram_s1_shift_register[4] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(4) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_read) AND internal_sdram_s1_posted_fifo_writenable(4)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(4) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(4))) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(4) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_data_master_read_data_valid_sdram_s1_shift_register[5] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(5) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_read) AND internal_sdram_s1_posted_fifo_writenable(5)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(5) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(5))) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(5) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_data_master_read_data_valid_sdram_s1_shift_register[6] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(6) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_read) AND internal_sdram_s1_posted_fifo_writenable(6)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(6) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(6))) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(6) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_data_master_read_data_valid_sdram_s1_fifo_output mux: inputs:: variable latency fifo state.  Output selects master which gets readdata, which is an e_mux
  cpu_data_master_read_data_valid_sdram_s1_fifo_output <= (((((((internal_sdram_s1_posted_fifo_readenable(0) AND internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(0))) OR ((internal_sdram_s1_posted_fifo_readenable(1) AND internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(1)))) OR ((internal_sdram_s1_posted_fifo_readenable(2) AND internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(2)))) OR ((internal_sdram_s1_posted_fifo_readenable(3) AND internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(3)))) OR ((internal_sdram_s1_posted_fifo_readenable(4) AND internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(4)))) OR ((internal_sdram_s1_posted_fifo_readenable(5) AND internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(5)))) OR ((internal_sdram_s1_posted_fifo_readenable(6) AND internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(6)));
  --local readdatavalid cpu_data_master_read_data_valid_sdram_s1, which is an e_mux
  cpu_data_master_read_data_valid_sdram_s1 <= sdram_s1_readdatavalid_from_sa AND cpu_data_master_read_data_valid_sdram_s1_fifo_output;
  --sdram_s1_writedata mux, which is an e_mux
  sdram_s1_writedata <= cpu_data_master_writedata;
  internal_cpu_instruction_master_requests_sdram_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_instruction_master_address_to_slave(25 DOWNTO 24) & std_logic_vector'("000000000000000000000000")) = std_logic_vector'("01000000000000000000000000")))) AND (cpu_instruction_master_read);
  --cpu/data_master granted sdram/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_data_master_granted_slave_sdram_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_data_master_granted_slave_sdram_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_data_master_saved_grant_sdram_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((sdram_s1_arbitration_holdoff_internal OR NOT internal_cpu_data_master_requests_sdram_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_data_master_granted_slave_sdram_s1))))));
      end if;
    end if;

  end process;

  --cpu_data_master_continuerequest continued request, which is an e_mux
  cpu_data_master_continuerequest <= last_cycle_cpu_data_master_granted_slave_sdram_s1 AND internal_cpu_data_master_requests_sdram_s1;
  internal_cpu_instruction_master_qualified_request_sdram_s1 <= internal_cpu_instruction_master_requests_sdram_s1 AND NOT ((((cpu_instruction_master_read AND (or_reduce(internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register)))) OR cpu_data_master_arbiterlock));
  --cpu_instruction_master_read_data_valid_sdram_s1_shift_register[0] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(0) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_instruction_master_granted_sdram_s1 AND cpu_instruction_master_read) AND internal_sdram_s1_posted_fifo_writenable(0)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(0) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(0))) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(0) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_instruction_master_read_data_valid_sdram_s1_shift_register[1] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(1) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_instruction_master_granted_sdram_s1 AND cpu_instruction_master_read) AND internal_sdram_s1_posted_fifo_writenable(1)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(1) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(1))) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(1) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_instruction_master_read_data_valid_sdram_s1_shift_register[2] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(2) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_instruction_master_granted_sdram_s1 AND cpu_instruction_master_read) AND internal_sdram_s1_posted_fifo_writenable(2)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(2) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(2))) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(2) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_instruction_master_read_data_valid_sdram_s1_shift_register[3] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(3) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_instruction_master_granted_sdram_s1 AND cpu_instruction_master_read) AND internal_sdram_s1_posted_fifo_writenable(3)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(3) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(3))) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(3) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_instruction_master_read_data_valid_sdram_s1_shift_register[4] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(4) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_instruction_master_granted_sdram_s1 AND cpu_instruction_master_read) AND internal_sdram_s1_posted_fifo_writenable(4)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(4) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(4))) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(4) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_instruction_master_read_data_valid_sdram_s1_shift_register[5] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(5) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_instruction_master_granted_sdram_s1 AND cpu_instruction_master_read) AND internal_sdram_s1_posted_fifo_writenable(5)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(5) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(5))) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(5) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_instruction_master_read_data_valid_sdram_s1_shift_register[6] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(6) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_instruction_master_granted_sdram_s1 AND cpu_instruction_master_read) AND internal_sdram_s1_posted_fifo_writenable(6)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(6) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(6))) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(6) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_instruction_master_read_data_valid_sdram_s1_fifo_output mux: inputs:: variable latency fifo state.  Output selects master which gets readdata, which is an e_mux
  cpu_instruction_master_read_data_valid_sdram_s1_fifo_output <= (((((((internal_sdram_s1_posted_fifo_readenable(0) AND internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(0))) OR ((internal_sdram_s1_posted_fifo_readenable(1) AND internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(1)))) OR ((internal_sdram_s1_posted_fifo_readenable(2) AND internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(2)))) OR ((internal_sdram_s1_posted_fifo_readenable(3) AND internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(3)))) OR ((internal_sdram_s1_posted_fifo_readenable(4) AND internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(4)))) OR ((internal_sdram_s1_posted_fifo_readenable(5) AND internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(5)))) OR ((internal_sdram_s1_posted_fifo_readenable(6) AND internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(6)));
  --local readdatavalid cpu_instruction_master_read_data_valid_sdram_s1, which is an e_mux
  cpu_instruction_master_read_data_valid_sdram_s1 <= sdram_s1_readdatavalid_from_sa AND cpu_instruction_master_read_data_valid_sdram_s1_fifo_output;
  --allow new arb cycle for sdram/s1, which is an e_assign
  sdram_s1_allow_new_arb_cycle <= NOT cpu_data_master_arbiterlock AND NOT cpu_instruction_master_arbiterlock;
  --cpu/instruction_master assignment into master qualified-requests vector for sdram/s1, which is an e_assign
  sdram_s1_master_qreq_vector(0) <= internal_cpu_instruction_master_qualified_request_sdram_s1;
  --cpu/instruction_master grant sdram/s1, which is an e_assign
  internal_cpu_instruction_master_granted_sdram_s1 <= sdram_s1_grant_vector(0);
  --cpu/instruction_master saved-grant sdram/s1, which is an e_assign
  cpu_instruction_master_saved_grant_sdram_s1 <= sdram_s1_arb_winner(0) AND internal_cpu_instruction_master_requests_sdram_s1;
  --cpu/data_master assignment into master qualified-requests vector for sdram/s1, which is an e_assign
  sdram_s1_master_qreq_vector(1) <= internal_cpu_data_master_qualified_request_sdram_s1;
  --cpu/data_master grant sdram/s1, which is an e_assign
  internal_cpu_data_master_granted_sdram_s1 <= sdram_s1_grant_vector(1);
  --cpu/data_master saved-grant sdram/s1, which is an e_assign
  cpu_data_master_saved_grant_sdram_s1 <= sdram_s1_arb_winner(1) AND internal_cpu_data_master_requests_sdram_s1;
  --sdram/s1 chosen-master double-vector, which is an e_assign
  sdram_s1_chosen_master_double_vector <= A_EXT (((std_logic_vector'("0") & ((sdram_s1_master_qreq_vector & sdram_s1_master_qreq_vector))) AND (((std_logic_vector'("0") & (Std_Logic_Vector'(NOT sdram_s1_master_qreq_vector & NOT sdram_s1_master_qreq_vector))) + (std_logic_vector'("000") & (sdram_s1_arb_addend))))), 4);
  --stable onehot encoding of arb winner
  sdram_s1_arb_winner <= A_WE_StdLogicVector((std_logic'(((sdram_s1_allow_new_arb_cycle AND or_reduce(sdram_s1_grant_vector)))) = '1'), sdram_s1_grant_vector, sdram_s1_saved_chosen_master_vector);
  --saved sdram_s1_grant_vector, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sdram_s1_saved_chosen_master_vector <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(sdram_s1_allow_new_arb_cycle) = '1' then 
        sdram_s1_saved_chosen_master_vector <= A_WE_StdLogicVector((std_logic'(or_reduce(sdram_s1_grant_vector)) = '1'), sdram_s1_grant_vector, sdram_s1_saved_chosen_master_vector);
      end if;
    end if;

  end process;

  --onehot encoding of chosen master
  sdram_s1_grant_vector <= Std_Logic_Vector'(A_ToStdLogicVector(((sdram_s1_chosen_master_double_vector(1) OR sdram_s1_chosen_master_double_vector(3)))) & A_ToStdLogicVector(((sdram_s1_chosen_master_double_vector(0) OR sdram_s1_chosen_master_double_vector(2)))));
  --sdram/s1 chosen master rotated left, which is an e_assign
  sdram_s1_chosen_master_rot_left <= A_EXT (A_WE_StdLogicVector((((A_SLL(sdram_s1_arb_winner,std_logic_vector'("00000000000000000000000000000001")))) /= std_logic_vector'("00")), (std_logic_vector'("000000000000000000000000000000") & ((A_SLL(sdram_s1_arb_winner,std_logic_vector'("00000000000000000000000000000001"))))), std_logic_vector'("00000000000000000000000000000001")), 2);
  --sdram/s1's addend for next-master-grant
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sdram_s1_arb_addend <= std_logic_vector'("01");
    elsif clk'event and clk = '1' then
      if std_logic'(or_reduce(sdram_s1_grant_vector)) = '1' then 
        sdram_s1_arb_addend <= A_WE_StdLogicVector((std_logic'(sdram_s1_end_xfer) = '1'), sdram_s1_chosen_master_rot_left, sdram_s1_grant_vector);
      end if;
    end if;

  end process;

  --sdram_s1_reset_n assignment, which is an e_assign
  sdram_s1_reset_n <= reset_n;
  sdram_s1_chipselect <= internal_cpu_data_master_granted_sdram_s1 OR internal_cpu_instruction_master_granted_sdram_s1;
  --sdram_s1_firsttransfer first transaction, which is an e_assign
  sdram_s1_firsttransfer <= NOT ((sdram_s1_slavearbiterlockenable AND sdram_s1_any_continuerequest));
  --sdram_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  sdram_s1_beginbursttransfer_internal <= sdram_s1_begins_xfer AND sdram_s1_firsttransfer;
  --sdram_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  sdram_s1_arbitration_holdoff_internal <= sdram_s1_begins_xfer AND sdram_s1_firsttransfer;
  --~sdram_s1_read_n assignment, which is an e_mux
  sdram_s1_read_n <= NOT ((((internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_sdram_s1 AND cpu_instruction_master_read))));
  --~sdram_s1_write_n assignment, which is an e_mux
  sdram_s1_write_n <= NOT ((internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_write));
  --sdram_s1_address mux, which is an e_mux
  sdram_s1_address <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_sdram_s1)) = '1'), (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010"))), (A_SRL(cpu_instruction_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")))), 22);
  --d1_sdram_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_sdram_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_sdram_s1_end_xfer <= sdram_s1_end_xfer;
      end if;
    end if;

  end process;

  --sdram_s1_waits_for_read in a cycle, which is an e_mux
  sdram_s1_waits_for_read <= sdram_s1_in_a_read_cycle AND internal_sdram_s1_waitrequest_from_sa;
  --sdram_s1_in_a_read_cycle assignment, which is an e_assign
  sdram_s1_in_a_read_cycle <= ((internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_sdram_s1 AND cpu_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= sdram_s1_in_a_read_cycle;
  --sdram_s1_waits_for_write in a cycle, which is an e_mux
  sdram_s1_waits_for_write <= sdram_s1_in_a_write_cycle AND internal_sdram_s1_waitrequest_from_sa;
  --sdram_s1_in_a_write_cycle assignment, which is an e_assign
  sdram_s1_in_a_write_cycle <= internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= sdram_s1_in_a_write_cycle;
  wait_for_sdram_s1_counter <= std_logic'('0');
  --~sdram_s1_byteenable_n byte enable port mux, which is an e_mux
  sdram_s1_byteenable_n <= A_EXT (NOT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_sdram_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001")))), 4);
  --vhdl renameroo for output signals
  cpu_data_master_granted_sdram_s1 <= internal_cpu_data_master_granted_sdram_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_sdram_s1 <= internal_cpu_data_master_qualified_request_sdram_s1;
  --vhdl renameroo for output signals
  cpu_data_master_read_data_valid_sdram_s1_shift_register <= internal_cpu_data_master_read_data_valid_sdram_s1_shift_register;
  --vhdl renameroo for output signals
  cpu_data_master_requests_sdram_s1 <= internal_cpu_data_master_requests_sdram_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_sdram_s1 <= internal_cpu_instruction_master_granted_sdram_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_sdram_s1 <= internal_cpu_instruction_master_qualified_request_sdram_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_read_data_valid_sdram_s1_shift_register <= internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_sdram_s1 <= internal_cpu_instruction_master_requests_sdram_s1;
  --vhdl renameroo for output signals
  sdram_s1_posted_fifo_readenable <= internal_sdram_s1_posted_fifo_readenable;
  --vhdl renameroo for output signals
  sdram_s1_posted_fifo_writenable <= internal_sdram_s1_posted_fifo_writenable;
  --vhdl renameroo for output signals
  sdram_s1_waitrequest_from_sa <= internal_sdram_s1_waitrequest_from_sa;
--synthesis translate_off
    --grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line8 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_granted_sdram_s1))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_instruction_master_granted_sdram_s1))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line8, now);
          write(write_line8, string'(": "));
          write(write_line8, string'("> 1 of grant signals are active simultaneously"));
          write(output, write_line8.all);
          deallocate (write_line8);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --saved_grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line9 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_data_master_saved_grant_sdram_s1))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_saved_grant_sdram_s1))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line9, now);
          write(write_line9, string'(": "));
          write(write_line9, string'("> 1 of saved_grant signals are active simultaneously"));
          write(output, write_line9.all);
          deallocate (write_line9);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity seven_seg_pio_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_seven_seg_pio_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_seven_seg_pio_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_seven_seg_pio_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_seven_seg_pio_s1 : OUT STD_LOGIC;
                 signal d1_seven_seg_pio_s1_end_xfer : OUT STD_LOGIC;
                 signal seven_seg_pio_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal seven_seg_pio_s1_chipselect : OUT STD_LOGIC;
                 signal seven_seg_pio_s1_reset_n : OUT STD_LOGIC;
                 signal seven_seg_pio_s1_write_n : OUT STD_LOGIC;
                 signal seven_seg_pio_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of seven_seg_pio_s1_arbitrator : entity is FALSE;
end entity seven_seg_pio_s1_arbitrator;


architecture europa of seven_seg_pio_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_seven_seg_pio_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_seven_seg_pio_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_seven_seg_pio_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_seven_seg_pio_s1 :  STD_LOGIC;
                signal seven_seg_pio_s1_allgrants :  STD_LOGIC;
                signal seven_seg_pio_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal seven_seg_pio_s1_any_continuerequest :  STD_LOGIC;
                signal seven_seg_pio_s1_arb_counter_enable :  STD_LOGIC;
                signal seven_seg_pio_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal seven_seg_pio_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal seven_seg_pio_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal seven_seg_pio_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal seven_seg_pio_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal seven_seg_pio_s1_begins_xfer :  STD_LOGIC;
                signal seven_seg_pio_s1_end_xfer :  STD_LOGIC;
                signal seven_seg_pio_s1_firsttransfer :  STD_LOGIC;
                signal seven_seg_pio_s1_grant_vector :  STD_LOGIC;
                signal seven_seg_pio_s1_in_a_read_cycle :  STD_LOGIC;
                signal seven_seg_pio_s1_in_a_write_cycle :  STD_LOGIC;
                signal seven_seg_pio_s1_master_qreq_vector :  STD_LOGIC;
                signal seven_seg_pio_s1_slavearbiterlockenable :  STD_LOGIC;
                signal seven_seg_pio_s1_waits_for_read :  STD_LOGIC;
                signal seven_seg_pio_s1_waits_for_write :  STD_LOGIC;
                signal wait_for_seven_seg_pio_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT seven_seg_pio_s1_end_xfer;
      end if;
    end if;

  end process;

  seven_seg_pio_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_seven_seg_pio_s1);
  internal_cpu_data_master_requests_seven_seg_pio_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(25 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10000100100000100010010000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --seven_seg_pio_s1_arb_share_counter set values, which is an e_mux
  seven_seg_pio_s1_arb_share_set_values <= std_logic_vector'("001");
  --seven_seg_pio_s1_arb_share_counter_next_value assignment, which is an e_assign
  seven_seg_pio_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(seven_seg_pio_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (seven_seg_pio_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(seven_seg_pio_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (seven_seg_pio_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --seven_seg_pio_s1_allgrants all slave grants, which is an e_mux
  seven_seg_pio_s1_allgrants <= seven_seg_pio_s1_grant_vector;
  --seven_seg_pio_s1_end_xfer assignment, which is an e_assign
  seven_seg_pio_s1_end_xfer <= NOT ((seven_seg_pio_s1_waits_for_read OR seven_seg_pio_s1_waits_for_write));
  --seven_seg_pio_s1_arb_share_counter arbitration counter enable, which is an e_assign
  seven_seg_pio_s1_arb_counter_enable <= seven_seg_pio_s1_end_xfer AND seven_seg_pio_s1_allgrants;
  --seven_seg_pio_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      seven_seg_pio_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(seven_seg_pio_s1_arb_counter_enable) = '1' then 
        seven_seg_pio_s1_arb_share_counter <= seven_seg_pio_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --seven_seg_pio_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      seven_seg_pio_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((seven_seg_pio_s1_master_qreq_vector AND seven_seg_pio_s1_end_xfer)) = '1' then 
        seven_seg_pio_s1_slavearbiterlockenable <= or_reduce(seven_seg_pio_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master seven_seg_pio/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= seven_seg_pio_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --seven_seg_pio_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  seven_seg_pio_s1_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_seven_seg_pio_s1 <= internal_cpu_data_master_requests_seven_seg_pio_s1 AND NOT (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write));
  --seven_seg_pio_s1_writedata mux, which is an e_mux
  seven_seg_pio_s1_writedata <= cpu_data_master_writedata (15 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_seven_seg_pio_s1 <= internal_cpu_data_master_qualified_request_seven_seg_pio_s1;
  --cpu/data_master saved-grant seven_seg_pio/s1, which is an e_assign
  cpu_data_master_saved_grant_seven_seg_pio_s1 <= internal_cpu_data_master_requests_seven_seg_pio_s1;
  --allow new arb cycle for seven_seg_pio/s1, which is an e_assign
  seven_seg_pio_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  seven_seg_pio_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  seven_seg_pio_s1_master_qreq_vector <= std_logic'('1');
  --seven_seg_pio_s1_reset_n assignment, which is an e_assign
  seven_seg_pio_s1_reset_n <= reset_n;
  seven_seg_pio_s1_chipselect <= internal_cpu_data_master_granted_seven_seg_pio_s1;
  --seven_seg_pio_s1_firsttransfer first transaction, which is an e_assign
  seven_seg_pio_s1_firsttransfer <= NOT ((seven_seg_pio_s1_slavearbiterlockenable AND seven_seg_pio_s1_any_continuerequest));
  --seven_seg_pio_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  seven_seg_pio_s1_beginbursttransfer_internal <= seven_seg_pio_s1_begins_xfer AND seven_seg_pio_s1_firsttransfer;
  --seven_seg_pio_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  seven_seg_pio_s1_arbitration_holdoff_internal <= seven_seg_pio_s1_begins_xfer AND seven_seg_pio_s1_firsttransfer;
  --~seven_seg_pio_s1_write_n assignment, which is an e_mux
  seven_seg_pio_s1_write_n <= NOT ((internal_cpu_data_master_granted_seven_seg_pio_s1 AND cpu_data_master_write));
  --seven_seg_pio_s1_address mux, which is an e_mux
  seven_seg_pio_s1_address <= A_EXT (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_seven_seg_pio_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_seven_seg_pio_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_seven_seg_pio_s1_end_xfer <= seven_seg_pio_s1_end_xfer;
      end if;
    end if;

  end process;

  --seven_seg_pio_s1_waits_for_read in a cycle, which is an e_mux
  seven_seg_pio_s1_waits_for_read <= seven_seg_pio_s1_in_a_read_cycle AND seven_seg_pio_s1_begins_xfer;
  --seven_seg_pio_s1_in_a_read_cycle assignment, which is an e_assign
  seven_seg_pio_s1_in_a_read_cycle <= internal_cpu_data_master_granted_seven_seg_pio_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= seven_seg_pio_s1_in_a_read_cycle;
  --seven_seg_pio_s1_waits_for_write in a cycle, which is an e_mux
  seven_seg_pio_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(seven_seg_pio_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --seven_seg_pio_s1_in_a_write_cycle assignment, which is an e_assign
  seven_seg_pio_s1_in_a_write_cycle <= internal_cpu_data_master_granted_seven_seg_pio_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= seven_seg_pio_s1_in_a_write_cycle;
  wait_for_seven_seg_pio_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_data_master_granted_seven_seg_pio_s1 <= internal_cpu_data_master_granted_seven_seg_pio_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_seven_seg_pio_s1 <= internal_cpu_data_master_qualified_request_seven_seg_pio_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_seven_seg_pio_s1 <= internal_cpu_data_master_requests_seven_seg_pio_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity sys_clk_timer_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;
                 signal sys_clk_timer_s1_irq : IN STD_LOGIC;
                 signal sys_clk_timer_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

              -- outputs:
                 signal cpu_data_master_granted_sys_clk_timer_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_sys_clk_timer_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sys_clk_timer_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_sys_clk_timer_s1 : OUT STD_LOGIC;
                 signal d1_sys_clk_timer_s1_end_xfer : OUT STD_LOGIC;
                 signal sys_clk_timer_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                 signal sys_clk_timer_s1_chipselect : OUT STD_LOGIC;
                 signal sys_clk_timer_s1_irq_from_sa : OUT STD_LOGIC;
                 signal sys_clk_timer_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal sys_clk_timer_s1_reset_n : OUT STD_LOGIC;
                 signal sys_clk_timer_s1_write_n : OUT STD_LOGIC;
                 signal sys_clk_timer_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of sys_clk_timer_s1_arbitrator : entity is FALSE;
end entity sys_clk_timer_s1_arbitrator;


architecture europa of sys_clk_timer_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_sys_clk_timer_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_sys_clk_timer_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_sys_clk_timer_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_sys_clk_timer_s1 :  STD_LOGIC;
                signal sys_clk_timer_s1_allgrants :  STD_LOGIC;
                signal sys_clk_timer_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal sys_clk_timer_s1_any_continuerequest :  STD_LOGIC;
                signal sys_clk_timer_s1_arb_counter_enable :  STD_LOGIC;
                signal sys_clk_timer_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sys_clk_timer_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sys_clk_timer_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sys_clk_timer_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal sys_clk_timer_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal sys_clk_timer_s1_begins_xfer :  STD_LOGIC;
                signal sys_clk_timer_s1_end_xfer :  STD_LOGIC;
                signal sys_clk_timer_s1_firsttransfer :  STD_LOGIC;
                signal sys_clk_timer_s1_grant_vector :  STD_LOGIC;
                signal sys_clk_timer_s1_in_a_read_cycle :  STD_LOGIC;
                signal sys_clk_timer_s1_in_a_write_cycle :  STD_LOGIC;
                signal sys_clk_timer_s1_master_qreq_vector :  STD_LOGIC;
                signal sys_clk_timer_s1_slavearbiterlockenable :  STD_LOGIC;
                signal sys_clk_timer_s1_waits_for_read :  STD_LOGIC;
                signal sys_clk_timer_s1_waits_for_write :  STD_LOGIC;
                signal wait_for_sys_clk_timer_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT sys_clk_timer_s1_end_xfer;
      end if;
    end if;

  end process;

  sys_clk_timer_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_sys_clk_timer_s1);
  internal_cpu_data_master_requests_sys_clk_timer_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(25 DOWNTO 5) & std_logic_vector'("00000")) = std_logic_vector'("10000100100000100000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign sys_clk_timer_s1_readdata_from_sa = sys_clk_timer_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  sys_clk_timer_s1_readdata_from_sa <= sys_clk_timer_s1_readdata;
  --sys_clk_timer_s1_arb_share_counter set values, which is an e_mux
  sys_clk_timer_s1_arb_share_set_values <= std_logic_vector'("001");
  --sys_clk_timer_s1_arb_share_counter_next_value assignment, which is an e_assign
  sys_clk_timer_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(sys_clk_timer_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (sys_clk_timer_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(sys_clk_timer_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (sys_clk_timer_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --sys_clk_timer_s1_allgrants all slave grants, which is an e_mux
  sys_clk_timer_s1_allgrants <= sys_clk_timer_s1_grant_vector;
  --sys_clk_timer_s1_end_xfer assignment, which is an e_assign
  sys_clk_timer_s1_end_xfer <= NOT ((sys_clk_timer_s1_waits_for_read OR sys_clk_timer_s1_waits_for_write));
  --sys_clk_timer_s1_arb_share_counter arbitration counter enable, which is an e_assign
  sys_clk_timer_s1_arb_counter_enable <= sys_clk_timer_s1_end_xfer AND sys_clk_timer_s1_allgrants;
  --sys_clk_timer_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sys_clk_timer_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(sys_clk_timer_s1_arb_counter_enable) = '1' then 
        sys_clk_timer_s1_arb_share_counter <= sys_clk_timer_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --sys_clk_timer_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sys_clk_timer_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((sys_clk_timer_s1_master_qreq_vector AND sys_clk_timer_s1_end_xfer)) = '1' then 
        sys_clk_timer_s1_slavearbiterlockenable <= or_reduce(sys_clk_timer_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master sys_clk_timer/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= sys_clk_timer_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --sys_clk_timer_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  sys_clk_timer_s1_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_sys_clk_timer_s1 <= internal_cpu_data_master_requests_sys_clk_timer_s1 AND NOT (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write));
  --sys_clk_timer_s1_writedata mux, which is an e_mux
  sys_clk_timer_s1_writedata <= cpu_data_master_writedata (15 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_sys_clk_timer_s1 <= internal_cpu_data_master_qualified_request_sys_clk_timer_s1;
  --cpu/data_master saved-grant sys_clk_timer/s1, which is an e_assign
  cpu_data_master_saved_grant_sys_clk_timer_s1 <= internal_cpu_data_master_requests_sys_clk_timer_s1;
  --allow new arb cycle for sys_clk_timer/s1, which is an e_assign
  sys_clk_timer_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  sys_clk_timer_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  sys_clk_timer_s1_master_qreq_vector <= std_logic'('1');
  --sys_clk_timer_s1_reset_n assignment, which is an e_assign
  sys_clk_timer_s1_reset_n <= reset_n;
  sys_clk_timer_s1_chipselect <= internal_cpu_data_master_granted_sys_clk_timer_s1;
  --sys_clk_timer_s1_firsttransfer first transaction, which is an e_assign
  sys_clk_timer_s1_firsttransfer <= NOT ((sys_clk_timer_s1_slavearbiterlockenable AND sys_clk_timer_s1_any_continuerequest));
  --sys_clk_timer_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  sys_clk_timer_s1_beginbursttransfer_internal <= sys_clk_timer_s1_begins_xfer AND sys_clk_timer_s1_firsttransfer;
  --sys_clk_timer_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  sys_clk_timer_s1_arbitration_holdoff_internal <= sys_clk_timer_s1_begins_xfer AND sys_clk_timer_s1_firsttransfer;
  --~sys_clk_timer_s1_write_n assignment, which is an e_mux
  sys_clk_timer_s1_write_n <= NOT ((internal_cpu_data_master_granted_sys_clk_timer_s1 AND cpu_data_master_write));
  --sys_clk_timer_s1_address mux, which is an e_mux
  sys_clk_timer_s1_address <= A_EXT (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")), 3);
  --d1_sys_clk_timer_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_sys_clk_timer_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_sys_clk_timer_s1_end_xfer <= sys_clk_timer_s1_end_xfer;
      end if;
    end if;

  end process;

  --sys_clk_timer_s1_waits_for_read in a cycle, which is an e_mux
  sys_clk_timer_s1_waits_for_read <= sys_clk_timer_s1_in_a_read_cycle AND sys_clk_timer_s1_begins_xfer;
  --sys_clk_timer_s1_in_a_read_cycle assignment, which is an e_assign
  sys_clk_timer_s1_in_a_read_cycle <= internal_cpu_data_master_granted_sys_clk_timer_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= sys_clk_timer_s1_in_a_read_cycle;
  --sys_clk_timer_s1_waits_for_write in a cycle, which is an e_mux
  sys_clk_timer_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(sys_clk_timer_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --sys_clk_timer_s1_in_a_write_cycle assignment, which is an e_assign
  sys_clk_timer_s1_in_a_write_cycle <= internal_cpu_data_master_granted_sys_clk_timer_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= sys_clk_timer_s1_in_a_write_cycle;
  wait_for_sys_clk_timer_s1_counter <= std_logic'('0');
  --assign sys_clk_timer_s1_irq_from_sa = sys_clk_timer_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  sys_clk_timer_s1_irq_from_sa <= sys_clk_timer_s1_irq;
  --vhdl renameroo for output signals
  cpu_data_master_granted_sys_clk_timer_s1 <= internal_cpu_data_master_granted_sys_clk_timer_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_sys_clk_timer_s1 <= internal_cpu_data_master_qualified_request_sys_clk_timer_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_sys_clk_timer_s1 <= internal_cpu_data_master_requests_sys_clk_timer_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity sysid_control_slave_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;
                 signal sysid_control_slave_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- outputs:
                 signal cpu_data_master_granted_sysid_control_slave : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_sysid_control_slave : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sysid_control_slave : OUT STD_LOGIC;
                 signal cpu_data_master_requests_sysid_control_slave : OUT STD_LOGIC;
                 signal d1_sysid_control_slave_end_xfer : OUT STD_LOGIC;
                 signal sysid_control_slave_address : OUT STD_LOGIC;
                 signal sysid_control_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of sysid_control_slave_arbitrator : entity is FALSE;
end entity sysid_control_slave_arbitrator;


architecture europa of sysid_control_slave_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_sysid_control_slave :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_sysid_control_slave :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_sysid_control_slave :  STD_LOGIC;
                signal internal_cpu_data_master_requests_sysid_control_slave :  STD_LOGIC;
                signal sysid_control_slave_allgrants :  STD_LOGIC;
                signal sysid_control_slave_allow_new_arb_cycle :  STD_LOGIC;
                signal sysid_control_slave_any_continuerequest :  STD_LOGIC;
                signal sysid_control_slave_arb_counter_enable :  STD_LOGIC;
                signal sysid_control_slave_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sysid_control_slave_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sysid_control_slave_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sysid_control_slave_arbitration_holdoff_internal :  STD_LOGIC;
                signal sysid_control_slave_beginbursttransfer_internal :  STD_LOGIC;
                signal sysid_control_slave_begins_xfer :  STD_LOGIC;
                signal sysid_control_slave_end_xfer :  STD_LOGIC;
                signal sysid_control_slave_firsttransfer :  STD_LOGIC;
                signal sysid_control_slave_grant_vector :  STD_LOGIC;
                signal sysid_control_slave_in_a_read_cycle :  STD_LOGIC;
                signal sysid_control_slave_in_a_write_cycle :  STD_LOGIC;
                signal sysid_control_slave_master_qreq_vector :  STD_LOGIC;
                signal sysid_control_slave_slavearbiterlockenable :  STD_LOGIC;
                signal sysid_control_slave_waits_for_read :  STD_LOGIC;
                signal sysid_control_slave_waits_for_write :  STD_LOGIC;
                signal wait_for_sysid_control_slave_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT sysid_control_slave_end_xfer;
      end if;
    end if;

  end process;

  sysid_control_slave_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_sysid_control_slave);
  internal_cpu_data_master_requests_sysid_control_slave <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(25 DOWNTO 3) & std_logic_vector'("000")) = std_logic_vector'("10000100100000100010111000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign sysid_control_slave_readdata_from_sa = sysid_control_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  sysid_control_slave_readdata_from_sa <= sysid_control_slave_readdata;
  --sysid_control_slave_arb_share_counter set values, which is an e_mux
  sysid_control_slave_arb_share_set_values <= std_logic_vector'("001");
  --sysid_control_slave_arb_share_counter_next_value assignment, which is an e_assign
  sysid_control_slave_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(sysid_control_slave_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (sysid_control_slave_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(sysid_control_slave_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (sysid_control_slave_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --sysid_control_slave_allgrants all slave grants, which is an e_mux
  sysid_control_slave_allgrants <= sysid_control_slave_grant_vector;
  --sysid_control_slave_end_xfer assignment, which is an e_assign
  sysid_control_slave_end_xfer <= NOT ((sysid_control_slave_waits_for_read OR sysid_control_slave_waits_for_write));
  --sysid_control_slave_arb_share_counter arbitration counter enable, which is an e_assign
  sysid_control_slave_arb_counter_enable <= sysid_control_slave_end_xfer AND sysid_control_slave_allgrants;
  --sysid_control_slave_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sysid_control_slave_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(sysid_control_slave_arb_counter_enable) = '1' then 
        sysid_control_slave_arb_share_counter <= sysid_control_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --sysid_control_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sysid_control_slave_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((sysid_control_slave_master_qreq_vector AND sysid_control_slave_end_xfer)) = '1' then 
        sysid_control_slave_slavearbiterlockenable <= or_reduce(sysid_control_slave_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master sysid/control_slave arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= sysid_control_slave_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --sysid_control_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  sysid_control_slave_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_sysid_control_slave <= internal_cpu_data_master_requests_sysid_control_slave;
  --master is always granted when requested
  internal_cpu_data_master_granted_sysid_control_slave <= internal_cpu_data_master_qualified_request_sysid_control_slave;
  --cpu/data_master saved-grant sysid/control_slave, which is an e_assign
  cpu_data_master_saved_grant_sysid_control_slave <= internal_cpu_data_master_requests_sysid_control_slave;
  --allow new arb cycle for sysid/control_slave, which is an e_assign
  sysid_control_slave_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  sysid_control_slave_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  sysid_control_slave_master_qreq_vector <= std_logic'('1');
  --sysid_control_slave_firsttransfer first transaction, which is an e_assign
  sysid_control_slave_firsttransfer <= NOT ((sysid_control_slave_slavearbiterlockenable AND sysid_control_slave_any_continuerequest));
  --sysid_control_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  sysid_control_slave_beginbursttransfer_internal <= sysid_control_slave_begins_xfer AND sysid_control_slave_firsttransfer;
  --sysid_control_slave_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  sysid_control_slave_arbitration_holdoff_internal <= sysid_control_slave_begins_xfer AND sysid_control_slave_firsttransfer;
  --sysid_control_slave_address mux, which is an e_mux
  sysid_control_slave_address <= Vector_To_Std_Logic(A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")));
  --d1_sysid_control_slave_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_sysid_control_slave_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_sysid_control_slave_end_xfer <= sysid_control_slave_end_xfer;
      end if;
    end if;

  end process;

  --sysid_control_slave_waits_for_read in a cycle, which is an e_mux
  sysid_control_slave_waits_for_read <= sysid_control_slave_in_a_read_cycle AND sysid_control_slave_begins_xfer;
  --sysid_control_slave_in_a_read_cycle assignment, which is an e_assign
  sysid_control_slave_in_a_read_cycle <= internal_cpu_data_master_granted_sysid_control_slave AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= sysid_control_slave_in_a_read_cycle;
  --sysid_control_slave_waits_for_write in a cycle, which is an e_mux
  sysid_control_slave_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(sysid_control_slave_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --sysid_control_slave_in_a_write_cycle assignment, which is an e_assign
  sysid_control_slave_in_a_write_cycle <= internal_cpu_data_master_granted_sysid_control_slave AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= sysid_control_slave_in_a_write_cycle;
  wait_for_sysid_control_slave_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_data_master_granted_sysid_control_slave <= internal_cpu_data_master_granted_sysid_control_slave;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_sysid_control_slave <= internal_cpu_data_master_qualified_request_sysid_control_slave;
  --vhdl renameroo for output signals
  cpu_data_master_requests_sysid_control_slave <= internal_cpu_data_master_requests_sysid_control_slave;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity uart1_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;
                 signal uart1_s1_dataavailable : IN STD_LOGIC;
                 signal uart1_s1_irq : IN STD_LOGIC;
                 signal uart1_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal uart1_s1_readyfordata : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_uart1_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_uart1_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_uart1_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_uart1_s1 : OUT STD_LOGIC;
                 signal d1_uart1_s1_end_xfer : OUT STD_LOGIC;
                 signal uart1_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                 signal uart1_s1_begintransfer : OUT STD_LOGIC;
                 signal uart1_s1_chipselect : OUT STD_LOGIC;
                 signal uart1_s1_dataavailable_from_sa : OUT STD_LOGIC;
                 signal uart1_s1_irq_from_sa : OUT STD_LOGIC;
                 signal uart1_s1_read_n : OUT STD_LOGIC;
                 signal uart1_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal uart1_s1_readyfordata_from_sa : OUT STD_LOGIC;
                 signal uart1_s1_reset_n : OUT STD_LOGIC;
                 signal uart1_s1_write_n : OUT STD_LOGIC;
                 signal uart1_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of uart1_s1_arbitrator : entity is FALSE;
end entity uart1_s1_arbitrator;


architecture europa of uart1_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_uart1_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_uart1_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_uart1_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_uart1_s1 :  STD_LOGIC;
                signal uart1_s1_allgrants :  STD_LOGIC;
                signal uart1_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal uart1_s1_any_continuerequest :  STD_LOGIC;
                signal uart1_s1_arb_counter_enable :  STD_LOGIC;
                signal uart1_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal uart1_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal uart1_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal uart1_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal uart1_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal uart1_s1_begins_xfer :  STD_LOGIC;
                signal uart1_s1_end_xfer :  STD_LOGIC;
                signal uart1_s1_firsttransfer :  STD_LOGIC;
                signal uart1_s1_grant_vector :  STD_LOGIC;
                signal uart1_s1_in_a_read_cycle :  STD_LOGIC;
                signal uart1_s1_in_a_write_cycle :  STD_LOGIC;
                signal uart1_s1_master_qreq_vector :  STD_LOGIC;
                signal uart1_s1_slavearbiterlockenable :  STD_LOGIC;
                signal uart1_s1_waits_for_read :  STD_LOGIC;
                signal uart1_s1_waits_for_write :  STD_LOGIC;
                signal wait_for_uart1_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT uart1_s1_end_xfer;
      end if;
    end if;

  end process;

  uart1_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_uart1_s1);
  internal_cpu_data_master_requests_uart1_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(25 DOWNTO 5) & std_logic_vector'("00000")) = std_logic_vector'("10000100100000100001000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign uart1_s1_dataavailable_from_sa = uart1_s1_dataavailable so that symbol knows where to group signals which may go to master only, which is an e_assign
  uart1_s1_dataavailable_from_sa <= uart1_s1_dataavailable;
  --assign uart1_s1_readyfordata_from_sa = uart1_s1_readyfordata so that symbol knows where to group signals which may go to master only, which is an e_assign
  uart1_s1_readyfordata_from_sa <= uart1_s1_readyfordata;
  --assign uart1_s1_readdata_from_sa = uart1_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  uart1_s1_readdata_from_sa <= uart1_s1_readdata;
  --uart1_s1_arb_share_counter set values, which is an e_mux
  uart1_s1_arb_share_set_values <= std_logic_vector'("001");
  --uart1_s1_arb_share_counter_next_value assignment, which is an e_assign
  uart1_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(uart1_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (uart1_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(uart1_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (uart1_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --uart1_s1_allgrants all slave grants, which is an e_mux
  uart1_s1_allgrants <= uart1_s1_grant_vector;
  --uart1_s1_end_xfer assignment, which is an e_assign
  uart1_s1_end_xfer <= NOT ((uart1_s1_waits_for_read OR uart1_s1_waits_for_write));
  --uart1_s1_arb_share_counter arbitration counter enable, which is an e_assign
  uart1_s1_arb_counter_enable <= uart1_s1_end_xfer AND uart1_s1_allgrants;
  --uart1_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      uart1_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(uart1_s1_arb_counter_enable) = '1' then 
        uart1_s1_arb_share_counter <= uart1_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --uart1_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      uart1_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((uart1_s1_master_qreq_vector AND uart1_s1_end_xfer)) = '1' then 
        uart1_s1_slavearbiterlockenable <= or_reduce(uart1_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master uart1/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= uart1_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --uart1_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  uart1_s1_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_uart1_s1 <= internal_cpu_data_master_requests_uart1_s1;
  --uart1_s1_writedata mux, which is an e_mux
  uart1_s1_writedata <= cpu_data_master_writedata (15 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_uart1_s1 <= internal_cpu_data_master_qualified_request_uart1_s1;
  --cpu/data_master saved-grant uart1/s1, which is an e_assign
  cpu_data_master_saved_grant_uart1_s1 <= internal_cpu_data_master_requests_uart1_s1;
  --allow new arb cycle for uart1/s1, which is an e_assign
  uart1_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  uart1_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  uart1_s1_master_qreq_vector <= std_logic'('1');
  uart1_s1_begintransfer <= uart1_s1_begins_xfer;
  --uart1_s1_reset_n assignment, which is an e_assign
  uart1_s1_reset_n <= reset_n;
  uart1_s1_chipselect <= internal_cpu_data_master_granted_uart1_s1;
  --uart1_s1_firsttransfer first transaction, which is an e_assign
  uart1_s1_firsttransfer <= NOT ((uart1_s1_slavearbiterlockenable AND uart1_s1_any_continuerequest));
  --uart1_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  uart1_s1_beginbursttransfer_internal <= uart1_s1_begins_xfer AND uart1_s1_firsttransfer;
  --uart1_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  uart1_s1_arbitration_holdoff_internal <= uart1_s1_begins_xfer AND uart1_s1_firsttransfer;
  --~uart1_s1_read_n assignment, which is an e_mux
  uart1_s1_read_n <= NOT ((internal_cpu_data_master_granted_uart1_s1 AND cpu_data_master_read));
  --~uart1_s1_write_n assignment, which is an e_mux
  uart1_s1_write_n <= NOT ((internal_cpu_data_master_granted_uart1_s1 AND cpu_data_master_write));
  --uart1_s1_address mux, which is an e_mux
  uart1_s1_address <= A_EXT (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")), 3);
  --d1_uart1_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_uart1_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_uart1_s1_end_xfer <= uart1_s1_end_xfer;
      end if;
    end if;

  end process;

  --uart1_s1_waits_for_read in a cycle, which is an e_mux
  uart1_s1_waits_for_read <= uart1_s1_in_a_read_cycle AND uart1_s1_begins_xfer;
  --uart1_s1_in_a_read_cycle assignment, which is an e_assign
  uart1_s1_in_a_read_cycle <= internal_cpu_data_master_granted_uart1_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= uart1_s1_in_a_read_cycle;
  --uart1_s1_waits_for_write in a cycle, which is an e_mux
  uart1_s1_waits_for_write <= uart1_s1_in_a_write_cycle AND uart1_s1_begins_xfer;
  --uart1_s1_in_a_write_cycle assignment, which is an e_assign
  uart1_s1_in_a_write_cycle <= internal_cpu_data_master_granted_uart1_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= uart1_s1_in_a_write_cycle;
  wait_for_uart1_s1_counter <= std_logic'('0');
  --assign uart1_s1_irq_from_sa = uart1_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  uart1_s1_irq_from_sa <= uart1_s1_irq;
  --vhdl renameroo for output signals
  cpu_data_master_granted_uart1_s1 <= internal_cpu_data_master_granted_uart1_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_uart1_s1 <= internal_cpu_data_master_qualified_request_uart1_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_uart1_s1 <= internal_cpu_data_master_requests_uart1_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity reset_clk_domain_synch_module is 
        port (
              -- inputs:
                 signal clk_in : IN STD_LOGIC;
                 signal clk_out : IN STD_LOGIC;
                 signal data_in : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal data_out : OUT STD_LOGIC
              );
end entity reset_clk_domain_synch_module;


architecture europa of reset_clk_domain_synch_module is
                signal always_one :  STD_LOGIC;
                signal data_in_d1 :  STD_LOGIC;
                signal p1_data_out :  STD_LOGIC;
attribute ALTERA_ATTRIBUTE : string;
attribute ALTERA_ATTRIBUTE of p1_data_out : signal is "{-from ""*""} CUT=ON";

begin

  always_one <= std_logic'('1');
  --reg to satisfy timing
  process (clk_in, always_one)
  begin
    if always_one = '0' then
      data_in_d1 <= std_logic'('0');
    elsif clk_in'event and clk_in = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        data_in_d1 <= data_in;
      end if;
    end if;

  end process;

  process (clk_out, reset_n)
  begin
    if reset_n = '0' then
      p1_data_out <= std_logic'('0');
    elsif clk_out'event and clk_out = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        p1_data_out <= data_in_d1;
      end if;
    end if;

  end process;

  process (clk_out, reset_n)
  begin
    if reset_n = '0' then
      data_out <= std_logic'('0');
    elsif clk_out'event and clk_out = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        data_out <= p1_data_out;
      end if;
    end if;

  end process;


end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity std_1s10 is 
        port (
              -- 1) global signals:
                 signal clk : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- the_button_pio
                 signal in_port_to_the_button_pio : IN STD_LOGIC_VECTOR (3 DOWNTO 0);

              -- the_ext_ram_bus_avalon_slave
                 signal be_n_to_the_ext_ram : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal ext_ram_bus_address : OUT STD_LOGIC_VECTOR (22 DOWNTO 0);
                 signal ext_ram_bus_byteenablen : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal ext_ram_bus_data : INOUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal ext_ram_bus_readn : OUT STD_LOGIC;
                 signal ior_n_to_the_lan91c111 : OUT STD_LOGIC;
                 signal iow_n_to_the_lan91c111 : OUT STD_LOGIC;
                 signal irq_from_the_lan91c111 : IN STD_LOGIC;
                 signal read_n_to_the_ext_ram : OUT STD_LOGIC;
                 signal reset_n_to_the_lan91c111 : OUT STD_LOGIC;
                 signal select_n_to_the_ext_flash : OUT STD_LOGIC;
                 signal select_n_to_the_ext_ram : OUT STD_LOGIC;
                 signal write_n_to_the_ext_flash : OUT STD_LOGIC;
                 signal write_n_to_the_ext_ram : OUT STD_LOGIC;

              -- the_jtagpio
                 signal in_port_to_the_jtagpio : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                 signal out_port_from_the_jtagpio : OUT STD_LOGIC_VECTOR (20 DOWNTO 0);

              -- the_led_pio
                 signal in_port_to_the_led_pio : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal out_port_from_the_led_pio : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);

              -- the_reconfig_request_pio
                 signal bidir_port_to_and_from_the_reconfig_request_pio : INOUT STD_LOGIC;

              -- the_sdram
                 signal zs_addr_from_the_sdram : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal zs_ba_from_the_sdram : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal zs_cas_n_from_the_sdram : OUT STD_LOGIC;
                 signal zs_cke_from_the_sdram : OUT STD_LOGIC;
                 signal zs_cs_n_from_the_sdram : OUT STD_LOGIC;
                 signal zs_dq_to_and_from_the_sdram : INOUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal zs_dqm_from_the_sdram : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal zs_ras_n_from_the_sdram : OUT STD_LOGIC;
                 signal zs_we_n_from_the_sdram : OUT STD_LOGIC;

              -- the_seven_seg_pio
                 signal out_port_from_the_seven_seg_pio : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);

              -- the_uart1
                 signal rxd_to_the_uart1 : IN STD_LOGIC;
                 signal txd_from_the_uart1 : OUT STD_LOGIC
              );
end entity std_1s10;


architecture europa of std_1s10 is
component button_pio_s1_arbitrator is 
           port (
                 -- inputs:
                    signal button_pio_s1_irq : IN STD_LOGIC;
                    signal button_pio_s1_readdata : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal button_pio_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal button_pio_s1_chipselect : OUT STD_LOGIC;
                    signal button_pio_s1_irq_from_sa : OUT STD_LOGIC;
                    signal button_pio_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal button_pio_s1_reset_n : OUT STD_LOGIC;
                    signal button_pio_s1_write_n : OUT STD_LOGIC;
                    signal button_pio_s1_writedata : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_granted_button_pio_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_button_pio_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_button_pio_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_button_pio_s1 : OUT STD_LOGIC;
                    signal d1_button_pio_s1_end_xfer : OUT STD_LOGIC
                 );
end component button_pio_s1_arbitrator;

component button_pio is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal in_port : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (3 DOWNTO 0);

                 -- outputs:
                    signal irq : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC_VECTOR (3 DOWNTO 0)
                 );
end component button_pio;

component cpu_jtag_debug_module_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_debugaccess : IN STD_LOGIC;
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal cpu_jtag_debug_module_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_jtag_debug_module_resetrequest : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_data_master_requests_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_instruction_master_requests_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_address : OUT STD_LOGIC_VECTOR (8 DOWNTO 0);
                    signal cpu_jtag_debug_module_begintransfer : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_jtag_debug_module_chipselect : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_debugaccess : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_jtag_debug_module_reset : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_reset_n : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_resetrequest_from_sa : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_write : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d1_cpu_jtag_debug_module_end_xfer : OUT STD_LOGIC
                 );
end component cpu_jtag_debug_module_arbitrator;

component cpu_data_master_arbitrator is 
           port (
                 -- inputs:
                    signal button_pio_s1_irq_from_sa : IN STD_LOGIC;
                    signal button_pio_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal cpu_data_master_byteenable_ext_flash_s1 : IN STD_LOGIC;
                    signal cpu_data_master_debugaccess : IN STD_LOGIC;
                    signal cpu_data_master_granted_button_pio_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_data_master_granted_ext_flash_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_ext_ram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_high_res_timer_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_jtag_uart_avalon_jtag_slave : IN STD_LOGIC;
                    signal cpu_data_master_granted_jtagpio_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_lan91c111_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_led_pio_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_onchip_ram_64_kbytes_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_reconfig_request_pio_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_sdram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_seven_seg_pio_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_sys_clk_timer_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_sysid_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_granted_uart1_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_button_pio_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_ext_flash_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_ext_ram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_high_res_timer_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_jtagpio_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_lan91c111_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_led_pio_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_onchip_ram_64_kbytes_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_reconfig_request_pio_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_sdram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_seven_seg_pio_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_sys_clk_timer_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_sysid_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_uart1_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_button_pio_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_ext_flash_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_ext_ram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_high_res_timer_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_jtagpio_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_lan91c111_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_led_pio_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_reconfig_request_pio_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sdram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sdram_s1_shift_register : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal cpu_data_master_read_data_valid_seven_seg_pio_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sys_clk_timer_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sysid_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_uart1_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_button_pio_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_data_master_requests_ext_flash_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_ext_ram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_high_res_timer_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_jtag_uart_avalon_jtag_slave : IN STD_LOGIC;
                    signal cpu_data_master_requests_jtagpio_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_lan91c111_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_led_pio_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_onchip_ram_64_kbytes_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_reconfig_request_pio_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_sdram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_seven_seg_pio_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_sys_clk_timer_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_sysid_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_requests_uart1_s1 : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d1_button_pio_s1_end_xfer : IN STD_LOGIC;
                    signal d1_cpu_jtag_debug_module_end_xfer : IN STD_LOGIC;
                    signal d1_ext_ram_bus_avalon_slave_end_xfer : IN STD_LOGIC;
                    signal d1_high_res_timer_s1_end_xfer : IN STD_LOGIC;
                    signal d1_irq_from_the_lan91c111 : IN STD_LOGIC;
                    signal d1_jtag_uart_avalon_jtag_slave_end_xfer : IN STD_LOGIC;
                    signal d1_jtagpio_s1_end_xfer : IN STD_LOGIC;
                    signal d1_led_pio_s1_end_xfer : IN STD_LOGIC;
                    signal d1_onchip_ram_64_kbytes_s1_end_xfer : IN STD_LOGIC;
                    signal d1_reconfig_request_pio_s1_end_xfer : IN STD_LOGIC;
                    signal d1_sdram_s1_end_xfer : IN STD_LOGIC;
                    signal d1_seven_seg_pio_s1_end_xfer : IN STD_LOGIC;
                    signal d1_sys_clk_timer_s1_end_xfer : IN STD_LOGIC;
                    signal d1_sysid_control_slave_end_xfer : IN STD_LOGIC;
                    signal d1_uart1_s1_end_xfer : IN STD_LOGIC;
                    signal ext_flash_s1_wait_counter_eq_0 : IN STD_LOGIC;
                    signal ext_flash_s1_wait_counter_eq_1 : IN STD_LOGIC;
                    signal high_res_timer_s1_irq_from_sa : IN STD_LOGIC;
                    signal high_res_timer_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal incoming_ext_ram_bus_data : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal incoming_ext_ram_bus_data_with_Xs_converted_to_0 : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal jtag_uart_avalon_jtag_slave_irq_from_sa : IN STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_uart_avalon_jtag_slave_waitrequest_from_sa : IN STD_LOGIC;
                    signal jtagpio_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal lan91c111_s1_wait_counter_eq_0 : IN STD_LOGIC;
                    signal led_pio_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal onchip_ram_64_kbytes_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reconfig_request_pio_s1_readdata_from_sa : IN STD_LOGIC;
                    signal registered_cpu_data_master_read_data_valid_ext_flash_s1 : IN STD_LOGIC;
                    signal registered_cpu_data_master_read_data_valid_ext_ram_s1 : IN STD_LOGIC;
                    signal registered_cpu_data_master_read_data_valid_lan91c111_s1 : IN STD_LOGIC;
                    signal registered_cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1 : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal sdram_s1_posted_fifo_readenable : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal sdram_s1_posted_fifo_writenable : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal sdram_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal sdram_s1_waitrequest_from_sa : IN STD_LOGIC;
                    signal sys_clk_timer_s1_irq_from_sa : IN STD_LOGIC;
                    signal sys_clk_timer_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal sysid_control_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal uart1_s1_irq_from_sa : IN STD_LOGIC;
                    signal uart1_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal cpu_data_master_address_to_slave : OUT STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal cpu_data_master_dbs_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_dbs_write_8 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal cpu_data_master_irq : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_data_master_no_byte_enables_and_last_term : OUT STD_LOGIC;
                    signal cpu_data_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_data_master_waitrequest : OUT STD_LOGIC
                 );
end component cpu_data_master_arbitrator;

component cpu_instruction_master_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_instruction_master_address : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal cpu_instruction_master_granted_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_instruction_master_granted_ext_flash_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_granted_ext_ram_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_granted_lan91c111_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_granted_onchip_ram_64_kbytes_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_granted_sdram_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_ext_flash_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_ext_ram_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_lan91c111_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_onchip_ram_64_kbytes_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_sdram_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_ext_flash_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_ext_ram_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_lan91c111_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_sdram_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_sdram_s1_shift_register : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal cpu_instruction_master_requests_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_ext_flash_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_ext_ram_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_lan91c111_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_onchip_ram_64_kbytes_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_sdram_s1 : IN STD_LOGIC;
                    signal cpu_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d1_cpu_jtag_debug_module_end_xfer : IN STD_LOGIC;
                    signal d1_ext_ram_bus_avalon_slave_end_xfer : IN STD_LOGIC;
                    signal d1_onchip_ram_64_kbytes_s1_end_xfer : IN STD_LOGIC;
                    signal d1_sdram_s1_end_xfer : IN STD_LOGIC;
                    signal ext_flash_s1_wait_counter_eq_0 : IN STD_LOGIC;
                    signal incoming_ext_ram_bus_data : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal lan91c111_s1_wait_counter_eq_0 : IN STD_LOGIC;
                    signal onchip_ram_64_kbytes_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal sdram_s1_posted_fifo_readenable : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal sdram_s1_posted_fifo_writenable : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal sdram_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal cpu_instruction_master_address_to_slave : OUT STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal cpu_instruction_master_dbs_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_instruction_master_waitrequest : OUT STD_LOGIC
                 );
end component cpu_instruction_master_arbitrator;

component cpu is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal d_irq : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d_waitrequest : IN STD_LOGIC;
                    signal i_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal i_waitrequest : IN STD_LOGIC;
                    signal jtag_debug_module_address : IN STD_LOGIC_VECTOR (8 DOWNTO 0);
                    signal jtag_debug_module_begintransfer : IN STD_LOGIC;
                    signal jtag_debug_module_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal jtag_debug_module_clk : IN STD_LOGIC;
                    signal jtag_debug_module_debugaccess : IN STD_LOGIC;
                    signal jtag_debug_module_reset : IN STD_LOGIC;
                    signal jtag_debug_module_select : IN STD_LOGIC;
                    signal jtag_debug_module_write : IN STD_LOGIC;
                    signal jtag_debug_module_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal d_address : OUT STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal d_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal d_read : OUT STD_LOGIC;
                    signal d_write : OUT STD_LOGIC;
                    signal d_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal i_address : OUT STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal i_read : OUT STD_LOGIC;
                    signal jtag_debug_module_debugaccess_to_roms : OUT STD_LOGIC;
                    signal jtag_debug_module_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_debug_module_resetrequest : OUT STD_LOGIC
                 );
end component cpu;

component ext_ram_bus_avalon_slave_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_dbs_write_8 : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal cpu_data_master_no_byte_enables_and_last_term : IN STD_LOGIC;
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal cpu_instruction_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal irq_from_the_lan91c111 : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal be_n_to_the_ext_ram : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_byteenable_ext_flash_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_granted_ext_flash_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_granted_ext_ram_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_granted_lan91c111_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_ext_flash_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_ext_ram_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_lan91c111_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_ext_flash_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_ext_ram_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_lan91c111_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_ext_flash_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_ext_ram_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_lan91c111_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_ext_flash_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_ext_ram_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_lan91c111_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_ext_flash_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_ext_ram_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_lan91c111_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_ext_flash_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_ext_ram_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_lan91c111_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_requests_ext_flash_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_requests_ext_ram_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_requests_lan91c111_s1 : OUT STD_LOGIC;
                    signal d1_ext_ram_bus_avalon_slave_end_xfer : OUT STD_LOGIC;
                    signal d1_irq_from_the_lan91c111 : OUT STD_LOGIC;
                    signal ext_flash_s1_wait_counter_eq_0 : OUT STD_LOGIC;
                    signal ext_flash_s1_wait_counter_eq_1 : OUT STD_LOGIC;
                    signal ext_ram_bus_address : OUT STD_LOGIC_VECTOR (22 DOWNTO 0);
                    signal ext_ram_bus_byteenablen : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal ext_ram_bus_data : INOUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal ext_ram_bus_readn : OUT STD_LOGIC;
                    signal incoming_ext_ram_bus_data : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal incoming_ext_ram_bus_data_with_Xs_converted_to_0 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal ior_n_to_the_lan91c111 : OUT STD_LOGIC;
                    signal iow_n_to_the_lan91c111 : OUT STD_LOGIC;
                    signal lan91c111_s1_wait_counter_eq_0 : OUT STD_LOGIC;
                    signal read_n_to_the_ext_ram : OUT STD_LOGIC;
                    signal registered_cpu_data_master_read_data_valid_ext_flash_s1 : OUT STD_LOGIC;
                    signal registered_cpu_data_master_read_data_valid_ext_ram_s1 : OUT STD_LOGIC;
                    signal registered_cpu_data_master_read_data_valid_lan91c111_s1 : OUT STD_LOGIC;
                    signal reset_n_to_the_lan91c111 : OUT STD_LOGIC;
                    signal select_n_to_the_ext_flash : OUT STD_LOGIC;
                    signal select_n_to_the_ext_ram : OUT STD_LOGIC;
                    signal write_n_to_the_ext_flash : OUT STD_LOGIC;
                    signal write_n_to_the_ext_ram : OUT STD_LOGIC
                 );
end component ext_ram_bus_avalon_slave_arbitrator;

component ext_ram_bus is 
end component ext_ram_bus;

component ext_ram_bus_bridge_arbitrator is 
end component ext_ram_bus_bridge_arbitrator;

component high_res_timer_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal high_res_timer_s1_irq : IN STD_LOGIC;
                    signal high_res_timer_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_high_res_timer_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_high_res_timer_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_high_res_timer_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_high_res_timer_s1 : OUT STD_LOGIC;
                    signal d1_high_res_timer_s1_end_xfer : OUT STD_LOGIC;
                    signal high_res_timer_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal high_res_timer_s1_chipselect : OUT STD_LOGIC;
                    signal high_res_timer_s1_irq_from_sa : OUT STD_LOGIC;
                    signal high_res_timer_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal high_res_timer_s1_reset_n : OUT STD_LOGIC;
                    signal high_res_timer_s1_write_n : OUT STD_LOGIC;
                    signal high_res_timer_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component high_res_timer_s1_arbitrator;

component high_res_timer is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal irq : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component high_res_timer;

component jtag_uart_avalon_jtag_slave_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_uart_avalon_jtag_slave_dataavailable : IN STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_irq : IN STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_uart_avalon_jtag_slave_readyfordata : IN STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_waitrequest : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_jtag_uart_avalon_jtag_slave : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave : OUT STD_LOGIC;
                    signal cpu_data_master_requests_jtag_uart_avalon_jtag_slave : OUT STD_LOGIC;
                    signal d1_jtag_uart_avalon_jtag_slave_end_xfer : OUT STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_address : OUT STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_chipselect : OUT STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_dataavailable_from_sa : OUT STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_irq_from_sa : OUT STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_read_n : OUT STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_uart_avalon_jtag_slave_readyfordata_from_sa : OUT STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_reset_n : OUT STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_waitrequest_from_sa : OUT STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_write_n : OUT STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component jtag_uart_avalon_jtag_slave_arbitrator;

component jtag_uart is 
           port (
                 -- inputs:
                    signal av_address : IN STD_LOGIC;
                    signal av_chipselect : IN STD_LOGIC;
                    signal av_read_n : IN STD_LOGIC;
                    signal av_write_n : IN STD_LOGIC;
                    signal av_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal rst_n : IN STD_LOGIC;

                 -- outputs:
                    signal av_irq : OUT STD_LOGIC;
                    signal av_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal av_waitrequest : OUT STD_LOGIC;
                    signal dataavailable : OUT STD_LOGIC;
                    signal readyfordata : OUT STD_LOGIC
                 );
end component jtag_uart;

component jtagpio_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtagpio_s1_readdata : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_jtagpio_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_jtagpio_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_jtagpio_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_jtagpio_s1 : OUT STD_LOGIC;
                    signal d1_jtagpio_s1_end_xfer : OUT STD_LOGIC;
                    signal jtagpio_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal jtagpio_s1_chipselect : OUT STD_LOGIC;
                    signal jtagpio_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal jtagpio_s1_reset_n : OUT STD_LOGIC;
                    signal jtagpio_s1_write_n : OUT STD_LOGIC;
                    signal jtagpio_s1_writedata : OUT STD_LOGIC_VECTOR (20 DOWNTO 0)
                 );
end component jtagpio_s1_arbitrator;

component jtagpio is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal in_port : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (20 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal readdata : OUT STD_LOGIC_VECTOR (20 DOWNTO 0)
                 );
end component jtagpio;

component led_pio_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal led_pio_s1_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_led_pio_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_led_pio_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_led_pio_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_led_pio_s1 : OUT STD_LOGIC;
                    signal d1_led_pio_s1_end_xfer : OUT STD_LOGIC;
                    signal led_pio_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal led_pio_s1_chipselect : OUT STD_LOGIC;
                    signal led_pio_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal led_pio_s1_reset_n : OUT STD_LOGIC;
                    signal led_pio_s1_write_n : OUT STD_LOGIC;
                    signal led_pio_s1_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component led_pio_s1_arbitrator;

component led_pio is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal in_port : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal readdata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component led_pio;

component onchip_ram_64_kbytes_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal onchip_ram_64_kbytes_s1_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_onchip_ram_64_kbytes_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_onchip_ram_64_kbytes_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_onchip_ram_64_kbytes_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_onchip_ram_64_kbytes_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_onchip_ram_64_kbytes_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_requests_onchip_ram_64_kbytes_s1 : OUT STD_LOGIC;
                    signal d1_onchip_ram_64_kbytes_s1_end_xfer : OUT STD_LOGIC;
                    signal onchip_ram_64_kbytes_s1_address : OUT STD_LOGIC_VECTOR (13 DOWNTO 0);
                    signal onchip_ram_64_kbytes_s1_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal onchip_ram_64_kbytes_s1_chipselect : OUT STD_LOGIC;
                    signal onchip_ram_64_kbytes_s1_clken : OUT STD_LOGIC;
                    signal onchip_ram_64_kbytes_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal onchip_ram_64_kbytes_s1_write : OUT STD_LOGIC;
                    signal onchip_ram_64_kbytes_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal registered_cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1 : OUT STD_LOGIC
                 );
end component onchip_ram_64_kbytes_s1_arbitrator;

component onchip_ram_64_kbytes is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (13 DOWNTO 0);
                    signal byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal clken : IN STD_LOGIC;
                    signal write : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component onchip_ram_64_kbytes;

component reconfig_request_pio_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reconfig_request_pio_s1_readdata : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_reconfig_request_pio_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_reconfig_request_pio_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_reconfig_request_pio_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_reconfig_request_pio_s1 : OUT STD_LOGIC;
                    signal d1_reconfig_request_pio_s1_end_xfer : OUT STD_LOGIC;
                    signal reconfig_request_pio_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal reconfig_request_pio_s1_chipselect : OUT STD_LOGIC;
                    signal reconfig_request_pio_s1_readdata_from_sa : OUT STD_LOGIC;
                    signal reconfig_request_pio_s1_reset_n : OUT STD_LOGIC;
                    signal reconfig_request_pio_s1_write_n : OUT STD_LOGIC;
                    signal reconfig_request_pio_s1_writedata : OUT STD_LOGIC
                 );
end component reconfig_request_pio_s1_arbitrator;

component reconfig_request_pio is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC;

                 -- outputs:
                    signal bidir_port : INOUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC
                 );
end component reconfig_request_pio;

component sdram_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal sdram_s1_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal sdram_s1_readdatavalid : IN STD_LOGIC;
                    signal sdram_s1_waitrequest : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_sdram_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_sdram_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sdram_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sdram_s1_shift_register : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal cpu_data_master_requests_sdram_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_sdram_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_sdram_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_sdram_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_sdram_s1_shift_register : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal cpu_instruction_master_requests_sdram_s1 : OUT STD_LOGIC;
                    signal d1_sdram_s1_end_xfer : OUT STD_LOGIC;
                    signal sdram_s1_address : OUT STD_LOGIC_VECTOR (21 DOWNTO 0);
                    signal sdram_s1_byteenable_n : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal sdram_s1_chipselect : OUT STD_LOGIC;
                    signal sdram_s1_posted_fifo_readenable : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal sdram_s1_posted_fifo_writenable : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal sdram_s1_read_n : OUT STD_LOGIC;
                    signal sdram_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal sdram_s1_reset_n : OUT STD_LOGIC;
                    signal sdram_s1_waitrequest_from_sa : OUT STD_LOGIC;
                    signal sdram_s1_write_n : OUT STD_LOGIC;
                    signal sdram_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component sdram_s1_arbitrator;

component sdram is 
           port (
                 -- inputs:
                    signal az_addr : IN STD_LOGIC_VECTOR (21 DOWNTO 0);
                    signal az_be_n : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal az_cs : IN STD_LOGIC;
                    signal az_data : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal az_rd_n : IN STD_LOGIC;
                    signal az_wr_n : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal za_data : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal za_valid : OUT STD_LOGIC;
                    signal za_waitrequest : OUT STD_LOGIC;
                    signal zs_addr : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal zs_ba : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal zs_cas_n : OUT STD_LOGIC;
                    signal zs_cke : OUT STD_LOGIC;
                    signal zs_cs_n : OUT STD_LOGIC;
                    signal zs_dq : INOUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal zs_dqm : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal zs_ras_n : OUT STD_LOGIC;
                    signal zs_we_n : OUT STD_LOGIC
                 );
end component sdram;

component seven_seg_pio_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_seven_seg_pio_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_seven_seg_pio_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_seven_seg_pio_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_seven_seg_pio_s1 : OUT STD_LOGIC;
                    signal d1_seven_seg_pio_s1_end_xfer : OUT STD_LOGIC;
                    signal seven_seg_pio_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal seven_seg_pio_s1_chipselect : OUT STD_LOGIC;
                    signal seven_seg_pio_s1_reset_n : OUT STD_LOGIC;
                    signal seven_seg_pio_s1_write_n : OUT STD_LOGIC;
                    signal seven_seg_pio_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component seven_seg_pio_s1_arbitrator;

component seven_seg_pio is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component seven_seg_pio;

component sys_clk_timer_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal sys_clk_timer_s1_irq : IN STD_LOGIC;
                    signal sys_clk_timer_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal cpu_data_master_granted_sys_clk_timer_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_sys_clk_timer_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sys_clk_timer_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_sys_clk_timer_s1 : OUT STD_LOGIC;
                    signal d1_sys_clk_timer_s1_end_xfer : OUT STD_LOGIC;
                    signal sys_clk_timer_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal sys_clk_timer_s1_chipselect : OUT STD_LOGIC;
                    signal sys_clk_timer_s1_irq_from_sa : OUT STD_LOGIC;
                    signal sys_clk_timer_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal sys_clk_timer_s1_reset_n : OUT STD_LOGIC;
                    signal sys_clk_timer_s1_write_n : OUT STD_LOGIC;
                    signal sys_clk_timer_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component sys_clk_timer_s1_arbitrator;

component sys_clk_timer is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal irq : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component sys_clk_timer;

component sysid_control_slave_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal sysid_control_slave_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal cpu_data_master_granted_sysid_control_slave : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_sysid_control_slave : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sysid_control_slave : OUT STD_LOGIC;
                    signal cpu_data_master_requests_sysid_control_slave : OUT STD_LOGIC;
                    signal d1_sysid_control_slave_end_xfer : OUT STD_LOGIC;
                    signal sysid_control_slave_address : OUT STD_LOGIC;
                    signal sysid_control_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component sysid_control_slave_arbitrator;

component sysid is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC;

                 -- outputs:
                    signal readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component sysid;

component uart1_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (25 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal uart1_s1_dataavailable : IN STD_LOGIC;
                    signal uart1_s1_irq : IN STD_LOGIC;
                    signal uart1_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal uart1_s1_readyfordata : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_uart1_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_uart1_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_uart1_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_uart1_s1 : OUT STD_LOGIC;
                    signal d1_uart1_s1_end_xfer : OUT STD_LOGIC;
                    signal uart1_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal uart1_s1_begintransfer : OUT STD_LOGIC;
                    signal uart1_s1_chipselect : OUT STD_LOGIC;
                    signal uart1_s1_dataavailable_from_sa : OUT STD_LOGIC;
                    signal uart1_s1_irq_from_sa : OUT STD_LOGIC;
                    signal uart1_s1_read_n : OUT STD_LOGIC;
                    signal uart1_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal uart1_s1_readyfordata_from_sa : OUT STD_LOGIC;
                    signal uart1_s1_reset_n : OUT STD_LOGIC;
                    signal uart1_s1_write_n : OUT STD_LOGIC;
                    signal uart1_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component uart1_s1_arbitrator;

component uart1 is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal begintransfer : IN STD_LOGIC;
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal read_n : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal rxd : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal dataavailable : OUT STD_LOGIC;
                    signal irq : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal readyfordata : OUT STD_LOGIC;
                    signal txd : OUT STD_LOGIC
                 );
end component uart1;

component reset_clk_domain_synch_module is 
           port (
                 -- inputs:
                    signal clk_in : IN STD_LOGIC;
                    signal clk_out : IN STD_LOGIC;
                    signal data_in : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal data_out : OUT STD_LOGIC
                 );
end component reset_clk_domain_synch_module;

                signal always_one :  STD_LOGIC;
                signal button_pio_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal button_pio_s1_chipselect :  STD_LOGIC;
                signal button_pio_s1_irq :  STD_LOGIC;
                signal button_pio_s1_irq_from_sa :  STD_LOGIC;
                signal button_pio_s1_readdata :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal button_pio_s1_readdata_from_sa :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal button_pio_s1_reset_n :  STD_LOGIC;
                signal button_pio_s1_write_n :  STD_LOGIC;
                signal button_pio_s1_writedata :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal clk_reset_n :  STD_LOGIC;
                signal clk_reset_n_sources :  STD_LOGIC;
                signal cpu_data_master_address :  STD_LOGIC_VECTOR (25 DOWNTO 0);
                signal cpu_data_master_address_to_slave :  STD_LOGIC_VECTOR (25 DOWNTO 0);
                signal cpu_data_master_byteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal cpu_data_master_byteenable_ext_flash_s1 :  STD_LOGIC;
                signal cpu_data_master_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_dbs_write_8 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal cpu_data_master_debugaccess :  STD_LOGIC;
                signal cpu_data_master_granted_button_pio_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_data_master_granted_ext_flash_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_ext_ram_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_high_res_timer_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_jtag_uart_avalon_jtag_slave :  STD_LOGIC;
                signal cpu_data_master_granted_jtagpio_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_lan91c111_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_led_pio_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_onchip_ram_64_kbytes_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_reconfig_request_pio_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_sdram_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_seven_seg_pio_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_sys_clk_timer_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_sysid_control_slave :  STD_LOGIC;
                signal cpu_data_master_granted_uart1_s1 :  STD_LOGIC;
                signal cpu_data_master_irq :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_data_master_no_byte_enables_and_last_term :  STD_LOGIC;
                signal cpu_data_master_qualified_request_button_pio_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_data_master_qualified_request_ext_flash_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_ext_ram_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_high_res_timer_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave :  STD_LOGIC;
                signal cpu_data_master_qualified_request_jtagpio_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_lan91c111_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_led_pio_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_onchip_ram_64_kbytes_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_reconfig_request_pio_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_sdram_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_seven_seg_pio_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_sys_clk_timer_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_sysid_control_slave :  STD_LOGIC;
                signal cpu_data_master_qualified_request_uart1_s1 :  STD_LOGIC;
                signal cpu_data_master_read :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_button_pio_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_ext_flash_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_ext_ram_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_high_res_timer_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_jtagpio_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_lan91c111_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_led_pio_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_reconfig_request_pio_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_sdram_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_sdram_s1_shift_register :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal cpu_data_master_read_data_valid_seven_seg_pio_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_sys_clk_timer_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_sysid_control_slave :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_uart1_s1 :  STD_LOGIC;
                signal cpu_data_master_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_data_master_requests_button_pio_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_data_master_requests_ext_flash_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_ext_ram_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_high_res_timer_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_jtag_uart_avalon_jtag_slave :  STD_LOGIC;
                signal cpu_data_master_requests_jtagpio_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_lan91c111_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_led_pio_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_onchip_ram_64_kbytes_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_reconfig_request_pio_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_sdram_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_seven_seg_pio_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_sys_clk_timer_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_sysid_control_slave :  STD_LOGIC;
                signal cpu_data_master_requests_uart1_s1 :  STD_LOGIC;
                signal cpu_data_master_waitrequest :  STD_LOGIC;
                signal cpu_data_master_write :  STD_LOGIC;
                signal cpu_data_master_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_instruction_master_address :  STD_LOGIC_VECTOR (25 DOWNTO 0);
                signal cpu_instruction_master_address_to_slave :  STD_LOGIC_VECTOR (25 DOWNTO 0);
                signal cpu_instruction_master_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_instruction_master_granted_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_granted_ext_flash_s1 :  STD_LOGIC;
                signal cpu_instruction_master_granted_ext_ram_s1 :  STD_LOGIC;
                signal cpu_instruction_master_granted_lan91c111_s1 :  STD_LOGIC;
                signal cpu_instruction_master_granted_onchip_ram_64_kbytes_s1 :  STD_LOGIC;
                signal cpu_instruction_master_granted_sdram_s1 :  STD_LOGIC;
                signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_qualified_request_ext_flash_s1 :  STD_LOGIC;
                signal cpu_instruction_master_qualified_request_ext_ram_s1 :  STD_LOGIC;
                signal cpu_instruction_master_qualified_request_lan91c111_s1 :  STD_LOGIC;
                signal cpu_instruction_master_qualified_request_onchip_ram_64_kbytes_s1 :  STD_LOGIC;
                signal cpu_instruction_master_qualified_request_sdram_s1 :  STD_LOGIC;
                signal cpu_instruction_master_read :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_ext_flash_s1 :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_ext_ram_s1 :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_lan91c111_s1 :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1 :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_sdram_s1 :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_sdram_s1_shift_register :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal cpu_instruction_master_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_instruction_master_requests_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_requests_ext_flash_s1 :  STD_LOGIC;
                signal cpu_instruction_master_requests_ext_ram_s1 :  STD_LOGIC;
                signal cpu_instruction_master_requests_lan91c111_s1 :  STD_LOGIC;
                signal cpu_instruction_master_requests_onchip_ram_64_kbytes_s1 :  STD_LOGIC;
                signal cpu_instruction_master_requests_sdram_s1 :  STD_LOGIC;
                signal cpu_instruction_master_waitrequest :  STD_LOGIC;
                signal cpu_jtag_debug_module_address :  STD_LOGIC_VECTOR (8 DOWNTO 0);
                signal cpu_jtag_debug_module_begintransfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_byteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal cpu_jtag_debug_module_chipselect :  STD_LOGIC;
                signal cpu_jtag_debug_module_debugaccess :  STD_LOGIC;
                signal cpu_jtag_debug_module_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_jtag_debug_module_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_jtag_debug_module_reset :  STD_LOGIC;
                signal cpu_jtag_debug_module_reset_n :  STD_LOGIC;
                signal cpu_jtag_debug_module_resetrequest :  STD_LOGIC;
                signal cpu_jtag_debug_module_resetrequest_from_sa :  STD_LOGIC;
                signal cpu_jtag_debug_module_write :  STD_LOGIC;
                signal cpu_jtag_debug_module_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal d1_button_pio_s1_end_xfer :  STD_LOGIC;
                signal d1_cpu_jtag_debug_module_end_xfer :  STD_LOGIC;
                signal d1_ext_ram_bus_avalon_slave_end_xfer :  STD_LOGIC;
                signal d1_high_res_timer_s1_end_xfer :  STD_LOGIC;
                signal d1_irq_from_the_lan91c111 :  STD_LOGIC;
                signal d1_jtag_uart_avalon_jtag_slave_end_xfer :  STD_LOGIC;
                signal d1_jtagpio_s1_end_xfer :  STD_LOGIC;
                signal d1_led_pio_s1_end_xfer :  STD_LOGIC;
                signal d1_onchip_ram_64_kbytes_s1_end_xfer :  STD_LOGIC;
                signal d1_reconfig_request_pio_s1_end_xfer :  STD_LOGIC;
                signal d1_sdram_s1_end_xfer :  STD_LOGIC;
                signal d1_seven_seg_pio_s1_end_xfer :  STD_LOGIC;
                signal d1_sys_clk_timer_s1_end_xfer :  STD_LOGIC;
                signal d1_sysid_control_slave_end_xfer :  STD_LOGIC;
                signal d1_uart1_s1_end_xfer :  STD_LOGIC;
                signal ext_flash_s1_wait_counter_eq_0 :  STD_LOGIC;
                signal ext_flash_s1_wait_counter_eq_1 :  STD_LOGIC;
                signal high_res_timer_s1_address :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal high_res_timer_s1_chipselect :  STD_LOGIC;
                signal high_res_timer_s1_irq :  STD_LOGIC;
                signal high_res_timer_s1_irq_from_sa :  STD_LOGIC;
                signal high_res_timer_s1_readdata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal high_res_timer_s1_readdata_from_sa :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal high_res_timer_s1_reset_n :  STD_LOGIC;
                signal high_res_timer_s1_write_n :  STD_LOGIC;
                signal high_res_timer_s1_writedata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal incoming_ext_ram_bus_data :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal incoming_ext_ram_bus_data_with_Xs_converted_to_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal internal_be_n_to_the_ext_ram :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal internal_ext_ram_bus_address :  STD_LOGIC_VECTOR (22 DOWNTO 0);
                signal internal_ext_ram_bus_byteenablen :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal internal_ext_ram_bus_readn :  STD_LOGIC;
                signal internal_ior_n_to_the_lan91c111 :  STD_LOGIC;
                signal internal_iow_n_to_the_lan91c111 :  STD_LOGIC;
                signal internal_out_port_from_the_jtagpio :  STD_LOGIC_VECTOR (20 DOWNTO 0);
                signal internal_out_port_from_the_led_pio :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal internal_out_port_from_the_seven_seg_pio :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal internal_read_n_to_the_ext_ram :  STD_LOGIC;
                signal internal_reset_n_to_the_lan91c111 :  STD_LOGIC;
                signal internal_select_n_to_the_ext_flash :  STD_LOGIC;
                signal internal_select_n_to_the_ext_ram :  STD_LOGIC;
                signal internal_txd_from_the_uart1 :  STD_LOGIC;
                signal internal_write_n_to_the_ext_flash :  STD_LOGIC;
                signal internal_write_n_to_the_ext_ram :  STD_LOGIC;
                signal internal_zs_addr_from_the_sdram :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal internal_zs_ba_from_the_sdram :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal internal_zs_cas_n_from_the_sdram :  STD_LOGIC;
                signal internal_zs_cke_from_the_sdram :  STD_LOGIC;
                signal internal_zs_cs_n_from_the_sdram :  STD_LOGIC;
                signal internal_zs_dqm_from_the_sdram :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal internal_zs_ras_n_from_the_sdram :  STD_LOGIC;
                signal internal_zs_we_n_from_the_sdram :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_address :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_chipselect :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_dataavailable :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_dataavailable_from_sa :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_irq :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_irq_from_sa :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_read_n :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal jtag_uart_avalon_jtag_slave_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal jtag_uart_avalon_jtag_slave_readyfordata :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_readyfordata_from_sa :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_reset_n :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_waitrequest :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_waitrequest_from_sa :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_write_n :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal jtagpio_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal jtagpio_s1_chipselect :  STD_LOGIC;
                signal jtagpio_s1_readdata :  STD_LOGIC_VECTOR (20 DOWNTO 0);
                signal jtagpio_s1_readdata_from_sa :  STD_LOGIC_VECTOR (20 DOWNTO 0);
                signal jtagpio_s1_reset_n :  STD_LOGIC;
                signal jtagpio_s1_write_n :  STD_LOGIC;
                signal jtagpio_s1_writedata :  STD_LOGIC_VECTOR (20 DOWNTO 0);
                signal lan91c111_s1_wait_counter_eq_0 :  STD_LOGIC;
                signal led_pio_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal led_pio_s1_chipselect :  STD_LOGIC;
                signal led_pio_s1_readdata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal led_pio_s1_readdata_from_sa :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal led_pio_s1_reset_n :  STD_LOGIC;
                signal led_pio_s1_write_n :  STD_LOGIC;
                signal led_pio_s1_writedata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal onchip_ram_64_kbytes_s1_address :  STD_LOGIC_VECTOR (13 DOWNTO 0);
                signal onchip_ram_64_kbytes_s1_byteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal onchip_ram_64_kbytes_s1_chipselect :  STD_LOGIC;
                signal onchip_ram_64_kbytes_s1_clken :  STD_LOGIC;
                signal onchip_ram_64_kbytes_s1_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal onchip_ram_64_kbytes_s1_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal onchip_ram_64_kbytes_s1_write :  STD_LOGIC;
                signal onchip_ram_64_kbytes_s1_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal reconfig_request_pio_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal reconfig_request_pio_s1_chipselect :  STD_LOGIC;
                signal reconfig_request_pio_s1_readdata :  STD_LOGIC;
                signal reconfig_request_pio_s1_readdata_from_sa :  STD_LOGIC;
                signal reconfig_request_pio_s1_reset_n :  STD_LOGIC;
                signal reconfig_request_pio_s1_write_n :  STD_LOGIC;
                signal reconfig_request_pio_s1_writedata :  STD_LOGIC;
                signal registered_cpu_data_master_read_data_valid_ext_flash_s1 :  STD_LOGIC;
                signal registered_cpu_data_master_read_data_valid_ext_ram_s1 :  STD_LOGIC;
                signal registered_cpu_data_master_read_data_valid_lan91c111_s1 :  STD_LOGIC;
                signal registered_cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1 :  STD_LOGIC;
                signal reset_n_sources :  STD_LOGIC;
                signal sdram_s1_address :  STD_LOGIC_VECTOR (21 DOWNTO 0);
                signal sdram_s1_byteenable_n :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal sdram_s1_chipselect :  STD_LOGIC;
                signal sdram_s1_posted_fifo_readenable :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal sdram_s1_posted_fifo_writenable :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal sdram_s1_read_n :  STD_LOGIC;
                signal sdram_s1_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal sdram_s1_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal sdram_s1_readdatavalid :  STD_LOGIC;
                signal sdram_s1_reset_n :  STD_LOGIC;
                signal sdram_s1_waitrequest :  STD_LOGIC;
                signal sdram_s1_waitrequest_from_sa :  STD_LOGIC;
                signal sdram_s1_write_n :  STD_LOGIC;
                signal sdram_s1_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal seven_seg_pio_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal seven_seg_pio_s1_chipselect :  STD_LOGIC;
                signal seven_seg_pio_s1_reset_n :  STD_LOGIC;
                signal seven_seg_pio_s1_write_n :  STD_LOGIC;
                signal seven_seg_pio_s1_writedata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal sys_clk_timer_s1_address :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sys_clk_timer_s1_chipselect :  STD_LOGIC;
                signal sys_clk_timer_s1_irq :  STD_LOGIC;
                signal sys_clk_timer_s1_irq_from_sa :  STD_LOGIC;
                signal sys_clk_timer_s1_readdata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal sys_clk_timer_s1_readdata_from_sa :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal sys_clk_timer_s1_reset_n :  STD_LOGIC;
                signal sys_clk_timer_s1_write_n :  STD_LOGIC;
                signal sys_clk_timer_s1_writedata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal sysid_control_slave_address :  STD_LOGIC;
                signal sysid_control_slave_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal sysid_control_slave_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal uart1_s1_address :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal uart1_s1_begintransfer :  STD_LOGIC;
                signal uart1_s1_chipselect :  STD_LOGIC;
                signal uart1_s1_dataavailable :  STD_LOGIC;
                signal uart1_s1_dataavailable_from_sa :  STD_LOGIC;
                signal uart1_s1_irq :  STD_LOGIC;
                signal uart1_s1_irq_from_sa :  STD_LOGIC;
                signal uart1_s1_read_n :  STD_LOGIC;
                signal uart1_s1_readdata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal uart1_s1_readdata_from_sa :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal uart1_s1_readyfordata :  STD_LOGIC;
                signal uart1_s1_readyfordata_from_sa :  STD_LOGIC;
                signal uart1_s1_reset_n :  STD_LOGIC;
                signal uart1_s1_write_n :  STD_LOGIC;
                signal uart1_s1_writedata :  STD_LOGIC_VECTOR (15 DOWNTO 0);

begin

  the_button_pio_s1 : button_pio_s1_arbitrator
    port map(
      button_pio_s1_address => button_pio_s1_address,
      button_pio_s1_chipselect => button_pio_s1_chipselect,
      button_pio_s1_irq_from_sa => button_pio_s1_irq_from_sa,
      button_pio_s1_readdata_from_sa => button_pio_s1_readdata_from_sa,
      button_pio_s1_reset_n => button_pio_s1_reset_n,
      button_pio_s1_write_n => button_pio_s1_write_n,
      button_pio_s1_writedata => button_pio_s1_writedata,
      cpu_data_master_granted_button_pio_s1 => cpu_data_master_granted_button_pio_s1,
      cpu_data_master_qualified_request_button_pio_s1 => cpu_data_master_qualified_request_button_pio_s1,
      cpu_data_master_read_data_valid_button_pio_s1 => cpu_data_master_read_data_valid_button_pio_s1,
      cpu_data_master_requests_button_pio_s1 => cpu_data_master_requests_button_pio_s1,
      d1_button_pio_s1_end_xfer => d1_button_pio_s1_end_xfer,
      button_pio_s1_irq => button_pio_s1_irq,
      button_pio_s1_readdata => button_pio_s1_readdata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n
    );


  the_button_pio : button_pio
    port map(
      irq => button_pio_s1_irq,
      readdata => button_pio_s1_readdata,
      address => button_pio_s1_address,
      chipselect => button_pio_s1_chipselect,
      clk => clk,
      in_port => in_port_to_the_button_pio,
      reset_n => button_pio_s1_reset_n,
      write_n => button_pio_s1_write_n,
      writedata => button_pio_s1_writedata
    );


  the_cpu_jtag_debug_module : cpu_jtag_debug_module_arbitrator
    port map(
      cpu_data_master_granted_cpu_jtag_debug_module => cpu_data_master_granted_cpu_jtag_debug_module,
      cpu_data_master_qualified_request_cpu_jtag_debug_module => cpu_data_master_qualified_request_cpu_jtag_debug_module,
      cpu_data_master_read_data_valid_cpu_jtag_debug_module => cpu_data_master_read_data_valid_cpu_jtag_debug_module,
      cpu_data_master_requests_cpu_jtag_debug_module => cpu_data_master_requests_cpu_jtag_debug_module,
      cpu_instruction_master_granted_cpu_jtag_debug_module => cpu_instruction_master_granted_cpu_jtag_debug_module,
      cpu_instruction_master_qualified_request_cpu_jtag_debug_module => cpu_instruction_master_qualified_request_cpu_jtag_debug_module,
      cpu_instruction_master_read_data_valid_cpu_jtag_debug_module => cpu_instruction_master_read_data_valid_cpu_jtag_debug_module,
      cpu_instruction_master_requests_cpu_jtag_debug_module => cpu_instruction_master_requests_cpu_jtag_debug_module,
      cpu_jtag_debug_module_address => cpu_jtag_debug_module_address,
      cpu_jtag_debug_module_begintransfer => cpu_jtag_debug_module_begintransfer,
      cpu_jtag_debug_module_byteenable => cpu_jtag_debug_module_byteenable,
      cpu_jtag_debug_module_chipselect => cpu_jtag_debug_module_chipselect,
      cpu_jtag_debug_module_debugaccess => cpu_jtag_debug_module_debugaccess,
      cpu_jtag_debug_module_readdata_from_sa => cpu_jtag_debug_module_readdata_from_sa,
      cpu_jtag_debug_module_reset => cpu_jtag_debug_module_reset,
      cpu_jtag_debug_module_reset_n => cpu_jtag_debug_module_reset_n,
      cpu_jtag_debug_module_resetrequest_from_sa => cpu_jtag_debug_module_resetrequest_from_sa,
      cpu_jtag_debug_module_write => cpu_jtag_debug_module_write,
      cpu_jtag_debug_module_writedata => cpu_jtag_debug_module_writedata,
      d1_cpu_jtag_debug_module_end_xfer => d1_cpu_jtag_debug_module_end_xfer,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_debugaccess => cpu_data_master_debugaccess,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      cpu_instruction_master_address_to_slave => cpu_instruction_master_address_to_slave,
      cpu_instruction_master_read => cpu_instruction_master_read,
      cpu_jtag_debug_module_readdata => cpu_jtag_debug_module_readdata,
      cpu_jtag_debug_module_resetrequest => cpu_jtag_debug_module_resetrequest,
      reset_n => clk_reset_n
    );


  the_cpu_data_master : cpu_data_master_arbitrator
    port map(
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_dbs_address => cpu_data_master_dbs_address,
      cpu_data_master_dbs_write_8 => cpu_data_master_dbs_write_8,
      cpu_data_master_irq => cpu_data_master_irq,
      cpu_data_master_no_byte_enables_and_last_term => cpu_data_master_no_byte_enables_and_last_term,
      cpu_data_master_readdata => cpu_data_master_readdata,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      button_pio_s1_irq_from_sa => button_pio_s1_irq_from_sa,
      button_pio_s1_readdata_from_sa => button_pio_s1_readdata_from_sa,
      clk => clk,
      cpu_data_master_address => cpu_data_master_address,
      cpu_data_master_byteenable_ext_flash_s1 => cpu_data_master_byteenable_ext_flash_s1,
      cpu_data_master_debugaccess => cpu_data_master_debugaccess,
      cpu_data_master_granted_button_pio_s1 => cpu_data_master_granted_button_pio_s1,
      cpu_data_master_granted_cpu_jtag_debug_module => cpu_data_master_granted_cpu_jtag_debug_module,
      cpu_data_master_granted_ext_flash_s1 => cpu_data_master_granted_ext_flash_s1,
      cpu_data_master_granted_ext_ram_s1 => cpu_data_master_granted_ext_ram_s1,
      cpu_data_master_granted_high_res_timer_s1 => cpu_data_master_granted_high_res_timer_s1,
      cpu_data_master_granted_jtag_uart_avalon_jtag_slave => cpu_data_master_granted_jtag_uart_avalon_jtag_slave,
      cpu_data_master_granted_jtagpio_s1 => cpu_data_master_granted_jtagpio_s1,
      cpu_data_master_granted_lan91c111_s1 => cpu_data_master_granted_lan91c111_s1,
      cpu_data_master_granted_led_pio_s1 => cpu_data_master_granted_led_pio_s1,
      cpu_data_master_granted_onchip_ram_64_kbytes_s1 => cpu_data_master_granted_onchip_ram_64_kbytes_s1,
      cpu_data_master_granted_reconfig_request_pio_s1 => cpu_data_master_granted_reconfig_request_pio_s1,
      cpu_data_master_granted_sdram_s1 => cpu_data_master_granted_sdram_s1,
      cpu_data_master_granted_seven_seg_pio_s1 => cpu_data_master_granted_seven_seg_pio_s1,
      cpu_data_master_granted_sys_clk_timer_s1 => cpu_data_master_granted_sys_clk_timer_s1,
      cpu_data_master_granted_sysid_control_slave => cpu_data_master_granted_sysid_control_slave,
      cpu_data_master_granted_uart1_s1 => cpu_data_master_granted_uart1_s1,
      cpu_data_master_qualified_request_button_pio_s1 => cpu_data_master_qualified_request_button_pio_s1,
      cpu_data_master_qualified_request_cpu_jtag_debug_module => cpu_data_master_qualified_request_cpu_jtag_debug_module,
      cpu_data_master_qualified_request_ext_flash_s1 => cpu_data_master_qualified_request_ext_flash_s1,
      cpu_data_master_qualified_request_ext_ram_s1 => cpu_data_master_qualified_request_ext_ram_s1,
      cpu_data_master_qualified_request_high_res_timer_s1 => cpu_data_master_qualified_request_high_res_timer_s1,
      cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave => cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave,
      cpu_data_master_qualified_request_jtagpio_s1 => cpu_data_master_qualified_request_jtagpio_s1,
      cpu_data_master_qualified_request_lan91c111_s1 => cpu_data_master_qualified_request_lan91c111_s1,
      cpu_data_master_qualified_request_led_pio_s1 => cpu_data_master_qualified_request_led_pio_s1,
      cpu_data_master_qualified_request_onchip_ram_64_kbytes_s1 => cpu_data_master_qualified_request_onchip_ram_64_kbytes_s1,
      cpu_data_master_qualified_request_reconfig_request_pio_s1 => cpu_data_master_qualified_request_reconfig_request_pio_s1,
      cpu_data_master_qualified_request_sdram_s1 => cpu_data_master_qualified_request_sdram_s1,
      cpu_data_master_qualified_request_seven_seg_pio_s1 => cpu_data_master_qualified_request_seven_seg_pio_s1,
      cpu_data_master_qualified_request_sys_clk_timer_s1 => cpu_data_master_qualified_request_sys_clk_timer_s1,
      cpu_data_master_qualified_request_sysid_control_slave => cpu_data_master_qualified_request_sysid_control_slave,
      cpu_data_master_qualified_request_uart1_s1 => cpu_data_master_qualified_request_uart1_s1,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_read_data_valid_button_pio_s1 => cpu_data_master_read_data_valid_button_pio_s1,
      cpu_data_master_read_data_valid_cpu_jtag_debug_module => cpu_data_master_read_data_valid_cpu_jtag_debug_module,
      cpu_data_master_read_data_valid_ext_flash_s1 => cpu_data_master_read_data_valid_ext_flash_s1,
      cpu_data_master_read_data_valid_ext_ram_s1 => cpu_data_master_read_data_valid_ext_ram_s1,
      cpu_data_master_read_data_valid_high_res_timer_s1 => cpu_data_master_read_data_valid_high_res_timer_s1,
      cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave => cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave,
      cpu_data_master_read_data_valid_jtagpio_s1 => cpu_data_master_read_data_valid_jtagpio_s1,
      cpu_data_master_read_data_valid_lan91c111_s1 => cpu_data_master_read_data_valid_lan91c111_s1,
      cpu_data_master_read_data_valid_led_pio_s1 => cpu_data_master_read_data_valid_led_pio_s1,
      cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1 => cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1,
      cpu_data_master_read_data_valid_reconfig_request_pio_s1 => cpu_data_master_read_data_valid_reconfig_request_pio_s1,
      cpu_data_master_read_data_valid_sdram_s1 => cpu_data_master_read_data_valid_sdram_s1,
      cpu_data_master_read_data_valid_sdram_s1_shift_register => cpu_data_master_read_data_valid_sdram_s1_shift_register,
      cpu_data_master_read_data_valid_seven_seg_pio_s1 => cpu_data_master_read_data_valid_seven_seg_pio_s1,
      cpu_data_master_read_data_valid_sys_clk_timer_s1 => cpu_data_master_read_data_valid_sys_clk_timer_s1,
      cpu_data_master_read_data_valid_sysid_control_slave => cpu_data_master_read_data_valid_sysid_control_slave,
      cpu_data_master_read_data_valid_uart1_s1 => cpu_data_master_read_data_valid_uart1_s1,
      cpu_data_master_requests_button_pio_s1 => cpu_data_master_requests_button_pio_s1,
      cpu_data_master_requests_cpu_jtag_debug_module => cpu_data_master_requests_cpu_jtag_debug_module,
      cpu_data_master_requests_ext_flash_s1 => cpu_data_master_requests_ext_flash_s1,
      cpu_data_master_requests_ext_ram_s1 => cpu_data_master_requests_ext_ram_s1,
      cpu_data_master_requests_high_res_timer_s1 => cpu_data_master_requests_high_res_timer_s1,
      cpu_data_master_requests_jtag_uart_avalon_jtag_slave => cpu_data_master_requests_jtag_uart_avalon_jtag_slave,
      cpu_data_master_requests_jtagpio_s1 => cpu_data_master_requests_jtagpio_s1,
      cpu_data_master_requests_lan91c111_s1 => cpu_data_master_requests_lan91c111_s1,
      cpu_data_master_requests_led_pio_s1 => cpu_data_master_requests_led_pio_s1,
      cpu_data_master_requests_onchip_ram_64_kbytes_s1 => cpu_data_master_requests_onchip_ram_64_kbytes_s1,
      cpu_data_master_requests_reconfig_request_pio_s1 => cpu_data_master_requests_reconfig_request_pio_s1,
      cpu_data_master_requests_sdram_s1 => cpu_data_master_requests_sdram_s1,
      cpu_data_master_requests_seven_seg_pio_s1 => cpu_data_master_requests_seven_seg_pio_s1,
      cpu_data_master_requests_sys_clk_timer_s1 => cpu_data_master_requests_sys_clk_timer_s1,
      cpu_data_master_requests_sysid_control_slave => cpu_data_master_requests_sysid_control_slave,
      cpu_data_master_requests_uart1_s1 => cpu_data_master_requests_uart1_s1,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      cpu_jtag_debug_module_readdata_from_sa => cpu_jtag_debug_module_readdata_from_sa,
      d1_button_pio_s1_end_xfer => d1_button_pio_s1_end_xfer,
      d1_cpu_jtag_debug_module_end_xfer => d1_cpu_jtag_debug_module_end_xfer,
      d1_ext_ram_bus_avalon_slave_end_xfer => d1_ext_ram_bus_avalon_slave_end_xfer,
      d1_high_res_timer_s1_end_xfer => d1_high_res_timer_s1_end_xfer,
      d1_irq_from_the_lan91c111 => d1_irq_from_the_lan91c111,
      d1_jtag_uart_avalon_jtag_slave_end_xfer => d1_jtag_uart_avalon_jtag_slave_end_xfer,
      d1_jtagpio_s1_end_xfer => d1_jtagpio_s1_end_xfer,
      d1_led_pio_s1_end_xfer => d1_led_pio_s1_end_xfer,
      d1_onchip_ram_64_kbytes_s1_end_xfer => d1_onchip_ram_64_kbytes_s1_end_xfer,
      d1_reconfig_request_pio_s1_end_xfer => d1_reconfig_request_pio_s1_end_xfer,
      d1_sdram_s1_end_xfer => d1_sdram_s1_end_xfer,
      d1_seven_seg_pio_s1_end_xfer => d1_seven_seg_pio_s1_end_xfer,
      d1_sys_clk_timer_s1_end_xfer => d1_sys_clk_timer_s1_end_xfer,
      d1_sysid_control_slave_end_xfer => d1_sysid_control_slave_end_xfer,
      d1_uart1_s1_end_xfer => d1_uart1_s1_end_xfer,
      ext_flash_s1_wait_counter_eq_0 => ext_flash_s1_wait_counter_eq_0,
      ext_flash_s1_wait_counter_eq_1 => ext_flash_s1_wait_counter_eq_1,
      high_res_timer_s1_irq_from_sa => high_res_timer_s1_irq_from_sa,
      high_res_timer_s1_readdata_from_sa => high_res_timer_s1_readdata_from_sa,
      incoming_ext_ram_bus_data => incoming_ext_ram_bus_data,
      incoming_ext_ram_bus_data_with_Xs_converted_to_0 => incoming_ext_ram_bus_data_with_Xs_converted_to_0,
      jtag_uart_avalon_jtag_slave_irq_from_sa => jtag_uart_avalon_jtag_slave_irq_from_sa,
      jtag_uart_avalon_jtag_slave_readdata_from_sa => jtag_uart_avalon_jtag_slave_readdata_from_sa,
      jtag_uart_avalon_jtag_slave_waitrequest_from_sa => jtag_uart_avalon_jtag_slave_waitrequest_from_sa,
      jtagpio_s1_readdata_from_sa => jtagpio_s1_readdata_from_sa,
      lan91c111_s1_wait_counter_eq_0 => lan91c111_s1_wait_counter_eq_0,
      led_pio_s1_readdata_from_sa => led_pio_s1_readdata_from_sa,
      onchip_ram_64_kbytes_s1_readdata_from_sa => onchip_ram_64_kbytes_s1_readdata_from_sa,
      reconfig_request_pio_s1_readdata_from_sa => reconfig_request_pio_s1_readdata_from_sa,
      registered_cpu_data_master_read_data_valid_ext_flash_s1 => registered_cpu_data_master_read_data_valid_ext_flash_s1,
      registered_cpu_data_master_read_data_valid_ext_ram_s1 => registered_cpu_data_master_read_data_valid_ext_ram_s1,
      registered_cpu_data_master_read_data_valid_lan91c111_s1 => registered_cpu_data_master_read_data_valid_lan91c111_s1,
      registered_cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1 => registered_cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1,
      reset_n => clk_reset_n,
      sdram_s1_posted_fifo_readenable => sdram_s1_posted_fifo_readenable,
      sdram_s1_posted_fifo_writenable => sdram_s1_posted_fifo_writenable,
      sdram_s1_readdata_from_sa => sdram_s1_readdata_from_sa,
      sdram_s1_waitrequest_from_sa => sdram_s1_waitrequest_from_sa,
      sys_clk_timer_s1_irq_from_sa => sys_clk_timer_s1_irq_from_sa,
      sys_clk_timer_s1_readdata_from_sa => sys_clk_timer_s1_readdata_from_sa,
      sysid_control_slave_readdata_from_sa => sysid_control_slave_readdata_from_sa,
      uart1_s1_irq_from_sa => uart1_s1_irq_from_sa,
      uart1_s1_readdata_from_sa => uart1_s1_readdata_from_sa
    );


  the_cpu_instruction_master : cpu_instruction_master_arbitrator
    port map(
      cpu_instruction_master_address_to_slave => cpu_instruction_master_address_to_slave,
      cpu_instruction_master_dbs_address => cpu_instruction_master_dbs_address,
      cpu_instruction_master_readdata => cpu_instruction_master_readdata,
      cpu_instruction_master_waitrequest => cpu_instruction_master_waitrequest,
      clk => clk,
      cpu_instruction_master_address => cpu_instruction_master_address,
      cpu_instruction_master_granted_cpu_jtag_debug_module => cpu_instruction_master_granted_cpu_jtag_debug_module,
      cpu_instruction_master_granted_ext_flash_s1 => cpu_instruction_master_granted_ext_flash_s1,
      cpu_instruction_master_granted_ext_ram_s1 => cpu_instruction_master_granted_ext_ram_s1,
      cpu_instruction_master_granted_lan91c111_s1 => cpu_instruction_master_granted_lan91c111_s1,
      cpu_instruction_master_granted_onchip_ram_64_kbytes_s1 => cpu_instruction_master_granted_onchip_ram_64_kbytes_s1,
      cpu_instruction_master_granted_sdram_s1 => cpu_instruction_master_granted_sdram_s1,
      cpu_instruction_master_qualified_request_cpu_jtag_debug_module => cpu_instruction_master_qualified_request_cpu_jtag_debug_module,
      cpu_instruction_master_qualified_request_ext_flash_s1 => cpu_instruction_master_qualified_request_ext_flash_s1,
      cpu_instruction_master_qualified_request_ext_ram_s1 => cpu_instruction_master_qualified_request_ext_ram_s1,
      cpu_instruction_master_qualified_request_lan91c111_s1 => cpu_instruction_master_qualified_request_lan91c111_s1,
      cpu_instruction_master_qualified_request_onchip_ram_64_kbytes_s1 => cpu_instruction_master_qualified_request_onchip_ram_64_kbytes_s1,
      cpu_instruction_master_qualified_request_sdram_s1 => cpu_instruction_master_qualified_request_sdram_s1,
      cpu_instruction_master_read => cpu_instruction_master_read,
      cpu_instruction_master_read_data_valid_cpu_jtag_debug_module => cpu_instruction_master_read_data_valid_cpu_jtag_debug_module,
      cpu_instruction_master_read_data_valid_ext_flash_s1 => cpu_instruction_master_read_data_valid_ext_flash_s1,
      cpu_instruction_master_read_data_valid_ext_ram_s1 => cpu_instruction_master_read_data_valid_ext_ram_s1,
      cpu_instruction_master_read_data_valid_lan91c111_s1 => cpu_instruction_master_read_data_valid_lan91c111_s1,
      cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1 => cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1,
      cpu_instruction_master_read_data_valid_sdram_s1 => cpu_instruction_master_read_data_valid_sdram_s1,
      cpu_instruction_master_read_data_valid_sdram_s1_shift_register => cpu_instruction_master_read_data_valid_sdram_s1_shift_register,
      cpu_instruction_master_requests_cpu_jtag_debug_module => cpu_instruction_master_requests_cpu_jtag_debug_module,
      cpu_instruction_master_requests_ext_flash_s1 => cpu_instruction_master_requests_ext_flash_s1,
      cpu_instruction_master_requests_ext_ram_s1 => cpu_instruction_master_requests_ext_ram_s1,
      cpu_instruction_master_requests_lan91c111_s1 => cpu_instruction_master_requests_lan91c111_s1,
      cpu_instruction_master_requests_onchip_ram_64_kbytes_s1 => cpu_instruction_master_requests_onchip_ram_64_kbytes_s1,
      cpu_instruction_master_requests_sdram_s1 => cpu_instruction_master_requests_sdram_s1,
      cpu_jtag_debug_module_readdata_from_sa => cpu_jtag_debug_module_readdata_from_sa,
      d1_cpu_jtag_debug_module_end_xfer => d1_cpu_jtag_debug_module_end_xfer,
      d1_ext_ram_bus_avalon_slave_end_xfer => d1_ext_ram_bus_avalon_slave_end_xfer,
      d1_onchip_ram_64_kbytes_s1_end_xfer => d1_onchip_ram_64_kbytes_s1_end_xfer,
      d1_sdram_s1_end_xfer => d1_sdram_s1_end_xfer,
      ext_flash_s1_wait_counter_eq_0 => ext_flash_s1_wait_counter_eq_0,
      incoming_ext_ram_bus_data => incoming_ext_ram_bus_data,
      lan91c111_s1_wait_counter_eq_0 => lan91c111_s1_wait_counter_eq_0,
      onchip_ram_64_kbytes_s1_readdata_from_sa => onchip_ram_64_kbytes_s1_readdata_from_sa,
      reset_n => clk_reset_n,
      sdram_s1_posted_fifo_readenable => sdram_s1_posted_fifo_readenable,
      sdram_s1_posted_fifo_writenable => sdram_s1_posted_fifo_writenable,
      sdram_s1_readdata_from_sa => sdram_s1_readdata_from_sa
    );


  the_cpu : cpu
    port map(
      d_address => cpu_data_master_address,
      d_byteenable => cpu_data_master_byteenable,
      d_read => cpu_data_master_read,
      d_write => cpu_data_master_write,
      d_writedata => cpu_data_master_writedata,
      i_address => cpu_instruction_master_address,
      i_read => cpu_instruction_master_read,
      jtag_debug_module_debugaccess_to_roms => cpu_data_master_debugaccess,
      jtag_debug_module_readdata => cpu_jtag_debug_module_readdata,
      jtag_debug_module_resetrequest => cpu_jtag_debug_module_resetrequest,
      clk => clk,
      d_irq => cpu_data_master_irq,
      d_readdata => cpu_data_master_readdata,
      d_waitrequest => cpu_data_master_waitrequest,
      i_readdata => cpu_instruction_master_readdata,
      i_waitrequest => cpu_instruction_master_waitrequest,
      jtag_debug_module_address => cpu_jtag_debug_module_address,
      jtag_debug_module_begintransfer => cpu_jtag_debug_module_begintransfer,
      jtag_debug_module_byteenable => cpu_jtag_debug_module_byteenable,
      jtag_debug_module_clk => clk,
      jtag_debug_module_debugaccess => cpu_jtag_debug_module_debugaccess,
      jtag_debug_module_reset => cpu_jtag_debug_module_reset,
      jtag_debug_module_select => cpu_jtag_debug_module_chipselect,
      jtag_debug_module_write => cpu_jtag_debug_module_write,
      jtag_debug_module_writedata => cpu_jtag_debug_module_writedata,
      reset_n => cpu_jtag_debug_module_reset_n
    );


  the_ext_ram_bus_avalon_slave : ext_ram_bus_avalon_slave_arbitrator
    port map(
      be_n_to_the_ext_ram => internal_be_n_to_the_ext_ram,
      cpu_data_master_byteenable_ext_flash_s1 => cpu_data_master_byteenable_ext_flash_s1,
      cpu_data_master_granted_ext_flash_s1 => cpu_data_master_granted_ext_flash_s1,
      cpu_data_master_granted_ext_ram_s1 => cpu_data_master_granted_ext_ram_s1,
      cpu_data_master_granted_lan91c111_s1 => cpu_data_master_granted_lan91c111_s1,
      cpu_data_master_qualified_request_ext_flash_s1 => cpu_data_master_qualified_request_ext_flash_s1,
      cpu_data_master_qualified_request_ext_ram_s1 => cpu_data_master_qualified_request_ext_ram_s1,
      cpu_data_master_qualified_request_lan91c111_s1 => cpu_data_master_qualified_request_lan91c111_s1,
      cpu_data_master_read_data_valid_ext_flash_s1 => cpu_data_master_read_data_valid_ext_flash_s1,
      cpu_data_master_read_data_valid_ext_ram_s1 => cpu_data_master_read_data_valid_ext_ram_s1,
      cpu_data_master_read_data_valid_lan91c111_s1 => cpu_data_master_read_data_valid_lan91c111_s1,
      cpu_data_master_requests_ext_flash_s1 => cpu_data_master_requests_ext_flash_s1,
      cpu_data_master_requests_ext_ram_s1 => cpu_data_master_requests_ext_ram_s1,
      cpu_data_master_requests_lan91c111_s1 => cpu_data_master_requests_lan91c111_s1,
      cpu_instruction_master_granted_ext_flash_s1 => cpu_instruction_master_granted_ext_flash_s1,
      cpu_instruction_master_granted_ext_ram_s1 => cpu_instruction_master_granted_ext_ram_s1,
      cpu_instruction_master_granted_lan91c111_s1 => cpu_instruction_master_granted_lan91c111_s1,
      cpu_instruction_master_qualified_request_ext_flash_s1 => cpu_instruction_master_qualified_request_ext_flash_s1,
      cpu_instruction_master_qualified_request_ext_ram_s1 => cpu_instruction_master_qualified_request_ext_ram_s1,
      cpu_instruction_master_qualified_request_lan91c111_s1 => cpu_instruction_master_qualified_request_lan91c111_s1,
      cpu_instruction_master_read_data_valid_ext_flash_s1 => cpu_instruction_master_read_data_valid_ext_flash_s1,
      cpu_instruction_master_read_data_valid_ext_ram_s1 => cpu_instruction_master_read_data_valid_ext_ram_s1,
      cpu_instruction_master_read_data_valid_lan91c111_s1 => cpu_instruction_master_read_data_valid_lan91c111_s1,
      cpu_instruction_master_requests_ext_flash_s1 => cpu_instruction_master_requests_ext_flash_s1,
      cpu_instruction_master_requests_ext_ram_s1 => cpu_instruction_master_requests_ext_ram_s1,
      cpu_instruction_master_requests_lan91c111_s1 => cpu_instruction_master_requests_lan91c111_s1,
      d1_ext_ram_bus_avalon_slave_end_xfer => d1_ext_ram_bus_avalon_slave_end_xfer,
      d1_irq_from_the_lan91c111 => d1_irq_from_the_lan91c111,
      ext_flash_s1_wait_counter_eq_0 => ext_flash_s1_wait_counter_eq_0,
      ext_flash_s1_wait_counter_eq_1 => ext_flash_s1_wait_counter_eq_1,
      ext_ram_bus_address => internal_ext_ram_bus_address,
      ext_ram_bus_byteenablen => internal_ext_ram_bus_byteenablen,
      ext_ram_bus_data => ext_ram_bus_data,
      ext_ram_bus_readn => internal_ext_ram_bus_readn,
      incoming_ext_ram_bus_data => incoming_ext_ram_bus_data,
      incoming_ext_ram_bus_data_with_Xs_converted_to_0 => incoming_ext_ram_bus_data_with_Xs_converted_to_0,
      ior_n_to_the_lan91c111 => internal_ior_n_to_the_lan91c111,
      iow_n_to_the_lan91c111 => internal_iow_n_to_the_lan91c111,
      lan91c111_s1_wait_counter_eq_0 => lan91c111_s1_wait_counter_eq_0,
      read_n_to_the_ext_ram => internal_read_n_to_the_ext_ram,
      registered_cpu_data_master_read_data_valid_ext_flash_s1 => registered_cpu_data_master_read_data_valid_ext_flash_s1,
      registered_cpu_data_master_read_data_valid_ext_ram_s1 => registered_cpu_data_master_read_data_valid_ext_ram_s1,
      registered_cpu_data_master_read_data_valid_lan91c111_s1 => registered_cpu_data_master_read_data_valid_lan91c111_s1,
      reset_n_to_the_lan91c111 => internal_reset_n_to_the_lan91c111,
      select_n_to_the_ext_flash => internal_select_n_to_the_ext_flash,
      select_n_to_the_ext_ram => internal_select_n_to_the_ext_ram,
      write_n_to_the_ext_flash => internal_write_n_to_the_ext_flash,
      write_n_to_the_ext_ram => internal_write_n_to_the_ext_ram,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_dbs_address => cpu_data_master_dbs_address,
      cpu_data_master_dbs_write_8 => cpu_data_master_dbs_write_8,
      cpu_data_master_no_byte_enables_and_last_term => cpu_data_master_no_byte_enables_and_last_term,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      cpu_instruction_master_address_to_slave => cpu_instruction_master_address_to_slave,
      cpu_instruction_master_dbs_address => cpu_instruction_master_dbs_address,
      cpu_instruction_master_read => cpu_instruction_master_read,
      irq_from_the_lan91c111 => irq_from_the_lan91c111,
      reset_n => clk_reset_n
    );


  the_high_res_timer_s1 : high_res_timer_s1_arbitrator
    port map(
      cpu_data_master_granted_high_res_timer_s1 => cpu_data_master_granted_high_res_timer_s1,
      cpu_data_master_qualified_request_high_res_timer_s1 => cpu_data_master_qualified_request_high_res_timer_s1,
      cpu_data_master_read_data_valid_high_res_timer_s1 => cpu_data_master_read_data_valid_high_res_timer_s1,
      cpu_data_master_requests_high_res_timer_s1 => cpu_data_master_requests_high_res_timer_s1,
      d1_high_res_timer_s1_end_xfer => d1_high_res_timer_s1_end_xfer,
      high_res_timer_s1_address => high_res_timer_s1_address,
      high_res_timer_s1_chipselect => high_res_timer_s1_chipselect,
      high_res_timer_s1_irq_from_sa => high_res_timer_s1_irq_from_sa,
      high_res_timer_s1_readdata_from_sa => high_res_timer_s1_readdata_from_sa,
      high_res_timer_s1_reset_n => high_res_timer_s1_reset_n,
      high_res_timer_s1_write_n => high_res_timer_s1_write_n,
      high_res_timer_s1_writedata => high_res_timer_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      high_res_timer_s1_irq => high_res_timer_s1_irq,
      high_res_timer_s1_readdata => high_res_timer_s1_readdata,
      reset_n => clk_reset_n
    );


  the_high_res_timer : high_res_timer
    port map(
      irq => high_res_timer_s1_irq,
      readdata => high_res_timer_s1_readdata,
      address => high_res_timer_s1_address,
      chipselect => high_res_timer_s1_chipselect,
      clk => clk,
      reset_n => high_res_timer_s1_reset_n,
      write_n => high_res_timer_s1_write_n,
      writedata => high_res_timer_s1_writedata
    );


  the_jtag_uart_avalon_jtag_slave : jtag_uart_avalon_jtag_slave_arbitrator
    port map(
      cpu_data_master_granted_jtag_uart_avalon_jtag_slave => cpu_data_master_granted_jtag_uart_avalon_jtag_slave,
      cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave => cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave,
      cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave => cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave,
      cpu_data_master_requests_jtag_uart_avalon_jtag_slave => cpu_data_master_requests_jtag_uart_avalon_jtag_slave,
      d1_jtag_uart_avalon_jtag_slave_end_xfer => d1_jtag_uart_avalon_jtag_slave_end_xfer,
      jtag_uart_avalon_jtag_slave_address => jtag_uart_avalon_jtag_slave_address,
      jtag_uart_avalon_jtag_slave_chipselect => jtag_uart_avalon_jtag_slave_chipselect,
      jtag_uart_avalon_jtag_slave_dataavailable_from_sa => jtag_uart_avalon_jtag_slave_dataavailable_from_sa,
      jtag_uart_avalon_jtag_slave_irq_from_sa => jtag_uart_avalon_jtag_slave_irq_from_sa,
      jtag_uart_avalon_jtag_slave_read_n => jtag_uart_avalon_jtag_slave_read_n,
      jtag_uart_avalon_jtag_slave_readdata_from_sa => jtag_uart_avalon_jtag_slave_readdata_from_sa,
      jtag_uart_avalon_jtag_slave_readyfordata_from_sa => jtag_uart_avalon_jtag_slave_readyfordata_from_sa,
      jtag_uart_avalon_jtag_slave_reset_n => jtag_uart_avalon_jtag_slave_reset_n,
      jtag_uart_avalon_jtag_slave_waitrequest_from_sa => jtag_uart_avalon_jtag_slave_waitrequest_from_sa,
      jtag_uart_avalon_jtag_slave_write_n => jtag_uart_avalon_jtag_slave_write_n,
      jtag_uart_avalon_jtag_slave_writedata => jtag_uart_avalon_jtag_slave_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      jtag_uart_avalon_jtag_slave_dataavailable => jtag_uart_avalon_jtag_slave_dataavailable,
      jtag_uart_avalon_jtag_slave_irq => jtag_uart_avalon_jtag_slave_irq,
      jtag_uart_avalon_jtag_slave_readdata => jtag_uart_avalon_jtag_slave_readdata,
      jtag_uart_avalon_jtag_slave_readyfordata => jtag_uart_avalon_jtag_slave_readyfordata,
      jtag_uart_avalon_jtag_slave_waitrequest => jtag_uart_avalon_jtag_slave_waitrequest,
      reset_n => clk_reset_n
    );


  the_jtag_uart : jtag_uart
    port map(
      av_irq => jtag_uart_avalon_jtag_slave_irq,
      av_readdata => jtag_uart_avalon_jtag_slave_readdata,
      av_waitrequest => jtag_uart_avalon_jtag_slave_waitrequest,
      dataavailable => jtag_uart_avalon_jtag_slave_dataavailable,
      readyfordata => jtag_uart_avalon_jtag_slave_readyfordata,
      av_address => jtag_uart_avalon_jtag_slave_address,
      av_chipselect => jtag_uart_avalon_jtag_slave_chipselect,
      av_read_n => jtag_uart_avalon_jtag_slave_read_n,
      av_write_n => jtag_uart_avalon_jtag_slave_write_n,
      av_writedata => jtag_uart_avalon_jtag_slave_writedata,
      clk => clk,
      rst_n => jtag_uart_avalon_jtag_slave_reset_n
    );


  the_jtagpio_s1 : jtagpio_s1_arbitrator
    port map(
      cpu_data_master_granted_jtagpio_s1 => cpu_data_master_granted_jtagpio_s1,
      cpu_data_master_qualified_request_jtagpio_s1 => cpu_data_master_qualified_request_jtagpio_s1,
      cpu_data_master_read_data_valid_jtagpio_s1 => cpu_data_master_read_data_valid_jtagpio_s1,
      cpu_data_master_requests_jtagpio_s1 => cpu_data_master_requests_jtagpio_s1,
      d1_jtagpio_s1_end_xfer => d1_jtagpio_s1_end_xfer,
      jtagpio_s1_address => jtagpio_s1_address,
      jtagpio_s1_chipselect => jtagpio_s1_chipselect,
      jtagpio_s1_readdata_from_sa => jtagpio_s1_readdata_from_sa,
      jtagpio_s1_reset_n => jtagpio_s1_reset_n,
      jtagpio_s1_write_n => jtagpio_s1_write_n,
      jtagpio_s1_writedata => jtagpio_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      jtagpio_s1_readdata => jtagpio_s1_readdata,
      reset_n => clk_reset_n
    );


  the_jtagpio : jtagpio
    port map(
      out_port => internal_out_port_from_the_jtagpio,
      readdata => jtagpio_s1_readdata,
      address => jtagpio_s1_address,
      chipselect => jtagpio_s1_chipselect,
      clk => clk,
      in_port => in_port_to_the_jtagpio,
      reset_n => jtagpio_s1_reset_n,
      write_n => jtagpio_s1_write_n,
      writedata => jtagpio_s1_writedata
    );


  the_led_pio_s1 : led_pio_s1_arbitrator
    port map(
      cpu_data_master_granted_led_pio_s1 => cpu_data_master_granted_led_pio_s1,
      cpu_data_master_qualified_request_led_pio_s1 => cpu_data_master_qualified_request_led_pio_s1,
      cpu_data_master_read_data_valid_led_pio_s1 => cpu_data_master_read_data_valid_led_pio_s1,
      cpu_data_master_requests_led_pio_s1 => cpu_data_master_requests_led_pio_s1,
      d1_led_pio_s1_end_xfer => d1_led_pio_s1_end_xfer,
      led_pio_s1_address => led_pio_s1_address,
      led_pio_s1_chipselect => led_pio_s1_chipselect,
      led_pio_s1_readdata_from_sa => led_pio_s1_readdata_from_sa,
      led_pio_s1_reset_n => led_pio_s1_reset_n,
      led_pio_s1_write_n => led_pio_s1_write_n,
      led_pio_s1_writedata => led_pio_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      led_pio_s1_readdata => led_pio_s1_readdata,
      reset_n => clk_reset_n
    );


  the_led_pio : led_pio
    port map(
      out_port => internal_out_port_from_the_led_pio,
      readdata => led_pio_s1_readdata,
      address => led_pio_s1_address,
      chipselect => led_pio_s1_chipselect,
      clk => clk,
      in_port => in_port_to_the_led_pio,
      reset_n => led_pio_s1_reset_n,
      write_n => led_pio_s1_write_n,
      writedata => led_pio_s1_writedata
    );


  the_onchip_ram_64_kbytes_s1 : onchip_ram_64_kbytes_s1_arbitrator
    port map(
      cpu_data_master_granted_onchip_ram_64_kbytes_s1 => cpu_data_master_granted_onchip_ram_64_kbytes_s1,
      cpu_data_master_qualified_request_onchip_ram_64_kbytes_s1 => cpu_data_master_qualified_request_onchip_ram_64_kbytes_s1,
      cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1 => cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1,
      cpu_data_master_requests_onchip_ram_64_kbytes_s1 => cpu_data_master_requests_onchip_ram_64_kbytes_s1,
      cpu_instruction_master_granted_onchip_ram_64_kbytes_s1 => cpu_instruction_master_granted_onchip_ram_64_kbytes_s1,
      cpu_instruction_master_qualified_request_onchip_ram_64_kbytes_s1 => cpu_instruction_master_qualified_request_onchip_ram_64_kbytes_s1,
      cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1 => cpu_instruction_master_read_data_valid_onchip_ram_64_kbytes_s1,
      cpu_instruction_master_requests_onchip_ram_64_kbytes_s1 => cpu_instruction_master_requests_onchip_ram_64_kbytes_s1,
      d1_onchip_ram_64_kbytes_s1_end_xfer => d1_onchip_ram_64_kbytes_s1_end_xfer,
      onchip_ram_64_kbytes_s1_address => onchip_ram_64_kbytes_s1_address,
      onchip_ram_64_kbytes_s1_byteenable => onchip_ram_64_kbytes_s1_byteenable,
      onchip_ram_64_kbytes_s1_chipselect => onchip_ram_64_kbytes_s1_chipselect,
      onchip_ram_64_kbytes_s1_clken => onchip_ram_64_kbytes_s1_clken,
      onchip_ram_64_kbytes_s1_readdata_from_sa => onchip_ram_64_kbytes_s1_readdata_from_sa,
      onchip_ram_64_kbytes_s1_write => onchip_ram_64_kbytes_s1_write,
      onchip_ram_64_kbytes_s1_writedata => onchip_ram_64_kbytes_s1_writedata,
      registered_cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1 => registered_cpu_data_master_read_data_valid_onchip_ram_64_kbytes_s1,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      cpu_instruction_master_address_to_slave => cpu_instruction_master_address_to_slave,
      cpu_instruction_master_read => cpu_instruction_master_read,
      onchip_ram_64_kbytes_s1_readdata => onchip_ram_64_kbytes_s1_readdata,
      reset_n => clk_reset_n
    );


  the_onchip_ram_64_kbytes : onchip_ram_64_kbytes
    port map(
      readdata => onchip_ram_64_kbytes_s1_readdata,
      address => onchip_ram_64_kbytes_s1_address,
      byteenable => onchip_ram_64_kbytes_s1_byteenable,
      chipselect => onchip_ram_64_kbytes_s1_chipselect,
      clk => clk,
      clken => onchip_ram_64_kbytes_s1_clken,
      write => onchip_ram_64_kbytes_s1_write,
      writedata => onchip_ram_64_kbytes_s1_writedata
    );


  the_reconfig_request_pio_s1 : reconfig_request_pio_s1_arbitrator
    port map(
      cpu_data_master_granted_reconfig_request_pio_s1 => cpu_data_master_granted_reconfig_request_pio_s1,
      cpu_data_master_qualified_request_reconfig_request_pio_s1 => cpu_data_master_qualified_request_reconfig_request_pio_s1,
      cpu_data_master_read_data_valid_reconfig_request_pio_s1 => cpu_data_master_read_data_valid_reconfig_request_pio_s1,
      cpu_data_master_requests_reconfig_request_pio_s1 => cpu_data_master_requests_reconfig_request_pio_s1,
      d1_reconfig_request_pio_s1_end_xfer => d1_reconfig_request_pio_s1_end_xfer,
      reconfig_request_pio_s1_address => reconfig_request_pio_s1_address,
      reconfig_request_pio_s1_chipselect => reconfig_request_pio_s1_chipselect,
      reconfig_request_pio_s1_readdata_from_sa => reconfig_request_pio_s1_readdata_from_sa,
      reconfig_request_pio_s1_reset_n => reconfig_request_pio_s1_reset_n,
      reconfig_request_pio_s1_write_n => reconfig_request_pio_s1_write_n,
      reconfig_request_pio_s1_writedata => reconfig_request_pio_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reconfig_request_pio_s1_readdata => reconfig_request_pio_s1_readdata,
      reset_n => clk_reset_n
    );


  the_reconfig_request_pio : reconfig_request_pio
    port map(
      bidir_port => bidir_port_to_and_from_the_reconfig_request_pio,
      readdata => reconfig_request_pio_s1_readdata,
      address => reconfig_request_pio_s1_address,
      chipselect => reconfig_request_pio_s1_chipselect,
      clk => clk,
      reset_n => reconfig_request_pio_s1_reset_n,
      write_n => reconfig_request_pio_s1_write_n,
      writedata => reconfig_request_pio_s1_writedata
    );


  the_sdram_s1 : sdram_s1_arbitrator
    port map(
      cpu_data_master_granted_sdram_s1 => cpu_data_master_granted_sdram_s1,
      cpu_data_master_qualified_request_sdram_s1 => cpu_data_master_qualified_request_sdram_s1,
      cpu_data_master_read_data_valid_sdram_s1 => cpu_data_master_read_data_valid_sdram_s1,
      cpu_data_master_read_data_valid_sdram_s1_shift_register => cpu_data_master_read_data_valid_sdram_s1_shift_register,
      cpu_data_master_requests_sdram_s1 => cpu_data_master_requests_sdram_s1,
      cpu_instruction_master_granted_sdram_s1 => cpu_instruction_master_granted_sdram_s1,
      cpu_instruction_master_qualified_request_sdram_s1 => cpu_instruction_master_qualified_request_sdram_s1,
      cpu_instruction_master_read_data_valid_sdram_s1 => cpu_instruction_master_read_data_valid_sdram_s1,
      cpu_instruction_master_read_data_valid_sdram_s1_shift_register => cpu_instruction_master_read_data_valid_sdram_s1_shift_register,
      cpu_instruction_master_requests_sdram_s1 => cpu_instruction_master_requests_sdram_s1,
      d1_sdram_s1_end_xfer => d1_sdram_s1_end_xfer,
      sdram_s1_address => sdram_s1_address,
      sdram_s1_byteenable_n => sdram_s1_byteenable_n,
      sdram_s1_chipselect => sdram_s1_chipselect,
      sdram_s1_posted_fifo_readenable => sdram_s1_posted_fifo_readenable,
      sdram_s1_posted_fifo_writenable => sdram_s1_posted_fifo_writenable,
      sdram_s1_read_n => sdram_s1_read_n,
      sdram_s1_readdata_from_sa => sdram_s1_readdata_from_sa,
      sdram_s1_reset_n => sdram_s1_reset_n,
      sdram_s1_waitrequest_from_sa => sdram_s1_waitrequest_from_sa,
      sdram_s1_write_n => sdram_s1_write_n,
      sdram_s1_writedata => sdram_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      cpu_instruction_master_address_to_slave => cpu_instruction_master_address_to_slave,
      cpu_instruction_master_read => cpu_instruction_master_read,
      reset_n => clk_reset_n,
      sdram_s1_readdata => sdram_s1_readdata,
      sdram_s1_readdatavalid => sdram_s1_readdatavalid,
      sdram_s1_waitrequest => sdram_s1_waitrequest
    );


  the_sdram : sdram
    port map(
      za_data => sdram_s1_readdata,
      za_valid => sdram_s1_readdatavalid,
      za_waitrequest => sdram_s1_waitrequest,
      zs_addr => internal_zs_addr_from_the_sdram,
      zs_ba => internal_zs_ba_from_the_sdram,
      zs_cas_n => internal_zs_cas_n_from_the_sdram,
      zs_cke => internal_zs_cke_from_the_sdram,
      zs_cs_n => internal_zs_cs_n_from_the_sdram,
      zs_dq => zs_dq_to_and_from_the_sdram,
      zs_dqm => internal_zs_dqm_from_the_sdram,
      zs_ras_n => internal_zs_ras_n_from_the_sdram,
      zs_we_n => internal_zs_we_n_from_the_sdram,
      az_addr => sdram_s1_address,
      az_be_n => sdram_s1_byteenable_n,
      az_cs => sdram_s1_chipselect,
      az_data => sdram_s1_writedata,
      az_rd_n => sdram_s1_read_n,
      az_wr_n => sdram_s1_write_n,
      clk => clk,
      reset_n => sdram_s1_reset_n
    );


  the_seven_seg_pio_s1 : seven_seg_pio_s1_arbitrator
    port map(
      cpu_data_master_granted_seven_seg_pio_s1 => cpu_data_master_granted_seven_seg_pio_s1,
      cpu_data_master_qualified_request_seven_seg_pio_s1 => cpu_data_master_qualified_request_seven_seg_pio_s1,
      cpu_data_master_read_data_valid_seven_seg_pio_s1 => cpu_data_master_read_data_valid_seven_seg_pio_s1,
      cpu_data_master_requests_seven_seg_pio_s1 => cpu_data_master_requests_seven_seg_pio_s1,
      d1_seven_seg_pio_s1_end_xfer => d1_seven_seg_pio_s1_end_xfer,
      seven_seg_pio_s1_address => seven_seg_pio_s1_address,
      seven_seg_pio_s1_chipselect => seven_seg_pio_s1_chipselect,
      seven_seg_pio_s1_reset_n => seven_seg_pio_s1_reset_n,
      seven_seg_pio_s1_write_n => seven_seg_pio_s1_write_n,
      seven_seg_pio_s1_writedata => seven_seg_pio_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n
    );


  the_seven_seg_pio : seven_seg_pio
    port map(
      out_port => internal_out_port_from_the_seven_seg_pio,
      address => seven_seg_pio_s1_address,
      chipselect => seven_seg_pio_s1_chipselect,
      clk => clk,
      reset_n => seven_seg_pio_s1_reset_n,
      write_n => seven_seg_pio_s1_write_n,
      writedata => seven_seg_pio_s1_writedata
    );


  the_sys_clk_timer_s1 : sys_clk_timer_s1_arbitrator
    port map(
      cpu_data_master_granted_sys_clk_timer_s1 => cpu_data_master_granted_sys_clk_timer_s1,
      cpu_data_master_qualified_request_sys_clk_timer_s1 => cpu_data_master_qualified_request_sys_clk_timer_s1,
      cpu_data_master_read_data_valid_sys_clk_timer_s1 => cpu_data_master_read_data_valid_sys_clk_timer_s1,
      cpu_data_master_requests_sys_clk_timer_s1 => cpu_data_master_requests_sys_clk_timer_s1,
      d1_sys_clk_timer_s1_end_xfer => d1_sys_clk_timer_s1_end_xfer,
      sys_clk_timer_s1_address => sys_clk_timer_s1_address,
      sys_clk_timer_s1_chipselect => sys_clk_timer_s1_chipselect,
      sys_clk_timer_s1_irq_from_sa => sys_clk_timer_s1_irq_from_sa,
      sys_clk_timer_s1_readdata_from_sa => sys_clk_timer_s1_readdata_from_sa,
      sys_clk_timer_s1_reset_n => sys_clk_timer_s1_reset_n,
      sys_clk_timer_s1_write_n => sys_clk_timer_s1_write_n,
      sys_clk_timer_s1_writedata => sys_clk_timer_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n,
      sys_clk_timer_s1_irq => sys_clk_timer_s1_irq,
      sys_clk_timer_s1_readdata => sys_clk_timer_s1_readdata
    );


  the_sys_clk_timer : sys_clk_timer
    port map(
      irq => sys_clk_timer_s1_irq,
      readdata => sys_clk_timer_s1_readdata,
      address => sys_clk_timer_s1_address,
      chipselect => sys_clk_timer_s1_chipselect,
      clk => clk,
      reset_n => sys_clk_timer_s1_reset_n,
      write_n => sys_clk_timer_s1_write_n,
      writedata => sys_clk_timer_s1_writedata
    );


  the_sysid_control_slave : sysid_control_slave_arbitrator
    port map(
      cpu_data_master_granted_sysid_control_slave => cpu_data_master_granted_sysid_control_slave,
      cpu_data_master_qualified_request_sysid_control_slave => cpu_data_master_qualified_request_sysid_control_slave,
      cpu_data_master_read_data_valid_sysid_control_slave => cpu_data_master_read_data_valid_sysid_control_slave,
      cpu_data_master_requests_sysid_control_slave => cpu_data_master_requests_sysid_control_slave,
      d1_sysid_control_slave_end_xfer => d1_sysid_control_slave_end_xfer,
      sysid_control_slave_address => sysid_control_slave_address,
      sysid_control_slave_readdata_from_sa => sysid_control_slave_readdata_from_sa,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      reset_n => clk_reset_n,
      sysid_control_slave_readdata => sysid_control_slave_readdata
    );


  the_sysid : sysid
    port map(
      readdata => sysid_control_slave_readdata,
      address => sysid_control_slave_address
    );


  the_uart1_s1 : uart1_s1_arbitrator
    port map(
      cpu_data_master_granted_uart1_s1 => cpu_data_master_granted_uart1_s1,
      cpu_data_master_qualified_request_uart1_s1 => cpu_data_master_qualified_request_uart1_s1,
      cpu_data_master_read_data_valid_uart1_s1 => cpu_data_master_read_data_valid_uart1_s1,
      cpu_data_master_requests_uart1_s1 => cpu_data_master_requests_uart1_s1,
      d1_uart1_s1_end_xfer => d1_uart1_s1_end_xfer,
      uart1_s1_address => uart1_s1_address,
      uart1_s1_begintransfer => uart1_s1_begintransfer,
      uart1_s1_chipselect => uart1_s1_chipselect,
      uart1_s1_dataavailable_from_sa => uart1_s1_dataavailable_from_sa,
      uart1_s1_irq_from_sa => uart1_s1_irq_from_sa,
      uart1_s1_read_n => uart1_s1_read_n,
      uart1_s1_readdata_from_sa => uart1_s1_readdata_from_sa,
      uart1_s1_readyfordata_from_sa => uart1_s1_readyfordata_from_sa,
      uart1_s1_reset_n => uart1_s1_reset_n,
      uart1_s1_write_n => uart1_s1_write_n,
      uart1_s1_writedata => uart1_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n,
      uart1_s1_dataavailable => uart1_s1_dataavailable,
      uart1_s1_irq => uart1_s1_irq,
      uart1_s1_readdata => uart1_s1_readdata,
      uart1_s1_readyfordata => uart1_s1_readyfordata
    );


  the_uart1 : uart1
    port map(
      dataavailable => uart1_s1_dataavailable,
      irq => uart1_s1_irq,
      readdata => uart1_s1_readdata,
      readyfordata => uart1_s1_readyfordata,
      txd => internal_txd_from_the_uart1,
      address => uart1_s1_address,
      begintransfer => uart1_s1_begintransfer,
      chipselect => uart1_s1_chipselect,
      clk => clk,
      read_n => uart1_s1_read_n,
      reset_n => uart1_s1_reset_n,
      rxd => rxd_to_the_uart1,
      write_n => uart1_s1_write_n,
      writedata => uart1_s1_writedata
    );


  --reset sources mux, which is an e_mux
  reset_n_sources <= NOT (((NOT reset_n OR cpu_jtag_debug_module_resetrequest_from_sa) OR cpu_jtag_debug_module_resetrequest_from_sa));
  reset_clk_domain_synch : reset_clk_domain_synch_module
    port map(
      data_out => clk_reset_n,
      clk_in => clk,
      clk_out => clk,
      data_in => always_one,
      reset_n => clk_reset_n_sources
    );


  clk_reset_n_sources <= reset_n_sources;
  --always one, which is an e_assign
  always_one <= std_logic'('1');
  --vhdl renameroo for output signals
  be_n_to_the_ext_ram <= internal_be_n_to_the_ext_ram;
  --vhdl renameroo for output signals
  ext_ram_bus_address <= internal_ext_ram_bus_address;
  --vhdl renameroo for output signals
  ext_ram_bus_byteenablen <= internal_ext_ram_bus_byteenablen;
  --vhdl renameroo for output signals
  ext_ram_bus_readn <= internal_ext_ram_bus_readn;
  --vhdl renameroo for output signals
  ior_n_to_the_lan91c111 <= internal_ior_n_to_the_lan91c111;
  --vhdl renameroo for output signals
  iow_n_to_the_lan91c111 <= internal_iow_n_to_the_lan91c111;
  --vhdl renameroo for output signals
  out_port_from_the_jtagpio <= internal_out_port_from_the_jtagpio;
  --vhdl renameroo for output signals
  out_port_from_the_led_pio <= internal_out_port_from_the_led_pio;
  --vhdl renameroo for output signals
  out_port_from_the_seven_seg_pio <= internal_out_port_from_the_seven_seg_pio;
  --vhdl renameroo for output signals
  read_n_to_the_ext_ram <= internal_read_n_to_the_ext_ram;
  --vhdl renameroo for output signals
  reset_n_to_the_lan91c111 <= internal_reset_n_to_the_lan91c111;
  --vhdl renameroo for output signals
  select_n_to_the_ext_flash <= internal_select_n_to_the_ext_flash;
  --vhdl renameroo for output signals
  select_n_to_the_ext_ram <= internal_select_n_to_the_ext_ram;
  --vhdl renameroo for output signals
  txd_from_the_uart1 <= internal_txd_from_the_uart1;
  --vhdl renameroo for output signals
  write_n_to_the_ext_flash <= internal_write_n_to_the_ext_flash;
  --vhdl renameroo for output signals
  write_n_to_the_ext_ram <= internal_write_n_to_the_ext_ram;
  --vhdl renameroo for output signals
  zs_addr_from_the_sdram <= internal_zs_addr_from_the_sdram;
  --vhdl renameroo for output signals
  zs_ba_from_the_sdram <= internal_zs_ba_from_the_sdram;
  --vhdl renameroo for output signals
  zs_cas_n_from_the_sdram <= internal_zs_cas_n_from_the_sdram;
  --vhdl renameroo for output signals
  zs_cke_from_the_sdram <= internal_zs_cke_from_the_sdram;
  --vhdl renameroo for output signals
  zs_cs_n_from_the_sdram <= internal_zs_cs_n_from_the_sdram;
  --vhdl renameroo for output signals
  zs_dqm_from_the_sdram <= internal_zs_dqm_from_the_sdram;
  --vhdl renameroo for output signals
  zs_ras_n_from_the_sdram <= internal_zs_ras_n_from_the_sdram;
  --vhdl renameroo for output signals
  zs_we_n_from_the_sdram <= internal_zs_we_n_from_the_sdram;

end europa;


--synthesis translate_off

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity ext_flash_lane0_module is 
        port (
              -- inputs:
                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal rdaddress : IN STD_LOGIC_VECTOR (22 DOWNTO 0);
                 signal rdclken : IN STD_LOGIC;
                 signal wraddress : IN STD_LOGIC_VECTOR (22 DOWNTO 0);
                 signal wrclock : IN STD_LOGIC;
                 signal wren : IN STD_LOGIC;

              -- outputs:
                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
end entity ext_flash_lane0_module;


architecture europa of ext_flash_lane0_module is
              signal internal_q :  STD_LOGIC_VECTOR (7 DOWNTO 0);
              TYPE mem_array is ARRAY( 8388607 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
              signal memory_has_been_read :  STD_LOGIC;
              signal read_address :  STD_LOGIC_VECTOR (22 DOWNTO 0);

      
FUNCTION convert_string_to_number(string_to_convert : STRING;
      final_char_index : NATURAL := 0)
RETURN NATURAL IS
   VARIABLE result: NATURAL := 0;
   VARIABLE current_index : NATURAL := 1;
   VARIABLE the_char : CHARACTER;

   BEGIN
      IF final_char_index = 0 THEN
         result := 0;
	 ELSE
         WHILE current_index <= final_char_index LOOP
            the_char := string_to_convert(current_index);
            IF    '0' <= the_char AND the_char <= '9' THEN
               result := result * 16 + character'pos(the_char) - character'pos('0');
            ELSIF 'A' <= the_char AND the_char <= 'F' THEN
               result := result * 16 + character'pos(the_char) - character'pos('A') + 10;
            ELSIF 'a' <= the_char AND the_char <= 'f' THEN
               result := result * 16 + character'pos(the_char) - character'pos('a') + 10;
            ELSE
               report "Ack, a formatting error!";
            END IF;
            current_index := current_index + 1;
         END LOOP;
      END IF; 
   RETURN result;
END convert_string_to_number;

 FUNCTION convert_string_to_std_logic(value : STRING; num_chars : INTEGER; mem_width_bits : INTEGER)
 RETURN STD_LOGIC_VECTOR is			   
     VARIABLE conv_string: std_logic_vector((mem_width_bits + 4)-1 downto 0);
     VARIABLE result : std_logic_vector((mem_width_bits -1) downto 0);
     VARIABLE curr_char : integer;
              
     BEGIN
     result := (others => '0');
     conv_string := (others => '0');
     
          FOR I IN 1 TO num_chars LOOP
	     curr_char := num_chars - (I-1);

             CASE value(I) IS
               WHEN '0' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0000";
               WHEN '1' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0001";
               WHEN '2' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0010";
               WHEN '3' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0011";
               WHEN '4' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0100";
               WHEN '5' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0101";
               WHEN '6' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0110";
               WHEN '7' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0111";
               WHEN '8' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1000";
               WHEN '9' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1001";
               WHEN 'A' | 'a' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1010";
               WHEN 'B' | 'b' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1011";
               WHEN 'C' | 'c' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1100";
               WHEN 'D' | 'd' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1101";
               WHEN 'E' | 'e' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1110";
               WHEN 'F' | 'f' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1111";
               WHEN 'X' | 'x' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "XXXX";
               WHEN ' ' => EXIT;
               WHEN HT  => exit;
               WHEN others =>
                  ASSERT False
                  REPORT "function From_Hex: string """ & value & """ contains non-hex character"
                       severity Error;
                  EXIT;
               END case;
            END loop;

          -- convert back to normal bit size
          result(mem_width_bits - 1 downto 0) := conv_string(mem_width_bits - 1 downto 0);

          RETURN result;
        END convert_string_to_std_logic;



begin
   process (wrclock, rdaddress) -- MG
    VARIABLE data_line : LINE;
    VARIABLE the_character_from_data_line : CHARACTER;
    VARIABLE b_munging_address : BOOLEAN := FALSE;
    VARIABLE converted_number : NATURAL := 0;
    VARIABLE found_string_array : STRING(1 TO 128);
    VARIABLE string_index : NATURAL := 0;
    VARIABLE line_length : NATURAL := 0;
    VARIABLE b_convert : BOOLEAN := FALSE;
    VARIABLE b_found_new_val : BOOLEAN := FALSE;
    VARIABLE load_address : NATURAL := 0;
    VARIABLE mem_index : NATURAL := 0;
    VARIABLE mem_init : BOOLEAN := FALSE;
    
    VARIABLE wr_address_internal : STD_LOGIC_VECTOR (22 DOWNTO 0) := (others => '0');
    FILE memory_contents_file : TEXT OPEN read_mode IS "ext_flash.dat";  
    variable Marc_Gaucherons_Memory_Variable : mem_array; -- MG
    
    begin
   -- need an initialization process
   -- this process initializes the whole memory array from a named file by copying the
   -- contents of the *.dat file to the memory array.

   -- find the @<address> thingy to load the memory from this point 
IF(NOT mem_init) THEN
   WHILE NOT(endfile(memory_contents_file)) LOOP

      readline(memory_contents_file, data_line);
      line_length := data_line'LENGTH;


      WHILE line_length > 0 LOOP
         read(data_line, the_character_from_data_line);

	       -- check for the @ character indicating a new address wad
 	       -- if not found, we're either still reading the new address _or_loading data
         IF '@' = the_character_from_data_line AND NOT b_munging_address THEN
  	    b_munging_address := TRUE;
            b_found_new_val := TRUE; 
	    -- get the rest of characters before white space and then convert them
	    -- to a number
	 ELSE 

            IF (' ' = the_character_from_data_line AND b_found_new_val) 
		OR (line_length = 1) THEN
               b_convert := TRUE;
	    END IF;

            IF NOT(' ' = the_character_from_data_line) THEN
               string_index := string_index + 1;
               found_string_array(string_index) := the_character_from_data_line;
--               IF NOT(b_munging_address) THEN
--                 dat_string_array(string_index) := the_character_from_data_line;
--               END IF;
	       b_found_new_val := TRUE;
            END IF;
	 END IF;

     IF b_convert THEN

       IF b_munging_address THEN
          converted_number := convert_string_to_number(found_string_array, string_index);    
          load_address := converted_number;
          mem_index := load_address;
--          mem_index := load_address / 1;
          b_munging_address := FALSE;
       ELSE
	  IF (mem_index < 8388608) THEN
	    Marc_Gaucherons_Memory_Variable(mem_index) := convert_string_to_std_logic(found_string_array, string_index, 8);
            mem_index := mem_index + 1;
          END IF;
       END IF; 
       b_convert := FALSE;
       b_found_new_val := FALSE;
       string_index := 0;
    END IF;
    line_length := line_length - 1; 
    END LOOP;

END LOOP;
-- get the first _real_ block of data, sized to our memory width
-- and keep on loading.
  mem_init := TRUE;
END IF;
-- END OF READMEM



      -- Write data
      if wrclock'event and wrclock = '1' then
        wr_address_internal := wraddress;
        if wren = '1' then 
          Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(wr_address_internal))) := data;
        end if;
      end if;

      -- read data
      q <= Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(rdaddress)));
      


    end process;
end europa;

--synthesis translate_on


--synthesis read_comments_as_HDL on
--library altera_vhdl_support;
--use altera_vhdl_support.altera_vhdl_support_lib.all;
--
--library ieee;
--use ieee.std_logic_1164.all;
--use ieee.std_logic_arith.all;
--use ieee.std_logic_unsigned.all;
--
--library std;
--use std.textio.all;
--
--entity ext_flash_lane0_module is 
--        port (
--              
--                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--                 signal rdaddress : IN STD_LOGIC_VECTOR (22 DOWNTO 0);
--                 signal rdclken : IN STD_LOGIC;
--                 signal wraddress : IN STD_LOGIC_VECTOR (22 DOWNTO 0);
--                 signal wrclock : IN STD_LOGIC;
--                 signal wren : IN STD_LOGIC;
--
--              
--                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
--              );
--end entity ext_flash_lane0_module;
--
--
--architecture europa of ext_flash_lane0_module is
--  component lpm_ram_dp is
--GENERIC (
--      lpm_file : STRING;
--        lpm_hint : STRING;
--        lpm_indata : STRING;
--        lpm_outdata : STRING;
--        lpm_rdaddress_control : STRING;
--        lpm_width : NATURAL;
--        lpm_widthad : NATURAL;
--        lpm_wraddress_control : STRING;
--        suppress_memory_conversion_warnings : STRING
--      );
--    PORT (
--    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal wraddress : IN STD_LOGIC_VECTOR (22 DOWNTO 0);
--        signal wrclock : IN STD_LOGIC;
--        signal rdaddress : IN STD_LOGIC_VECTOR (22 DOWNTO 0);
--        signal rdclken : IN STD_LOGIC;
--        signal wren : IN STD_LOGIC
--      );
--  end component lpm_ram_dp;
--                signal internal_q :  STD_LOGIC_VECTOR (7 DOWNTO 0);
--                TYPE mem_array is ARRAY( 8388607 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
--                signal memory_has_been_read :  STD_LOGIC;
--                signal read_address :  STD_LOGIC_VECTOR (22 DOWNTO 0);
--
--begin
--
--  process (rdaddress)
--  begin
--      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
--        read_address <= rdaddress;
--      end if;
--
--  end process;
--
--  lpm_ram_dp_component : lpm_ram_dp
--    generic map(
--      lpm_file => "ext_flash.mif",
--      lpm_hint => "USE_EAB=ON",
--      lpm_indata => "REGISTERED",
--      lpm_outdata => "UNREGISTERED",
--      lpm_rdaddress_control => "UNREGISTERED",
--      lpm_width => 8,
--      lpm_widthad => 23,
--      lpm_wraddress_control => "REGISTERED",
--      suppress_memory_conversion_warnings => "ON"
--    )
--    port map(
--            data => data,
--            q => internal_q,
--            rdaddress => read_address,
--            rdclken => rdclken,
--            wraddress => wraddress,
--            wrclock => wrclock,
--            wren => wren
--    );
--
--  
--  q <= internal_q;
--end europa;
--
--synthesis read_comments_as_HDL off

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity ext_flash is 
        port (
              -- inputs:
                 signal address : IN STD_LOGIC_VECTOR (22 DOWNTO 0);
                 signal read_n : IN STD_LOGIC;
                 signal select_n : IN STD_LOGIC;
                 signal write_n : IN STD_LOGIC;

              -- outputs:
                 signal data : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
end entity ext_flash;


architecture europa of ext_flash is
--synthesis translate_off
component ext_flash_lane0_module is 
           port (
                 -- inputs:
                    signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal rdaddress : IN STD_LOGIC_VECTOR (22 DOWNTO 0);
                    signal rdclken : IN STD_LOGIC;
                    signal wraddress : IN STD_LOGIC_VECTOR (22 DOWNTO 0);
                    signal wrclock : IN STD_LOGIC;
                    signal wren : IN STD_LOGIC;

                 -- outputs:
                    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component ext_flash_lane0_module;

--synthesis translate_on
                signal data_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal logic_vector_gasket :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal module_input :  STD_LOGIC;
                signal module_input1 :  STD_LOGIC;
                signal q_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);

begin

--synthesis translate_off
    logic_vector_gasket <= data;
    data_0 <= logic_vector_gasket(7 DOWNTO 0);
    ext_flash_lane0 : ext_flash_lane0_module
      port map(
        q => q_0,
        data => data_0,
        rdaddress => address,
        rdclken => module_input,
        wraddress => address,
        wrclock => write_n,
        wren => module_input1
      );

    module_input <= std_logic'('1');
    module_input1 <= NOT select_n;

    data <= A_WE_StdLogicVector((std_logic'(((NOT select_n AND NOT read_n))) = '1'), q_0, A_REP(std_logic'('Z'), 8));
--synthesis translate_on

end europa;


--synthesis translate_off

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity ext_ram_lane0_module is 
        port (
              -- inputs:
                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal rdclken : IN STD_LOGIC;
                 signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal wrclock : IN STD_LOGIC;
                 signal wren : IN STD_LOGIC;

              -- outputs:
                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
end entity ext_ram_lane0_module;


architecture europa of ext_ram_lane0_module is
              signal internal_q1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
              TYPE mem_array is ARRAY( 262143 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
              signal memory_has_been_read :  STD_LOGIC;
              signal read_address :  STD_LOGIC_VECTOR (17 DOWNTO 0);

      
FUNCTION convert_string_to_number(string_to_convert : STRING;
      final_char_index : NATURAL := 0)
RETURN NATURAL IS
   VARIABLE result: NATURAL := 0;
   VARIABLE current_index : NATURAL := 1;
   VARIABLE the_char : CHARACTER;

   BEGIN
      IF final_char_index = 0 THEN
         result := 0;
	 ELSE
         WHILE current_index <= final_char_index LOOP
            the_char := string_to_convert(current_index);
            IF    '0' <= the_char AND the_char <= '9' THEN
               result := result * 16 + character'pos(the_char) - character'pos('0');
            ELSIF 'A' <= the_char AND the_char <= 'F' THEN
               result := result * 16 + character'pos(the_char) - character'pos('A') + 10;
            ELSIF 'a' <= the_char AND the_char <= 'f' THEN
               result := result * 16 + character'pos(the_char) - character'pos('a') + 10;
            ELSE
               report "Ack, a formatting error!";
            END IF;
            current_index := current_index + 1;
         END LOOP;
      END IF; 
   RETURN result;
END convert_string_to_number;

 FUNCTION convert_string_to_std_logic(value : STRING; num_chars : INTEGER; mem_width_bits : INTEGER)
 RETURN STD_LOGIC_VECTOR is			   
     VARIABLE conv_string: std_logic_vector((mem_width_bits + 4)-1 downto 0);
     VARIABLE result : std_logic_vector((mem_width_bits -1) downto 0);
     VARIABLE curr_char : integer;
              
     BEGIN
     result := (others => '0');
     conv_string := (others => '0');
     
          FOR I IN 1 TO num_chars LOOP
	     curr_char := num_chars - (I-1);

             CASE value(I) IS
               WHEN '0' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0000";
               WHEN '1' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0001";
               WHEN '2' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0010";
               WHEN '3' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0011";
               WHEN '4' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0100";
               WHEN '5' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0101";
               WHEN '6' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0110";
               WHEN '7' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0111";
               WHEN '8' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1000";
               WHEN '9' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1001";
               WHEN 'A' | 'a' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1010";
               WHEN 'B' | 'b' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1011";
               WHEN 'C' | 'c' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1100";
               WHEN 'D' | 'd' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1101";
               WHEN 'E' | 'e' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1110";
               WHEN 'F' | 'f' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1111";
               WHEN 'X' | 'x' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "XXXX";
               WHEN ' ' => EXIT;
               WHEN HT  => exit;
               WHEN others =>
                  ASSERT False
                  REPORT "function From_Hex: string """ & value & """ contains non-hex character"
                       severity Error;
                  EXIT;
               END case;
            END loop;

          -- convert back to normal bit size
          result(mem_width_bits - 1 downto 0) := conv_string(mem_width_bits - 1 downto 0);

          RETURN result;
        END convert_string_to_std_logic;



begin
   process (wrclock, rdaddress) -- MG
    VARIABLE data_line : LINE;
    VARIABLE the_character_from_data_line : CHARACTER;
    VARIABLE b_munging_address : BOOLEAN := FALSE;
    VARIABLE converted_number : NATURAL := 0;
    VARIABLE found_string_array : STRING(1 TO 128);
    VARIABLE string_index : NATURAL := 0;
    VARIABLE line_length : NATURAL := 0;
    VARIABLE b_convert : BOOLEAN := FALSE;
    VARIABLE b_found_new_val : BOOLEAN := FALSE;
    VARIABLE load_address : NATURAL := 0;
    VARIABLE mem_index : NATURAL := 0;
    VARIABLE mem_init : BOOLEAN := FALSE;
    
    VARIABLE wr_address_internal : STD_LOGIC_VECTOR (17 DOWNTO 0) := (others => '0');
    FILE memory_contents_file : TEXT OPEN read_mode IS "ext_ram_lane0.dat";  
    variable Marc_Gaucherons_Memory_Variable : mem_array; -- MG
    
    begin
   -- need an initialization process
   -- this process initializes the whole memory array from a named file by copying the
   -- contents of the *.dat file to the memory array.

   -- find the @<address> thingy to load the memory from this point 
IF(NOT mem_init) THEN
   WHILE NOT(endfile(memory_contents_file)) LOOP

      readline(memory_contents_file, data_line);
      line_length := data_line'LENGTH;


      WHILE line_length > 0 LOOP
         read(data_line, the_character_from_data_line);

	       -- check for the @ character indicating a new address wad
 	       -- if not found, we're either still reading the new address _or_loading data
         IF '@' = the_character_from_data_line AND NOT b_munging_address THEN
  	    b_munging_address := TRUE;
            b_found_new_val := TRUE; 
	    -- get the rest of characters before white space and then convert them
	    -- to a number
	 ELSE 

            IF (' ' = the_character_from_data_line AND b_found_new_val) 
		OR (line_length = 1) THEN
               b_convert := TRUE;
	    END IF;

            IF NOT(' ' = the_character_from_data_line) THEN
               string_index := string_index + 1;
               found_string_array(string_index) := the_character_from_data_line;
--               IF NOT(b_munging_address) THEN
--                 dat_string_array(string_index) := the_character_from_data_line;
--               END IF;
	       b_found_new_val := TRUE;
            END IF;
	 END IF;

     IF b_convert THEN

       IF b_munging_address THEN
          converted_number := convert_string_to_number(found_string_array, string_index);    
          load_address := converted_number;
          mem_index := load_address;
--          mem_index := load_address / 1;
          b_munging_address := FALSE;
       ELSE
	  IF (mem_index < 262144) THEN
	    Marc_Gaucherons_Memory_Variable(mem_index) := convert_string_to_std_logic(found_string_array, string_index, 8);
            mem_index := mem_index + 1;
          END IF;
       END IF; 
       b_convert := FALSE;
       b_found_new_val := FALSE;
       string_index := 0;
    END IF;
    line_length := line_length - 1; 
    END LOOP;

END LOOP;
-- get the first _real_ block of data, sized to our memory width
-- and keep on loading.
  mem_init := TRUE;
END IF;
-- END OF READMEM



      -- Write data
      if wrclock'event and wrclock = '1' then
        wr_address_internal := wraddress;
        if wren = '1' then 
          Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(wr_address_internal))) := data;
        end if;
      end if;

      -- read data
      q <= Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(rdaddress)));
      


    end process;
end europa;

--synthesis translate_on


--synthesis read_comments_as_HDL on
--library altera_vhdl_support;
--use altera_vhdl_support.altera_vhdl_support_lib.all;
--
--library ieee;
--use ieee.std_logic_1164.all;
--use ieee.std_logic_arith.all;
--use ieee.std_logic_unsigned.all;
--
--library std;
--use std.textio.all;
--
--entity ext_ram_lane0_module is 
--        port (
--              
--                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--                 signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--                 signal rdclken : IN STD_LOGIC;
--                 signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--                 signal wrclock : IN STD_LOGIC;
--                 signal wren : IN STD_LOGIC;
--
--              
--                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
--              );
--end entity ext_ram_lane0_module;
--
--
--architecture europa of ext_ram_lane0_module is
--  component lpm_ram_dp is
--GENERIC (
--      lpm_file : STRING;
--        lpm_hint : STRING;
--        lpm_indata : STRING;
--        lpm_outdata : STRING;
--        lpm_rdaddress_control : STRING;
--        lpm_width : NATURAL;
--        lpm_widthad : NATURAL;
--        lpm_wraddress_control : STRING;
--        suppress_memory_conversion_warnings : STRING
--      );
--    PORT (
--    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--        signal wrclock : IN STD_LOGIC;
--        signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--        signal rdclken : IN STD_LOGIC;
--        signal wren : IN STD_LOGIC
--      );
--  end component lpm_ram_dp;
--                signal internal_q1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
--                TYPE mem_array is ARRAY( 262143 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
--                signal memory_has_been_read :  STD_LOGIC;
--                signal read_address :  STD_LOGIC_VECTOR (17 DOWNTO 0);
--
--begin
--
--  process (rdaddress)
--  begin
--      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
--        read_address <= rdaddress;
--      end if;
--
--  end process;
--
--  lpm_ram_dp_component : lpm_ram_dp
--    generic map(
--      lpm_file => "ext_ram_lane0.mif",
--      lpm_hint => "USE_EAB=ON",
--      lpm_indata => "REGISTERED",
--      lpm_outdata => "UNREGISTERED",
--      lpm_rdaddress_control => "UNREGISTERED",
--      lpm_width => 8,
--      lpm_widthad => 18,
--      lpm_wraddress_control => "REGISTERED",
--      suppress_memory_conversion_warnings => "ON"
--    )
--    port map(
--            data => data,
--            q => internal_q1,
--            rdaddress => read_address,
--            rdclken => rdclken,
--            wraddress => wraddress,
--            wrclock => wrclock,
--            wren => wren
--    );
--
--  
--  q <= internal_q1;
--end europa;
--
--synthesis read_comments_as_HDL off

--synthesis translate_off

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity ext_ram_lane1_module is 
        port (
              -- inputs:
                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal rdclken : IN STD_LOGIC;
                 signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal wrclock : IN STD_LOGIC;
                 signal wren : IN STD_LOGIC;

              -- outputs:
                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
end entity ext_ram_lane1_module;


architecture europa of ext_ram_lane1_module is
              signal internal_q2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
              TYPE mem_array is ARRAY( 262143 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
              signal memory_has_been_read :  STD_LOGIC;
              signal read_address :  STD_LOGIC_VECTOR (17 DOWNTO 0);

      
FUNCTION convert_string_to_number(string_to_convert : STRING;
      final_char_index : NATURAL := 0)
RETURN NATURAL IS
   VARIABLE result: NATURAL := 0;
   VARIABLE current_index : NATURAL := 1;
   VARIABLE the_char : CHARACTER;

   BEGIN
      IF final_char_index = 0 THEN
         result := 0;
	 ELSE
         WHILE current_index <= final_char_index LOOP
            the_char := string_to_convert(current_index);
            IF    '0' <= the_char AND the_char <= '9' THEN
               result := result * 16 + character'pos(the_char) - character'pos('0');
            ELSIF 'A' <= the_char AND the_char <= 'F' THEN
               result := result * 16 + character'pos(the_char) - character'pos('A') + 10;
            ELSIF 'a' <= the_char AND the_char <= 'f' THEN
               result := result * 16 + character'pos(the_char) - character'pos('a') + 10;
            ELSE
               report "Ack, a formatting error!";
            END IF;
            current_index := current_index + 1;
         END LOOP;
      END IF; 
   RETURN result;
END convert_string_to_number;

 FUNCTION convert_string_to_std_logic(value : STRING; num_chars : INTEGER; mem_width_bits : INTEGER)
 RETURN STD_LOGIC_VECTOR is			   
     VARIABLE conv_string: std_logic_vector((mem_width_bits + 4)-1 downto 0);
     VARIABLE result : std_logic_vector((mem_width_bits -1) downto 0);
     VARIABLE curr_char : integer;
              
     BEGIN
     result := (others => '0');
     conv_string := (others => '0');
     
          FOR I IN 1 TO num_chars LOOP
	     curr_char := num_chars - (I-1);

             CASE value(I) IS
               WHEN '0' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0000";
               WHEN '1' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0001";
               WHEN '2' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0010";
               WHEN '3' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0011";
               WHEN '4' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0100";
               WHEN '5' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0101";
               WHEN '6' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0110";
               WHEN '7' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0111";
               WHEN '8' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1000";
               WHEN '9' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1001";
               WHEN 'A' | 'a' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1010";
               WHEN 'B' | 'b' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1011";
               WHEN 'C' | 'c' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1100";
               WHEN 'D' | 'd' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1101";
               WHEN 'E' | 'e' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1110";
               WHEN 'F' | 'f' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1111";
               WHEN 'X' | 'x' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "XXXX";
               WHEN ' ' => EXIT;
               WHEN HT  => exit;
               WHEN others =>
                  ASSERT False
                  REPORT "function From_Hex: string """ & value & """ contains non-hex character"
                       severity Error;
                  EXIT;
               END case;
            END loop;

          -- convert back to normal bit size
          result(mem_width_bits - 1 downto 0) := conv_string(mem_width_bits - 1 downto 0);

          RETURN result;
        END convert_string_to_std_logic;



begin
   process (wrclock, rdaddress) -- MG
    VARIABLE data_line : LINE;
    VARIABLE the_character_from_data_line : CHARACTER;
    VARIABLE b_munging_address : BOOLEAN := FALSE;
    VARIABLE converted_number : NATURAL := 0;
    VARIABLE found_string_array : STRING(1 TO 128);
    VARIABLE string_index : NATURAL := 0;
    VARIABLE line_length : NATURAL := 0;
    VARIABLE b_convert : BOOLEAN := FALSE;
    VARIABLE b_found_new_val : BOOLEAN := FALSE;
    VARIABLE load_address : NATURAL := 0;
    VARIABLE mem_index : NATURAL := 0;
    VARIABLE mem_init : BOOLEAN := FALSE;
    
    VARIABLE wr_address_internal : STD_LOGIC_VECTOR (17 DOWNTO 0) := (others => '0');
    FILE memory_contents_file : TEXT OPEN read_mode IS "ext_ram_lane1.dat";  
    variable Marc_Gaucherons_Memory_Variable : mem_array; -- MG
    
    begin
   -- need an initialization process
   -- this process initializes the whole memory array from a named file by copying the
   -- contents of the *.dat file to the memory array.

   -- find the @<address> thingy to load the memory from this point 
IF(NOT mem_init) THEN
   WHILE NOT(endfile(memory_contents_file)) LOOP

      readline(memory_contents_file, data_line);
      line_length := data_line'LENGTH;


      WHILE line_length > 0 LOOP
         read(data_line, the_character_from_data_line);

	       -- check for the @ character indicating a new address wad
 	       -- if not found, we're either still reading the new address _or_loading data
         IF '@' = the_character_from_data_line AND NOT b_munging_address THEN
  	    b_munging_address := TRUE;
            b_found_new_val := TRUE; 
	    -- get the rest of characters before white space and then convert them
	    -- to a number
	 ELSE 

            IF (' ' = the_character_from_data_line AND b_found_new_val) 
		OR (line_length = 1) THEN
               b_convert := TRUE;
	    END IF;

            IF NOT(' ' = the_character_from_data_line) THEN
               string_index := string_index + 1;
               found_string_array(string_index) := the_character_from_data_line;
--               IF NOT(b_munging_address) THEN
--                 dat_string_array(string_index) := the_character_from_data_line;
--               END IF;
	       b_found_new_val := TRUE;
            END IF;
	 END IF;

     IF b_convert THEN

       IF b_munging_address THEN
          converted_number := convert_string_to_number(found_string_array, string_index);    
          load_address := converted_number;
          mem_index := load_address;
--          mem_index := load_address / 1;
          b_munging_address := FALSE;
       ELSE
	  IF (mem_index < 262144) THEN
	    Marc_Gaucherons_Memory_Variable(mem_index) := convert_string_to_std_logic(found_string_array, string_index, 8);
            mem_index := mem_index + 1;
          END IF;
       END IF; 
       b_convert := FALSE;
       b_found_new_val := FALSE;
       string_index := 0;
    END IF;
    line_length := line_length - 1; 
    END LOOP;

END LOOP;
-- get the first _real_ block of data, sized to our memory width
-- and keep on loading.
  mem_init := TRUE;
END IF;
-- END OF READMEM



      -- Write data
      if wrclock'event and wrclock = '1' then
        wr_address_internal := wraddress;
        if wren = '1' then 
          Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(wr_address_internal))) := data;
        end if;
      end if;

      -- read data
      q <= Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(rdaddress)));
      


    end process;
end europa;

--synthesis translate_on


--synthesis read_comments_as_HDL on
--library altera_vhdl_support;
--use altera_vhdl_support.altera_vhdl_support_lib.all;
--
--library ieee;
--use ieee.std_logic_1164.all;
--use ieee.std_logic_arith.all;
--use ieee.std_logic_unsigned.all;
--
--library std;
--use std.textio.all;
--
--entity ext_ram_lane1_module is 
--        port (
--              
--                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--                 signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--                 signal rdclken : IN STD_LOGIC;
--                 signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--                 signal wrclock : IN STD_LOGIC;
--                 signal wren : IN STD_LOGIC;
--
--              
--                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
--              );
--end entity ext_ram_lane1_module;
--
--
--architecture europa of ext_ram_lane1_module is
--  component lpm_ram_dp is
--GENERIC (
--      lpm_file : STRING;
--        lpm_hint : STRING;
--        lpm_indata : STRING;
--        lpm_outdata : STRING;
--        lpm_rdaddress_control : STRING;
--        lpm_width : NATURAL;
--        lpm_widthad : NATURAL;
--        lpm_wraddress_control : STRING;
--        suppress_memory_conversion_warnings : STRING
--      );
--    PORT (
--    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--        signal wrclock : IN STD_LOGIC;
--        signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--        signal rdclken : IN STD_LOGIC;
--        signal wren : IN STD_LOGIC
--      );
--  end component lpm_ram_dp;
--                signal internal_q2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
--                TYPE mem_array is ARRAY( 262143 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
--                signal memory_has_been_read :  STD_LOGIC;
--                signal read_address :  STD_LOGIC_VECTOR (17 DOWNTO 0);
--
--begin
--
--  process (rdaddress)
--  begin
--      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
--        read_address <= rdaddress;
--      end if;
--
--  end process;
--
--  lpm_ram_dp_component : lpm_ram_dp
--    generic map(
--      lpm_file => "ext_ram_lane1.mif",
--      lpm_hint => "USE_EAB=ON",
--      lpm_indata => "REGISTERED",
--      lpm_outdata => "UNREGISTERED",
--      lpm_rdaddress_control => "UNREGISTERED",
--      lpm_width => 8,
--      lpm_widthad => 18,
--      lpm_wraddress_control => "REGISTERED",
--      suppress_memory_conversion_warnings => "ON"
--    )
--    port map(
--            data => data,
--            q => internal_q2,
--            rdaddress => read_address,
--            rdclken => rdclken,
--            wraddress => wraddress,
--            wrclock => wrclock,
--            wren => wren
--    );
--
--  
--  q <= internal_q2;
--end europa;
--
--synthesis read_comments_as_HDL off

--synthesis translate_off

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity ext_ram_lane2_module is 
        port (
              -- inputs:
                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal rdclken : IN STD_LOGIC;
                 signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal wrclock : IN STD_LOGIC;
                 signal wren : IN STD_LOGIC;

              -- outputs:
                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
end entity ext_ram_lane2_module;


architecture europa of ext_ram_lane2_module is
              signal internal_q3 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
              TYPE mem_array is ARRAY( 262143 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
              signal memory_has_been_read :  STD_LOGIC;
              signal read_address :  STD_LOGIC_VECTOR (17 DOWNTO 0);

      
FUNCTION convert_string_to_number(string_to_convert : STRING;
      final_char_index : NATURAL := 0)
RETURN NATURAL IS
   VARIABLE result: NATURAL := 0;
   VARIABLE current_index : NATURAL := 1;
   VARIABLE the_char : CHARACTER;

   BEGIN
      IF final_char_index = 0 THEN
         result := 0;
	 ELSE
         WHILE current_index <= final_char_index LOOP
            the_char := string_to_convert(current_index);
            IF    '0' <= the_char AND the_char <= '9' THEN
               result := result * 16 + character'pos(the_char) - character'pos('0');
            ELSIF 'A' <= the_char AND the_char <= 'F' THEN
               result := result * 16 + character'pos(the_char) - character'pos('A') + 10;
            ELSIF 'a' <= the_char AND the_char <= 'f' THEN
               result := result * 16 + character'pos(the_char) - character'pos('a') + 10;
            ELSE
               report "Ack, a formatting error!";
            END IF;
            current_index := current_index + 1;
         END LOOP;
      END IF; 
   RETURN result;
END convert_string_to_number;

 FUNCTION convert_string_to_std_logic(value : STRING; num_chars : INTEGER; mem_width_bits : INTEGER)
 RETURN STD_LOGIC_VECTOR is			   
     VARIABLE conv_string: std_logic_vector((mem_width_bits + 4)-1 downto 0);
     VARIABLE result : std_logic_vector((mem_width_bits -1) downto 0);
     VARIABLE curr_char : integer;
              
     BEGIN
     result := (others => '0');
     conv_string := (others => '0');
     
          FOR I IN 1 TO num_chars LOOP
	     curr_char := num_chars - (I-1);

             CASE value(I) IS
               WHEN '0' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0000";
               WHEN '1' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0001";
               WHEN '2' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0010";
               WHEN '3' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0011";
               WHEN '4' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0100";
               WHEN '5' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0101";
               WHEN '6' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0110";
               WHEN '7' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0111";
               WHEN '8' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1000";
               WHEN '9' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1001";
               WHEN 'A' | 'a' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1010";
               WHEN 'B' | 'b' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1011";
               WHEN 'C' | 'c' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1100";
               WHEN 'D' | 'd' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1101";
               WHEN 'E' | 'e' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1110";
               WHEN 'F' | 'f' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1111";
               WHEN 'X' | 'x' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "XXXX";
               WHEN ' ' => EXIT;
               WHEN HT  => exit;
               WHEN others =>
                  ASSERT False
                  REPORT "function From_Hex: string """ & value & """ contains non-hex character"
                       severity Error;
                  EXIT;
               END case;
            END loop;

          -- convert back to normal bit size
          result(mem_width_bits - 1 downto 0) := conv_string(mem_width_bits - 1 downto 0);

          RETURN result;
        END convert_string_to_std_logic;



begin
   process (wrclock, rdaddress) -- MG
    VARIABLE data_line : LINE;
    VARIABLE the_character_from_data_line : CHARACTER;
    VARIABLE b_munging_address : BOOLEAN := FALSE;
    VARIABLE converted_number : NATURAL := 0;
    VARIABLE found_string_array : STRING(1 TO 128);
    VARIABLE string_index : NATURAL := 0;
    VARIABLE line_length : NATURAL := 0;
    VARIABLE b_convert : BOOLEAN := FALSE;
    VARIABLE b_found_new_val : BOOLEAN := FALSE;
    VARIABLE load_address : NATURAL := 0;
    VARIABLE mem_index : NATURAL := 0;
    VARIABLE mem_init : BOOLEAN := FALSE;
    
    VARIABLE wr_address_internal : STD_LOGIC_VECTOR (17 DOWNTO 0) := (others => '0');
    FILE memory_contents_file : TEXT OPEN read_mode IS "ext_ram_lane2.dat";  
    variable Marc_Gaucherons_Memory_Variable : mem_array; -- MG
    
    begin
   -- need an initialization process
   -- this process initializes the whole memory array from a named file by copying the
   -- contents of the *.dat file to the memory array.

   -- find the @<address> thingy to load the memory from this point 
IF(NOT mem_init) THEN
   WHILE NOT(endfile(memory_contents_file)) LOOP

      readline(memory_contents_file, data_line);
      line_length := data_line'LENGTH;


      WHILE line_length > 0 LOOP
         read(data_line, the_character_from_data_line);

	       -- check for the @ character indicating a new address wad
 	       -- if not found, we're either still reading the new address _or_loading data
         IF '@' = the_character_from_data_line AND NOT b_munging_address THEN
  	    b_munging_address := TRUE;
            b_found_new_val := TRUE; 
	    -- get the rest of characters before white space and then convert them
	    -- to a number
	 ELSE 

            IF (' ' = the_character_from_data_line AND b_found_new_val) 
		OR (line_length = 1) THEN
               b_convert := TRUE;
	    END IF;

            IF NOT(' ' = the_character_from_data_line) THEN
               string_index := string_index + 1;
               found_string_array(string_index) := the_character_from_data_line;
--               IF NOT(b_munging_address) THEN
--                 dat_string_array(string_index) := the_character_from_data_line;
--               END IF;
	       b_found_new_val := TRUE;
            END IF;
	 END IF;

     IF b_convert THEN

       IF b_munging_address THEN
          converted_number := convert_string_to_number(found_string_array, string_index);    
          load_address := converted_number;
          mem_index := load_address;
--          mem_index := load_address / 1;
          b_munging_address := FALSE;
       ELSE
	  IF (mem_index < 262144) THEN
	    Marc_Gaucherons_Memory_Variable(mem_index) := convert_string_to_std_logic(found_string_array, string_index, 8);
            mem_index := mem_index + 1;
          END IF;
       END IF; 
       b_convert := FALSE;
       b_found_new_val := FALSE;
       string_index := 0;
    END IF;
    line_length := line_length - 1; 
    END LOOP;

END LOOP;
-- get the first _real_ block of data, sized to our memory width
-- and keep on loading.
  mem_init := TRUE;
END IF;
-- END OF READMEM



      -- Write data
      if wrclock'event and wrclock = '1' then
        wr_address_internal := wraddress;
        if wren = '1' then 
          Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(wr_address_internal))) := data;
        end if;
      end if;

      -- read data
      q <= Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(rdaddress)));
      


    end process;
end europa;

--synthesis translate_on


--synthesis read_comments_as_HDL on
--library altera_vhdl_support;
--use altera_vhdl_support.altera_vhdl_support_lib.all;
--
--library ieee;
--use ieee.std_logic_1164.all;
--use ieee.std_logic_arith.all;
--use ieee.std_logic_unsigned.all;
--
--library std;
--use std.textio.all;
--
--entity ext_ram_lane2_module is 
--        port (
--              
--                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--                 signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--                 signal rdclken : IN STD_LOGIC;
--                 signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--                 signal wrclock : IN STD_LOGIC;
--                 signal wren : IN STD_LOGIC;
--
--              
--                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
--              );
--end entity ext_ram_lane2_module;
--
--
--architecture europa of ext_ram_lane2_module is
--  component lpm_ram_dp is
--GENERIC (
--      lpm_file : STRING;
--        lpm_hint : STRING;
--        lpm_indata : STRING;
--        lpm_outdata : STRING;
--        lpm_rdaddress_control : STRING;
--        lpm_width : NATURAL;
--        lpm_widthad : NATURAL;
--        lpm_wraddress_control : STRING;
--        suppress_memory_conversion_warnings : STRING
--      );
--    PORT (
--    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--        signal wrclock : IN STD_LOGIC;
--        signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--        signal rdclken : IN STD_LOGIC;
--        signal wren : IN STD_LOGIC
--      );
--  end component lpm_ram_dp;
--                signal internal_q3 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
--                TYPE mem_array is ARRAY( 262143 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
--                signal memory_has_been_read :  STD_LOGIC;
--                signal read_address :  STD_LOGIC_VECTOR (17 DOWNTO 0);
--
--begin
--
--  process (rdaddress)
--  begin
--      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
--        read_address <= rdaddress;
--      end if;
--
--  end process;
--
--  lpm_ram_dp_component : lpm_ram_dp
--    generic map(
--      lpm_file => "ext_ram_lane2.mif",
--      lpm_hint => "USE_EAB=ON",
--      lpm_indata => "REGISTERED",
--      lpm_outdata => "UNREGISTERED",
--      lpm_rdaddress_control => "UNREGISTERED",
--      lpm_width => 8,
--      lpm_widthad => 18,
--      lpm_wraddress_control => "REGISTERED",
--      suppress_memory_conversion_warnings => "ON"
--    )
--    port map(
--            data => data,
--            q => internal_q3,
--            rdaddress => read_address,
--            rdclken => rdclken,
--            wraddress => wraddress,
--            wrclock => wrclock,
--            wren => wren
--    );
--
--  
--  q <= internal_q3;
--end europa;
--
--synthesis read_comments_as_HDL off

--synthesis translate_off

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity ext_ram_lane3_module is 
        port (
              -- inputs:
                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal rdclken : IN STD_LOGIC;
                 signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal wrclock : IN STD_LOGIC;
                 signal wren : IN STD_LOGIC;

              -- outputs:
                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
end entity ext_ram_lane3_module;


architecture europa of ext_ram_lane3_module is
              signal internal_q4 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
              TYPE mem_array is ARRAY( 262143 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
              signal memory_has_been_read :  STD_LOGIC;
              signal read_address :  STD_LOGIC_VECTOR (17 DOWNTO 0);

      
FUNCTION convert_string_to_number(string_to_convert : STRING;
      final_char_index : NATURAL := 0)
RETURN NATURAL IS
   VARIABLE result: NATURAL := 0;
   VARIABLE current_index : NATURAL := 1;
   VARIABLE the_char : CHARACTER;

   BEGIN
      IF final_char_index = 0 THEN
         result := 0;
	 ELSE
         WHILE current_index <= final_char_index LOOP
            the_char := string_to_convert(current_index);
            IF    '0' <= the_char AND the_char <= '9' THEN
               result := result * 16 + character'pos(the_char) - character'pos('0');
            ELSIF 'A' <= the_char AND the_char <= 'F' THEN
               result := result * 16 + character'pos(the_char) - character'pos('A') + 10;
            ELSIF 'a' <= the_char AND the_char <= 'f' THEN
               result := result * 16 + character'pos(the_char) - character'pos('a') + 10;
            ELSE
               report "Ack, a formatting error!";
            END IF;
            current_index := current_index + 1;
         END LOOP;
      END IF; 
   RETURN result;
END convert_string_to_number;

 FUNCTION convert_string_to_std_logic(value : STRING; num_chars : INTEGER; mem_width_bits : INTEGER)
 RETURN STD_LOGIC_VECTOR is			   
     VARIABLE conv_string: std_logic_vector((mem_width_bits + 4)-1 downto 0);
     VARIABLE result : std_logic_vector((mem_width_bits -1) downto 0);
     VARIABLE curr_char : integer;
              
     BEGIN
     result := (others => '0');
     conv_string := (others => '0');
     
          FOR I IN 1 TO num_chars LOOP
	     curr_char := num_chars - (I-1);

             CASE value(I) IS
               WHEN '0' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0000";
               WHEN '1' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0001";
               WHEN '2' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0010";
               WHEN '3' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0011";
               WHEN '4' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0100";
               WHEN '5' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0101";
               WHEN '6' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0110";
               WHEN '7' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0111";
               WHEN '8' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1000";
               WHEN '9' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1001";
               WHEN 'A' | 'a' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1010";
               WHEN 'B' | 'b' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1011";
               WHEN 'C' | 'c' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1100";
               WHEN 'D' | 'd' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1101";
               WHEN 'E' | 'e' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1110";
               WHEN 'F' | 'f' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1111";
               WHEN 'X' | 'x' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "XXXX";
               WHEN ' ' => EXIT;
               WHEN HT  => exit;
               WHEN others =>
                  ASSERT False
                  REPORT "function From_Hex: string """ & value & """ contains non-hex character"
                       severity Error;
                  EXIT;
               END case;
            END loop;

          -- convert back to normal bit size
          result(mem_width_bits - 1 downto 0) := conv_string(mem_width_bits - 1 downto 0);

          RETURN result;
        END convert_string_to_std_logic;



begin
   process (wrclock, rdaddress) -- MG
    VARIABLE data_line : LINE;
    VARIABLE the_character_from_data_line : CHARACTER;
    VARIABLE b_munging_address : BOOLEAN := FALSE;
    VARIABLE converted_number : NATURAL := 0;
    VARIABLE found_string_array : STRING(1 TO 128);
    VARIABLE string_index : NATURAL := 0;
    VARIABLE line_length : NATURAL := 0;
    VARIABLE b_convert : BOOLEAN := FALSE;
    VARIABLE b_found_new_val : BOOLEAN := FALSE;
    VARIABLE load_address : NATURAL := 0;
    VARIABLE mem_index : NATURAL := 0;
    VARIABLE mem_init : BOOLEAN := FALSE;
    
    VARIABLE wr_address_internal : STD_LOGIC_VECTOR (17 DOWNTO 0) := (others => '0');
    FILE memory_contents_file : TEXT OPEN read_mode IS "ext_ram_lane3.dat";  
    variable Marc_Gaucherons_Memory_Variable : mem_array; -- MG
    
    begin
   -- need an initialization process
   -- this process initializes the whole memory array from a named file by copying the
   -- contents of the *.dat file to the memory array.

   -- find the @<address> thingy to load the memory from this point 
IF(NOT mem_init) THEN
   WHILE NOT(endfile(memory_contents_file)) LOOP

      readline(memory_contents_file, data_line);
      line_length := data_line'LENGTH;


      WHILE line_length > 0 LOOP
         read(data_line, the_character_from_data_line);

	       -- check for the @ character indicating a new address wad
 	       -- if not found, we're either still reading the new address _or_loading data
         IF '@' = the_character_from_data_line AND NOT b_munging_address THEN
  	    b_munging_address := TRUE;
            b_found_new_val := TRUE; 
	    -- get the rest of characters before white space and then convert them
	    -- to a number
	 ELSE 

            IF (' ' = the_character_from_data_line AND b_found_new_val) 
		OR (line_length = 1) THEN
               b_convert := TRUE;
	    END IF;

            IF NOT(' ' = the_character_from_data_line) THEN
               string_index := string_index + 1;
               found_string_array(string_index) := the_character_from_data_line;
--               IF NOT(b_munging_address) THEN
--                 dat_string_array(string_index) := the_character_from_data_line;
--               END IF;
	       b_found_new_val := TRUE;
            END IF;
	 END IF;

     IF b_convert THEN

       IF b_munging_address THEN
          converted_number := convert_string_to_number(found_string_array, string_index);    
          load_address := converted_number;
          mem_index := load_address;
--          mem_index := load_address / 1;
          b_munging_address := FALSE;
       ELSE
	  IF (mem_index < 262144) THEN
	    Marc_Gaucherons_Memory_Variable(mem_index) := convert_string_to_std_logic(found_string_array, string_index, 8);
            mem_index := mem_index + 1;
          END IF;
       END IF; 
       b_convert := FALSE;
       b_found_new_val := FALSE;
       string_index := 0;
    END IF;
    line_length := line_length - 1; 
    END LOOP;

END LOOP;
-- get the first _real_ block of data, sized to our memory width
-- and keep on loading.
  mem_init := TRUE;
END IF;
-- END OF READMEM



      -- Write data
      if wrclock'event and wrclock = '1' then
        wr_address_internal := wraddress;
        if wren = '1' then 
          Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(wr_address_internal))) := data;
        end if;
      end if;

      -- read data
      q <= Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(rdaddress)));
      


    end process;
end europa;

--synthesis translate_on


--synthesis read_comments_as_HDL on
--library altera_vhdl_support;
--use altera_vhdl_support.altera_vhdl_support_lib.all;
--
--library ieee;
--use ieee.std_logic_1164.all;
--use ieee.std_logic_arith.all;
--use ieee.std_logic_unsigned.all;
--
--library std;
--use std.textio.all;
--
--entity ext_ram_lane3_module is 
--        port (
--              
--                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--                 signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--                 signal rdclken : IN STD_LOGIC;
--                 signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--                 signal wrclock : IN STD_LOGIC;
--                 signal wren : IN STD_LOGIC;
--
--              
--                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
--              );
--end entity ext_ram_lane3_module;
--
--
--architecture europa of ext_ram_lane3_module is
--  component lpm_ram_dp is
--GENERIC (
--      lpm_file : STRING;
--        lpm_hint : STRING;
--        lpm_indata : STRING;
--        lpm_outdata : STRING;
--        lpm_rdaddress_control : STRING;
--        lpm_width : NATURAL;
--        lpm_widthad : NATURAL;
--        lpm_wraddress_control : STRING;
--        suppress_memory_conversion_warnings : STRING
--      );
--    PORT (
--    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--        signal wrclock : IN STD_LOGIC;
--        signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
--        signal rdclken : IN STD_LOGIC;
--        signal wren : IN STD_LOGIC
--      );
--  end component lpm_ram_dp;
--                signal internal_q4 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
--                TYPE mem_array is ARRAY( 262143 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
--                signal memory_has_been_read :  STD_LOGIC;
--                signal read_address :  STD_LOGIC_VECTOR (17 DOWNTO 0);
--
--begin
--
--  process (rdaddress)
--  begin
--      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
--        read_address <= rdaddress;
--      end if;
--
--  end process;
--
--  lpm_ram_dp_component : lpm_ram_dp
--    generic map(
--      lpm_file => "ext_ram_lane3.mif",
--      lpm_hint => "USE_EAB=ON",
--      lpm_indata => "REGISTERED",
--      lpm_outdata => "UNREGISTERED",
--      lpm_rdaddress_control => "UNREGISTERED",
--      lpm_width => 8,
--      lpm_widthad => 18,
--      lpm_wraddress_control => "REGISTERED",
--      suppress_memory_conversion_warnings => "ON"
--    )
--    port map(
--            data => data,
--            q => internal_q4,
--            rdaddress => read_address,
--            rdclken => rdclken,
--            wraddress => wraddress,
--            wrclock => wrclock,
--            wren => wren
--    );
--
--  
--  q <= internal_q4;
--end europa;
--
--synthesis read_comments_as_HDL off

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity ext_ram is 
        port (
              -- inputs:
                 signal address : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal be_n : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal read_n : IN STD_LOGIC;
                 signal select_n : IN STD_LOGIC;
                 signal write_n : IN STD_LOGIC;

              -- outputs:
                 signal data : INOUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
end entity ext_ram;


architecture europa of ext_ram is
--synthesis translate_off
component ext_ram_lane0_module is 
           port (
                 -- inputs:
                    signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal rdclken : IN STD_LOGIC;
                    signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal wrclock : IN STD_LOGIC;
                    signal wren : IN STD_LOGIC;

                 -- outputs:
                    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component ext_ram_lane0_module;

component ext_ram_lane1_module is 
           port (
                 -- inputs:
                    signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal rdclken : IN STD_LOGIC;
                    signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal wrclock : IN STD_LOGIC;
                    signal wren : IN STD_LOGIC;

                 -- outputs:
                    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component ext_ram_lane1_module;

component ext_ram_lane2_module is 
           port (
                 -- inputs:
                    signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal rdclken : IN STD_LOGIC;
                    signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal wrclock : IN STD_LOGIC;
                    signal wren : IN STD_LOGIC;

                 -- outputs:
                    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component ext_ram_lane2_module;

component ext_ram_lane3_module is 
           port (
                 -- inputs:
                    signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal rdclken : IN STD_LOGIC;
                    signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal wrclock : IN STD_LOGIC;
                    signal wren : IN STD_LOGIC;

                 -- outputs:
                    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component ext_ram_lane3_module;

--synthesis translate_on
                signal data_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal data_1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal data_2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal data_3 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal logic_vector_gasket :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal module_input2 :  STD_LOGIC;
                signal module_input3 :  STD_LOGIC;
                signal module_input4 :  STD_LOGIC;
                signal module_input5 :  STD_LOGIC;
                signal module_input6 :  STD_LOGIC;
                signal module_input7 :  STD_LOGIC;
                signal module_input8 :  STD_LOGIC;
                signal module_input9 :  STD_LOGIC;
                signal q_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal q_1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal q_2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal q_3 :  STD_LOGIC_VECTOR (7 DOWNTO 0);

begin

--synthesis translate_off
    logic_vector_gasket <= data;
    data_0 <= logic_vector_gasket(7 DOWNTO 0);
    ext_ram_lane0 : ext_ram_lane0_module
      port map(
        q => q_0,
        data => data_0,
        rdaddress => address,
        rdclken => module_input2,
        wraddress => address,
        wrclock => write_n,
        wren => module_input3
      );

    module_input2 <= std_logic'('1');
    module_input3 <= NOT select_n AND NOT be_n(0);

    data_1 <= logic_vector_gasket(15 DOWNTO 8);
    ext_ram_lane1 : ext_ram_lane1_module
      port map(
        q => q_1,
        data => data_1,
        rdaddress => address,
        rdclken => module_input4,
        wraddress => address,
        wrclock => write_n,
        wren => module_input5
      );

    module_input4 <= std_logic'('1');
    module_input5 <= NOT select_n AND NOT be_n(1);

    data_2 <= logic_vector_gasket(23 DOWNTO 16);
    ext_ram_lane2 : ext_ram_lane2_module
      port map(
        q => q_2,
        data => data_2,
        rdaddress => address,
        rdclken => module_input6,
        wraddress => address,
        wrclock => write_n,
        wren => module_input7
      );

    module_input6 <= std_logic'('1');
    module_input7 <= NOT select_n AND NOT be_n(2);

    data_3 <= logic_vector_gasket(31 DOWNTO 24);
    ext_ram_lane3 : ext_ram_lane3_module
      port map(
        q => q_3,
        data => data_3,
        rdaddress => address,
        rdclken => module_input8,
        wraddress => address,
        wrclock => write_n,
        wren => module_input9
      );

    module_input8 <= std_logic'('1');
    module_input9 <= NOT select_n AND NOT be_n(3);

    data <= A_WE_StdLogicVector((std_logic'(((NOT select_n AND NOT read_n))) = '1'), (q_3 & q_2 & q_1 & q_0), A_REP(std_logic'('Z'), 32));
--synthesis translate_on

end europa;


--synthesis translate_off

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;



-- <ALTERA_NOTE> CODE INSERTED BETWEEN HERE
--add your libraries here
-- AND HERE WILL BE PRESERVED </ALTERA_NOTE>

entity test_bench is 
end entity test_bench;


architecture europa of test_bench is
component std_1s10 is 
           port (
                 -- 1) global signals:
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- the_button_pio
                    signal in_port_to_the_button_pio : IN STD_LOGIC_VECTOR (3 DOWNTO 0);

                 -- the_ext_ram_bus_avalon_slave
                    signal be_n_to_the_ext_ram : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal ext_ram_bus_address : OUT STD_LOGIC_VECTOR (22 DOWNTO 0);
                    signal ext_ram_bus_byteenablen : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal ext_ram_bus_data : INOUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal ext_ram_bus_readn : OUT STD_LOGIC;
                    signal ior_n_to_the_lan91c111 : OUT STD_LOGIC;
                    signal iow_n_to_the_lan91c111 : OUT STD_LOGIC;
                    signal irq_from_the_lan91c111 : IN STD_LOGIC;
                    signal read_n_to_the_ext_ram : OUT STD_LOGIC;
                    signal reset_n_to_the_lan91c111 : OUT STD_LOGIC;
                    signal select_n_to_the_ext_flash : OUT STD_LOGIC;
                    signal select_n_to_the_ext_ram : OUT STD_LOGIC;
                    signal write_n_to_the_ext_flash : OUT STD_LOGIC;
                    signal write_n_to_the_ext_ram : OUT STD_LOGIC;

                 -- the_jtagpio
                    signal in_port_to_the_jtagpio : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal out_port_from_the_jtagpio : OUT STD_LOGIC_VECTOR (20 DOWNTO 0);

                 -- the_led_pio
                    signal in_port_to_the_led_pio : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal out_port_from_the_led_pio : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);

                 -- the_reconfig_request_pio
                    signal bidir_port_to_and_from_the_reconfig_request_pio : INOUT STD_LOGIC;

                 -- the_sdram
                    signal zs_addr_from_the_sdram : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal zs_ba_from_the_sdram : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal zs_cas_n_from_the_sdram : OUT STD_LOGIC;
                    signal zs_cke_from_the_sdram : OUT STD_LOGIC;
                    signal zs_cs_n_from_the_sdram : OUT STD_LOGIC;
                    signal zs_dq_to_and_from_the_sdram : INOUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal zs_dqm_from_the_sdram : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal zs_ras_n_from_the_sdram : OUT STD_LOGIC;
                    signal zs_we_n_from_the_sdram : OUT STD_LOGIC;

                 -- the_seven_seg_pio
                    signal out_port_from_the_seven_seg_pio : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- the_uart1
                    signal rxd_to_the_uart1 : IN STD_LOGIC;
                    signal txd_from_the_uart1 : OUT STD_LOGIC
                 );
end component std_1s10;

component ext_flash is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (22 DOWNTO 0);
                    signal read_n : IN STD_LOGIC;
                    signal select_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;

                 -- outputs:
                    signal data : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component ext_flash;

component ext_ram is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal be_n : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal read_n : IN STD_LOGIC;
                    signal select_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;

                 -- outputs:
                    signal data : INOUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component ext_ram;

component sdram_test_component is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal zs_addr : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal zs_ba : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal zs_cas_n : IN STD_LOGIC;
                    signal zs_cke : IN STD_LOGIC;
                    signal zs_cs_n : IN STD_LOGIC;
                    signal zs_dqm : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal zs_ras_n : IN STD_LOGIC;
                    signal zs_we_n : IN STD_LOGIC;

                 -- outputs:
                    signal zs_dq : INOUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component sdram_test_component;

                signal be_n_to_the_ext_ram :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal bidir_port_to_and_from_the_reconfig_request_pio :  STD_LOGIC;
                signal clk :  STD_LOGIC;
                signal ext_ram_bus_address :  STD_LOGIC_VECTOR (22 DOWNTO 0);
                signal ext_ram_bus_byteenablen :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal ext_ram_bus_data :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal ext_ram_bus_readn :  STD_LOGIC;
                signal in_port_to_the_button_pio :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal in_port_to_the_jtagpio :  STD_LOGIC_VECTOR (20 DOWNTO 0);
                signal in_port_to_the_led_pio :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal ior_n_to_the_lan91c111 :  STD_LOGIC;
                signal iow_n_to_the_lan91c111 :  STD_LOGIC;
                signal irq_from_the_lan91c111 :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_dataavailable_from_sa :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_readyfordata_from_sa :  STD_LOGIC;
                signal module_input10 :  STD_LOGIC_VECTOR (17 DOWNTO 0);
                signal out_port_from_the_jtagpio :  STD_LOGIC_VECTOR (20 DOWNTO 0);
                signal out_port_from_the_led_pio :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal out_port_from_the_seven_seg_pio :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal read_n_to_the_ext_ram :  STD_LOGIC;
                signal reset_n :  STD_LOGIC;
                signal reset_n_to_the_lan91c111 :  STD_LOGIC;
                signal rxd_to_the_uart1 :  STD_LOGIC;
                signal select_n_to_the_ext_flash :  STD_LOGIC;
                signal select_n_to_the_ext_ram :  STD_LOGIC;
                signal txd_from_the_uart1 :  STD_LOGIC;
                signal uart1_s1_dataavailable_from_sa :  STD_LOGIC;
                signal uart1_s1_readyfordata_from_sa :  STD_LOGIC;
                signal write_n_to_the_ext_flash :  STD_LOGIC;
                signal write_n_to_the_ext_ram :  STD_LOGIC;
                signal zs_addr_from_the_sdram :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal zs_ba_from_the_sdram :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal zs_cas_n_from_the_sdram :  STD_LOGIC;
                signal zs_cke_from_the_sdram :  STD_LOGIC;
                signal zs_cs_n_from_the_sdram :  STD_LOGIC;
                signal zs_dq_to_and_from_the_sdram :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal zs_dqm_from_the_sdram :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal zs_ras_n_from_the_sdram :  STD_LOGIC;
                signal zs_we_n_from_the_sdram :  STD_LOGIC;


-- <ALTERA_NOTE> CODE INSERTED BETWEEN HERE
--add your component and signal declaration here
-- AND HERE WILL BE PRESERVED </ALTERA_NOTE>


begin

  DUT : std_1s10
    port map(
      be_n_to_the_ext_ram => be_n_to_the_ext_ram,
      bidir_port_to_and_from_the_reconfig_request_pio => bidir_port_to_and_from_the_reconfig_request_pio,
      ext_ram_bus_address => ext_ram_bus_address,
      ext_ram_bus_byteenablen => ext_ram_bus_byteenablen,
      ext_ram_bus_data => ext_ram_bus_data,
      ext_ram_bus_readn => ext_ram_bus_readn,
      ior_n_to_the_lan91c111 => ior_n_to_the_lan91c111,
      iow_n_to_the_lan91c111 => iow_n_to_the_lan91c111,
      out_port_from_the_jtagpio => out_port_from_the_jtagpio,
      out_port_from_the_led_pio => out_port_from_the_led_pio,
      out_port_from_the_seven_seg_pio => out_port_from_the_seven_seg_pio,
      read_n_to_the_ext_ram => read_n_to_the_ext_ram,
      reset_n_to_the_lan91c111 => reset_n_to_the_lan91c111,
      select_n_to_the_ext_flash => select_n_to_the_ext_flash,
      select_n_to_the_ext_ram => select_n_to_the_ext_ram,
      txd_from_the_uart1 => txd_from_the_uart1,
      write_n_to_the_ext_flash => write_n_to_the_ext_flash,
      write_n_to_the_ext_ram => write_n_to_the_ext_ram,
      zs_addr_from_the_sdram => zs_addr_from_the_sdram,
      zs_ba_from_the_sdram => zs_ba_from_the_sdram,
      zs_cas_n_from_the_sdram => zs_cas_n_from_the_sdram,
      zs_cke_from_the_sdram => zs_cke_from_the_sdram,
      zs_cs_n_from_the_sdram => zs_cs_n_from_the_sdram,
      zs_dq_to_and_from_the_sdram => zs_dq_to_and_from_the_sdram,
      zs_dqm_from_the_sdram => zs_dqm_from_the_sdram,
      zs_ras_n_from_the_sdram => zs_ras_n_from_the_sdram,
      zs_we_n_from_the_sdram => zs_we_n_from_the_sdram,
      clk => clk,
      in_port_to_the_button_pio => in_port_to_the_button_pio,
      in_port_to_the_jtagpio => in_port_to_the_jtagpio,
      in_port_to_the_led_pio => in_port_to_the_led_pio,
      irq_from_the_lan91c111 => irq_from_the_lan91c111,
      reset_n => reset_n,
      rxd_to_the_uart1 => rxd_to_the_uart1
    );


  --default value specified in MODULE button_pio ptf port section
  in_port_to_the_button_pio <= std_logic_vector'("1111");
  the_ext_flash : ext_flash
    port map(
      data => ext_ram_bus_data (7 DOWNTO 0),
      address => ext_ram_bus_address,
      read_n => ext_ram_bus_readn,
      select_n => select_n_to_the_ext_flash,
      write_n => write_n_to_the_ext_flash
    );


  the_ext_ram : ext_ram
    port map(
      data => ext_ram_bus_data,
      address => module_input10,
      be_n => be_n_to_the_ext_ram,
      read_n => read_n_to_the_ext_ram,
      select_n => select_n_to_the_ext_ram,
      write_n => write_n_to_the_ext_ram
    );

  module_input10 <= ext_ram_bus_address(19 DOWNTO 2);

  --default value specified in MODULE lan91c111 ptf port section
  irq_from_the_lan91c111 <= std_logic'('0');
  the_sdram_test_component : sdram_test_component
    port map(
      zs_dq => zs_dq_to_and_from_the_sdram,
      clk => clk,
      zs_addr => zs_addr_from_the_sdram,
      zs_ba => zs_ba_from_the_sdram,
      zs_cas_n => zs_cas_n_from_the_sdram,
      zs_cke => zs_cke_from_the_sdram,
      zs_cs_n => zs_cs_n_from_the_sdram,
      zs_dqm => zs_dqm_from_the_sdram,
      zs_ras_n => zs_ras_n_from_the_sdram,
      zs_we_n => zs_we_n_from_the_sdram
    );


  process
  begin
    clk <= '0';
    loop
       wait for 10 ns;
       clk <= not clk;
    end loop;
  end process;
  PROCESS
    BEGIN
       reset_n <= '0';
       wait for 200 ns;
       reset_n <= '1'; 
    WAIT;
  END PROCESS;


-- <ALTERA_NOTE> CODE INSERTED BETWEEN HERE
--add additional architecture here
-- AND HERE WILL BE PRESERVED </ALTERA_NOTE>


end europa;



--synthesis translate_on
